#ifndef __ELC_H_
#define __ELC_H_
#include <stdint.h>
#include "common.h"

//event be triggerred module
#define  _00_ELC_EVENT_LINK_GPTEVENTA     0           /* ELSR00 */
#define  _01_ELC_EVENT_LINK_GPTEVENTB     1           /* ELSR01 */
#define  _02_ELC_EVENT_LINK_GPTEVENTC     2           /* ELSR02 */
#define  _03_ELC_EVENT_LINK_GPTEVENTD     3           /* ELSR03 */
#define  _04_ELC_EVENT_LINK_ADCEVENT0     4           /* ELSR04 */
#define  _05_ELC_EVENT_LINK_ADCEVENT1     5           /* ELSR05 */
#define  _06_ELC_EVENT_LINK_ADCEVENT2     6           /* ELSR06 */
#define  _07_ELC_EVENT_LINK_ADCEVENT3     7           /* ELSR07 */
#define  _08_ELC_EVENT_LINK_ADCEVENT4     8           /* ELSR08 */
#define  _09_ELC_EVENT_LINK_ADCEVENT5     9           /* ELSR09 */
#define  _0A_ELC_EVENT_LINK_ADCEVENT6    10           /* ELSR10 */
#define  _0B_ELC_EVENT_LINK_ADCEVENT7    11           /* ELSR11 */
#define  _0C_ELC_EVENT_LINK_ADCEVENT8    12           /* ELSR12 */
#define  _0D_ELC_EVENT_LINK_TI00         13           /* ELSR13 */
#define  _0E_ELC_EVENT_LINK_TI10         14           /* ELSR14 */
#define  _0F_ELC_EVENT_LINK_DA0          15           /* ELSR15 */
#define  _10_ELC_EVENT_LINK_DA1          16           /* ELSR16 */
#define  _11_ELC_EVENT_LINK_DMA0         17           /* ELSR17 */
#define  _12_ELC_EVENT_LINK_DMA1         18           /* ELSR18 */
#define  _13_ELC_EVENT_LINK_DMA2         19           /* ELSR19 */
#define  _14_ELC_EVENT_LINK_DMA3         20           /* ELSR20 */
#define  _15_ELC_EVENT_LINK_DMA4         21           /* ELSR21 */
#define  _16_ELC_EVENT_LINK_DMA5         22           /* ELSR22 */
#define  _17_ELC_EVENT_LINK_DMA6         23           /* ELSR23 */
#define  _18_ELC_EVENT_LINK_DMA7         24           /* ELSR24 */
#define  _19_ELC_EVENT_LINK_DMA8         25           /* ELSR25 */
#define  _1A_ELC_EVENT_LINK_DMA9         26           /* ELSR26 */
#define  _1B_ELC_EVENT_LINK_DMA10        27           /* ELSR27 */
#define  _1C_ELC_EVENT_LINK_DMA11        28           /* ELSR28 */
#define  _1D_ELC_EVENT_LINK_DMA12        29           /* ELSR29 */
#define  _1E_ELC_EVENT_LINK_DMA13        30           /* ELSR30 */
#define  _1F_ELC_EVENT_LINK_DMA14        31           /* ELSR31 */
#define  _20_ELC_EVENT_LINK_DMA15        32            /* ELSR32 */

//event resources
#define  _00_ELC_EVENT_INTP0             0
#define  _01_ELC_EVENT_INTP1             1
#define  _02_ELC_EVENT_INTP2             2
#define  _03_ELC_EVENT_INTP3             3
#define  _04_ELC_EVENT_INTP4             4
#define  _05_ELC_EVENT_INTP5             5
#define  _06_ELC_EVENT_INTP6             6
#define  _07_ELC_EVENT_INTP7             7
#define  _08_ELC_EVENT_ST0               8
#define  _09_ELC_EVENT_SR0               9
#define  _0A_ELC_EVENT_ST1              10
#define  _0B_ELC_EVENT_SR1              11
#define  _0C_ELC_EVENT_ST2              12
#define  _0D_ELC_EVENT_SR2              13
#define  _0E_ELC_EVENT_ST3              14
#define  _0F_ELC_EVENT_SR3              15
#define  _10_ELC_EVENT_IICA0            16
#define  _11_ELC_EVENT_IICA1            17
#define  _12_ELC_EVENT_SPI0             18
#define  _13_ELC_EVENT_SPI1             19
#define  _14_ELC_EVENT_TM00             20
#define  _15_ELC_EVENT_TM01             21
#define  _16_ELC_EVENT_TM02             22
#define  _17_ELC_EVENT_TM03             23
#define  _18_ELC_EVENT_TM04             24
#define  _19_ELC_EVENT_TM05             25
#define  _1A_ELC_EVENT_TM06             26
#define  _1B_ELC_EVENT_TM07             27
#define  _1C_ELC_EVENT_TM10             28
#define  _1D_ELC_EVENT_TM11             29
#define  _1E_ELC_EVENT_TM12             30
#define  _1F_ELC_EVENT_TM13             31
#define  _20_ELC_EVENT_TM14             32
#define  _21_ELC_EVENT_TM15             33
#define  _22_ELC_EVENT_TM16             34
#define  _23_ELC_EVENT_TM17             35
#define  _24_ELC_EVENT_ADC0_ADIREQ      36
#define  _25_ELC_EVENT_ADC1_ADIREQ      37
#define  _26_ELC_EVENT_ADC2_ADIREQ      38
#define  _27_ELC_EVENT_RTC              39
#define  _28_ELC_EVENT_IT               40
#define  _29_ELC_EVENT_KR               41
#define  _2A_ELC_EVENT_CMP0             42
#define  _2B_ELC_EVENT_CMP1             43
#define  _2C_ELC_EVENT_CMP2             44
#define  _2D_ELC_EVENT_CMP3             45
#define  _2E_ELC_EVENT_C0ERR            46
#define  _2F_ELC_EVENT_C0REC            47
#define  _30_ELC_EVENT_C0WUP            48
#define  _31_ELC_EVENT_C0TRX            49
#define  _32_ELC_EVENT_LCDB             50
#define  _33_ELC_EVENT_QSPI_DMAREQ      51
#define  _34_ELC_EVENT_FL               52											//flash
#define  _35_ELC_EVENT_OSDC             53
#define  _36_ELC_EVENT_PGI0             54
#define  _37_ELC_EVENT_PGI1             55
#define  _38_ELC_EVENT_PGI2             56
#define  _39_ELC_EVENT_PGI3             57
#define  _3A_ELC_EVENT_GPT0_ELCCMPA0    58
#define  _3B_ELC_EVENT_GPT0_ELCCMPB0    59
#define  _3C_ELC_EVENT_GPT0_ELCCMPC0    60
#define  _3D_ELC_EVENT_GPT0_ELCCMPD0    61
#define  _3E_ELC_EVENT_GPT0_ELCCMPE0    62
#define  _3F_ELC_EVENT_GPT0_ELCCMPF0    63
#define  _40_ELC_EVENT_GPT0_ELCOVF0     64
#define  _41_ELC_EVENT_GPT0_ELCUDF0     65
#define  _42_ELC_EVENT_GPT0_ELCCMPA1    66
#define  _43_ELC_EVENT_GPT0_ELCCMPB1    67
#define  _44_ELC_EVENT_GPT0_ELCCMPC1    68
#define  _45_ELC_EVENT_GPT0_ELCCMPD1    69
#define  _46_ELC_EVENT_GPT0_ELCCMPE1    70
#define  _47_ELC_EVENT_GPT0_ELCCMPF1    71
#define  _48_ELC_EVENT_GPT0_ELCOVF1     72
#define  _49_ELC_EVENT_GPT0_ELCUDF1     73
#define  _4A_ELC_EVENT_GPT0_ELCCMPA2    74
#define  _4B_ELC_EVENT_GPT0_ELCCMPB2    75
#define  _4C_ELC_EVENT_GPT0_ELCCMPC2    76
#define  _4D_ELC_EVENT_GPT0_ELCCMPD2    77
#define  _4E_ELC_EVENT_GPT0_ELCCMPE2    78
#define  _4F_ELC_EVENT_GPT0_ELCCMPF2    79
#define  _50_ELC_EVENT_GPT0_ELCOVF2     80
#define  _51_ELC_EVENT_GPT0_ELCUDF2     81
#define  _52_ELC_EVENT_GPT0_ELCCMPA3    82
#define  _53_ELC_EVENT_GPT0_ELCCMPB3    83
#define  _54_ELC_EVENT_GPT0_ELCCMPC3    84
#define  _55_ELC_EVENT_GPT0_ELCCMPD3    85
#define  _56_ELC_EVENT_GPT0_ELCCMPE3    86
#define  _57_ELC_EVENT_GPT0_ELCCMPF3    87
#define  _58_ELC_EVENT_GPT0_ELCOVF3     88
#define  _59_ELC_EVENT_GPT0_ELCUDF3     89
#define  _5A_ELC_EVENT_GPT1_ELCCMPA0    90
#define  _5B_ELC_EVENT_GPT1_ELCCMPB0    91
#define  _5C_ELC_EVENT_GPT1_ELCCMPC0    92
#define  _5D_ELC_EVENT_GPT1_ELCCMPD0    93
#define  _5E_ELC_EVENT_GPT1_ELCCMPE0    94
#define  _5F_ELC_EVENT_GPT1_ELCCMPF0    95
#define  _60_ELC_EVENT_GPT1_ELCOVF0     96
#define  _61_ELC_EVENT_GPT1_ELCUDF0     97
#define  _62_ELC_EVENT_GPT1_ELCCMPA1    98
#define  _63_ELC_EVENT_GPT1_ELCCMPB1    99
#define  _64_ELC_EVENT_GPT1_ELCCMPC1   100
#define  _65_ELC_EVENT_GPT1_ELCCMPD1   101
#define  _66_ELC_EVENT_GPT1_ELCCMPE1   102
#define  _67_ELC_EVENT_GPT1_ELCCMPF1   103
#define  _68_ELC_EVENT_GPT1_ELCOVF1    104
#define  _69_ELC_EVENT_GPT1_ELCUDF1    105
#define  _6A_ELC_EVENT_GPT1_ELCCMPA2   106
#define  _6B_ELC_EVENT_GPT1_ELCCMPB2   107
#define  _6C_ELC_EVENT_GPT1_ELCCMPC2   108
#define  _6D_ELC_EVENT_GPT1_ELCCMPD2   109
#define  _6E_ELC_EVENT_GPT1_ELCCMPE2   110
#define  _6F_ELC_EVENT_GPT1_ELCCMPF2   111
#define  _70_ELC_EVENT_GPT1_ELCOVF2    112
#define  _71_ELC_EVENT_GPT1_ELCUDF2    113
#define  _72_ELC_EVENT_GPT1_ELCCMPA3   114
#define  _73_ELC_EVENT_GPT1_ELCCMPB3   115
#define  _74_ELC_EVENT_GPT1_ELCCMPC3   116
#define  _75_ELC_EVENT_GPT1_ELCCMPD3   117
#define  _76_ELC_EVENT_GPT1_ELCCMPE3   118
#define  _77_ELC_EVENT_GPT1_ELCCMPF3   119
#define  _78_ELC_EVENT_GPT1_ELCOVF3    120
#define  _79_ELC_EVENT_GPT1_ELCUDF3    121
#define  _7A_ELC_EVENT_GPT1_ELCCMPA4   122
#define  _7B_ELC_EVENT_GPT1_ELCCMPB4   123
#define  _7C_ELC_EVENT_GPT1_ELCCMPC4   124
#define  _7D_ELC_EVENT_GPT1_ELCCMPD4   125
#define  _7E_ELC_EVENT_GPT1_ELCCMPE4   126
#define  _7F_ELC_EVENT_GPT1_ELCCMPF4   127
#define  _80_ELC_EVENT_GPT1_ELCOVF4    128
#define  _81_ELC_EVENT_GPT1_ELCUDF4    129
#define  _82_ELC_EVENT_GPT1_ELCCMPA5   130
#define  _83_ELC_EVENT_GPT1_ELCCMPB5   131
#define  _84_ELC_EVENT_GPT1_ELCCMPC5   132
#define  _85_ELC_EVENT_GPT1_ELCCMPD5   133
#define  _86_ELC_EVENT_GPT1_ELCCMPE5   134
#define  _87_ELC_EVENT_GPT1_ELCCMPF5   135
#define  _88_ELC_EVENT_GPT1_ELCOVF5    136
#define  _89_ELC_EVENT_GPT1_ELCUDF5    137
#define  _8A_ELC_EVENT_GPT1_ELCCMPA6   138
#define  _8B_ELC_EVENT_GPT1_ELCCMPB6   139
#define  _8C_ELC_EVENT_GPT1_ELCCMPC6   140
#define  _8D_ELC_EVENT_GPT1_ELCCMPD6   141
#define  _8E_ELC_EVENT_GPT1_ELCCMPE6   142
#define  _8F_ELC_EVENT_GPT1_ELCCMPF6   143
#define  _90_ELC_EVENT_GPT1_ELCOVF6    144
#define  _91_ELC_EVENT_GPT1_ELCUDF6    145
#define  _92_ELC_EVENT_GPT1_ELCCMPA7   146
#define  _93_ELC_EVENT_GPT1_ELCCMPB7   147
#define  _94_ELC_EVENT_GPT1_ELCCMPC7   148
#define  _95_ELC_EVENT_GPT1_ELCCMPD7   149
#define  _96_ELC_EVENT_GPT1_ELCCMPE7   150
#define  _97_ELC_EVENT_GPT1_ELCCMPF7   151
#define  _98_ELC_EVENT_GPT1_ELCOVF7    152
#define  _99_ELC_EVENT_GPT1_ELCUDF7    153
#define  _9A_ELC_EVENT_GPT1_ELCEDGUVW  154
#define  _9B_ELC_EVENT_C1ERR           155
#define  _9C_ELC_EVENT_C1REC           156
#define  _9D_ELC_EVENT_C1WUP           157
#define  _9E_ELC_EVENT_C1TRX           158
#define  _9F_ELC_EVENT_IIR0WFIFOEMP    159
#define  _A0_ELC_EVENT_IIR0WFIFOFUL    160
#define  _A1_ELC_EVENT_IIR1WFIFOEMP    161
#define  _A2_ELC_EVENT_IIR1WFIFOFUL    162
#define  _FF_ELC_EVENT_LINK_OFF        255



/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/
#define ELC_DESTINATION_COUNT              (0x0FU)

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
void ELC_Start(uint32_t event_dst, uint32_t event_src);
void ELC_Stop(uint32_t event);
#endif
