#ifndef __INTP_H__
#define __INTP_H__
#include "common.h"
#include "gpio.h"
#define KEY_WAITTIME                    (1U)   /* change the waiting time according to the system */


#define INTP0     0x01
#define INTP1     0x02
#define INTP2     0x04
#define INTP3     0x08
#define INTP4     0x10
#define INTP5     0x20
#define INTP6     0x40
#define INTP7     0x80

#define PORT_INTP0_PA08     0x00
#define PORT_INTP0_PB07     0x01
#define PORT_INTP0_PE04     0x02

#define PORT_INTP1_PA09     0x00
#define PORT_INTP1_PB06     0x01
#define PORT_INTP1_PD10     0x02
#define PORT_INTP1_PH04     0x03

#define PORT_INTP2_PA10     0x00
#define PORT_INTP2_PD07     0x01
#define PORT_INTP2_PE05     0x02
#define PORT_INTP2_PH03     0x03

#define PORT_INTP3_PD03     0x00
#define PORT_INTP3_PD08     0x01
#define PORT_INTP3_PA13     0x02

#define PORT_INTP4_PC10     0x00
#define PORT_INTP4_PD09     0x01
#define PORT_INTP4_PE02     0x02
#define PORT_INTP4_PA14     0x03

#define PORT_INTP5_PE09     0x00
#define PORT_INTP5_PD05     0x01
#define PORT_INTP5_PE06     0x02
#define PORT_INTP5_PA15     0x03

#define PORT_INTP6_PB00     0x00
#define PORT_INTP6_PB05     0x01
#define PORT_INTP6_PB09     0x02

#define PORT_INTP7_PB01     0x00
#define PORT_INTP7_PB08     0x01
#define PORT_INTP7_PB12     0x02



#define IS_INTP_TYPE(INTP) (((INTP) != (uint16_t)0x00))

typedef enum
{
	Trigger_None,
	Trigger_Falling ,
	Trigger_Rising ,	
	Trigger_Rising_Falling
}Trigger_TypeDef;

typedef struct
{
	uint8_t INTP_Select;     /*!< Specifies the trigger signal active edge for the EXTI lines.
                                         This parameter can be a value of @ref Trigger_TypeDef */
	
	Trigger_TypeDef EXTI_Trigger; /*!< Specifies the trigger signal active edge for the EXTI lines.
                                         This parameter can be a value of @ref Trigger_TypeDef */
}INTP_InitTypeDef;

void INTP_Init(INTP_InitTypeDef* Intp_InitStruct);

#endif
