#ifndef __LVD_H__
#define __LVD_H__
#include "common.h"


/********LVD Mode**************************/
#define LVD_MDInterrupt        0					//LVDж
#define LVD_MDReset            1					//LVDλ

/********LVD Mode**************************/
#define LVD_DetectHigh         0					//LVDߵƽ
#define LVD_DetectLow          1					//LVD͵ƽ

/**
  * @brief  LVD lock.
  * @param  None
  * @retval None
  */
void LVD_Lock(void);

/**
  * @brief  LVD unlock.
  * @param  None
  * @retval None
  */
void LVD_UnLock(void);

/**
  * @brief  Select LVD mode.
  * @param  LMod:
	*               LVD_MDInterrupt interrupt when LVD
	*               LVD_MDReset:reset when LVD
  * @retval None
  */
void LVD_Mode(uint8_t LMod);

/**
  * @brief  Select LVD detect level.
  * @param  Level:
  *               LVD_DetectHigh: LVD detect high level
	*               LVD_DetectLow: LVD detect low level
  * @retval None
  */
void LVD_DetectLevel(uint8_t Level);

/**
  * @brief  return LVD detect voltage status.
  * @param  None:
	* @retval status:
  *            1:ԴѹVDDѹVLVD
  *            0:ԴѹVDDݼѹVLVDLVDΪOFF
  */
uint8_t LVD_StatusLevel(void);

/**
  * @brief  return LVD mask status.
  * @param  None:
	* @retval status:
  *            1:LVDЧ
  *            0:LVDЧ
  */
uint8_t LVD_StatusMask(void);


#endif

