#ifndef __ADC_DEMO_H__
#define __ADC_DEMO_H__
#include <stdio.h>
#include <stdint.h>
#include "adc.h"
#include "gpio.h"
#include "isr.h"

//#define ADC_BURNTEST
//#define ADC_TEMPSENSOR
void adc0_interrupt(void *msg);
void adc1_interrupt(void *msg);
void adc2_interrupt(void *msg);
void adcb0_interrupt(void *msg);
void adcb1_interrupt(void *msg);
void adcb2_interrupt(void *msg);
void adcc0_interrupt(void *msg);
void adcc1_interrupt(void *msg);
void adcc2_interrupt(void *msg);
/***********************************************************************************************************************
* Function Name: Adc0_Init
* @brief  initial ADC uint0
* @param  none
* @return none
***********************************************************************************************************************/
void Adc0_Init(void);
/***********************************************************************************************************************
* Function Name: Adc1_Init
* @brief  initial ADC uint1
* @param  none
* @return none
***********************************************************************************************************************/
void Adc1_Init(void);
	
/***********************************************************************************************************************
* Function Name: Adc3_Init
* @brief  initial ADC uint0
* @param  none
* @return none
***********************************************************************************************************************/
void Adc2_Init(void);
	
/***********************************************************************************************************************
* Function Name: Adc_GroupScan_Init
* @brief  initial ADC group scan 
* @param  none
* @return none
***********************************************************************************************************************/
void Adc_GroupScan_Init(void);

/***********************************************************************************************************************
* Function Name: AdcTemperature_Init
* @brief  initial ADC Temperature uint
* @param  none
* @return none
***********************************************************************************************************************/
void AdcTemperature_Init(void);

/***********************************************************************************************************************
* Function Name: adc_get_temperature
* @brief  ADC Get temperature
* @param  dat - the adc conversion value of ADC_TEMPERSENSOR0 channel
* @return temperature
***********************************************************************************************************************/
int16_t adc_get_temperature(int16_t dat);

/***********************************************************************************************************************
* Function Name: AdcTemperature_Init
* @brief  initial ADC Temperature uint
* @param  none
* @return none
***********************************************************************************************************************/
void AdcInterRefVoltage_Init(void);

#endif
