/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : adc_demo.c                                                  *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "adc_demo.h"
#include "elc.h"
#include "cgc.h"

uint32_t   g_AdcIntTaken;
int16_t   g_temperature;


/***********************************************************************************************************************
* Function Name: Adc0_Init
* @brief  initial ADC uint0
* @param  none
* @return none
***********************************************************************************************************************/
void Adc0_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_ADC0, ENABLE);		//Enable module clock
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_1;  			//adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; 	//ģ
	GPIO_Init(GPIO_PORTA, &GPIO_InitStructure);				//ʼ
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_SingleScan; //ѡɨģʽ
	ADC_InitStructure.ADC_TrigMode = ADCTRGSingle; //ֹ˫
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software;//ѡ񴥷ʽ
	ADC_InitStructure.ADC_ScanIntStatus = ADC_ScanInt_Ensable; //ʹתж
	ADC_InitStructure.ADC_AccEqualStatus = ADC_AccEqual_Ensable; //ʹͨתƽ
	ADC_InitStructure.ADC_ACCEqualNum = ADC_RstACCNum_4;	//ۼ/ƽ4
	ADC_InitStructure.ADC_RstAutoClear = ADC_AutoClear_Disable;   //رսԶ
	ADC_InitStructure.ADC_TransFormat = ADC_Format_right; //ʹתʽҶ
	ADC_InitStructure.ADC_SamplingTimCtrl = 6; //ʱ䣨4-255״̬	
	ADC_InitStructure.ADC_AChannelSelect = ADCChannel_AN001;
	ADC_Init(ADC0, &ADC_InitStructure);

	if((ADC_InitStructure.ADC_ScanIntStatus) == ADC_ScanInt_Ensable)
	{
		// SCANж
		NVIC_EnableIRQ(ADC0_ADIREQ_N_IRQn);
		
		ISR_Register(ADC0_ADIREQ_N_IRQn, adc0_interrupt); //жϷ·ע
	}
	if((ADC_InitStructure.ADC_BScanInt) == ADC_BScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC0_GBADIREQ_N_IRQn);
		ISR_Register(ADC0_GBADIREQ_N_IRQn, adcb0_interrupt); //жϷ·ע
		
	}
	if((ADC_InitStructure.ADC_CScanInt) == ADC_CScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC0_GCADIREQ_N_IRQn);
		ISR_Register(ADC0_GCADIREQ_N_IRQn, adcc0_interrupt); //жϷ·ע
		
	}
}

/***********************************************************************************************************************
* Function Name: Adc1_Init
* @brief  initial ADC uint1
* @param  none
* @return none
***********************************************************************************************************************/
void Adc1_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_ADC1, ENABLE);		//Enable module clock
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_4 | GPIO_Pin_5;  			//adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; 	//ģ
	GPIO_Init(GPIO_PORTA, &GPIO_InitStructure);				//ʼ	
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_GroupScan; 								//ѡɨģʽ
	ADC_InitStructure.ADC_TrigMode = ADCTRGSingle; 									//ֹ˫
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Synch;//ѡͬʽ
	ADC_InitStructure.ADC_GASynchTrgSource = ADC_GABSynch_ELSR04;		//ѡ¼4
	ADC_InitStructure.ADC_GBSynchTrgSource = ADC_GABSynch_ELSR05;		//ѡ¼5ʽ
	ADC_InitStructure.ADC_ScanIntStatus = ADC_ScanInt_Ensable; 			//ʹתж
	ADC_InitStructure.ADC_AccEqualStatus = ADC_AccEqual_Ensable; 		//ʹͨתƽ
	ADC_InitStructure.ADC_ACCEqualNum = ADC_RstACCNum_16;						//ۼ/ƽ4
	ADC_InitStructure.ADC_RstAutoClear = ADC_AutoClear_Disable;   	//رսԶ
	ADC_InitStructure.ADC_TransFormat = ADC_Format_right; 					//ʹתʽҶ
	ADC_InitStructure.ADC_SamplingTimCtrl = 8; 											//ʱ䣨4-255״̬	
	ADC_InitStructure.ADC_AChannelSelect = ADCChannel_AN101;
	ADC_InitStructure.ADC_BChannelSelect = ADCChannel_AN102;
	ADC_InitStructure.ADC_BScanInt = ADC_BScanInt_Enable;
	ADC_Init(ADC1, &ADC_InitStructure);

	//
	ELC_Start(_04_ELC_EVENT_LINK_ADCEVENT0, _00_ELC_EVENT_INTP0);
	ELC_Start(_05_ELC_EVENT_LINK_ADCEVENT1, _01_ELC_EVENT_INTP1);
	if((ADC_InitStructure.ADC_ScanIntStatus) == ADC_ScanInt_Ensable)
	{
		// SCANж
		NVIC_EnableIRQ(ADC1_ADIREQ_N_IRQn);
		
		ISR_Register(ADC1_ADIREQ_N_IRQn, adc1_interrupt); //жϷ·ע
	}
	if((ADC_InitStructure.ADC_BScanInt) == ADC_BScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC1_GBADIREQ_N_IRQn);
		ISR_Register(ADC1_GBADIREQ_N_IRQn, adcb1_interrupt); //жϷ·ע
		
	}
	if((ADC_InitStructure.ADC_CScanInt) == ADC_CScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC1_GCADIREQ_N_IRQn);
		ISR_Register(ADC1_GCADIREQ_N_IRQn, adcc1_interrupt); //жϷ·ע
		
	}
	Adc_GroupScan_Init();
}

/***********************************************************************************************************************
* Function Name: Adc3_Init
* @brief  initial ADC uint0
* @param  none
* @return none
***********************************************************************************************************************/
void Adc2_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_ADC2, ENABLE);		//Enable module clock
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;  			//adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; 	//ģ
	GPIO_Init(GPIO_PORTA, &GPIO_InitStructure);				//ʼ
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_SingleScan; //ѡɨģʽ
	ADC_InitStructure.ADC_TrigMode = ADCTRGSingle; //ֹ˫
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software;//ѡ񴥷ʽ
	ADC_InitStructure.ADC_ScanIntStatus = ADC_ScanInt_Ensable; //ʹתж
	ADC_InitStructure.ADC_AccEqualStatus = ADC_AccEqual_Ensable; //ʹͨתƽ
	ADC_InitStructure.ADC_ACCEqualNum = ADC_RstACCNum_4;	//ۼ/ƽ4
	ADC_InitStructure.ADC_RstAutoClear = ADC_AutoClear_Disable;   //رսԶ
	ADC_InitStructure.ADC_TransFormat = ADC_Format_right; //ʹתʽҶ
	ADC_InitStructure.ADC_SamplingTimCtrl = 6; //ʱ䣨4-255״̬	
	ADC_InitStructure.ADC_AChannelSelect = ADCChannel_AN002;
	ADC_Init(ADC2, &ADC_InitStructure);

	if((ADC_InitStructure.ADC_ScanIntStatus) == ADC_ScanInt_Ensable)
	{
		// SCANж
		NVIC_EnableIRQ(ADC2_ADIREQ_N_IRQn);
		
		ISR_Register(ADC2_ADIREQ_N_IRQn, adc2_interrupt); //жϷ·ע
	}
	if((ADC_InitStructure.ADC_BScanInt) == ADC_BScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC2_GBADIREQ_N_IRQn);
		ISR_Register(ADC2_GBADIREQ_N_IRQn, adcb2_interrupt); //жϷ·ע
		
	}
	if((ADC_InitStructure.ADC_CScanInt) == ADC_CScanInt_Enable)
	{
		//B SCANж
		NVIC_EnableIRQ(ADC2_GCADIREQ_N_IRQn);
		ISR_Register(ADC2_GCADIREQ_N_IRQn, adcc2_interrupt); //жϷ·ע
		
	}
}

/***********************************************************************************************************************
* Function Name: AdcTemperature_Init
* @brief  initial ADC Temperature uint
* @param  none
* @return none
***********************************************************************************************************************/
void AdcTemperature_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_ADC2, ENABLE);		//Enable module clock
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_SingleScan; //ѡɨģʽ
	ADC_InitStructure.ADC_TrigMode = ADCTRGSingle; //ֹ˫
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software;//ѡ񴥷ʽ
	ADC_InitStructure.ADC_ScanIntStatus = ADC_ScanInt_Ensable; //ʹתж
	ADC_InitStructure.ADC_AccEqualStatus = ADC_AccEqual_Ensable; //ʹͨתƽ
	ADC_InitStructure.ADC_ACCEqualNum = ADC_RstACCNum_4;	//ۼ/ƽ4
	ADC_InitStructure.ADC_RstAutoClear = ADC_AutoClear_Disable;   //رսԶ
	ADC_InitStructure.ADC_TransFormat = ADC_Format_right; //ʹתʽҶ
	ADC_InitStructure.ADC_SamplingTimCtrl = 6; //ʱ䣨4-255״̬	
//	ADC_InitStructure.ADC_AChannelSelect = ADCChannel_Temp;
	ADC_Init(ADC2, &ADC_InitStructure);
	
	ADCTemperature_Enable(ADC_TempACC_Enable);  //enable ADC temperature sensor
	
	if((ADC_InitStructure.ADC_ScanIntStatus) == ADC_ScanInt_Ensable)
	{
		// SCANж
		NVIC_EnableIRQ(ADC2_ADIREQ_N_IRQn);
		
		ISR_Register(ADC2_ADIREQ_N_IRQn, adc2_interrupt); //жϷ·ע
	}

}

/***********************************************************************************************************************
* Function Name: AdcTemperature_Init
* @brief  initial ADC Temperature uint
* @param  none
* @return none
***********************************************************************************************************************/
void AdcInterRefVoltage_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_ADC2, ENABLE);		//Enable module clock
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_SingleScan; //ѡɨģʽ
	ADC_InitStructure.ADC_TrigMode = ADCTRGSingle; //ֹ˫
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software;//ѡ񴥷ʽ
	ADC_InitStructure.ADC_ScanIntStatus = ADC_ScanInt_Ensable; //ʹתж
	ADC_InitStructure.ADC_AccEqualStatus = ADC_AccEqual_Ensable; //ʹͨתƽ
	ADC_InitStructure.ADC_ACCEqualNum = ADC_RstACCNum_4;	//ۼ/ƽ4
	ADC_InitStructure.ADC_RstAutoClear = ADC_AutoClear_Disable;   //رսԶ
	ADC_InitStructure.ADC_TransFormat = ADC_Format_right; //ʹתʽҶ
	ADC_InitStructure.ADC_SamplingTimCtrl = 6; //ʱ䣨4-255״̬	
	ADC_Init(ADC2, &ADC_InitStructure);
	
	ADCInterRefVol_Enable(ADC_TempACC_Enable);  //enable ADC temperature sensor
	
	if((ADC_InitStructure.ADC_ScanIntStatus) == ADC_ScanInt_Ensable)
	{
		// SCANж
		NVIC_EnableIRQ(ADC2_ADIREQ_N_IRQn);
		
		ISR_Register(ADC2_ADIREQ_N_IRQn, adc2_interrupt); //жϷ·ע
	}

}

/***********************************************************************************************************************
* Function Name: Adc_GroupScan_Init
* @brief  initial ADC group scan 
* @param  none
* @return none
***********************************************************************************************************************/
void Adc_GroupScan_Init(void)
{
	ADC_GroupScanTypeDef      ADC_GSInitStructure = {0};
 
	
	ADC_GSInitStructure.ADC_GPrioritySet = ADC_GroupPriority_Disable; 		//رȼ
	ADC_GSInitStructure.ADC_GScanRstart = ADC_GScanRstart_Enable; 		//ȼ鱻ϺҪ
	ADC_GSInitStructure.ADC_GScanRSCh = ADC_GScanRstartCh_BrkChan; 		//ȼ鱻ϺӴϵͨʼɨ
	ADC_GSInitStructure.ADC_GScanRSMode = ADC_GScanMode_Normal; 			//ȼɨģʽΪɨ

	ADC_GScan_Init(ADC0, &ADC_GSInitStructure);
}

/***********************************************************************************************************************
* Function Name: adc_get_temperature
* @brief  ADC Get temperature
* @param  dat - the adc conversion value of ADC_TEMPERSENSOR0 channel
* @return temperature
***********************************************************************************************************************/
#if 0
double adc_get_temperature(int16_t dat)
{
	double temp;    /* temperature value */

	temp = (double)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

	return (temp);
}
#else
int16_t adc_get_temperature(int16_t dat)
{
	int16_t temp;   /* temperature value */

	temp = (int16_t)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

	return (temp);
}
#endif

/***********************************************************************************************************************
* Function Name: adc0_interrupt
* @brief  ADC transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adc0_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC0_ADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adc1_interrupt
* @brief  ADC transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adc1_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC1_ADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adc2_interrupt
* @brief  ADC transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adc2_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC2_ADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcb0_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcb0_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC0_GBADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcb1_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcb1_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC1_GBADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcb2_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcb2_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC2_GBADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcc0_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcc0_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC0_GCADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcb0_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcc1_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC1_GCADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}

/***********************************************************************************************************************
* Function Name: adcc2_interrupt
* @brief  ADC group B transfer complete interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void adcc2_interrupt(void *msg)
{
	NVIC_ClearPendingIRQ(ADC2_GCADIREQ_N_IRQn);     //clear AD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}


