#ifndef __IIC_DEMO_H__
#define __IIC_DEMO_H__
#include "i2c.h"
#include "gpio.h"
#include "isr.h"

#define IIC_NO_ACK   1
#define IIC_OVF_RUN   2
typedef enum
{
    SCI_IIC_IDLE = 0,
    SCI_IIC_SEND = 1,
    SCI_IIC_RECV = 2,
    SCI_IIC_SENDADR = 4,
} IIC_STATUS;
void iic00_interrupt(void *msg);
void iic01_interrupt(void *msg);
void iic10_interrupt(void *msg);
void iic11_interrupt(void *msg);
void iic20_interrupt(void *msg);
void iic21_interrupt(void *msg);
void iic30_interrupt(void *msg);
void iic31_interrupt(void *msg);

int8_t Iic00_Init(void);
int8_t Iic01_Init(void);
int8_t Iic10_Init(void);
int8_t Iic11_Init(void);
int8_t Iic20_Init(void);
int8_t Iic21_Init(void);

void Iic20_Write(uint8_t address, uint8_t *tx_buf, uint16_t tx_num);
void Iic20_Read(uint8_t address, uint8_t *rx_buf, uint16_t rx_num);

void IIC_WriteBuff(SCIAFSelect_TypeDef func, uint8_t address, uint8_t Reg, uint8_t *Bufp, uint8_t len);
void IIC_ReadBuff(SCIAFSelect_TypeDef func, uint8_t I2c_Add, uint8_t Reg, uint8_t *Bufp, uint8_t len);


#endif
