/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "rtc_demo.h"
#include "cgc.h"
#define RTC_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
void Led_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1 | GPIO_Pin_2 ;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTC, &GPIO_InitStruct);
}

int main()
{
    uint32_t msCnt;     // count value of 1ms
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
	Led_Init();
    Uart0_Init(19200);

#if RTC_ENABLE
	CGC_LSEConfig(OSC_OSCILLATOR,OSC_NORMAL_POWER);//ⲿپ
    Rtc_Init();
#endif


}


