/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : spihs_demo.c                                                 *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "spihs_demo.h"

volatile uint8_t *gp_spi_rx_address;       /* spi receive buffer address */
volatile uint16_t g_spi_rx_count;          /* spi receive data count */
uint8_t g_spi_tx_end = 0, g_spi_rx_end = 0;

void NSS1_set()
{
    GPIO_SetBits(GPIO_PORTB, GPIO_Pin_1);
}
void NSS1_clr()
{
    GPIO_ResetBits(GPIO_PORTB, GPIO_Pin_1);
}
void NSS0_set()
{
    GPIO_SetBits(GPIO_PORTD, GPIO_Pin_9);
}
void NSS0_clr()
{
    GPIO_ResetBits(GPIO_PORTD, GPIO_Pin_9);
}
/***********************************************************************************************************************
* Function Name: Spihs_Init
* @brief high speed spi init
* @param
* @return
***********************************************************************************************************************/
void Spihs_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure = {0};
																						 
		GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_12, GROUP_AF_SPIHS0MOSI);
		GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_15, GROUP_AF_SPIHS0MISO);
		GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_9, GROUP_AF_SPIHS0NSS);
		GPIO_PinAFConfig(GPIO_PORTD, GPIO_Pin_14, GROUP_AF_SPIHS0SCK);
    /*NSS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_9;   //NSSѡģʽʼʱø/͵ƽΪ
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_14;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);

    /*MOSI GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_12;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);

    /*MISO GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_15;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTD, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;           //SPIģʽ:ΪSPI SPI_Mode_Master
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;       //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_CPOL      = SPI_CPOL_Low;         //ʱڵ͵ƽʱΪ̬ ģʽ0
    SPI_InitStructure.SPI_CPHA      = SPI_CPHA_1Edge;       //ڵһز   ģʽ0
    SPI_InitStructure.SPI_NSS       = SPI_NSS_Hard ;        //ʹNSS
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_32; //ѡspiʱ fmclk =clk/2^3
    SPI_InitStructure.SPI_FirstBit  = SPI_FirstBit_MSB;          //ѡbitȴ
		SPI_InitStructure.SPI_RecieveMode  = SPI_ReceiveMD_Single;          //ѡģʽ
    SPI_Init(SPIHS0,&SPI_InitStructure);
    SPI_BiDirectionalLineConfig(SPIHS0,SPI_Direction_TxRx);

    ISR_Register(SPI0_IRQn, spi0hs_interrupt);   //жϷ·ע

    NSS.Active = NSS0_clr;                             //NSSƬѡʼ
    NSS.Inactive = NSS0_set;
    NSS.Inactive();                                  //NSSʼ״̬
}


/***********************************************************************************************************************
* Function Name: Spihs_Write
* @brief  spi write data
* @param  None
* @return None
***********************************************************************************************************************/
void Spihs_Write(uint8_t data)
{
    SPI_TransmitByte(SPIHS0,data);
}

/***********************************************************************************************************************
* Function Name: Spihs_Read
* @brief  spi read data
* @param  None
* @return None
***********************************************************************************************************************/
uint8_t Spihs_Read(void)
{
    return SPI_ReceiveByte(SPIHS0);
}

/***********************************************************************************************************************
* Function Name: SPI_Start
* @brief  high speed spi interrupt start
* @param  SPI_FUNC_t
* @return
***********************************************************************************************************************/
void SPI_Start()
{
    NVIC_ClearPendingIRQ(SPI0_IRQn);
    NVIC_ClearPendingIRQ(SPI0_IRQn);
    NVIC_EnableIRQ(SPI0_IRQn);
    NVIC_EnableIRQ(SPI0_IRQn);
    SPI_Cmd(SPIHS0,ENABLE);        //spi
}

/***********************************************************************************************************************
* Function Name: SPI_Stop
* @brief  high speed spi interrupt stop
* @param  SPI_FUNC_t
* @return
***********************************************************************************************************************/
void SPI_Stop()
{
    SPI_Cmd(SPIHS0,DISABLE);        //رspi
    NVIC_DisableIRQ(SPI0_IRQn);
    NVIC_DisableIRQ(SPI0_IRQn);
    NVIC_ClearPendingIRQ(SPI0_IRQn);
    NVIC_ClearPendingIRQ(SPI0_IRQn);

}

/***********************************************************************************************************************
* Function Name: Spihs_Int_Write
* @brief  high speed spi write data by interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void Spihs_Int_Write(uint8_t *tx_buf, uint16_t tx_num)
{
    SPI_Start();

    g_spi_tx_end = 0;
    pData.data = &tx_buf[1];    //send buffer pointer
    pData.len  = tx_num - 1; //set send data count
    pData.flag = INT_TX;   //set data direction

    SPI_SendData(SPIHS0,tx_buf[0]);
}

/***********************************************************************************************************************
* Function Name: Spihs_Int_TxRx
* @brief  high speed spi write data and read data
* @param  None
* @return None
***********************************************************************************************************************/
void Spihs_Int_TxRx(uint8_t *tx_buf, uint16_t tx_num, uint8_t *rx_buf, uint16_t rx_num)
{
    SPI_Start();
    SPI_BiDirectionalLineConfig(SPIHS0,SPI_Direction_TxRx);
    g_spi_tx_end = 0;
    pData.data = &tx_buf[1];    //send buffer pointer
    pData.len  = tx_num;  //set send data count
    pData.flag = INT_TX;   //set data direction

    g_spi_rx_count = rx_num;    /* receive data count */
    gp_spi_rx_address = rx_buf; /* receive buffer pointer */
    SPI_SendData(SPIHS0,tx_buf[0]);
}
/***********************************************************************************************************************
* Function Name: Spihs_Int_Read
* @brief  high speed spi read data by interrupt
* @param  None
* @return None
***********************************************************************************************************************/
void Spihs_Int_Read(uint8_t *rx_buf, uint16_t rx_num)
{
    uint32_t dummy_sdr;

    SPI_Start();

    SPI_BiDirectionalLineConfig(SPIHS0,SPI_Direction_Rx);

    g_spi_rx_end = 0;
    pData.data = rx_buf;   //read buffer pointer
    pData.len  = rx_num;   //set receive data count
    pData.flag = INT_RX;   //set data direction

    dummy_sdr = SPI_ReceiveData(SPIHS0);
}




/***********************************************************************************************************************
* Function Name: spi0hs_interrupt
* @brief  high speed spi interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi0hs_interrupt(void *msg)
{
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;

    if (pFrame->flag == INT_TX)
    {
        if (pFrame->len > 0)
        {
            //          if (0U != pFrame->data)
            {
                SPI0_WRDR = *pFrame->data;
                pFrame->data++;
                pFrame->len--;
                *gp_spi_rx_address = SPI_ReceiveData(SPIHS0);
                gp_spi_rx_address++;

            }
            //          else
            //          {
            //              SPI_WRDR = 0xFFU;
            //          }
        }
        else
        {
            while (SPI0_BUSY);

            /* complete send */
            SPI_Stop();
            pFrame->len = 0;
            pFrame->flag = INT_IDLE;
            g_spi_tx_end = 1;
        }
    }

    if (pFrame->flag == INT_RX)
    {
        if (pFrame->len > 1)
        {
            *pFrame->data = SPI_ReceiveData(SPIHS0);
            pFrame->data++;
            pFrame->len--;
        }
        else if (pFrame->len == 1)
        {
            *pFrame->data =  SPI_ReceiveData(SPIHS0);
            pFrame->data++;
            pFrame->len--;
            {
                /* complete receive */
                SPI_Stop();
                pFrame->len = 0;
                pFrame->flag = INT_IDLE;
                g_spi_rx_end = 1;
            }
        }
    }

    if (pFrame->flag == INT_DMA)
    {
        if (pFrame->len == 1)
        {		
            SPI_Stop();
            g_spi_rx_end = 1;
        }

        while (SPI0_BUSY);

        SPI_Stop();
        g_spi_tx_end = 1;
    }

    NVIC_ClearPendingIRQ(SPI0_IRQn);
}


