/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "spihs_demo.h"
#include "gpio_demo.h"
#include "delay_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t mrx0_buf[13];
uint8_t mtx_buf[] = {0xA5, 0x5A, 0xCC};
extern uint8_t g_spi_tx_end, g_spi_rx_end;


int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t i, err;
    uint32_t tmp;
    uint8_t uniq_id[8];
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
    Led_Init();


    Uart0_Init(19200);
    Spihs_Init();

    Spihs_Int_Write(mtx_buf, sizeof(mtx_buf));

    while (g_spi_tx_end == 0);



    delayMS(4);

    Spihs_Int_Read(mrx0_buf, sizeof(mrx0_buf));

    while (g_spi_rx_end == 0);

    delayMS(2);
    err = 0;

    for (i = 0; i < sizeof(mrx0_buf); i++)
    {
        if (mtx_buf[i] != mrx0_buf[i])
        {
            err++;
        }

        printf(" %02x", mrx0_buf[i]);
    }

    if (err)
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_OFF;
    }
    else
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_ON;
    }


}

