/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "pcbz.h"
#include "BAT32G439.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORTE, GPIO_Pin_5, GROUP_AF_PCLBUZ0); // CLKBUZ0 can be alternative to PE05

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTE, &GPIO_InitStruct);
	
		PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
		PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
		PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_13;	
		PCBZ_Init(&PCBZ_InitStructure);	
	
}
int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t width = 0;
		float time = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
		
		PCBZIO_Init();

    Uart0_Init(19200);

    /*Example4:Tim8 get external wave pluse widthpulse period*/	
#if 1
		Tim81_GetPulsePeriod_Init();

		while(1)
		{
			width = TIM_GetPulsePeriod(TIM81,TTM_Channel_2);			
			printf("PA00/TI00 pulse width  = %d fCLK\n", width);  /* expected value: msCnt */	
		}
#endif
}




