/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "gpio_demo.h"
#include "wdt.h"
#include "dma_demo.h"
#include "delay_demo.h"
#include "elc.h"

#define UART0_DMA_RCV
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    uint32_t i,j;
    uint8_t rxbuf[64];
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
		
		Uart0_Init(115200);
	
#ifdef UART0_DMA_RCV
    /*0ͨDMAղ*/
		ELC_Start(_11_ELC_EVENT_LINK_DMA0, _09_ELC_EVENT_SR0);  //uart0DMA0
    DMA_Uart0_Rx(ELC_EVENT_LINK_DMA0, DMA_Mode_Repeat, (void *)&UART0_RX, UART0_RX_BUF, UART_MAX_RECV_LEN); //config dma transmission
		i = Uart0_Receive();
#endif
    printf("Hello, UART\n");
#ifdef UART0_DMA_RCV
	Uart0_Dma_Send(UART0_RX_BUF,UART_MAX_RECV_LEN);
#endif	
UART0_RX_STA = 0x8040;
		
		 while (1)
    {
#ifndef UART0_DMA_RCV

        if (UART0_RX_STA & 0x8000U)
        {
            //          Uart0_IntSend(UART0_RX_BUF,UART0_RX_STA&0x3fff); //жϷ
            //          Uart0_Dma_Send(UART0_RX_BUF,UART0_RX_STA&0x3fff);//DMA 
            for (i = 0; i < (UART0_RX_STA & 0x3fff); i++)   //ѯ
            {
                Uart0_Send(UART0_RX_BUF[i]);
            }

            UART0_RX_STA = 0;
        }

#endif
    }
}




