/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "gpio_demo.h"
#include "wdt.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t tmp;

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);
    Led_Init();
		wdt_Int();
	
    tmp = RST->RESF;
    if (tmp & RST_RESF_WDTRF_Msk)
    {
        printf("WDT Reset taken! RESF = 0x%02x\n", tmp);
        PD1_toggle;     // PD1 toggle

        while (1)
        {
            WDT_Restart();
        }
    }
    else
    {
        while (g_WdtIntTaken == 0) {;}

        printf("WDT Interrupt taken! RESF = 0x%02x\n", RST->RESF);
        PD2_toggle;     // PD2 toggle

        while (1);
    }
}




