/*
 * ARM Limited (ARM) is supplying this software for use with Cortex-M
 * processor based microcontroller, but can be equally used for other
 * suitable processor architectures. This file can be freely distributed.
 * Modifications to this file shall be clearly marked.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * @file     BAT32G439.h
 * @brief    CMSIS HeaderFile
 * @version  1.0
 * @date     03. February 2023
 * @note     Generated by SVDConv V3.3.42 on Friday, 03.02.2023 10:54:43
 *           from File 'Files/SVD/BAT32G439.svd',
 *           last modified on Friday, 30.12.2022 09:42:16
 */



/** @addtogroup Cmsemicon
  * @{
  */


/** @addtogroup BAT32G439
  * @{
  */


#ifndef BAT32G439_H
#define BAT32G439_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M33 Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SecureFault_IRQn          =  -9,              /*!< -9 Secure Fault Handler                                                   */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* =========================================  BAT32G439 Specific Interrupt Numbers  ========================================== */
  LVI_IRQn                  =   0,              /*!< 0  Low Voltage detection interrupt                                        */
  WDT0_IRQn                 =   1,              /*!< 1  Watch dog timer 0 interrupt request                                    */
  WDT1_IRQn                 =   2,              /*!< 2  Watch dog timer 1 interrupt request                                    */
  INTP0_IRQn                =   3,              /*!< 3  INTP0 External interrupt request                                       */
  INTP1_IRQn                =   4,              /*!< 4  INTP1 External interrupt request                                       */
  INTP2_IRQn                =   5,              /*!< 5  INTP2 External interrupt request                                       */
  INTP3_IRQn                =   6,              /*!< 6  INTP3 External interrupt request                                       */
  INTP4_IRQn                =   7,              /*!< 7  INTP4 External interrupt request                                       */
  INTP5_IRQn                =   8,              /*!< 8  INTP5 External interrupt request                                       */
  INTP6_IRQn                =   9,              /*!< 9  INTP6 External interrupt request                                       */
  INTP7_IRQn                =  10,              /*!< 10 INTP7 External interrupt request                                       */
  ST0_IRQn                  =  11,              /*!< 11 UART0 transmission transfer end or buffer empty                        */
  SPI00_IRQn                =  11,              /*!< 11 SPI00 transfer end or buffer empty                                     */
  IIC00_IRQn                =  11,              /*!< 11 IIC00 transfer end                                                     */
  SR0_IRQn                  =  12,              /*!< 12 UART0 rerception transfer                                              */
  SPI01_IRQn                =  12,              /*!< 12 SPI01 transfer end or buffer empty                                     */
  IIC01_IRQn                =  12,              /*!< 12 IIC01 transfer end                                                     */
  SRE0_IRQn                 =  13,              /*!< 13 UART0 rerception communication error occurrence                        */
  ST1_IRQn                  =  14,              /*!< 14 UART1 transmission transfer end or buffer empty                        */
  SPI10_IRQn                =  14,              /*!< 14 SPI10 transfer end or buffer empty                                     */
  IIC10_IRQn                =  14,              /*!< 14 IIC10 transfer end                                                     */
  SR1_IRQn                  =  15,              /*!< 15 UART1 rerception transfer                                              */
  SPI11_IRQn                =  15,              /*!< 15 SPI11 transfer end or buffer empty                                     */
  IIC11_IRQn                =  15,              /*!< 15 IIC11 transfer end                                                     */
  SRE1_IRQn                 =  16,              /*!< 16 UART1 rerception communication error occurrence                        */
  ST2_IRQn                  =  17,              /*!< 17 UART2 transmission transfer end or buffer empty                        */
  SPI20_IRQn                =  17,              /*!< 17 SPI20 transfer end or buffer empty                                     */
  IIC20_IRQn                =  17,              /*!< 17 IIC20 transfer end                                                     */
  SR2_IRQn                  =  18,              /*!< 18 UART2 rerception transfer                                              */
  SPI21_IRQn                =  18,              /*!< 18 SPI21 transfer end or buffer empty                                     */
  IIC21_IRQn                =  18,              /*!< 18 IIC21 transfer end                                                     */
  SRE2_IRQn                 =  19,              /*!< 19 UART2 rerception communication error occurrence                        */
  ST3_IRQn                  =  20,              /*!< 20 UART3 transmission transfer end or buffer empty                        */
  SPI30_IRQn                =  20,              /*!< 20 SPI30 transfer end or buffer empty                                     */
  IIC30_IRQn                =  20,              /*!< 20 IIC30 transfer end                                                     */
  SR3_IRQn                  =  21,              /*!< 21 UART3 rerception transfer                                              */
  SPI31_IRQn                =  21,              /*!< 21 SPI31 transfer end or buffer empty                                     */
  IIC31_IRQn                =  21,              /*!< 21 IIC31 transfer end                                                     */
  SRE3_IRQn                 =  22,              /*!< 22 UART3 rerception communication error occurrence                        */
  IICA0_IRQn                =  23,              /*!< 23 IICA0 communication finish                                             */
  IICA1_IRQn                =  24,              /*!< 24 IICA1 communication finish                                             */
  SPI0_IRQn                 =  25,              /*!< 25 high speed spi0 transmission finish                                    */
  SPI1_IRQn                 =  26,              /*!< 26 high speed spi1 transmission finish                                    */
  TM00_IRQn                 =  27,              /*!< 27 TM80 channel 0 interrupt request                                       */
  TM01_IRQn                 =  28,              /*!< 28 TM80 channel 1 interrupt request                                       */
  TM02_IRQn                 =  29,              /*!< 29 TM80 channel 2 interrupt request                                       */
  TM03_IRQn                 =  30,              /*!< 30 TM80 channel 3 interrupt request                                       */
  TM04_IRQn                 =  31,              /*!< 31 TM80 channel 4 interrupt request                                       */
  TM05_IRQn                 =  32,              /*!< 32 TM80 channel 5 interrupt request                                       */
  TM06_IRQn                 =  33,              /*!< 33 TM80 channel 6 interrupt request                                       */
  TM07_IRQn                 =  34,              /*!< 34 TM80 channel 7 interrupt request                                       */
  TM01H_IRQn                =  35,              /*!< 35 when high 8-bit timer working,TM80 channel 1 interrupt request         */
  TM03H_IRQn                =  36,              /*!< 36 when high 8-bit timer working,TM80 channel 3 interrupt request         */
  TM10_IRQn                 =  37,              /*!< 37 TM81 channel 0 interrupt request                                       */
  TM11_IRQn                 =  38,              /*!< 38 TM81 channel 1 interrupt request                                       */
  TM12_IRQn                 =  39,              /*!< 39 TM81 channel 2 interrupt request                                       */
  TM13_IRQn                 =  40,              /*!< 40 TM81 channel 3 interrupt request                                       */
  TM14_IRQn                 =  41,              /*!< 41 TM81 channel 4 interrupt request                                       */
  TM15_IRQn                 =  42,              /*!< 42 TM81 channel 5 interrupt request                                       */
  TM16_IRQn                 =  43,              /*!< 43 TM81 channel 6 interrupt request                                       */
  TM17_IRQn                 =  44,              /*!< 44 TM81 channel 7 interrupt request                                       */
  TM11H_IRQn                =  45,              /*!< 45 when high 8-bit timer working,TM81 channel 1 interrupt request         */
  TM13H_IRQn                =  46,              /*!< 46 when high 8-bit timer working,TM81 channel 3 interrupt request         */
  ADC0_ADIREQ_N_IRQn        =  47,              /*!< 47 ADCTL0 scan end interrupt request / group A scan end interrupt
                                                     request                                                                   */
  ADC1_ADIREQ_N_IRQn        =  48,              /*!< 48 ADCTL1 scan end interrupt request / group A scan end interrupt
                                                     request                                                                   */
  ADC2_ADIREQ_N_IRQn        =  49,              /*!< 49 ADCTL2 scan end interrupt request / group A scan end interrupt
                                                     request                                                                   */
  ADC0_GBADIREQ_N_IRQn      =  50,              /*!< 50 ADCTL0 group B scan end interrupt request                              */
  ADC1_GBADIREQ_N_IRQn      =  51,              /*!< 51 ADCTL1 group B scan end interrupt request                              */
  ADC2_GBADIREQ_N_IRQn      =  52,              /*!< 52 ADCTL2 group B scan end interrupt request                              */
  ADC0_GCADIREQ_N_IRQn      =  53,              /*!< 53 ADCTL0 group C scan end interrupt request                              */
  ADC1_GCADIREQ_N_IRQn      =  54,              /*!< 54 ADCTL1 group C scan end interrupt request                              */
  ADC2_GCADIREQ_N_IRQn      =  55,              /*!< 55 ADCTL2 group C scan end interrupt request                              */
  RTC_IRQn                  =  56,              /*!< 56 Real-Time Clock interrupt request                                      */
  IT_IRQn                   =  57,              /*!< 57 15-bit interval timer interrupt request                                */
  KR_IRQn                   =  58,              /*!< 58 KEY return interrupt request                                           */
  CMP0_IRQn                 =  59,              /*!< 59 CMP0 interrupt request                                                 */
  CMP1_IRQn                 =  60,              /*!< 60 CMP1 interrupt request                                                 */
  CMP2_IRQn                 =  61,              /*!< 61 CMP2 interrupt request                                                 */
  CMP3_IRQn                 =  62,              /*!< 62 CMP3 interrupt request                                                 */
  C0ERR_IRQn                =  63,              /*!< 63 CAN0 error interrupt                                                   */
  C0REC_IRQn                =  64,              /*!< 64 CAN0 reception completion interrupt                                    */
  C0WUP_IRQn                =  65,              /*!< 65 CAN0 wakeup interrupt                                                  */
  C0TRX_IRQn                =  66,              /*!< 66 CAN0 transmission completion interrupt                                 */
  LCDB_IRQn                 =  67,              /*!< 67 The LCD BUS transfer ends interrupt request                            */
  QSPI_IRQn                 =  68,              /*!< 68 QSPI interrupt request                                                 */
  QSPI_DMAREQ_IRQn          =  69,              /*!< 69 QSPI transfer request                                                  */
  FMC_IRQn                  =  70,              /*!< 70 Flash programming finish                                               */
  OSDC_IRQn                 =  71,              /*!< 71 Oscillator stop detection                                              */
  PGI0_IRQn                 =  72,              /*!< 72 PGI0 output cutoff event                                               */
  PGI1_IRQn                 =  73,              /*!< 73 PGI1 output cutoff event                                               */
  PGI2_IRQn                 =  74,              /*!< 74 PGI2 output cutoff event                                               */
  PGI3_IRQn                 =  75,              /*!< 75 PGI3 output cutoff event                                               */
  GPT0_ELCCMPA0_IRQn        =  76,              /*!< 76 The GTCCRA of GPT0 CH0 are consistent                                  */
  GPT0_ELCCMPB0_IRQn        =  77,              /*!< 77 The GTCCRB of GPT0 CH0 are consistent                                  */
  GPT0_ELCCMPC0_IRQn        =  78,              /*!< 78 The GTCCRC of GPT0 CH0 are consistent                                  */
  GPT0_ELCCMPD0_IRQn        =  79,              /*!< 79 The GTCCRD of GPT0 CH0 are consistent                                  */
  GPT0_ELCCMPE0_IRQn        =  80,              /*!< 80 The GTCCRE of GPT0 CH0 are consistent                                  */
  GPT0_ELCCMPF0_IRQn        =  81,              /*!< 81 The GTCCRF of GPT0 CH0 are consistent                                  */
  GPT0_ELCOVF0_IRQn         =  82,              /*!< 82 The GTCNT of GPT0 CH0 overflow                                         */
  GPT0_ELCUDF0_IRQn         =  83,              /*!< 83 The GTCNT of GPT0 CH0 underflow                                        */
  GPT0_ELCCMPA1_IRQn        =  84,              /*!< 84 The GTCCRA of GPT0 CH1 are consistent                                  */
  GPT0_ELCCMPB1_IRQn        =  85,              /*!< 85 The GTCCRB of GPT0 CH1 are consistent                                  */
  GPT0_ELCCMPC1_IRQn        =  86,              /*!< 86 The GTCCRC of GPT0 CH1 are consistent                                  */
  GPT0_ELCCMPD1_IRQn        =  87,              /*!< 87 The GTCCRD of GPT0 CH1 are consistent                                  */
  GPT0_ELCCMPE1_IRQn        =  88,              /*!< 88 The GTCCRE of GPT0 CH1 are consistent                                  */
  GPT0_ELCCMPF1_IRQn        =  89,              /*!< 89 The GTCCRF of GPT0 CH1 are consistent                                  */
  GPT0_ELCOVF1_IRQn         =  90,              /*!< 90 The GTCNT of GPT0 CH1 overflow                                         */
  GPT0_ELCUDF1_IRQn         =  91,              /*!< 91 The GTCNT of GPT0 CH1 underflow                                        */
  GPT0_ELCCMPA2_IRQn        =  92,              /*!< 92 The GTCCRA of GPT0 CH2 are consistent                                  */
  GPT0_ELCCMPB2_IRQn        =  93,              /*!< 93 The GTCCRB of GPT0 CH2 are consistent                                  */
  GPT0_ELCCMPC2_IRQn        =  94,              /*!< 94 The GTCCRC of GPT0 CH2 are consistent                                  */
  GPT0_ELCCMPD2_IRQn        =  95,              /*!< 95 The GTCCRD of GPT0 CH2 are consistent                                  */
  GPT0_ELCCMPE2_IRQn        =  96,              /*!< 96 The GTCCRE of GPT0 CH2 are consistent                                  */
  GPT0_ELCCMPF2_IRQn        =  97,              /*!< 97 The GTCCRF of GPT0 CH2 are consistent                                  */
  GPT0_ELCOVF2_IRQn         =  98,              /*!< 98 The GTCNT of GPT0 CH2 overflow                                         */
  GPT0_ELCUDF2_IRQn         =  99,              /*!< 99 The GTCNT of GPT0 CH2 underflow                                        */
  GPT0_ELCCMPA3_IRQn        = 100,              /*!< 100  The GTCCRA of GPT0 CH3 are consistent                                */
  GPT0_ELCCMPB3_IRQn        = 101,              /*!< 101  The GTCCRB of GPT0 CH3 are consistent                                */
  GPT0_ELCCMPC3_IRQn        = 102,              /*!< 102  The GTCCRC of GPT0 CH3 are consistent                                */
  GPT0_ELCCMPD3_IRQn        = 103,              /*!< 103  The GTCCRD of GPT0 CH3 are consistent                                */
  GPT0_ELCCMPE3_IRQn        = 104,              /*!< 104  The GTCCRE of GPT0 CH3 are consistent                                */
  GPT0_ELCCMPF3_IRQn        = 105,              /*!< 105  The GTCCRF of GPT0 CH3 are consistent                                */
  GPT0_ELCOVF3_IRQn         = 106,              /*!< 106  The GTCNT of GPT0 CH3 overflow                                       */
  GPT0_ELCUDF3_IRQn         = 107,              /*!< 107  The GTCNT of GPT0 CH3 underflow                                      */
  GPT1_ELCCMPA0_IRQn        = 108,              /*!< 108  The GTCCRA of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPB0_IRQn        = 109,              /*!< 109  The GTCCRB of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPC0_IRQn        = 110,              /*!< 110  The GTCCRC of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPD0_IRQn        = 111,              /*!< 111  The GTCCRD of GPT0 CH1 are consistent                                */
  GPT1_ELCCMPE0_IRQn        = 112,              /*!< 112  The GTCCRE of GPT0 CH1 are consistent                                */
  GPT1_ELCCMPF0_IRQn        = 113,              /*!< 113  The GTCCRF of GPT0 CH1 are consistent                                */
  GPT1_ELCOVF0_IRQn         = 114,              /*!< 114  The GTCNT of GPT0 CH1 overflow                                       */
  GPT1_ELCUDF0_IRQn         = 115,              /*!< 115  The GTCNT of GPT0 CH1 underflow                                      */
  GPT1_ELCCMPA1_IRQn        = 116,              /*!< 116  The GTCCRA of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPB1_IRQn        = 117,              /*!< 117  The GTCCRB of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPC1_IRQn        = 118,              /*!< 118  The GTCCRC of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPD1_IRQn        = 119,              /*!< 119  The GTCCRD of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPE1_IRQn        = 120,              /*!< 120  The GTCCRE of GPT1 CH1 are consistent                                */
  GPT1_ELCCMPF1_IRQn        = 121,              /*!< 121  The GTCCRF of GPT1 CH1 are consistent                                */
  GPT1_ELCOVF1_IRQn         = 122,              /*!< 122  The GTCNT of GPT1 CH1 overflow                                       */
  GPT1_ELCUDF1_IRQn         = 123,              /*!< 123  The GTCNT of GPT1 CH1 underflow                                      */
  GPT1_ELCCMPA2_IRQn        = 124,              /*!< 124  The GTCCRA of GPT1 CH2 are consistent                                */
  GPT1_ELCCMPB2_IRQn        = 125,              /*!< 125  The GTCCRB of GPT1 CH2 are consistent                                */
  GPT1_ELCCMPC2_IRQn        = 126,              /*!< 126  The GTCCRC of GPT1 CH2 are consistent                                */
  GPT1_ELCCMPD2_IRQn        = 127,              /*!< 127  The GTCCRD of GPT1 CH2 are consistent                                */
  GPT1_ELCCMPE2_IRQn        = 128,              /*!< 128  The GTCCRE of GPT1 CH2 are consistent                                */
  GPT1_ELCCMPF2_IRQn        = 129,              /*!< 129  The GTCCRF of GPT1 CH2 are consistent                                */
  GPT1_ELCOVF2_IRQn         = 130,              /*!< 130  The GTCNT of GPT1 CH2 overflow                                       */
  GPT1_ELCUDF2_IRQn         = 131,              /*!< 131  The GTCNT of GPT1 CH2 underflow                                      */
  GPT1_ELCCMPA3_IRQn        = 132,              /*!< 132  The GTCCRA of GPT1 CH3 are consistent                                */
  GPT1_ELCCMPB3_IRQn        = 133,              /*!< 133  The GTCCRB of GPT1 CH3 are consistent                                */
  GPT1_ELCCMPC3_IRQn        = 134,              /*!< 134  The GTCCRC of GPT1 CH3 are consistent                                */
  GPT1_ELCCMPD3_IRQn        = 135,              /*!< 135  The GTCCRD of GPT1 CH3 are consistent                                */
  GPT1_ELCCMPE3_IRQn        = 136,              /*!< 136  The GTCCRE of GPT1 CH3 are consistent                                */
  GPT1_ELCCMPF3_IRQn        = 137,              /*!< 137  The GTCCRF of GPT1 CH3 are consistent                                */
  GPT1_ELCOVF3_IRQn         = 138,              /*!< 138  The GTCNT of GPT1 CH3 overflow                                       */
  GPT1_ELCUDF3_IRQn         = 139,              /*!< 139  The GTCNT of GPT1 CH3 underflow                                      */
  GPT1_ELCCMPA4_IRQn        = 140,              /*!< 140  The GTCCRA of GPT1 CH4 are consistent                                */
  GPT1_ELCCMPB4_IRQn        = 141,              /*!< 141  The GTCCRB of GPT1 CH4 are consistent                                */
  GPT1_ELCCMPC4_IRQn        = 142,              /*!< 142  The GTCCRC of GPT1 CH4 are consistent                                */
  GPT1_ELCCMPD4_IRQn        = 143,              /*!< 143  The GTCCRD of GPT1 CH4 are consistent                                */
  GPT1_ELCCMPE4_IRQn        = 144,              /*!< 144  The GTCCRE of GPT1 CH4 are consistent                                */
  GPT1_ELCCMPF4_IRQn        = 145,              /*!< 145  The GTCCRF of GPT1 CH4 are consistent                                */
  GPT1_ELCOVF4_IRQn         = 146,              /*!< 146  The GTCNT of GPT1 CH4 overflow                                       */
  GPT1_ELCUDF4_IRQn         = 147,              /*!< 147  The GTCNT of GPT1 CH4 underflow                                      */
  GPT1_ELCCMPA5_IRQn        = 148,              /*!< 148  The GTCCRA of GPT1 CH5 are consistent                                */
  GPT1_ELCCMPB5_IRQn        = 149,              /*!< 149  The GTCCRB of GPT1 CH5 are consistent                                */
  GPT1_ELCCMPC5_IRQn        = 150,              /*!< 150  The GTCCRC of GPT1 CH5 are consistent                                */
  GPT1_ELCCMPD5_IRQn        = 151,              /*!< 151  The GTCCRD of GPT1 CH5 are consistent                                */
  GPT1_ELCCMPE5_IRQn        = 152,              /*!< 152  The GTCCRE of GPT1 CH5 are consistent                                */
  GPT1_ELCCMPF5_IRQn        = 153,              /*!< 153  The GTCCRF of GPT1 CH5 are consistent                                */
  GPT1_ELCOVF5_IRQn         = 154,              /*!< 154  The GTCNT of GPT1 CH5 overflow                                       */
  GPT1_ELCUDF5_IRQn         = 155,              /*!< 155  The GTCNT of GPT1 CH5 underflow                                      */
  GPT1_ELCCMPA6_IRQn        = 156,              /*!< 156  The GTCCRA of GPT1 CH6 are consistent                                */
  GPT1_ELCCMPB6_IRQn        = 157,              /*!< 157  The GTCCRB of GPT1 CH6 are consistent                                */
  GPT1_ELCCMPC6_IRQn        = 158,              /*!< 158  The GTCCRC of GPT1 CH6 are consistent                                */
  GPT1_ELCCMPD6_IRQn        = 159,              /*!< 159  The GTCCRD of GPT1 CH6 are consistent                                */
  GPT1_ELCCMPE6_IRQn        = 160,              /*!< 160  The GTCCRE of GPT1 CH6 are consistent                                */
  GPT1_ELCCMPF6_IRQn        = 161,              /*!< 161  The GTCCRF of GPT1 CH6 are consistent                                */
  GPT1_ELCOVF6_IRQn         = 162,              /*!< 162  The GTCNT of GPT1 CH6 overflow                                       */
  GPT1_ELCUDF6_IRQn         = 163,              /*!< 163  The GTCNT of GPT1 CH6 underflow                                      */
  GPT1_ELCCMPA7_IRQn        = 164,              /*!< 164  The GTCCRA of GPT1 CH7 are consistent                                */
  GPT1_ELCCMPB7_IRQn        = 165,              /*!< 165  The GTCCRB of GPT1 CH7 are consistent                                */
  GPT1_ELCCMPC7_IRQn        = 166,              /*!< 166  The GTCCRC of GPT1 CH7 are consistent                                */
  GPT1_ELCCMPD7_IRQn        = 167,              /*!< 167  The GTCCRD of GPT1 CH7 are consistent                                */
  GPT1_ELCCMPE7_IRQn        = 168,              /*!< 168  The GTCCRE of GPT1 CH7 are consistent                                */
  GPT1_ELCCMPF7_IRQn        = 169,              /*!< 169  The GTCCRF of GPT1 CH7 are consistent                                */
  GPT1_ELCOVF7_IRQn         = 170,              /*!< 170  The GTCNT of GPT1 CH7 overflow                                       */
  GPT1_ELCUDF7_IRQn         = 171,              /*!< 171  The GTCNT of GPT1 CH7 underflow                                      */
  GPT1_ELCEDGUVW_IRQn       = 172,              /*!< 172  Hall sensor input edge                                               */
  AES_WRREQ_IRQn            = 173,              /*!< 173  AES wrreq                                                            */
  AES_RDREQ_IRQn            = 174,              /*!< 174  AES rdreq                                                            */
  RNG_RDREQ_IRQn            = 175,              /*!< 175  RNG rdreq                                                            */
  DMA0_IRQn                 = 176,              /*!< 176  DMA CH0 transfer finish                                              */
  DMA1_IRQn                 = 177,              /*!< 177  DMA CH1 transfer finish                                              */
  DMA2_IRQn                 = 178,              /*!< 178  DMA CH2 transfer finish                                              */
  DMA3_IRQn                 = 179,              /*!< 179  DMA CH3 transfer finish                                              */
  DMA4_IRQn                 = 180,              /*!< 180  DMA CH4 transfer finish                                              */
  DMA5_IRQn                 = 181,              /*!< 181  DMA CH5 transfer finish                                              */
  DMA6_IRQn                 = 182,              /*!< 182  DMA CH6 transfer finish                                              */
  DMA7_IRQn                 = 183,              /*!< 183  DMA CH7 transfer finish                                              */
  DMA8_IRQn                 = 184,              /*!< 184  DMA CH8 transfer finish                                              */
  DMA9_IRQn                 = 185,              /*!< 185  DMA CH9 transfer finish                                              */
  DMA10_IRQn                = 186,              /*!< 186  DMA CH10 transfer finish                                             */
  DMA11_IRQn                = 187,              /*!< 187  DMA CH11 transfer finish                                             */
  DMA12_IRQn                = 188,              /*!< 188  DMA CH12 transfer finish                                             */
  DMA13_IRQn                = 189,              /*!< 189  DMA CH13 transfer finish                                             */
  DMA14_IRQn                = 190,              /*!< 190  DMA CH14 transfer finish                                             */
  DMA15_IRQn                = 191,              /*!< 191  DMA CH15 transfer finish                                             */
  OCRV_IRQn                 = 192,              /*!< 192  OCRV                                                                 */
  RAMPARITY_IRQn            = 193,              /*!< 193  Ram parity                                                           */
  C1ERR_IRQn                = 194,              /*!< 194  CAN1 error interrupt                                                 */
  C1REC_IRQn                = 195,              /*!< 195  CAN1 reception completion interrupt                                  */
  C1WUP_IRQn                = 196,              /*!< 196  CAN1 wakeup interrupt                                                */
  C1TRX_IRQn                = 197,              /*!< 197  CAN1 transmission completion interrupt                               */
  IIR0WFIFOEMP_IRQn         = 198,              /*!< 198  IIR0 write FIFO empty                                                */
  IIR0WFIFOFUL_IRQn         = 199,              /*!< 199  IIR0 write FIFO full                                                 */
  IIR1WFIFOEMP_IRQn         = 200,              /*!< 200  IIR1 write FIFO empty                                                */
  IIR1WFIFOFUL_IRQn         = 201               /*!< 201  IIR1 write FIFO full                                                 */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M33 Processor and Core Peripherals  =========================== */
#define __CM33_REV                 0x0001U      /*!< CM33 Core Revision                                                        */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  1        /*!< FPU present                                                               */
#define __FPU_DP                       0        /*!< Double Precision FPU                                                      */
#define __DSP_PRESENT                  1        /* DSP extension present */
#define __SAUREGION_PRESENT            4        /*!< SAU present or not                                                        */
#define __ICACHE_PRESENT               1
#define __DCACHE_PRESENT               1

/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_star.h"                          /*!< ARM Cortex-M33 processor and core peripherals                             */
#include "system_BAT32G439.h"                   /*!< BAT32G439 System                                                          */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* ========================================  Start of section using anonymous unions  ======================================== */
#if defined (__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined (__ICCARM__)
  #pragma language=extended
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic push
  #pragma clang diagnostic ignored "-Wc11-extensions"
  #pragma clang diagnostic ignored "-Wreserved-id-macro"
  #pragma clang diagnostic ignored "-Wgnu-anonymous-struct"
  #pragma clang diagnostic ignored "-Wnested-anon-types"
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning 586
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#else
  #warning Not supported compiler type
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief DMAVEC_CTRL [CTRL] (DMA control data area)
  */
typedef struct {
  __IOM uint16_t  DMACR;                        /*!< (@ 0x00000000) DMA Control register                                       */
  __IOM uint16_t  DMBLS;                        /*!< (@ 0x00000002) DMA Block Size register                                    */
  __IOM uint16_t  DMACT;                        /*!< (@ 0x00000004) DMA Transfer Count register                                */
  __IOM uint16_t  DMRLD;                        /*!< (@ 0x00000006) DMA Transfer Count Reload register                         */
  __IOM uint32_t  DMSAR;                        /*!< (@ 0x00000008) DMA Source Address register                                */
  __IOM uint32_t  DMDAR;                        /*!< (@ 0x0000000C) DMA Destination Address register                           */
} DMAVEC_CTRL_Type;                             /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock Generate Control (CGC)
  */

typedef struct {                                /*!< (@ 0x40020400) CGC Structure                                              */
  __IOM uint8_t   CMC;                          /*!< (@ 0x00000000) Clock operaton Mode Control Register                       */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   CSC;                          /*!< (@ 0x00000004) Clock operation Status Register                            */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IM  uint8_t   OSTC;                         /*!< (@ 0x00000008) Oscillation stabilization time counter status              */
  __IM  uint8_t   RESERVED4;
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   OSTS;                         /*!< (@ 0x0000000C) Oscillation stabilization time select register             */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
  __IOM uint8_t   CKC;                          /*!< (@ 0x00000010) System clock control register                              */
  __IM  uint8_t   RESERVED8;
  __IM  uint16_t  RESERVED9;
  __IOM uint8_t   LOCKCTL;                      /*!< (@ 0x00000014) Lockup Watchdog timer enable register                      */
  __IM  uint8_t   RESERVED10;
  __IM  uint16_t  RESERVED11;
  __IOM uint8_t   PRCR;                         /*!< (@ 0x00000018) Lockup Watchdog timer enable protect register              */
  __IM  uint8_t   RESERVED12;
  __IM  uint16_t  RESERVED13;
  __IOM uint8_t   SUBCKSEL;                     /*!< (@ 0x0000001C) Subsystem Clock select register                            */
  __IM  uint8_t   RESERVED14;
  __IM  uint16_t  RESERVED15;
  __IOM uint8_t   RSTM;                         /*!< (@ 0x00000020) External reset port mask register                          */
  __IM  uint8_t   RESERVED16;
  __IM  uint16_t  RESERVED17;
  __IOM uint32_t  PERA;                         /*!< (@ 0x00000024) Peripheral enable register A                               */
  __IM  uint32_t  RESERVED18[3];
  __IOM uint8_t   OSMC;                         /*!< (@ 0x00000034) Subsystem clock supply mode control register               */
  __IM  uint8_t   RESERVED19;
  __IM  uint16_t  RESERVED20;
  __IM  uint32_t  RESERVED21[4];
  __IOM uint32_t  WDTCFG;                       /*!< (@ 0x00000048) WDTCFG                                                     */
  __IOM uint16_t  PMUKEY;                       /*!< (@ 0x0000004C) PMUKEY1                                                    */
  __IM  uint16_t  RESERVED22;
  __IOM uint16_t  PMUCTL;                       /*!< (@ 0x00000050) PMUCTL1                                                    */
  __IM  uint16_t  RESERVED23;
  __IOM uint32_t  BG1CTL;                       /*!< (@ 0x00000054) BG1CTL1                                                    */
  __IOM uint16_t  IWDTCTL;                      /*!< (@ 0x00000058) IWDTCTL1                                                   */
  __IM  uint16_t  RESERVED24;
  __IM  uint32_t  RESERVED25[489];
  __IOM uint8_t   MCKC;                         /*!< (@ 0x00000800) Main system clock control register                         */
  __IM  uint8_t   RESERVED26;
  __IM  uint16_t  RESERVED27;
  __IOM uint8_t   PLLCR;                        /*!< (@ 0x00000804) System PLL clock control register                          */
  __IM  uint8_t   RESERVED28;
  __IM  uint16_t  RESERVED29;
  __IM  uint32_t  RESERVED30[1022];
  __IOM uint8_t   HIOTRM;                       /*!< (@ 0x00001800) High-speed on-chip oscillator trimming register            */
  __IM  uint8_t   RESERVED31;
  __IM  uint16_t  RESERVED32;
  __IM  uint32_t  RESERVED33[13];
  __IOM uint8_t   HOCODIV;                      /*!< (@ 0x00001838) High-speed on-chip oscillator frequency select
                                                                    register                                                   */
  __IM  uint8_t   RESERVED34;
  __IM  uint16_t  RESERVED35;
} CGC_Type;                                     /*!< Size = 6204 (0x183c)                                                      */



/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset Function (RST)
  */

typedef struct {                                /*!< (@ 0x40020420) RST Structure                                              */
  __IM  uint8_t   RESERVED[28];
  __IM  uint8_t   RESF;                         /*!< (@ 0x0000001C) Reset flag register                                        */
} RST_Type;                                     /*!< Size = 29 (0x1d)                                                          */



/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash memory CRC operation function (High-Speed CRC) (SAF)
  */

typedef struct {                                /*!< (@ 0x40020100) SAF Structure                                              */
  __IM  uint16_t  RESERVED[412];
  __IOM uint8_t   RPECTL;                       /*!< (@ 0x00000338) RAM parity error control register                          */
  __IM  uint8_t   RESERVED1;
  __IM  uint16_t  RESERVED2[2531];
  __IOM uint8_t   CRC0CTL;                      /*!< (@ 0x00001700) Flash memory CRC control register                          */
  __IM  uint8_t   RESERVED3;
  __IM  uint16_t  RESERVED4;
  __IOM uint16_t  PGCRCL;                       /*!< (@ 0x00001704) Flash memory CRC operation result register                 */
  __IM  uint16_t  RESERVED5[63033];
  __IOM uint8_t   SFRGD;                        /*!< (@ 0x00020378) SFR guard control register                                 */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7[5952];
  __IOM uint16_t  CRCD;                         /*!< (@ 0x000231FA) CRC data register                                          */
  __IM  uint16_t  RESERVED8[88];
  __IOM uint8_t   CRCIN;                        /*!< (@ 0x000232AC) CRC input register                                         */
  __IM  uint8_t   RESERVED9;
  __IM  uint16_t  RESERVED10;
} SAF_Type;                                     /*!< Size = 144048 (0x232b0)                                                   */



/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage detector (LVD)
  */

typedef struct {                                /*!< (@ 0x40020440) LVD Structure                                              */
  __IOM uint8_t   LVIM;                         /*!< (@ 0x00000000) Voltage detection register                                 */
  __IM  uint8_t   RESERVED[3];
  __IOM uint8_t   LVIS;                         /*!< (@ 0x00000004) Voltage detection level register                           */
} LVD_Type;                                     /*!< Size = 5 (0x5)                                                            */



/* =========================================================================================================================== */
/* ================                                           SRAM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief RAM control (SRAM)
  */

typedef struct {                                /*!< (@ 0x40018000) SRAM Structure                                             */
  __IOM uint32_t  PARIOAD;                      /*!< (@ 0x00000000) PARIOAD                                                    */
  __IOM uint32_t  RAMPRCR;                      /*!< (@ 0x00000004) RAMPRCR                                                    */
} SRAM_Type;                                    /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Enhanced DMA Controller (DMA)
  */

typedef struct {                                /*!< (@ 0x40005000) DMA Structure                                              */
  __IOM uint8_t   DMAEN0;                       /*!< (@ 0x00000000) DMA activation enable register 0                           */
  __IOM uint8_t   DMAEN1;                       /*!< (@ 0x00000001) DMA activation enable register 1                           */
  __IOM uint8_t   DMAEN2;                       /*!< (@ 0x00000002) DMA activation enable register 2                           */
  __IOM uint8_t   DMAEN3;                       /*!< (@ 0x00000003) DMA activation enable register 3                           */
  __IOM uint8_t   DMAEN4;                       /*!< (@ 0x00000004) DMA activation enable register 4                           */
  __IOM uint8_t   DMAEN5;                       /*!< (@ 0x00000005) DMA activation enable register 5                           */
  __IOM uint8_t   DMAEN6;                       /*!< (@ 0x00000006) DMA activation enable register 6                           */
  __IOM uint8_t   DMAEN7;                       /*!< (@ 0x00000007) DMA activation enable register 7                           */
  __IOM uint32_t  DMABAR;                       /*!< (@ 0x00000008) DMA base address register                                  */
  __IOM uint32_t  IFPRCR;                       /*!< (@ 0x0000000C) DMA IF portect register                                    */
  __IOM uint8_t   DMAIF0;                       /*!< (@ 0x00000010) DMA interrupt flag register 0                              */
  __IOM uint8_t   DMAIF1;                       /*!< (@ 0x00000011) DMA interrupt flag register 1                              */
  __IOM uint8_t   DMAIF2;                       /*!< (@ 0x00000012) DMA interrupt flag register 2                              */
  __IOM uint8_t   DMAIF3;                       /*!< (@ 0x00000013) DMA interrupt flag register 3                              */
  __IOM uint8_t   DMAIF4;                       /*!< (@ 0x00000014) DMA interrupt flag register 4                              */
  __IOM uint8_t   DMAIF5;                       /*!< (@ 0x00000015) DMA interrupt flag register 5                              */
  __IOM uint8_t   DMAIF6;                       /*!< (@ 0x00000016) DMA interrupt flag register 6                              */
  __IOM uint8_t   DMAIF7;                       /*!< (@ 0x00000017) DMA interrupt flag register 7                              */
  __IOM uint8_t   DMASET0;                      /*!< (@ 0x00000018) DMA activation enable set register 0                       */
  __IOM uint8_t   DMASET1;                      /*!< (@ 0x00000019) DMA activation enable set register 1                       */
  __IOM uint8_t   DMASET2;                      /*!< (@ 0x0000001A) DMA activation enable set register 2                       */
  __IOM uint8_t   DMASET3;                      /*!< (@ 0x0000001B) DMA activation enable set register 3                       */
  __IOM uint8_t   DMASET4;                      /*!< (@ 0x0000001C) DMA activation enable set register 4                       */
  __IOM uint8_t   DMASET5;                      /*!< (@ 0x0000001D) DMA activation enable set register 5                       */
  __IOM uint8_t   DMASET6;                      /*!< (@ 0x0000001E) DMA activation enable set register 6                       */
  __IOM uint8_t   DMASET7;                      /*!< (@ 0x0000001F) DMA activation enable set register 7                       */
  __IOM uint8_t   DMACLR0;                      /*!< (@ 0x00000020) DMA activation enable clear register 0                     */
  __IOM uint8_t   DMACLR1;                      /*!< (@ 0x00000021) DMA activation enable clear register 1                     */
  __IOM uint8_t   DMACLR2;                      /*!< (@ 0x00000022) DMA activation enable clear register 2                     */
  __IOM uint8_t   DMACLR3;                      /*!< (@ 0x00000023) DMA activation enable clear register 3                     */
  __IOM uint8_t   DMACLR4;                      /*!< (@ 0x00000024) DMA activation enable clear register 4                     */
  __IOM uint8_t   DMACLR5;                      /*!< (@ 0x00000025) DMA activation enable clear register 5                     */
  __IOM uint8_t   DMACLR6;                      /*!< (@ 0x00000026) DMA activation enable clear register 6                     */
  __IOM uint8_t   DMACLR7;                      /*!< (@ 0x00000027) DMA activation enable clear register 7                     */
} DMA_Type;                                     /*!< Size = 40 (0x28)                                                          */



/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief DMA Vector and Control Data Area (DMAVEC)
  */

typedef struct {                                /*!< (@ 0x20000000) DMAVEC Structure                                           */
  __IOM uint8_t   VEC[16];                      /*!< (@ 0x00000000) DMA vector area                                            */
  __IOM DMAVEC_CTRL_Type CTRL[16];              /*!< (@ 0x00000010) DMA control data area                                      */
} DMAVEC_Type;                                  /*!< Size = 272 (0x110)                                                        */



/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer with window (WDT)
  */

typedef struct {                                /*!< (@ 0x40021000) WDT Structure                                              */
  __IOM uint8_t   WDTE;                         /*!< (@ 0x00000000) Watchdog timer enable register                             */
} WDT_Type;                                     /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                           IWDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer with window (IWDT)
  */

typedef struct {                                /*!< (@ 0x40021100) IWDT Structure                                             */
  __IOM uint8_t   WDTE;                         /*!< (@ 0x00000000) Watchdog timer enable register                             */
} IWDT_Type;                                    /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                           OSDC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Vibration stop detection circuit (OSDC)
  */

typedef struct {                                /*!< (@ 0x40022200) OSDC Structure                                             */
  __IOM uint32_t  SCMCTL;                       /*!< (@ 0x00000000) Vibration stop detection control register                  */
  __IOM uint32_t  SCMMD;                        /*!< (@ 0x00000004) Vibration stop detection mode register                     */
  __IOM uint32_t  SCMST;                        /*!< (@ 0x00000008) Vibration stop detection status register                   */
} OSDC_Type;                                    /*!< Size = 12 (0xc)                                                           */



/* =========================================================================================================================== */
/* ================                                           OCRV                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief 1 (OCRV)
  */

typedef struct {                                /*!< (@ 0x40022400) OCRV Structure                                             */
  __IOM uint32_t  HOCOFC;                       /*!< (@ 0x00000000) High speed internal vibration frequency correction
                                                                    control register                                           */
} OCRV_Type;                                    /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash Memory Controller (FMC)
  */

typedef struct {                                /*!< (@ 0x40020000) FMC Structure                                              */
  __IOM uint32_t  FLSTS;                        /*!< (@ 0x00000000) Flash status register                                      */
  __IOM uint32_t  FLOPMD1;                      /*!< (@ 0x00000004) Flash operation mode register 1                            */
  __IOM uint32_t  FLOPMD2;                      /*!< (@ 0x00000008) Flash operation mode register 2                            */
  __IOM uint32_t  FLERMD;                       /*!< (@ 0x0000000C) Flash erase mode register                                  */
  __IOM uint32_t  FLCERCNT;                     /*!< (@ 0x00000010) Flash chip erase control register                          */
  __IOM uint32_t  FLSERCNT;                     /*!< (@ 0x00000014) Flash sector erase control register                        */
  __IOM uint32_t  FLNVSCNT;                     /*!< (@ 0x00000018) Flash address setup time (Tnvs) control register           */
  __IOM uint32_t  FLPROCNT;                     /*!< (@ 0x0000001C) Flash program control register                             */
  __IOM uint32_t  FLPROT;                       /*!< (@ 0x00000020) Flash protect control register                             */
  __IM  uint32_t  RESERVED[6];
  __IOM uint32_t  FLRCVCNT;                     /*!< (@ 0x0000003C) Set the recovery time when flash is written                */
  __IM  uint32_t  RESERVED1[116];
  __IOM uint32_t  FLSECPR;                      /*!< (@ 0x00000210) Flash erase protection control register                    */
} FMC_Type;                                     /*!< Size = 532 (0x214)                                                        */



/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Port functions (PORT)
  */

typedef struct {                                /*!< (@ 0x40040000) PORT Structure                                             */
  __IOM uint16_t  PA;                           /*!< (@ 0x00000000) Port register A                                            */
  __IOM uint16_t  PB;                           /*!< (@ 0x00000002) Port register B                                            */
  __IOM uint16_t  PC;                           /*!< (@ 0x00000004) Port register C                                            */
  __IOM uint16_t  PD;                           /*!< (@ 0x00000006) Port register D                                            */
  __IOM uint16_t  PE;                           /*!< (@ 0x00000008) Port register E                                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  PH;                           /*!< (@ 0x0000000E) Port register H                                            */
  __IOM uint16_t  PMA;                          /*!< (@ 0x00000010) Port mode register A                                       */
  __IOM uint16_t  PMB;                          /*!< (@ 0x00000012) Port mode register B                                       */
  __IOM uint16_t  PMC;                          /*!< (@ 0x00000014) Port mode register C                                       */
  __IOM uint16_t  PMD;                          /*!< (@ 0x00000016) Port mode register D                                       */
  __IOM uint16_t  PME;                          /*!< (@ 0x00000018) Port mode register E                                       */
  __IM  uint16_t  RESERVED1[2];
  __IOM uint16_t  PMH;                          /*!< (@ 0x0000001E) Port mode register H                                       */
  __IOM uint16_t  PUA;                          /*!< (@ 0x00000020) Pull-up resistor option register A                         */
  __IOM uint16_t  PUB;                          /*!< (@ 0x00000022) Pull-up resistor option register B                         */
  __IOM uint16_t  PUC;                          /*!< (@ 0x00000024) Pull-up resistor option register C                         */
  __IOM uint16_t  PUD;                          /*!< (@ 0x00000026) Pull-up resistor option register D                         */
  __IOM uint16_t  PUE;                          /*!< (@ 0x00000028) Pull-up resistor option register E                         */
  __IM  uint16_t  RESERVED2[2];
  __IOM uint16_t  PUH;                          /*!< (@ 0x0000002E) Pull-up resistor option register H                         */
  __IOM uint16_t  PDA;                          /*!< (@ 0x00000030) Pull-down resistor option register A                       */
  __IOM uint16_t  PDB;                          /*!< (@ 0x00000032) Pull-down resistor option register B                       */
  __IOM uint16_t  PDC;                          /*!< (@ 0x00000034) Pull-down resistor option register C                       */
  __IOM uint16_t  PDD;                          /*!< (@ 0x00000036) Pull-down resistor option register D                       */
  __IOM uint16_t  PDE;                          /*!< (@ 0x00000038) Pull-down resistor option register E                       */
  __IM  uint16_t  RESERVED3[3];
  __IOM uint16_t  POMA;                         /*!< (@ 0x00000040) Port output mode register A                                */
  __IOM uint16_t  POMB;                         /*!< (@ 0x00000042) Port output mode register B                                */
  __IOM uint16_t  POMC;                         /*!< (@ 0x00000044) Port output mode register C                                */
  __IOM uint16_t  POMD;                         /*!< (@ 0x00000046) Port output mode register D                                */
  __IOM uint16_t  POME;                         /*!< (@ 0x00000048) Port output mode register E                                */
  __IM  uint16_t  RESERVED4[2];
  __IOM uint16_t  POMH;                         /*!< (@ 0x0000004E) Port output mode register H                                */
  __IOM uint16_t  PMCA;                         /*!< (@ 0x00000050) Port mode control register A                               */
  __IOM uint16_t  PMCB;                         /*!< (@ 0x00000052) Port mode control register B                               */
//  __IOM uint16_t  PMCC;                         /*!< (@ 0x00000054) Port mode control register C                               */
//  __IOM uint16_t  PMCD;                         /*!< (@ 0x00000056) Port mode control register D                               */
  __IM  uint16_t  RESERVED5[6];
  __IOM uint16_t  PSETA;                        /*!< (@ 0x00000060) Port set register A                                        */
  __IOM uint16_t  PSETB;                        /*!< (@ 0x00000062) Port set register B                                        */
  __IOM uint16_t  PSETC;                        /*!< (@ 0x00000064) Port set register C                                        */
  __IOM uint16_t  PSETD;                        /*!< (@ 0x00000066) Port set register D                                        */
  __IOM uint16_t  PSETE;                        /*!< (@ 0x00000068) Port set register E                                        */
  __IM  uint16_t  RESERVED6[2];
  __IOM uint16_t  PSETH;                        /*!< (@ 0x0000006E) Port set register H                                        */
  __IOM uint16_t  PCLRA;                        /*!< (@ 0x00000070) Port clear register A                                      */
  __IOM uint16_t  PCLRB;                        /*!< (@ 0x00000072) Port clear register B                                      */
  __IOM uint16_t  PCLRC;                        /*!< (@ 0x00000074) Port clear register C                                      */
  __IOM uint16_t  PCLRD;                        /*!< (@ 0x00000076) Port clear register D                                      */
  __IOM uint16_t  PCLRE;                        /*!< (@ 0x00000078) Port clear register E                                      */
  __IM  uint16_t  RESERVED7[2];
  __IOM uint16_t  PCLRH;                        /*!< (@ 0x0000007E) Port clear register H                                      */
  __IOM uint16_t  PREADA;                       /*!< (@ 0x00000080) Port read register A                                       */
  __IOM uint16_t  PREADB;                       /*!< (@ 0x00000082) Port read register B                                       */
  __IOM uint16_t  PREADC;                       /*!< (@ 0x00000084) Port read register C                                       */
  __IOM uint16_t  PREADD;                       /*!< (@ 0x00000086) Port read register D                                       */
  __IOM uint16_t  PREADE;                       /*!< (@ 0x00000088) Port read registerE                                        */
  __IM  uint16_t  RESERVED8[2];
  __IOM uint16_t  PREADH;                       /*!< (@ 0x0000008E) Port read register H                                       */
  __IM  uint16_t  RESERVED9[1080];
  __IOM uint8_t   PA00CFG;                      /*!< (@ 0x00000900) Alterate Output Function configuration register            */
  __IOM uint8_t   PA01CFG;                      /*!< (@ 0x00000901) Alterate Output Function configuration register            */
  __IOM uint8_t   PA02CFG;                      /*!< (@ 0x00000902) Alterate Output Function configuration register            */
  __IOM uint8_t   PA03CFG;                      /*!< (@ 0x00000903) Alterate Output Function configuration register            */
  __IOM uint8_t   PA04CFG;                      /*!< (@ 0x00000904) Alterate Output Function configuration register            */
  __IOM uint8_t   PA05CFG;                      /*!< (@ 0x00000905) Alterate Output Function configuration register            */
  __IOM uint8_t   PA06CFG;                      /*!< (@ 0x00000906) Alterate Output Function configuration register            */
  __IOM uint8_t   PA07CFG;                      /*!< (@ 0x00000907) Alterate Output Function configuration register            */
  __IOM uint8_t   PA08CFG;                      /*!< (@ 0x00000908) Alterate Output Function configuration register            */
  __IOM uint8_t   PA09CFG;                      /*!< (@ 0x00000909) Alterate Output Function configuration register            */
  __IOM uint8_t   PA10CFG;                      /*!< (@ 0x0000090A) Alterate Output Function configuration register            */
  __IOM uint8_t   PA11CFG;                      /*!< (@ 0x0000090B) Alterate Output Function configuration register            */
  __IOM uint8_t   PA12CFG;                      /*!< (@ 0x0000090C) Alterate Output Function configuration register            */
  __IOM uint8_t   PA13CFG;                      /*!< (@ 0x0000090D) Alterate Output Function configuration register            */
  __IOM uint8_t   PA14CFG;                      /*!< (@ 0x0000090E) Alterate Output Function configuration register            */
  __IOM uint8_t   PA15CFG;                      /*!< (@ 0x0000090F) Alterate Output Function configuration register            */
  __IOM uint8_t   PB00CFG;                      /*!< (@ 0x00000910) Alterate Output Function configuration register            */
  __IOM uint8_t   PB01CFG;                      /*!< (@ 0x00000911) Alterate Output Function configuration register            */
  __IOM uint8_t   PB02CFG;                      /*!< (@ 0x00000912) Alterate Output Function configuration register            */
  __IOM uint8_t   PB03CFG;                      /*!< (@ 0x00000913) Alterate Output Function configuration register            */
  __IOM uint8_t   PB04CFG;                      /*!< (@ 0x00000914) Alterate Output Function configuration register            */
  __IOM uint8_t   PB05CFG;                      /*!< (@ 0x00000915) Alterate Output Function configuration register            */
  __IOM uint8_t   PB06CFG;                      /*!< (@ 0x00000916) Alterate Output Function configuration register            */
  __IOM uint8_t   PB07CFG;                      /*!< (@ 0x00000917) Alterate Output Function configuration register            */
  __IOM uint8_t   PB08CFG;                      /*!< (@ 0x00000918) Alterate Output Function configuration register            */
  __IOM uint8_t   PB09CFG;                      /*!< (@ 0x00000919) Alterate Output Function configuration register            */
  __IOM uint8_t   PB10CFG;                      /*!< (@ 0x0000091A) Alterate Output Function configuration register            */
  __IOM uint8_t   PB11CFG;                      /*!< (@ 0x0000091B) Alterate Output Function configuration register            */
  __IOM uint8_t   PB12CFG;                      /*!< (@ 0x0000091C) Alterate Output Function configuration register            */
  __IOM uint8_t   PB13CFG;                      /*!< (@ 0x0000091D) Alterate Output Function configuration register            */
  __IOM uint8_t   PB14CFG;                      /*!< (@ 0x0000091E) Alterate Output Function configuration register            */
  __IOM uint8_t   PB15CFG;                      /*!< (@ 0x0000091F) Alterate Output Function configuration register            */
  __IOM uint8_t   PC00CFG;                      /*!< (@ 0x00000920) Alterate Output Function configuration register            */
  __IOM uint8_t   PC01CFG;                      /*!< (@ 0x00000921) Alterate Output Function configuration register            */
  __IOM uint8_t   PC02CFG;                      /*!< (@ 0x00000922) Alterate Output Function configuration register            */
  __IOM uint8_t   PC03CFG;                      /*!< (@ 0x00000923) Alterate Output Function configuration register            */
  __IOM uint8_t   PC04CFG;                      /*!< (@ 0x00000924) Alterate Output Function configuration register            */
  __IOM uint8_t   PC05CFG;                      /*!< (@ 0x00000925) Alterate Output Function configuration register            */
  __IOM uint8_t   PC06CFG;                      /*!< (@ 0x00000926) Alterate Output Function configuration register            */
  __IOM uint8_t   PC07CFG;                      /*!< (@ 0x00000927) Alterate Output Function configuration register            */
  __IOM uint8_t   PC08CFG;                      /*!< (@ 0x00000928) Alterate Output Function configuration register            */
  __IOM uint8_t   PC09CFG;                      /*!< (@ 0x00000929) Alterate Output Function configuration register            */
  __IOM uint8_t   PC10CFG;                      /*!< (@ 0x0000092A) Alterate Output Function configuration register            */
  __IOM uint8_t   PC11CFG;                      /*!< (@ 0x0000092B) Alterate Output Function configuration register            */
  __IOM uint8_t   PC12CFG;                      /*!< (@ 0x0000092C) Alterate Output Function configuration register            */
  __IOM uint8_t   PC13CFG;                      /*!< (@ 0x0000092D) Alterate Output Function configuration register            */
  __IOM uint8_t   PC14CFG;                      /*!< (@ 0x0000092E) Alterate Output Function configuration register            */
  __IOM uint8_t   PC15CFG;                      /*!< (@ 0x0000092F) Alterate Output Function configuration register            */
  __IOM uint8_t   PD00CFG;                      /*!< (@ 0x00000930) Alterate Output Function configuration register            */
  __IOM uint8_t   PD01CFG;                      /*!< (@ 0x00000931) Alterate Output Function configuration register            */
  __IOM uint8_t   PD02CFG;                      /*!< (@ 0x00000932) Alterate Output Function configuration register            */
  __IOM uint8_t   PD03CFG;                      /*!< (@ 0x00000933) Alterate Output Function configuration register            */
  __IOM uint8_t   PD04CFG;                      /*!< (@ 0x00000934) Alterate Output Function configuration register            */
  __IOM uint8_t   PD05CFG;                      /*!< (@ 0x00000935) Alterate Output Function configuration register            */
  __IOM uint8_t   PD06CFG;                      /*!< (@ 0x00000936) Alterate Output Function configuration register            */
  __IOM uint8_t   PD07CFG;                      /*!< (@ 0x00000937) Alterate Output Function configuration register            */
  __IOM uint8_t   PD08CFG;                      /*!< (@ 0x00000938) Alterate Output Function configuration register            */
  __IOM uint8_t   PD09CFG;                      /*!< (@ 0x00000939) Alterate Output Function configuration register            */
  __IOM uint8_t   PD10CFG;                      /*!< (@ 0x0000093A) Alterate Output Function configuration register            */
  __IOM uint8_t   PD11CFG;                      /*!< (@ 0x0000093B) Alterate Output Function configuration register            */
  __IOM uint8_t   PD12CFG;                      /*!< (@ 0x0000093C) Alterate Output Function configuration register            */
  __IOM uint8_t   PD13CFG;                      /*!< (@ 0x0000093D) Alterate Output Function configuration register            */
  __IOM uint8_t   PD14CFG;                      /*!< (@ 0x0000093E) Alterate Output Function configuration register            */
  __IOM uint8_t   PD15CFG;                      /*!< (@ 0x0000093F) Alterate Output Function configuration register            */
  __IOM uint8_t   PE00CFG;                      /*!< (@ 0x00000940) Alterate Output Function configuration register            */
  __IOM uint8_t   PE01CFG;                      /*!< (@ 0x00000941) Alterate Output Function configuration register            */
  __IOM uint8_t   PE02CFG;                      /*!< (@ 0x00000942) Alterate Output Function configuration register            */
  __IOM uint8_t   PE03CFG;                      /*!< (@ 0x00000943) Alterate Output Function configuration register            */
  __IOM uint8_t   PE04CFG;                      /*!< (@ 0x00000944) Alterate Output Function configuration register            */
  __IOM uint8_t   PE05CFG;                      /*!< (@ 0x00000945) Alterate Output Function configuration register            */
  __IOM uint8_t   PE06CFG;                      /*!< (@ 0x00000946) Alterate Output Function configuration register            */
  __IOM uint8_t   PE07CFG;                      /*!< (@ 0x00000947) Alterate Output Function configuration register            */
  __IOM uint8_t   PE08CFG;                      /*!< (@ 0x00000948) Alterate Output Function configuration register            */
  __IOM uint8_t   PE09CFG;                      /*!< (@ 0x00000949) Alterate Output Function configuration register            */
  __IOM uint8_t   PE10CFG;                      /*!< (@ 0x0000094A) Alterate Output Function configuration register            */
  __IOM uint8_t   PE11CFG;                      /*!< (@ 0x0000094B) Alterate Output Function configuration register            */
  __IOM uint8_t   PE12CFG;                      /*!< (@ 0x0000094C) Alterate Output Function configuration register            */
  __IOM uint8_t   PE13CFG;                      /*!< (@ 0x0000094D) Alterate Output Function configuration register            */
  __IOM uint8_t   PE14CFG;                      /*!< (@ 0x0000094E) Alterate Output Function configuration register            */
  __IOM uint8_t   PE15CFG;                      /*!< (@ 0x0000094F) Alterate Output Function configuration register            */
  __IM  uint16_t  RESERVED10[25];
  __IM  uint8_t   RESERVED11;
  __IOM uint8_t   PH03CFG;                      /*!< (@ 0x00000983) Alterate Output Function configuration register            */
  __IOM uint8_t   PH04CFG;                      /*!< (@ 0x00000984) Alterate Output Function configuration register            */
  __IM  uint8_t   RESERVED12;
  __IM  uint16_t  RESERVED13[45];
  __IOM uint8_t   INTP0PCFG;                    /*!< (@ 0x000009E0) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP1PCFG;                    /*!< (@ 0x000009E1) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP2PCFG;                    /*!< (@ 0x000009E2) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP3PCFG;                    /*!< (@ 0x000009E3) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP4PCFG;                    /*!< (@ 0x000009E4) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP5PCFG;                    /*!< (@ 0x000009E5) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP6PCFG;                    /*!< (@ 0x000009E6) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP7PCFG;                    /*!< (@ 0x000009E7) Alternate INTP pin configuration register                  */
} PORT_Type;                                    /*!< Size = 2536 (0x9e8)                                                       */



/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Miscellaneous function (MISC)
  */

typedef struct {                                /*!< (@ 0x40040470) MISC Structure                                             */
  __IOM uint8_t   NFEN0;                        /*!< (@ 0x00000000) Noise filter enable register 0                             */
  __IOM uint8_t   NFEN1;                        /*!< (@ 0x00000001) Noise filter enable register 1                             */
  __IOM uint8_t   NFEN2;                        /*!< (@ 0x00000002) Noise filter enable register 2                             */
  __IOM uint8_t   ISC;                          /*!< (@ 0x00000003) Input switch control register                              */
  __IOM uint8_t   TIOS0;                        /*!< (@ 0x00000004) Timer I/O select register 0                                */
  __IOM uint8_t   TIOS1;                        /*!< (@ 0x00000005) Timer I/O select register 1                                */
  __IM  uint8_t   RESERVED[6];
  __IOM uint8_t   RTCCL;                        /*!< (@ 0x0000000C) Real-time clock select register                            */
  __IOM uint8_t   TRNGCKS;                      /*!< (@ 0x0000000D) TRNG clock div select register                             */
} MISC_Type;                                    /*!< Size = 14 (0xe)                                                           */



/* =========================================================================================================================== */
/* ================                                          PPORGA                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Selection of reading data (PPORGA)
  */

typedef struct {                                /*!< (@ 0x4004087B) PPORGA Structure                                           */
  __IOM uint8_t   PMS;                          /*!< (@ 0x00000000) Port mode select register                                  */
} PPORGA_Type;                                  /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock/Buzzer output controller (PCBZ)
  */

typedef struct {                                /*!< (@ 0x40040FA0) PCBZ Structure                                             */
  __IM  uint8_t   RESERVED[5];
  __IOM uint8_t   CKS0;                         /*!< (@ 0x00000005) Clock output select registers 0                            */
  __IOM uint8_t   CKS1;                         /*!< (@ 0x00000006) Clock output select registers 1                            */
} PCBZ_Type;                                    /*!< Size = 7 (0x7)                                                            */


/* =========================================================================================================================== */
/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0)
  */

typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
  __IM  uint16_t  SSR00;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR01;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR00;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR01;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR00;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR01;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR00;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR01;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE0;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS0;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST0;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS0;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO0;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE0;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL0;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR00;                       /*!< (@ 0x00000040) Serial data register 00                                    */
    __IOM uint8_t SIO00;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD0;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR01;                       /*!< (@ 0x00000042) Serial data register 01                                    */
    __IOM uint8_t SIO01;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD0;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI0_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     : 14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;

	__IOM uint16_t     :  2;
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;	
//	__IOM uint16_t  SO;							/*!< */

	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
//	__IOM uint16_t  SOE;						/*!< */
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
  __IM  uint16_t  RESERVED1[119];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART0_TypeDef;



typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];

	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;
	
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
  __IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
  __IM  uint16_t  RESERVED5[119];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6[1];
} I2C0_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1[1];
	__IM  uint16_t  SSR;						/*!< */

	__IOM uint16_t  RESERVED3[1];
	__IOM uint16_t  SIR;						/*!< */
	
	__IOM uint16_t  RESERVED5[1];
	__IOM uint16_t  SMR;						/*!< */
	
	__IOM uint16_t  RESERVED7[1];
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
  __IM  uint16_t  RESERVED9[119];
	
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

//	__IM  uint16_t  RESERVED10[26];
} I2C1_TypeDef;



typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
	union {
		SCI0_TypeDef	SCI;
		UART0_TypeDef 	UART0;
		I2C0_TypeDef	I2C0;
		I2C1_TypeDef	I2C1;

	};
} SCI0_Type;                                    /*!< Size = 584 (0x248)                  																				*/


/* =========================================================================================================================== */
/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0)
  */

typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
  __IM  uint16_t  SSR10;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR11;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR10;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR11;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR10;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR11;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR10;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR11;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE1;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS1;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST1;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS1;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO1;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE1;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL1;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR10;                       /*!< (@ 0x00000040) Serial data register 00                                    */
    __IOM uint8_t SIO10;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD1;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR11;                       /*!< (@ 0x00000042) Serial data register 01                                    */
    __IOM uint8_t SIO11;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD1;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI1_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     : 14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;

	__IOM uint16_t     :  2;
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;	
//	__IOM uint16_t  SO;							/*!< */

	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
//	__IOM uint16_t  SOE;						/*!< */
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
  __IM  uint16_t  RESERVED1[119];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART1_TypeDef;



typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];

	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;
	
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
  __IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
  __IM  uint16_t  RESERVED5[119];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6[1];
} I2C2_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1[1];
	__IM  uint16_t  SSR;						/*!< */

	__IOM uint16_t  RESERVED3[1];
	__IOM uint16_t  SIR;						/*!< */
	
	__IOM uint16_t  RESERVED5[1];
	__IOM uint16_t  SMR;						/*!< */
	
	__IOM uint16_t  RESERVED7[1];
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
  __IM  uint16_t  RESERVED9[119];
	
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

//	__IM  uint16_t  RESERVED10[26];
} I2C3_TypeDef;



typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
	union {
		SCI1_TypeDef	SCI;
		UART1_TypeDef 	UART1;
		I2C2_TypeDef	I2C2;
		I2C3_TypeDef	I2C3;

	};
} SCI1_Type;                                    /*!< Size = 584 (0x248)                  																				*/


typedef struct {                                /*!< (@ 0x40041000) SCI0 Structure                                             */
  __IM  uint16_t  SSRm0;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSRm1;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIRm0;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIRm1;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMRm0;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMRm1;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCRm0;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCRm1;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDRm0;                       /*!< (@ 0x00000110) Serial data register 00                                    */
    __IOM uint8_t SIOm0;                        /*!< (@ 0x00000110) SPI data register                                          */
    __IOM uint8_t TXD;                         /*!< (@ 0x00000110) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDRm1;                       /*!< (@ 0x00000112) Serial data register 01                                    */
    __IOM uint8_t SIOm1;                        /*!< (@ 0x00000112) SPI data register                                          */
    __IOM uint8_t RXD;                         /*!< (@ 0x00000112) UART receive data register                                 */
  };
} SCI_Type;                                    /*!< Size = 276 (0x114)                                                        */


/* =========================================================================================================================== * /
/ * ================                                           SCI1                                            ================ * /
/ * =========================================================================================================================== */



/* *
  * @brief Serial Communication Interface 1 with UART, SPI and simplified I2C supported (SCI1)
  */

//typedef struct {                                /*!< (@ 0x40046400) SCI1 Structure                                             */
//  __IM  uint16_t  SSR10;                        /*!< (@ 0x00000000) Serial status register mn                                  */
//  __IM  uint16_t  SSR11;                        /*!< (@ 0x00000002) Serial status register mn                                  */
//  __IOM uint16_t  SIR10;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
//  __IOM uint16_t  SIR11;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
//  __IOM uint16_t  SMR10;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
//  __IOM uint16_t  SMR11;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
//  __IOM uint16_t  SCR10;                        /*!< (@ 0x0000000C) Serial communication operation setting register
//                                                                    mn                                                         */
//  __IOM uint16_t  SCR11;                        /*!< (@ 0x0000000E) Serial communication operation setting register
//                                                                    mn                                                         */
//  __IM  uint16_t  SE1;                          /*!< (@ 0x00000010) Serial channel enable status register 1                    */
//  __IOM uint16_t  SS1;                          /*!< (@ 0x00000012) Serial channel start register 1                            */
//  __IOM uint16_t  ST1;                          /*!< (@ 0x00000014) Serial channel stop register 1                             */
//  __IOM uint16_t  SPS1;                         /*!< (@ 0x00000016) Serial clock select register 1                             */
//  __IOM uint16_t  SO1;                          /*!< (@ 0x00000018) Serial output register 1                                   */
//  __IOM uint16_t  SOE1;                         /*!< (@ 0x0000001A) Serial output enable register 1                            */
//  __IM  uint16_t  RESERVED[2];
//  __IOM uint16_t  SOL1;                         /*!< (@ 0x00000020) Serial output level register 1                             */
//  __IM  uint16_t  RESERVED1[119];
//  
//  union {
//    __IOM uint16_t SDR10;                       /*!< (@ 0x00000040) Serial data register 10                                    */
//    __IOM uint8_t SIO10;                        /*!< (@ 0x00000040) SPI data register                                          */
//    __IOM uint8_t TXD1;                         /*!< (@ 0x00000040) UART transmit data register                                */
//  };
//  
//  union {
//    __IOM uint16_t SDR11;                       /*!< (@ 0x00000042) Serial data register 11                                    */
//    __IOM uint8_t SIO11;                        /*!< (@ 0x00000042) SPI data register                                          */
//    __IOM uint8_t RXD1;                         /*!< (@ 0x00000042) UART receive data register                                 */
//  };
//} SCI1X_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


//typedef struct {
//	__IM  uint16_t  TSSR;						/*!< */
//	__IM  uint16_t  RSSR;						/*!< */
//	__IOM uint16_t  TSIR;						/*!< */
//	__IOM uint16_t  RSIR;						/*!< */	
//	__IOM uint16_t  TSMR;						/*!< */
//	__IOM uint16_t  RSMR;						/*!< */
//	__IOM uint16_t  TSCR;						/*!< */
//	__IOM uint16_t  RSCR;						/*!< */
//	
//	__IM  uint16_t  SE :  2;					/*!< */
//	__IM  uint16_t     :  14;
//	
//	__IOM uint16_t  SS :  2;					/*!< */
//	__IOM uint16_t	   : 14;
//	__IOM uint16_t  ST :  2;					/*!< */
//	__IOM uint16_t	   : 14;
//	
//	__IOM uint16_t  SPS: 4;						/*!< */
//	__IOM uint16_t     :12;

//	__IOM uint16_t     :  2;					/*!< */	
//	__IOM uint16_t  SO :  2;					/*!< */
//	__IOM uint16_t	   : 12;
//	__IOM uint16_t  SOE:  2;					/*!< */
//	__IOM uint16_t	   : 14;
//	__IM  uint16_t  RESERVED5[2];
//	__IOM uint16_t  SOL;						/*!< */
//  __IM  uint16_t  RESERVED1[119];

//	__IOM uint16_t TXD : 9;
//	__IOM uint16_t TSDR: 7;
//	__IOM uint16_t RXD : 9;						/*!< */
//	__IOM uint16_t RSDR: 7;
//} UART1_TypeDef;

//typedef struct {
//	__IM  uint16_t  SSR;						/*!< */
//	__IM  uint16_t  RESERVED1[1];
//	
//	__IOM uint16_t  SIR;						/*!< */
//	__IOM uint16_t  RESERVED2[1];
//	
//	__IOM uint16_t  SMR;						/*!< */
//	__IOM uint16_t  RESERVED3[1];
//	
//	__IOM uint16_t  SCR;						/*!< */
//	__IOM uint16_t  RESERVED4[1];
//	
//	__IM  uint16_t  SE :  1;					/*!< */
//	__IM  uint16_t     :  15;

//	__IOM uint16_t  SS :  1;					/*!< */
//	__IOM uint16_t	   : 15;

//	__IOM uint16_t  ST :  1;					/*!< */
//	__IOM uint16_t	   : 15;
//	
//	__IOM uint16_t  SPS:  4;					/*!< */
//	__IOM uint16_t     : 12;
//	
//	__IOM uint16_t  SO :  1;					/*!< */
//	__IOM uint16_t	   :  7;
//	__IOM uint16_t  CKO:  1;					/*!< */
//	__IOM uint16_t	   :  7;

//	__IOM uint16_t  SOE:  1;					/*!< */
//	__IOM uint16_t	   : 15;

//  __IM  uint16_t  RESERVED7[3];
//	
//  __IM  uint16_t  RESERVED5[119];
//	
////	__IM  uint16_t  RESERVED5[18];

//	__IOM uint16_t SIO: 8;
//	__IOM uint16_t    : 1;
//	__IOM uint16_t SDR: 7;

//	__IM  uint16_t  RESERVED6;
//} I2C2X_TypeDef;

//typedef struct {
//	__IM  uint16_t  RESERVED1;
//	__IM  uint16_t  SSR;						/*!< */
//	
//	__IM  uint16_t  RESERVED3;
//	__IOM uint16_t  SIR;						/*!< */
//	
//	__IM  uint16_t  RESERVED5;
//	__IOM uint16_t  SMR;						/*!< */
//	
//	__IM  uint16_t  RESERVED7;
//	__IOM uint16_t  SCR;						/*!< */
//	
//	__IM  uint16_t     :  1;
//	__IM  uint16_t  SE :  1;					/*!< */
//	__IM  uint16_t     : 14;

//	__IOM uint16_t     :  1;
//	__IOM uint16_t  SS :  1;					/*!< */
//	__IOM uint16_t	   : 14;

//	__IOM uint16_t     :  1;
//	__IOM uint16_t  ST :  1;					/*!< */
//	__IOM uint16_t	   : 14;
//	
//	__IOM uint16_t     :  4;
//	__IOM uint16_t  SPS:  4;					/*!< */
//	__IOM uint16_t     :  8;
//	
//	__IOM uint16_t	   :  1;
//	__IOM uint16_t  SO :  1;					/*!< */
//	__IOM uint16_t	   :  7;
//	__IOM uint16_t  CKO:  1;					/*!< */
//	__IOM uint16_t	   :  6;

//	__IOM uint16_t     :  1;
//	__IOM uint16_t  SOE:  1;					/*!< */
//	__IOM uint16_t	   : 14;

//  __IM  uint16_t  RESERVED8[3];
//	
//  __IM  uint16_t  RESERVED9[119];
////	__IM  uint16_t  RESERVED9[19];

//	__IOM uint16_t SIO: 8;
//	__IOM uint16_t	  : 1;
//	__IOM uint16_t SDR: 7;
//} I2C3X_TypeDef;

//typedef struct {                                /*!< (@ 0x40046400) SCI1 Structure                                             */
//	union {
//		SCI1X_TypeDef	SCI;
//		UART1X_TypeDef	UART1;
//		I2C2X_TypeDef	I2C2;
//		I2C3X_TypeDef	I2C3;
//	};
//} SCI1X_Type;                                    /*!< Size = 524 (0x20c)                                                        */


/* =========================================================================================================================== * /
/ * ================                                           SCI2                                            ================ * /
/ * =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 2 with UART, SPI and simplified I2C supported (SCI2)
  */

typedef struct {                                /*!< (@ 0x40046800) SCI2 Structure                                             */
  __IM  uint16_t  SSR20;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR21;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR20;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR21;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR20;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR21;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR20;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR21;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE2;                          /*!< (@ 0x00000010) Serial channel enable status register 2                    */
  __IOM uint16_t  SS2;                          /*!< (@ 0x00000012) Serial channel start register 2                            */
  __IOM uint16_t  ST2;                          /*!< (@ 0x00000014) Serial channel stop register 2                             */
  __IOM uint16_t  SPS2;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO2;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE2;                         /*!< (@ 0x0000001A) Serial output enable register 2                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL2;                         /*!< (@ 0x00000020) Serial output level register 2                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR20;                       /*!< (@ 0x00000040) Serial data register 20                                    */
    __IOM uint8_t SIO20;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD2;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR21;                       /*!< (@ 0x00000042) Serial data register 21                                    */
    __IOM uint8_t SIO21;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD2;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI2_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */
	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */
	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS: 4;						/*!< */
	__IOM uint16_t     :12;
	
	__IOM uint16_t     :  2;					/*!< */
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;
	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
  __IM  uint16_t  RESERVED1[119];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART2_TypeDef;

typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];
	
	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;

	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
  __IM  uint16_t  RESERVED5[119];
//	__IM  uint16_t  RESERVED5[18];

	__IOM uint8_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6;
} I2C4_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1;
	__IM  uint16_t  SSR;						/*!< */
	
	__IM  uint16_t  RESERVED3;
	__IOM uint16_t  SIR;						/*!< */
	
	__IM  uint16_t  RESERVED5;
	__IOM uint16_t  SMR;						/*!< */
	
	__IM  uint16_t  RESERVED7;
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
  __IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t	   :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
  __IM  uint16_t  RESERVED2[119];
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t	  : 1;
	__IOM uint16_t SDR: 7;
} I2C5_TypeDef;

typedef struct {                                /*!< (@ 0x40046800) SCI1 Structure                                             */
	union {
		SCI2_TypeDef	SCI;
		UART2_TypeDef	UART2;
		I2C4_TypeDef	I2C4;
		I2C5_TypeDef	I2C5;
	};
} SCI2_Type;                                    /*!< Size = 524 (0x20c)                                                        */

/* =========================================================================================================================== * /
/ * ================                                           SCI3                                            ================ * /
/ * =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 2 with UART, SPI and simplified I2C supported (SCI2)
  */

typedef struct {                                /*!< (@ 0x40046800) SCI2 Structure                                             */
  __IM  uint16_t  SSR30;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR31;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR30;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR31;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR30;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR31;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR30;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR31;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE3;                          /*!< (@ 0x00000010) Serial channel enable status register 2                    */
  __IOM uint16_t  SS3;                          /*!< (@ 0x00000012) Serial channel start register 2                            */
  __IOM uint16_t  ST3;                          /*!< (@ 0x00000014) Serial channel stop register 2                             */
  __IOM uint16_t  SPS3;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO3;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE3;                         /*!< (@ 0x0000001A) Serial output enable register 2                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL3;                         /*!< (@ 0x00000020) Serial output level register 2                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR30;                       /*!< (@ 0x00000040) Serial data register 20                                    */
    __IOM uint8_t SIO30;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD3;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR31;                       /*!< (@ 0x00000042) Serial data register 21                                    */
    __IOM uint8_t SIO31;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD3;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI3_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */
	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */
	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS: 4;						/*!< */
	__IOM uint16_t     :12;
	
	__IOM uint16_t     :  2;					/*!< */
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;
	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
  __IM  uint16_t  RESERVED1[119];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART3_TypeDef;

typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];
	
	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;

	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
  __IM  uint16_t  RESERVED5[119];
//	__IM  uint16_t  RESERVED5[18];

	__IOM uint8_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6;
} I2C6_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1;
	__IM  uint16_t  SSR;						/*!< */
	
	__IM  uint16_t  RESERVED3;
	__IOM uint16_t  SIR;						/*!< */
	
	__IM  uint16_t  RESERVED5;
	__IOM uint16_t  SMR;						/*!< */
	
	__IM  uint16_t  RESERVED7;
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
  __IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t	   :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
  __IM  uint16_t  RESERVED2[119];
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t	  : 1;
	__IOM uint16_t SDR: 7;
} I2C7_TypeDef;

typedef struct {                                /*!< (@ 0x40046800) SCI1 Structure                                             */
	union {
		SCI3_TypeDef	SCI;
		UART3_TypeDef	UART3;
		I2C6_TypeDef	I2C6;
		I2C7_TypeDef	I2C7;
	};
} SCI3_Type;                                    /*!< Size = 524 (0x20c)                                                        */



#if 1

/* =========================================================================================================================== */
/* ================                                           SCI                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0, SCI1,SCI2, SCI3)
  */

//typedef struct {                                /*!< (@ 0x40041000) SCI0 Structure                                             */
//  __IM  uint16_t  SSRm0;                        /*!< (@ 0x00000000) Serial status register mn                                  */
//  __IM  uint16_t  SSRm1;                        /*!< (@ 0x00000002) Serial status register mn                                  */
//  __IOM uint16_t  SIRm0;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
//  __IOM uint16_t  SIRm1;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
//  __IOM uint16_t  SMRm0;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
//  __IOM uint16_t  SMRm1;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
//  __IOM uint16_t  SCRm0;                        /*!< (@ 0x0000000C) Serial communication operation setting register
//                                                                    mn                                                         */
//  __IOM uint16_t  SCRm1;                        /*!< (@ 0x0000000E) Serial communication operation setting register
//                                                                    mn                                                         */
//  __IM  uint16_t  SE;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
//  __IOM uint16_t  SS;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
//  __IOM uint16_t  ST;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
//  __IOM uint16_t  SPS;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
//  __IOM uint16_t  SO;                          /*!< (@ 0x00000018) Serial output register 0                                   */
//  __IOM uint16_t  SOE;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
//  __IM  uint16_t  RESERVED[2];
//  __IOM uint16_t  SOL;                         /*!< (@ 0x00000020) Serial output level register 0                             */
//  __IM  uint16_t  RESERVED1[119];
//  
//  union {
//    __IOM uint16_t SDRm0;                       /*!< (@ 0x00000110) Serial data register 00                                    */
//    __IOM uint8_t SIOm0;                        /*!< (@ 0x00000110) SPI data register                                          */
//    __IOM uint8_t TXD;                         /*!< (@ 0x00000110) UART transmit data register                                */
//  };
//  
//  union {
//    __IOM uint16_t SDRm1;                       /*!< (@ 0x00000112) Serial data register 01                                    */
//    __IOM uint8_t SIOm1;                        /*!< (@ 0x00000112) SPI data register                                          */
//    __IOM uint8_t RXD;                         /*!< (@ 0x00000112) UART receive data register                                 */
//  };
//} SCI_Type;                                    /*!< Size = 276 (0x114)                                                        */


#else
/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0, SCI1,SCI2, SCI3)
  */

typedef struct {                                /*!< (@ 0x40041000) SCI0 Structure                                             */
  __IM  uint16_t  SSR00;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR01;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR00;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR01;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR00;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR01;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR00;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR01;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE0;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS0;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST0;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS0;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO0;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE0;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL0;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR00;                       /*!< (@ 0x00000110) Serial data register 00                                    */
    __IOM uint8_t SIO00;                        /*!< (@ 0x00000110) SPI data register                                          */
    __IOM uint8_t TXD0;                         /*!< (@ 0x00000110) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR01;                       /*!< (@ 0x00000112) Serial data register 01                                    */
    __IOM uint8_t SIO01;                        /*!< (@ 0x00000112) SPI data register                                          */
    __IOM uint8_t RXD0;                         /*!< (@ 0x00000112) UART receive data register                                 */
  };
} SCI0_Type;                                    /*!< Size = 276 (0x114)                                                        */


/* =========================================================================================================================== */
/* ================                                           SCI1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 1 with UART, SPI and simplified I2C supported (SCI1)
  */

typedef struct {                                /*!< (@ 0x40041200) SCI1 Structure                                             */
  __IM  uint16_t  SSR10;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR11;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR10;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR11;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR10;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR11;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR10;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR11;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE1;                          /*!< (@ 0x00000010) Serial channel enable status register 1                    */
  __IOM uint16_t  SS1;                          /*!< (@ 0x00000012) Serial channel start register 1                            */
  __IOM uint16_t  ST1;                          /*!< (@ 0x00000014) Serial channel stop register 1                             */
  __IOM uint16_t  SPS1;                         /*!< (@ 0x00000016) Serial clock select register 1                             */
  __IOM uint16_t  SO1;                          /*!< (@ 0x00000018) Serial output register 1                                   */
  __IOM uint16_t  SOE1;                         /*!< (@ 0x0000001A) Serial output enable register 1                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL1;                         /*!< (@ 0x00000020) Serial output level register 1                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR10;                       /*!< (@ 0x00000110) Serial data register 10                                    */
    __IOM uint8_t SIO10;                        /*!< (@ 0x00000110) SPI data register                                          */
    __IOM uint8_t TXD1;                         /*!< (@ 0x00000110) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR11;                       /*!< (@ 0x00000112) Serial data register 11                                    */
    __IOM uint8_t SIO11;                        /*!< (@ 0x00000112) SPI data register                                          */
    __IOM uint8_t RXD1;                         /*!< (@ 0x00000112) UART receive data register                                 */
  };
} SCI1_Type;                                    /*!< Size = 276 (0x114)                                                        */



/* =========================================================================================================================== */
/* ================                                           SCI2                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 2 with UART, SPI and simplified I2C supported (SCI2)
  */

typedef struct {                                /*!< (@ 0x40041400) SCI2 Structure                                             */
  __IM  uint16_t  SSR20;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR21;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR20;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR21;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR20;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR21;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR20;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR21;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE2;                          /*!< (@ 0x00000010) Serial channel enable status register 2                    */
  __IOM uint16_t  SS2;                          /*!< (@ 0x00000012) Serial channel start register 2                            */
  __IOM uint16_t  ST2;                          /*!< (@ 0x00000014) Serial channel stop register 2                             */
  __IOM uint16_t  SPS2;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO2;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE2;                         /*!< (@ 0x0000001A) Serial output enable register 2                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL2;                         /*!< (@ 0x00000020) Serial output level register 2                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR20;                       /*!< (@ 0x00000110) Serial data register 20                                    */
    __IOM uint8_t SIO20;                        /*!< (@ 0x00000110) SPI data register                                          */
    __IOM uint8_t TXD2;                         /*!< (@ 0x00000110) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR21;                       /*!< (@ 0x00000112) Serial data register 21                                    */
    __IOM uint8_t SIO21;                        /*!< (@ 0x00000112) SPI data register                                          */
    __IOM uint8_t RXD2;                         /*!< (@ 0x00000112) UART receive data register                                 */
  };
} SCI2_Type;                                    /*!< Size = 276 (0x114)                                                        */



/* =========================================================================================================================== */
/* ================                                           SCI3                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 3 with UART, SPI and simplified I2C supported (SCI3)
  */

typedef struct {                                /*!< (@ 0x40041600) SCI3 Structure                                             */
  __IM  uint16_t  SSR30;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR31;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR30;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR31;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR30;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR31;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR30;                        /*!< (@ 0x0000000C) Serial communication operation setting register            */
  __IOM uint16_t  SCR31;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE3;                          /*!< (@ 0x00000010) Serial channel enable status register 3                    */
  __IOM uint16_t  SS3;                          /*!< (@ 0x00000012) Serial channel start register 3                            */
  __IOM uint16_t  ST3;                          /*!< (@ 0x00000014) Serial channel stop register 3                             */
  __IOM uint16_t  SPS3;                         /*!< (@ 0x00000016) Serial clock select register 3                             */
  __IOM uint16_t  SO3;                          /*!< (@ 0x00000018) Serial output register 3                                   */
  __IOM uint16_t  SOE3;                         /*!< (@ 0x0000001A) Serial output enable register 3                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL3;                         /*!< (@ 0x00000020) Serial output level register 3                             */
  __IM  uint16_t  RESERVED1[119];
  
  union {
    __IOM uint16_t SDR30;                       /*!< (@ 0x00000110) Serial data register 30                                    */
    __IOM uint8_t SIO30;                        /*!< (@ 0x00000110) SPI data register                                          */
    __IOM uint8_t TXD3;                         /*!< (@ 0x00000110) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR31;                       /*!< (@ 0x00000112) Serial data register 31                                    */
    __IOM uint8_t SIO31;                        /*!< (@ 0x00000112) SPI data register                                          */
    __IOM uint8_t RXD3;                         /*!< (@ 0x00000112) UART receive data register                                 */
  };
} SCI3_Type;                                    /*!< Size = 276 (0x114)                                                        */

#endif

/* =========================================================================================================================== */
/* ================                                           TM80                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer 8 (TM80)
  */

typedef struct {                                /*!< (@ 0x40041C00) TM80 Structure                                             */
  __IM  uint16_t  RESERVED[192];
  __IM  uint16_t  TCR00;                        /*!< (@ 0x00000180) Timer count register 00                                    */
  __IM  uint16_t  TCR01;                        /*!< (@ 0x00000182) Timer count register 01                                    */
  __IM  uint16_t  TCR02;                        /*!< (@ 0x00000184) Timer count register 02                                    */
  __IM  uint16_t  TCR03;                        /*!< (@ 0x00000186) Timer count register 03                                    */
  __IM  uint16_t  TCR04;                        /*!< (@ 0x00000188) Timer count register 04                                    */
  __IM  uint16_t  TCR05;                        /*!< (@ 0x0000018A) Timer count register 05                                    */
  __IM  uint16_t  TCR06;                        /*!< (@ 0x0000018C) Timer count register 06                                    */
  __IM  uint16_t  TCR07;                        /*!< (@ 0x0000018E) Timer count register 07                                    */
  __IOM uint16_t  TMR00;                        /*!< (@ 0x00000190) Timer mode register mn                                     */
  __IOM uint16_t  TMR01;                        /*!< (@ 0x00000192) Timer mode register mn                                     */
  __IOM uint16_t  TMR02;                        /*!< (@ 0x00000194) Timer mode register mn                                     */
  __IOM uint16_t  TMR03;                        /*!< (@ 0x00000196) Timer mode register mn                                     */
  __IOM uint16_t  TMR04;                        /*!< (@ 0x00000198) Timer mode register mn                                     */
  __IOM uint16_t  TMR05;                        /*!< (@ 0x0000019A) Timer mode register mn                                     */
  __IOM uint16_t  TMR06;                        /*!< (@ 0x0000019C) Timer mode register mn                                     */
  __IOM uint16_t  TMR07;                        /*!< (@ 0x0000019E) Timer mode register mn                                     */
  __IM  uint16_t  TSR00;                        /*!< (@ 0x000001A0) Timer status register mn                                   */
  __IM  uint16_t  TSR01;                        /*!< (@ 0x000001A2) Timer status register mn                                   */
  __IM  uint16_t  TSR02;                        /*!< (@ 0x000001A4) Timer status register mn                                   */
  __IM  uint16_t  TSR03;                        /*!< (@ 0x000001A6) Timer status register mn                                   */
  __IM  uint16_t  TSR04;                        /*!< (@ 0x000001A8) Timer status register mn                                   */
  __IM  uint16_t  TSR05;                        /*!< (@ 0x000001AA) Timer status register mn                                   */
  __IM  uint16_t  TSR06;                        /*!< (@ 0x000001AC) Timer status register mn                                   */
  __IM  uint16_t  TSR07;                        /*!< (@ 0x000001AE) Timer status register mn                                   */
  __IM  uint16_t  TE0;                          /*!< (@ 0x000001B0) Timer channel enable status register m                     */
  __IOM uint16_t  TS0;                          /*!< (@ 0x000001B2) Timer channel start register 0                             */
  __IOM uint16_t  TT0;                          /*!< (@ 0x000001B4) Timer channel stop register 0                              */
  __IOM uint16_t  TPS0;                         /*!< (@ 0x000001B6) Timer clock select register 0                              */
  __IOM uint16_t  TO0;                          /*!< (@ 0x000001B8) Timer output register 0                                    */
  __IOM uint16_t  TOE0;                         /*!< (@ 0x000001BA) Timer output enable register 0                             */
  __IOM uint16_t  TOL0;                         /*!< (@ 0x000001BC) Timer output level register 0                              */
  __IOM uint16_t  TOM0;                         /*!< (@ 0x000001BE) Timer output mode register 0                               */
  __IM  uint16_t  RESERVED1[168];
  __IOM uint16_t  TDR00;                        /*!< (@ 0x00000310) Timer data register 00                                     */
  
  union {
    __IOM uint16_t TDR01;                       /*!< (@ 0x00000312) Timer data register 01                                     */
    
    struct {
      __IOM uint8_t TDR01L;                     /*!< (@ 0x00000312) Timer data lower register 01                               */
      __IOM uint8_t TDR01H;                     /*!< (@ 0x00000313) Timer data higher register 01                              */
    };
  };
  __IOM uint16_t  TDR02;                        /*!< (@ 0x00000314) Timer data register 02                                     */
  
  union {
    __IOM uint16_t TDR03;                       /*!< (@ 0x00000316) Timer data register 03                                     */
    
    struct {
      __IOM uint8_t TDR03L;                     /*!< (@ 0x00000316) Timer data lower register 03                               */
      __IOM uint8_t TDR03H;                     /*!< (@ 0x00000317) Timer data higher register 03                              */
    };
  };
  __IOM uint16_t  TDR04;                        /*!< (@ 0x00000318) Timer data register 04                                     */
  __IOM uint16_t  TDR05;                        /*!< (@ 0x0000031A) Timer data register 05                                     */
  __IOM uint16_t  TDR06;                        /*!< (@ 0x0000031C) Timer data register 06                                     */
  __IOM uint16_t  TDR07;                        /*!< (@ 0x0000031E) Timer data register 07                                     */
} TM80_Type;                                    /*!< Size = 800 (0x320)                                                        */



/* =========================================================================================================================== */
/* ================                                           TM81                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer 8 (TM81)
  */

typedef struct {                                /*!< (@ 0x40042000) TM81 Structure                                             */
  __IM  uint16_t  RESERVED[192];
  __IM  uint16_t  TCR10;                        /*!< (@ 0x00000180) Timer count register 00                                    */
  __IM  uint16_t  TCR11;                        /*!< (@ 0x00000182) Timer count register 01                                    */
  __IM  uint16_t  TCR12;                        /*!< (@ 0x00000184) Timer count register 02                                    */
  __IM  uint16_t  TCR13;                        /*!< (@ 0x00000186) Timer count register 03                                    */
  __IM  uint16_t  TCR14;                        /*!< (@ 0x00000188) Timer count register 04                                    */
  __IM  uint16_t  TCR15;                        /*!< (@ 0x0000018A) Timer count register 05                                    */
  __IM  uint16_t  TCR16;                        /*!< (@ 0x0000018C) Timer count register 06                                    */
  __IM  uint16_t  TCR17;                        /*!< (@ 0x0000018E) Timer count register 07                                    */
  __IOM uint16_t  TMR10;                        /*!< (@ 0x00000190) Timer mode register mn                                     */
  __IOM uint16_t  TMR11;                        /*!< (@ 0x00000192) Timer mode register mn                                     */
  __IOM uint16_t  TMR12;                        /*!< (@ 0x00000194) Timer mode register mn                                     */
  __IOM uint16_t  TMR13;                        /*!< (@ 0x00000196) Timer mode register mn                                     */
  __IOM uint16_t  TMR14;                        /*!< (@ 0x00000198) Timer mode register mn                                     */
  __IOM uint16_t  TMR15;                        /*!< (@ 0x0000019A) Timer mode register mn                                     */
  __IOM uint16_t  TMR16;                        /*!< (@ 0x0000019C) Timer mode register mn                                     */
  __IOM uint16_t  TMR17;                        /*!< (@ 0x0000019E) Timer mode register mn                                     */
  __IM  uint16_t  TSR10;                        /*!< (@ 0x000001A0) Timer status register mn                                   */
  __IM  uint16_t  TSR11;                        /*!< (@ 0x000001A2) Timer status register mn                                   */
  __IM  uint16_t  TSR12;                        /*!< (@ 0x000001A4) Timer status register mn                                   */
  __IM  uint16_t  TSR13;                        /*!< (@ 0x000001A6) Timer status register mn                                   */
  __IM  uint16_t  TSR14;                        /*!< (@ 0x000001A8) Timer status register mn                                   */
  __IM  uint16_t  TSR15;                        /*!< (@ 0x000001AA) Timer status register mn                                   */
  __IM  uint16_t  TSR16;                        /*!< (@ 0x000001AC) Timer status register mn                                   */
  __IM  uint16_t  TSR17;                        /*!< (@ 0x000001AE) Timer status register mn                                   */
  __IM  uint16_t  TE1;                          /*!< (@ 0x000001B0) Timer channel enable status register m                     */
  __IOM uint16_t  TS1;                          /*!< (@ 0x000001B2) Timer channel start register 0                             */
  __IOM uint16_t  TT1;                          /*!< (@ 0x000001B4) Timer channel stop register 0                              */
  __IOM uint16_t  TPS1;                         /*!< (@ 0x000001B6) Timer clock select register 0                              */
  __IOM uint16_t  TO1;                          /*!< (@ 0x000001B8) Timer output register 0                                    */
  __IOM uint16_t  TOE1;                         /*!< (@ 0x000001BA) Timer output enable register 0                             */
  __IOM uint16_t  TOL1;                         /*!< (@ 0x000001BC) Timer output level register 0                              */
  __IOM uint16_t  TOM1;                         /*!< (@ 0x000001BE) Timer output mode register 0                               */
  __IM  uint16_t  RESERVED1[168];
  __IOM uint16_t  TDR10;                        /*!< (@ 0x00000310) Timer data register 10                                     */
  
  union {
    __IOM uint16_t TDR11;                       /*!< (@ 0x00000312) Timer data register 11                                     */
    
    struct {
      __IOM uint8_t TDR11L;                     /*!< (@ 0x00000312) Timer data lower register 11                               */
      __IOM uint8_t TDR11H;                     /*!< (@ 0x00000313) Timer data higher register 11                              */
    };
  };
  __IOM uint16_t  TDR12;                        /*!< (@ 0x00000314) Timer data register 12                                     */
  
  union {
    __IOM uint16_t TDR13;                       /*!< (@ 0x00000316) Timer data register 13                                     */
    
    struct {
      __IOM uint8_t TDR13L;                     /*!< (@ 0x00000316) Timer data lower register 13                               */
      __IOM uint8_t TDR13H;                     /*!< (@ 0x00000317) Timer data higher register 13                              */
    };
  };
  __IOM uint16_t  TDR14;                        /*!< (@ 0x00000318) Timer data register 14                                     */
  __IOM uint16_t  TDR15;                        /*!< (@ 0x0000031A) Timer data register 15                                     */
  __IOM uint16_t  TDR16;                        /*!< (@ 0x0000031C) Timer data register 16                                     */
  __IOM uint16_t  TDR17;                        /*!< (@ 0x0000031E) Timer data register 17                                     */
} TM81_Type;                                    /*!< Size = 800 (0x320)                                                        */


#if 0
/* =========================================================================================================================== */
/* ================                                          SPIHS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface SPI0 (SPIHS0, SPIHS1)
  */

typedef struct {                                /*!< (@ 0x40042400) SPIHS0 Structure                                           */
  __IOM uint8_t   SPIM;                        /*!< (@ 0x00000000) SPI mode control register                                  */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   SPIC;                        /*!< (@ 0x00000004) SPI control register                                       */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IOM uint16_t  SDRO;                        /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IM  uint16_t  RESERVED4;
  __IOM uint16_t  SDRI;                        /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   SPIS;                        /*!< (@ 0x00000010) SPI status register                                        */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
} SPIHS_Type;                                  /*!< Size = 20 (0x14)                                                          */



#else
/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */
/**
  * @brief Serial Interface SPI (SPIHS)
  */

typedef struct {                                /*!< (@ 0x40042400) SPIHS0 Structure                                           */
  __IOM uint8_t   SPIM;                        /*!< (@ 0x00000000) SPI mode control register                                  */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   SPIC;                        /*!< (@ 0x00000004) SPI control register                                       */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IOM uint16_t  SDRO;                        /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IM  uint16_t  RESERVED4;
  __IOM uint16_t  SDRI;                        /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   SPIS;                        /*!< (@ 0x00000010) SPI status register                                        */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
} SPIHS_Type;                                  /*!< Size = 20 (0x14)                                                          */


/**
  * @brief Serial Interface SPI0 (SPIHS0)
  */

typedef struct {                                /*!< (@ 0x40042400) SPIHS0 Structure                                           */
  __IOM uint8_t   SPIM0;                        /*!< (@ 0x00000000) SPI mode control register                                  */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   SPIC0;                        /*!< (@ 0x00000004) SPI control register                                       */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IOM uint16_t  SDRO0;                        /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IM  uint16_t  RESERVED4;
  __IOM uint16_t  SDRI0;                        /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   SPIS0;                        /*!< (@ 0x00000010) SPI status register                                        */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
} SPIHS0_Type;                                  /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                          SPIHS1                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface SPI1 (SPIHS1)
  */

typedef struct {                                /*!< (@ 0x40042800) SPIHS1 Structure                                           */
  __IOM uint8_t   SPIM1;                        /*!< (@ 0x00000000) SPI mode control register                                  */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   SPIC1;                        /*!< (@ 0x00000004) SPI control register                                       */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IOM uint16_t  SDRO1;                        /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IM  uint16_t  RESERVED4;
  __IOM uint16_t  SDRI1;                        /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   SPIS1;                        /*!< (@ 0x00000010) SPI status register                                        */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
} SPIHS1_Type;                                  /*!< Size = 20 (0x14)                                                          */
#endif


#if 0
/* =========================================================================================================================== */
/* ================                                           IICA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface I2C with multimaster and wakeup supported (IICA0, IICA1)
  */

typedef struct {                                /*!< (@ 0x40041A30) IICA0 Structure                                            */
  __IOM uint8_t   IICCTL0;                      /*!< (@ 0x00000000) IICA0 control register 0                                   */
  __IOM uint8_t   IICCTL1;                      /*!< (@ 0x00000001) IICA0 control register 1                                   */
  __IOM uint8_t   IICWL;                        /*!< (@ 0x00000002) IICA0 low-level width setting register                     */
  __IOM uint8_t   IICWH;                        /*!< (@ 0x00000003) IICA0 high-level width setting register                    */
  __IOM uint8_t   SVA;                          /*!< (@ 0x00000004) Slave address register                                     */
  __IM  uint8_t   RESERVED[283];
  __IOM uint8_t   IICA;                        /*!< (@ 0x00000120) IICA0 shift register                                       */
  __IM  uint8_t   IICS;                        /*!< (@ 0x00000121) IICA0 status register                                      */
  __IOM uint8_t   IICF;                        /*!< (@ 0x00000122) IICA0 flag register                                        */
} IICA_Type;                                   /*!< Size = 291 (0x123)                                                        */


#else
/* =========================================================================================================================== */
/* ================                                           IICA0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface I2C with multimaster and wakeup supported (IICA0)
  */

typedef struct {                                /*!< (@ 0x40041A30) IICA0 Structure                                            */
  __IOM uint8_t   IICCTL00;                     /*!< (@ 0x00000000) IICA0 control register 0                                   */
  __IOM uint8_t   IICCTL01;                     /*!< (@ 0x00000001) IICA0 control register 1                                   */
  __IOM uint8_t   IICWL0;                       /*!< (@ 0x00000002) IICA0 low-level width setting register                     */
  __IOM uint8_t   IICWH0;                       /*!< (@ 0x00000003) IICA0 high-level width setting register                    */
  __IOM uint8_t   SVA0;                         /*!< (@ 0x00000004) Slave address register                                     */
  __IM  uint8_t   RESERVED[283];
  __IOM uint8_t   IICA00;                       /*!< (@ 0x00000120) IICA0 shift register                                       */
  __IM  uint8_t   IICS0;                        /*!< (@ 0x00000121) IICA0 status register                                      */
  __IOM uint8_t   IICF0;                        /*!< (@ 0x00000122) IICA0 flag register                                        */
} IICA0_Type;                                   /*!< Size = 291 (0x123)                                                        */



/* =========================================================================================================================== */
/* ================                                           IICA1                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface I2C with multimaster and wakeup supported (IICA1)
  */

typedef struct {                                /*!< (@ 0x40042E30) IICA1 Structure                                            */
  __IOM uint8_t   IICCTL10;                     /*!< (@ 0x00000000) IICA1 control register 0                                   */
  __IOM uint8_t   IICCTL11;                     /*!< (@ 0x00000001) IICA1 control register 1                                   */
  __IOM uint8_t   IICWL1;                       /*!< (@ 0x00000002) IICA1 low-level width setting register                     */
  __IOM uint8_t   IICWH1;                       /*!< (@ 0x00000003) IICA1 high-level width setting register                    */
  __IOM uint8_t   SVA1;                         /*!< (@ 0x00000004) Slave address register                                     */
  __IM  uint8_t   RESERVED[283];
  __IOM uint8_t   IICA10;                       /*!< (@ 0x00000120) IICA1 shift register                                       */
  __IM  uint8_t   IICS1;                        /*!< (@ 0x00000121) IICA1 status register                                      */
  __IOM uint8_t   IICF1;                        /*!< (@ 0x00000122) IICA1 flag register                                        */
} IICA1_Type;                                   /*!< Size = 291 (0x123)                                                        */
#endif

typedef struct {                                                               
  __IOM uint8_t   IICCTL0;                                                  
  __IOM uint8_t   IICCTL1;                     
  __IOM uint8_t   IICWL;                       
  __IOM uint8_t   IICWH;                       
  __IOM uint8_t   SVA;                        
  __IM  uint8_t   RESERVED[283];
  __IOM uint8_t   IICA;                       
  __IM  uint8_t   IICS0;                        
  __IOM uint8_t   IICF0;                        
} IICA_TypeDef;
#if 0
/* =========================================================================================================================== */
/* ================                                           CMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP0, CMP1, CMP2, CMP3)
  */

typedef struct {                                /*!< (@ 0x40043840) CMPm Structure                                             */
  __IOM uint8_t   COMPMDR;                      /*!< (@ 0x00000000) Comparator m mode setting register                         */
  __IOM uint8_t   COMPFIR;                      /*!< (@ 0x00000001) Comparator m filter control register                       */
  __IOM uint8_t   COMPOCR;                      /*!< (@ 0x00000002) Comparator m output control register                       */
  __IM  uint8_t   RESERVED[7];
  __IOM uint8_t   COMPSEL;                      /*!< (@ 0x0000000A) Comparator m input signal selection control register       */
  __IM  uint8_t   RESERVED1[3];
  __IOM uint8_t   COMPHY;                       /*!< (@ 0x0000000E) Comparator m input voltage hysteresis control
                                                                    register                                                   */
} CMP_Type;                                     /*!< Size = 15 (0xf)                                                           */


#else
/* =========================================================================================================================== */
/* ================                                           CMP0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP0)
  */

typedef struct {                                /*!< (@ 0x40043840) CMP0 Structure                                             */
  __IOM uint8_t   COMP0MDR;                     /*!< (@ 0x00000000) Comparator 0 mode setting register                         */
  __IOM uint8_t   COMP0FIR;                     /*!< (@ 0x00000001) Comparator 0 filter control register                       */
  __IOM uint8_t   COMP0OCR;                     /*!< (@ 0x00000002) Comparator 0 output control register                       */
  __IM  uint8_t   RESERVED[7];
  __IOM uint8_t   COMP0SEL;                     /*!< (@ 0x0000000A) Comparator 0 input signal selection control register       */
  __IM  uint8_t   RESERVED1[3];
  __IOM uint8_t   COMP0HY;                      /*!< (@ 0x0000000E) Comparator 0 input voltage hysteresis control
                                                                    register                                                   */
} CMP0_Type;                                    /*!< Size = 15 (0xf)                                                           */



/* =========================================================================================================================== */
/* ================                                           CMP1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP1)
  */

typedef struct {                                /*!< (@ 0x40043940) CMP1 Structure                                             */
  __IOM uint8_t   COMP1MDR;                     /*!< (@ 0x00000000) Comparator 1 mode setting register                         */
  __IOM uint8_t   COMP1FIR;                     /*!< (@ 0x00000001) Comparator 1 filter control register                       */
  __IOM uint8_t   COMP1OCR;                     /*!< (@ 0x00000002) Comparator 1 output control register                       */
  __IM  uint8_t   RESERVED[7];
  __IOM uint8_t   COMP1SEL;                     /*!< (@ 0x0000000A) Comparator 1 input signal selection control register       */
  __IM  uint8_t   RESERVED1[3];
  __IOM uint8_t   COMP1HY;                      /*!< (@ 0x0000000E) Comparator 1 input voltage hysteresis control
                                                                    register                                                   */
} CMP1_Type;                                    /*!< Size = 15 (0xf)                                                           */



/* =========================================================================================================================== */
/* ================                                           CMP2                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP2)
  */

typedef struct {                                /*!< (@ 0x40043A40) CMP2 Structure                                             */
  __IOM uint8_t   COMP2MDR;                     /*!< (@ 0x00000000) Comparator 2 mode setting register                         */
  __IOM uint8_t   COMP2FIR;                     /*!< (@ 0x00000001) Comparator 2 filter control register                       */
  __IOM uint8_t   COMP2OCR;                     /*!< (@ 0x00000002) Comparator 2 output control register                       */
  __IM  uint8_t   RESERVED[7];
  __IOM uint8_t   COMP2SEL;                     /*!< (@ 0x0000000A) Comparator 2 input signal selection control register       */
  __IM  uint8_t   RESERVED1[3];
  __IOM uint8_t   COMP2HY;                      /*!< (@ 0x0000000E) Comparator 2 input voltage hysteresis control
                                                                    register                                                   */
} CMP2_Type;                                    /*!< Size = 15 (0xf)                                                           */



/* =========================================================================================================================== */
/* ================                                           CMP3                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP3)
  */

typedef struct {                                /*!< (@ 0x40043B40) CMP3 Structure                                             */
  __IOM uint8_t   COMP3MDR;                     /*!< (@ 0x00000000) Comparator 3 mode setting register                         */
  __IOM uint8_t   COMP3FIR;                     /*!< (@ 0x00000001) Comparator 3 filter control register                       */
  __IOM uint8_t   COMP3OCR;                     /*!< (@ 0x00000002) Comparator 3 output control register                       */
  __IM  uint8_t   RESERVED[7];
  __IOM uint8_t   COMP3SEL;                     /*!< (@ 0x0000000A) Comparator 3 input signal selection control register       */
  __IM  uint8_t   RESERVED1[3];
  __IOM uint8_t   COMP3HY;                      /*!< (@ 0x0000000E) Comparator 3 input voltage hysteresis control
                                                                    register                                                   */
} CMP3_Type;                                    /*!< Size = 15 (0xf)                                                           */
#endif


/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief IrDA communication module based on Infrared Data Association stardard 1.0 (IRDA)
  */

typedef struct {                                /*!< (@ 0x40043CA0) IRDA Structure                                             */
  __IOM uint8_t   IRCR;                         /*!< (@ 0x00000000) IrDA control register                                      */
} IRDA_Type;                                    /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Programmable Gain Amplifier (DAC)
  */

typedef struct {                                /*!< (@ 0x40044334) DAC Structure                                              */
  __IOM uint8_t   DACS0;                        /*!< (@ 0x00000000) D/A conversion value setting register 0                    */
  __IOM uint8_t   DACS1;                        /*!< (@ 0x00000001) D/A conversion value setting register 1                    */
  __IOM uint8_t   DAM;                          /*!< (@ 0x00000002) Mode register of D/A converter                             */
} DAC_Type;                                     /*!< Size = 3 (0x3)                                                            */



/* =========================================================================================================================== */
/* ================                                           LCDB                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief LCD Bus Interface (LCDB)
  */

typedef struct {                                /*!< (@ 0x40044400) LCDB Structure                                             */
  __IOM uint8_t   LBCTL;                        /*!< (@ 0x00000000) LCD Bus Interface mode register                            */
  __IOM uint8_t   LBCYC;                        /*!< (@ 0x00000001) LCB Bus Interface cycle control register                   */
  __IOM uint8_t   LBWST;                        /*!< (@ 0x00000002) LCB Bus Interface wait control register                    */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1[6];
  
  union {
    __IOM uint16_t LBDATA;                      /*!< (@ 0x00000010) LCD Bus Interface data register                            */
    __IOM uint8_t LBDATAL;                      /*!< (@ 0x00000010) SPI data register                                          */
  };
  
  union {
    __IOM uint16_t LBDATAR;                     /*!< (@ 0x00000012) LCD Bus Interface read data register                       */
    __IOM uint8_t LBDATARL;                     /*!< (@ 0x00000012) LCD Bus Interface read data register                       */
  };
} LCDB_Type;                                    /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                            KEY                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Key interrupt (KEY)
  */

typedef struct {                                /*!< (@ 0x40044B37) KEY Structure                                              */
  __IOM uint8_t   KRM;                          /*!< (@ 0x00000000) Key return mode register                                   */
} KEY_Type;                                     /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-Time clock (RTC)
  */

typedef struct {                                /*!< (@ 0x40044F00) RTC Structure                                              */
  __IM  uint16_t  RESERVED[26];
  __IOM uint16_t  SUBCUD;                       /*!< (@ 0x00000034) Watch error correction register                            */
  __IM  uint16_t  RESERVED1[13];
  __IOM uint16_t  ITMC;                         /*!< (@ 0x00000050) 15-bit interval timer control register                     */
  __IOM uint8_t   SEC;                          /*!< (@ 0x00000052) Second count register                                      */
  __IOM uint8_t   MIN;                          /*!< (@ 0x00000053) Minute count register                                      */
  __IOM uint8_t   HOUR;                         /*!< (@ 0x00000054) Hour count register                                        */
  __IOM uint8_t   WEEK;                         /*!< (@ 0x00000055) Week count register                                        */
  __IOM uint8_t   DAY;                          /*!< (@ 0x00000056) Day count register                                         */
  __IOM uint8_t   MONTH;                        /*!< (@ 0x00000057) Month count register                                       */
  __IOM uint8_t   YEAR;                         /*!< (@ 0x00000058) Year count register                                        */
  __IM  uint8_t   RESERVED2;
  __IOM uint8_t   ALARMWM;                      /*!< (@ 0x0000005A) Alarm minute register                                      */
  __IOM uint8_t   ALARMWH;                      /*!< (@ 0x0000005B) Alarm hour register                                        */
  __IOM uint8_t   ALARMWW;                      /*!< (@ 0x0000005C) Alarm week register                                        */
  __IOM uint8_t   RTCC0;                        /*!< (@ 0x0000005D) Real-time clock control register 0                         */
  __IOM uint8_t   RTCC1;                        /*!< (@ 0x0000005E) Real-time clock control register 1                         */
  __IM  uint8_t   RESERVED3;
  __IM  uint16_t  RESERVED4;
} RTC_Type;                                     /*!< Size = 98 (0x62)                                                          */



/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Pin input edge detection (INTM)
  */

typedef struct {                                /*!< (@ 0x40045B38) INTM Structure                                             */
  __IOM uint8_t   EGP0;                         /*!< (@ 0x00000000) External interrupt rising edge enable register             */
  __IOM uint8_t   EGN0;                         /*!< (@ 0x00000001) External interrupt falling edge enable register            */
} INTM_Type;                                    /*!< Size = 2 (0x2)                                                            */



/* =========================================================================================================================== */
/* ================                                           CAN                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief CAN0 Controller (CAN)
  */

typedef struct {                                /*!< (@ 0x40045C00) CAN0 Structure                                             */
  __IOM uint16_t  CGMCTRL;                      /*!< (@ 0x00000000) CAN global module control register                         */
  __IOM uint8_t   CGMCS;                        /*!< (@ 0x00000002) CAN global module clock select register                    */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint16_t  CGMABT;                       /*!< (@ 0x00000006) CAN global automatic block transmission control
                                                                    register                                                   */
  __IOM uint8_t   CGMABTD;                      /*!< (@ 0x00000008) CAN global automatic block transmission delay
                                                                    setting register                                           */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3[27];
  __IOM uint16_t  CMASK1L;                      /*!< (@ 0x00000040) CAN module mask 1 register                                 */
  __IOM uint16_t  CMASK1H;                      /*!< (@ 0x00000042) CAN module mask 1 register                                 */
  __IOM uint16_t  CMASK2L;                      /*!< (@ 0x00000044) CAN module mask 2 register                                 */
  __IOM uint16_t  CMASK2H;                      /*!< (@ 0x00000046) CAN module mask 2 register                                 */
  __IOM uint16_t  CMASK3L;                      /*!< (@ 0x00000048) CAN module mask 3 register                                 */
  __IOM uint16_t  CMASK3H;                      /*!< (@ 0x0000004A) CAN module mask 3 register                                 */
  __IOM uint16_t  CMASK4L;                      /*!< (@ 0x0000004C) CAN module mask 4 register                                 */
  __IOM uint16_t  CMASK4H;                      /*!< (@ 0x0000004E) CAN module mask 4 register                                 */
  __IOM uint16_t  CCTRL;                        /*!< (@ 0x00000050) CAN module control register                                */
  __IOM uint8_t   CLEC;                         /*!< (@ 0x00000052) CAN module last error code register                        */
  __IM  uint8_t   CINFO;                        /*!< (@ 0x00000053) CAN module information register                            */
  __IM  uint16_t  CERC;                         /*!< (@ 0x00000054) CAN module error counter register                          */
  __IOM uint16_t  CIE;                          /*!< (@ 0x00000056) CAN module interrupt enable register                       */
  __IOM uint16_t  CINTS;                        /*!< (@ 0x00000058) CAN module interrupt status register                       */
  __IOM uint8_t   CBRP;                         /*!< (@ 0x0000005A) CAN module bit rate prescaler register                     */
  __IM  uint8_t   RESERVED4;
  __IOM uint16_t  CBTR;                         /*!< (@ 0x0000005C) CAN module bit rate register                               */
  __IM  uint8_t   CLIPT;                        /*!< (@ 0x0000005E) CAN module last in-pointer register                        */
  __IM  uint8_t   RESERVED5;
  __IOM uint16_t  CRGPT;                        /*!< (@ 0x00000060) CAN module receive history list register                   */
  __IM  uint8_t   CLOPT;                        /*!< (@ 0x00000062) CAN module last out-pointer register                       */
  __IM  uint8_t   RESERVED6;
  __IOM uint16_t  CTGPT;                        /*!< (@ 0x00000064) CAN module transmit history list register                  */
  __IOM uint16_t  CTS;                          /*!< (@ 0x00000066) CAN module time stamp register                             */
} CAN_Type;                                    /*!< Size = 104 (0x68)                                                         */



/* =========================================================================================================================== */
/* ================                                           CANMSG                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief CAN Controller Message 00 (CANMSG)
  */

typedef struct {                                /*!< (@ 0x40045D00) CAN0MSG00 Structure                                        */
  
  union {
    __IOM uint16_t CMDB01;                      /*!< (@ 0x00000000) CAN message data byte 01 register                          */
    
    struct {
      __IOM uint8_t CMDB0;                      /*!< (@ 0x00000000) CAN message data byte 0 register                           */
      __IOM uint8_t CMDB1;                      /*!< (@ 0x00000001) CAN message data byte 1 register                           */
    };
  };
  
  union {
    __IOM uint16_t CMDB23;                      /*!< (@ 0x00000002) CAN message data byte 23 register                          */
    
    struct {
      __IOM uint8_t CMDB2;                      /*!< (@ 0x00000002) CAN message data byte 2 register                           */
      __IOM uint8_t CMDB3;                      /*!< (@ 0x00000003) CAN message data byte 3 register                           */
    };
  };
  
  union {
    __IOM uint16_t CMDB45;                      /*!< (@ 0x00000004) CAN message data byte 45 register                          */
    
    struct {
      __IOM uint8_t CMDB4;                      /*!< (@ 0x00000004) CAN message data byte 4 register                           */
      __IOM uint8_t CMDB5;                      /*!< (@ 0x00000005) CAN message data byte 5 register                           */
    };
  };
  
  union {
    __IOM uint16_t CMDB67;                      /*!< (@ 0x00000006) CAN message data byte 67 register                          */
    
    struct {
      __IOM uint8_t CMDB6;                      /*!< (@ 0x00000006) CAN message data byte 6 register                           */
      __IOM uint8_t CMDB7;                      /*!< (@ 0x00000007) CAN message data byte 7 register                           */
    };
  };
  __IOM uint8_t   CMDLC;                        /*!< (@ 0x00000008) CAN message data length register                           */
  __IOM uint8_t   CMCONF;                       /*!< (@ 0x00000009) CAN message configuration register                         */
  __IOM uint16_t  CMIDL;                        /*!< (@ 0x0000000A) CAN message ID register                                    */
  __IOM uint16_t  CMIDH;                        /*!< (@ 0x0000000C) CAN message ID register                                    */
  __IOM uint16_t  CMCTRL;                       /*!< (@ 0x0000000E) CAN message control register                               */
} CANMSG_Type;                               /*!< Size = 16 (0x10)                                                          */



/* =========================================================================================================================== */
/* ================                                           TRNG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief True Random Number Generator (TRNG)
  */

typedef struct {                                /*!< (@ 0x40046400) TRNG Structure                                             */
  __IOM uint8_t   SDR;                          /*!< (@ 0x00000000) Control register                                           */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   SCR;                          /*!< (@ 0x00000002) Random number seed command register                        */
} TRNG_Type;                                    /*!< Size = 3 (0x3)                                                            */



/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief DBG Controller (DBG)
  */

typedef struct {                                /*!< (@ 0x4001B000) DBG Structure                                              */
  __IM  uint32_t  DBGSTR;                       /*!< (@ 0x00000000) Debug status register                                      */
  __IOM uint32_t  DBGSTOPCR;                    /*!< (@ 0x00000004) Debug Stop Control register                                */
} DBG_Type;                                     /*!< Size = 8 (0x8)                                                            */


# if 1
/* =========================================================================================================================== */
/* ================                                           GPT                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal PWM timer (32-bit counter 4 channels) (GPT0), (16-bit counter 8 channels) (GPT1)
  */

typedef struct {                                /*!< (@ 0x40090000) GPT0 Structure                                             */
  __IOM uint32_t  GTWP;                       /*!< (@ 0x00000000) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR;                      /*!< (@ 0x00000004) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP;                      /*!< (@ 0x00000008) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR;                      /*!< (@ 0x0000000C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR;                      /*!< (@ 0x00000010) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR;                      /*!< (@ 0x00000014) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR;                      /*!< (@ 0x00000018) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR;                     /*!< (@ 0x0000001C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR;                     /*!< (@ 0x00000020) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR;                    /*!< (@ 0x00000024) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR;                    /*!< (@ 0x00000028) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR;                       /*!< (@ 0x0000002C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC;                   /*!< (@ 0x00000030) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR;                      /*!< (@ 0x00000034) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD;                    /*!< (@ 0x00000038) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST;                       /*!< (@ 0x0000003C) General PWM timer status register                          */
  __IOM uint32_t  GTBER;                      /*!< (@ 0x00000040) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  GTCNT;                      /*!< (@ 0x00000048) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA;                     /*!< (@ 0x0000004C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB;                     /*!< (@ 0x00000050) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC;                     /*!< (@ 0x00000054) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE;                     /*!< (@ 0x00000058) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRD;                     /*!< (@ 0x0000005C) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRF;                     /*!< (@ 0x00000060) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR;                       /*!< (@ 0x00000064) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR;                      /*!< (@ 0x00000068) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED1[7];
  __IOM uint32_t  GTDTCR;                     /*!< (@ 0x00000088) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU;                      /*!< (@ 0x0000008C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED2[28];
  
}GPT_Type;

typedef struct {                                /*!< (@ 0x40090BF0) GPT1_OPS Structure                                             */
  __IOM uint32_t  OPSCR;                        /*!< (@ 0x00000000) Output phase switch control register                       */
} GPT10OPS_Type;      
#else
/* =========================================================================================================================== */
/* ================                                           GPT0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal PWM timer (32-bit counter 4 channels) (GPT0)
  */

typedef struct {                                /*!< (@ 0x40090000) GPT0 Structure                                             */
  __IOM uint32_t  GTWP00;                       /*!< (@ 0x00000000) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR00;                      /*!< (@ 0x00000004) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP00;                      /*!< (@ 0x00000008) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR00;                      /*!< (@ 0x0000000C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR00;                      /*!< (@ 0x00000010) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR00;                      /*!< (@ 0x00000014) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR00;                      /*!< (@ 0x00000018) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR00;                     /*!< (@ 0x0000001C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR00;                     /*!< (@ 0x00000020) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR00;                    /*!< (@ 0x00000024) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR00;                    /*!< (@ 0x00000028) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR00;                       /*!< (@ 0x0000002C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC00;                   /*!< (@ 0x00000030) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR00;                      /*!< (@ 0x00000034) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD00;                    /*!< (@ 0x00000038) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST00;                       /*!< (@ 0x0000003C) General PWM timer status register                          */
  __IOM uint32_t  GTBER00;                      /*!< (@ 0x00000040) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  GTCNT00;                      /*!< (@ 0x00000048) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA00;                     /*!< (@ 0x0000004C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB00;                     /*!< (@ 0x00000050) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC00;                     /*!< (@ 0x00000054) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE00;                     /*!< (@ 0x00000058) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD00;                     /*!< (@ 0x0000005C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF00;                     /*!< (@ 0x00000060) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR00;                       /*!< (@ 0x00000064) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR00;                      /*!< (@ 0x00000068) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED1[7];
  __IOM uint32_t  GTDTCR00;                     /*!< (@ 0x00000088) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU00;                      /*!< (@ 0x0000008C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  GTWP01;                       /*!< (@ 0x00000100) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR01;                      /*!< (@ 0x00000104) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP01;                      /*!< (@ 0x00000108) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR01;                      /*!< (@ 0x0000010C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR01;                      /*!< (@ 0x00000110) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR01;                      /*!< (@ 0x00000114) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR01;                      /*!< (@ 0x00000118) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR01;                     /*!< (@ 0x0000011C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR01;                     /*!< (@ 0x00000120) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR01;                    /*!< (@ 0x00000124) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR01;                    /*!< (@ 0x00000128) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR01;                       /*!< (@ 0x0000012C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC01;                   /*!< (@ 0x00000130) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR01;                      /*!< (@ 0x00000134) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD01;                    /*!< (@ 0x00000138) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST01;                       /*!< (@ 0x0000013C) General PWM timer status register                          */
  __IOM uint32_t  GTBER01;                      /*!< (@ 0x00000140) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  GTCNT01;                      /*!< (@ 0x00000148) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA01;                     /*!< (@ 0x0000014C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB01;                     /*!< (@ 0x00000150) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC01;                     /*!< (@ 0x00000154) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE01;                     /*!< (@ 0x00000158) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD01;                     /*!< (@ 0x0000015C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF01;                     /*!< (@ 0x00000160) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR01;                       /*!< (@ 0x00000164) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR01;                      /*!< (@ 0x00000168) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  GTDTCR01;                     /*!< (@ 0x00000188) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU01;                      /*!< (@ 0x0000018C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED5[28];
  __IOM uint32_t  GTWP02;                       /*!< (@ 0x00000200) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR02;                      /*!< (@ 0x00000204) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP02;                      /*!< (@ 0x00000208) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR02;                      /*!< (@ 0x0000020C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR02;                      /*!< (@ 0x00000210) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR02;                      /*!< (@ 0x00000214) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR02;                      /*!< (@ 0x00000218) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR02;                     /*!< (@ 0x0000021C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR02;                     /*!< (@ 0x00000220) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR02;                    /*!< (@ 0x00000224) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR02;                    /*!< (@ 0x00000228) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR02;                       /*!< (@ 0x0000022C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC02;                   /*!< (@ 0x00000230) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR02;                      /*!< (@ 0x00000234) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD02;                    /*!< (@ 0x00000238) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST02;                       /*!< (@ 0x0000023C) General PWM timer status register                          */
  __IOM uint32_t  GTBER02;                      /*!< (@ 0x00000240) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  GTCNT02;                      /*!< (@ 0x00000248) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA02;                     /*!< (@ 0x0000024C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB02;                     /*!< (@ 0x00000250) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC02;                     /*!< (@ 0x00000254) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE02;                     /*!< (@ 0x00000258) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD02;                     /*!< (@ 0x0000025C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF02;                     /*!< (@ 0x00000260) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR02;                       /*!< (@ 0x00000264) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR02;                      /*!< (@ 0x00000268) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED7[7];
  __IOM uint32_t  GTDTCR02;                     /*!< (@ 0x00000288) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU02;                      /*!< (@ 0x0000028C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED8[28];
  __IOM uint32_t  GTWP03;                       /*!< (@ 0x00000300) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR03;                      /*!< (@ 0x00000304) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP03;                      /*!< (@ 0x00000308) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR03;                      /*!< (@ 0x0000030C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR03;                      /*!< (@ 0x00000310) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR03;                      /*!< (@ 0x00000314) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR03;                      /*!< (@ 0x00000318) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR03;                     /*!< (@ 0x0000031C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR03;                     /*!< (@ 0x00000320) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR03;                    /*!< (@ 0x00000324) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR03;                    /*!< (@ 0x00000328) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR03;                       /*!< (@ 0x0000032C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC03;                   /*!< (@ 0x00000330) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR03;                      /*!< (@ 0x00000334) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD03;                    /*!< (@ 0x00000338) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST03;                       /*!< (@ 0x0000033C) General PWM timer status register                          */
  __IOM uint32_t  GTBER03;                      /*!< (@ 0x00000340) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED9;
  __IOM uint32_t  GTCNT03;                      /*!< (@ 0x00000348) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA03;                     /*!< (@ 0x0000034C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB03;                     /*!< (@ 0x00000350) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC03;                     /*!< (@ 0x00000354) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE03;                     /*!< (@ 0x00000358) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD03;                     /*!< (@ 0x0000035C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF03;                     /*!< (@ 0x00000360) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR03;                       /*!< (@ 0x00000364) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR03;                      /*!< (@ 0x00000368) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED10[7];
  __IOM uint32_t  GTDTCR03;                     /*!< (@ 0x00000388) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU03;                      /*!< (@ 0x0000038C) Universal PWM timer dead time value register
                                                                    U                                                          */
} GPT0_Type;                                    /*!< Size = 912 (0x390)                                                        */



/* =========================================================================================================================== */
/* ================                                           GPT1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal PWM timer (16-bit counter 8 channels) (GPT1)
  */

typedef struct {                                /*!< (@ 0x40090400) GPT1 Structure                                             */
  __IOM uint32_t  GTWP10;                       /*!< (@ 0x00000000) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR10;                      /*!< (@ 0x00000004) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP10;                      /*!< (@ 0x00000008) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR10;                      /*!< (@ 0x0000000C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR10;                      /*!< (@ 0x00000010) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR10;                      /*!< (@ 0x00000014) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR10;                      /*!< (@ 0x00000018) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR10;                     /*!< (@ 0x0000001C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR10;                     /*!< (@ 0x00000020) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR10;                    /*!< (@ 0x00000024) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR10;                    /*!< (@ 0x00000028) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR10;                       /*!< (@ 0x0000002C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC10;                   /*!< (@ 0x00000030) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR10;                      /*!< (@ 0x00000034) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD10;                    /*!< (@ 0x00000038) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST10;                       /*!< (@ 0x0000003C) General PWM timer status register                          */
  __IOM uint32_t  GTBER10;                      /*!< (@ 0x00000040) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  GTCNT10;                      /*!< (@ 0x00000048) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA10;                     /*!< (@ 0x0000004C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB10;                     /*!< (@ 0x00000050) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC10;                     /*!< (@ 0x00000054) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE10;                     /*!< (@ 0x00000058) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD10;                     /*!< (@ 0x0000005C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF10;                     /*!< (@ 0x00000060) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR10;                       /*!< (@ 0x00000064) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR10;                      /*!< (@ 0x00000068) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED1[7];
  __IOM uint32_t  GTDTCR10;                     /*!< (@ 0x00000088) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU10;                      /*!< (@ 0x0000008C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  GTWP11;                       /*!< (@ 0x00000100) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR11;                      /*!< (@ 0x00000104) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP11;                      /*!< (@ 0x00000108) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR11;                      /*!< (@ 0x0000010C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR11;                      /*!< (@ 0x00000110) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR11;                      /*!< (@ 0x00000114) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR11;                      /*!< (@ 0x00000118) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR11;                     /*!< (@ 0x0000011C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR11;                     /*!< (@ 0x00000120) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR11;                    /*!< (@ 0x00000124) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR11;                    /*!< (@ 0x00000128) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR11;                       /*!< (@ 0x0000012C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC11;                   /*!< (@ 0x00000130) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR11;                      /*!< (@ 0x00000134) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD11;                    /*!< (@ 0x00000138) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST11;                       /*!< (@ 0x0000013C) General PWM timer status register                          */
  __IOM uint32_t  GTBER11;                      /*!< (@ 0x00000140) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  GTCNT11;                      /*!< (@ 0x00000148) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA11;                     /*!< (@ 0x0000014C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB11;                     /*!< (@ 0x00000150) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC11;                     /*!< (@ 0x00000154) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE11;                     /*!< (@ 0x00000158) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD11;                     /*!< (@ 0x0000015C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF11;                     /*!< (@ 0x00000160) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR11;                       /*!< (@ 0x00000164) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR11;                      /*!< (@ 0x00000168) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  GTDTCR11;                     /*!< (@ 0x00000188) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU11;                      /*!< (@ 0x0000018C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED5[28];
  __IOM uint32_t  GTWP12;                       /*!< (@ 0x00000200) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR12;                      /*!< (@ 0x00000204) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP12;                      /*!< (@ 0x00000208) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR12;                      /*!< (@ 0x0000020C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR12;                      /*!< (@ 0x00000210) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR12;                      /*!< (@ 0x00000214) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR12;                      /*!< (@ 0x00000218) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR12;                     /*!< (@ 0x0000021C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR12;                     /*!< (@ 0x00000220) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR12;                    /*!< (@ 0x00000224) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR12;                    /*!< (@ 0x00000228) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR12;                       /*!< (@ 0x0000022C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC12;                   /*!< (@ 0x00000230) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR12;                      /*!< (@ 0x00000234) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD12;                    /*!< (@ 0x00000238) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST12;                       /*!< (@ 0x0000023C) General PWM timer status register                          */
  __IOM uint32_t  GTBER12;                      /*!< (@ 0x00000240) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  GTCNT12;                      /*!< (@ 0x00000248) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA12;                     /*!< (@ 0x0000024C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB12;                     /*!< (@ 0x00000250) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC12;                     /*!< (@ 0x00000254) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE12;                     /*!< (@ 0x00000258) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD12;                     /*!< (@ 0x0000025C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF12;                     /*!< (@ 0x00000260) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR12;                       /*!< (@ 0x00000264) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR12;                      /*!< (@ 0x00000268) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED7[7];
  __IOM uint32_t  GTDTCR12;                     /*!< (@ 0x00000288) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU12;                      /*!< (@ 0x0000028C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED8[28];
  __IOM uint32_t  GTWP13;                       /*!< (@ 0x00000300) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR13;                      /*!< (@ 0x00000304) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP13;                      /*!< (@ 0x00000308) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR13;                      /*!< (@ 0x0000030C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR13;                      /*!< (@ 0x00000310) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR13;                      /*!< (@ 0x00000314) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR13;                      /*!< (@ 0x00000318) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR13;                     /*!< (@ 0x0000031C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR13;                     /*!< (@ 0x00000320) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR13;                    /*!< (@ 0x00000324) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR13;                    /*!< (@ 0x00000328) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR13;                       /*!< (@ 0x0000032C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC13;                   /*!< (@ 0x00000330) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR13;                      /*!< (@ 0x00000334) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD13;                    /*!< (@ 0x00000338) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST13;                       /*!< (@ 0x0000033C) General PWM timer status register                          */
  __IOM uint32_t  GTBER13;                      /*!< (@ 0x00000340) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED9;
  __IOM uint32_t  GTCNT13;                      /*!< (@ 0x00000348) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA13;                     /*!< (@ 0x0000034C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB13;                     /*!< (@ 0x00000350) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC13;                     /*!< (@ 0x00000354) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE13;                     /*!< (@ 0x00000358) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD13;                     /*!< (@ 0x0000035C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF13;                     /*!< (@ 0x00000360) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR13;                       /*!< (@ 0x00000364) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR13;                      /*!< (@ 0x00000368) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED10[7];
  __IOM uint32_t  GTDTCR13;                     /*!< (@ 0x00000388) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU13;                      /*!< (@ 0x0000038C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED11[28];
  __IOM uint32_t  GTWP14;                       /*!< (@ 0x00000400) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR14;                      /*!< (@ 0x00000404) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP14;                      /*!< (@ 0x00000408) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR14;                      /*!< (@ 0x0000040C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR14;                      /*!< (@ 0x00000410) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR14;                      /*!< (@ 0x00000414) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR14;                      /*!< (@ 0x00000418) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR14;                     /*!< (@ 0x0000041C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR14;                     /*!< (@ 0x00000420) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR14;                    /*!< (@ 0x00000424) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR14;                    /*!< (@ 0x00000428) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR14;                       /*!< (@ 0x0000042C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC14;                   /*!< (@ 0x00000430) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR14;                      /*!< (@ 0x00000434) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD14;                    /*!< (@ 0x00000438) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST14;                       /*!< (@ 0x0000043C) General PWM timer status register                          */
  __IOM uint32_t  GTBER14;                      /*!< (@ 0x00000440) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED12;
  __IOM uint32_t  GTCNT14;                      /*!< (@ 0x00000448) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA14;                     /*!< (@ 0x0000044C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB14;                     /*!< (@ 0x00000450) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC14;                     /*!< (@ 0x00000454) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE14;                     /*!< (@ 0x00000458) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD14;                     /*!< (@ 0x0000045C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF14;                     /*!< (@ 0x00000460) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR14;                       /*!< (@ 0x00000464) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR14;                      /*!< (@ 0x00000468) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED13[7];
  __IOM uint32_t  GTDTCR14;                     /*!< (@ 0x00000488) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU14;                      /*!< (@ 0x0000048C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED14[28];
  __IOM uint32_t  GTWP15;                       /*!< (@ 0x00000500) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR15;                      /*!< (@ 0x00000504) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP15;                      /*!< (@ 0x00000508) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR15;                      /*!< (@ 0x0000050C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR15;                      /*!< (@ 0x00000510) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR15;                      /*!< (@ 0x00000514) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR15;                      /*!< (@ 0x00000518) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR15;                     /*!< (@ 0x0000051C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR15;                     /*!< (@ 0x00000520) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR15;                    /*!< (@ 0x00000524) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR15;                    /*!< (@ 0x00000528) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR15;                       /*!< (@ 0x0000052C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC15;                   /*!< (@ 0x00000530) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR15;                      /*!< (@ 0x00000534) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD15;                    /*!< (@ 0x00000538) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST15;                       /*!< (@ 0x0000053C) General PWM timer status register                          */
  __IOM uint32_t  GTBER15;                      /*!< (@ 0x00000540) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED15;
  __IOM uint32_t  GTCNT15;                      /*!< (@ 0x00000548) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA15;                     /*!< (@ 0x0000054C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB15;                     /*!< (@ 0x00000550) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC15;                     /*!< (@ 0x00000554) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE15;                     /*!< (@ 0x00000558) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD15;                     /*!< (@ 0x0000055C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF15;                     /*!< (@ 0x00000560) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR15;                       /*!< (@ 0x00000564) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR15;                      /*!< (@ 0x00000568) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED16[7];
  __IOM uint32_t  GTDTCR15;                     /*!< (@ 0x00000588) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU15;                      /*!< (@ 0x0000058C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED17[28];
  __IOM uint32_t  GTWP16;                       /*!< (@ 0x00000600) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR16;                      /*!< (@ 0x00000604) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP16;                      /*!< (@ 0x00000608) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR16;                      /*!< (@ 0x0000060C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR16;                      /*!< (@ 0x00000610) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR16;                      /*!< (@ 0x00000614) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR16;                      /*!< (@ 0x00000618) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR16;                     /*!< (@ 0x0000061C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR16;                     /*!< (@ 0x00000620) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR16;                    /*!< (@ 0x00000624) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR16;                    /*!< (@ 0x00000628) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR16;                       /*!< (@ 0x0000062C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC16;                   /*!< (@ 0x00000630) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR16;                      /*!< (@ 0x00000634) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD16;                    /*!< (@ 0x00000638) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST16;                       /*!< (@ 0x0000063C) General PWM timer status register                          */
  __IOM uint32_t  GTBER16;                      /*!< (@ 0x00000640) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED18;
  __IOM uint32_t  GTCNT16;                      /*!< (@ 0x00000648) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA16;                     /*!< (@ 0x0000064C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB16;                     /*!< (@ 0x00000650) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC16;                     /*!< (@ 0x00000654) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE16;                     /*!< (@ 0x00000658) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD16;                     /*!< (@ 0x0000065C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF16;                     /*!< (@ 0x00000660) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR16;                       /*!< (@ 0x00000664) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR16;                      /*!< (@ 0x00000668) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED19[7];
  __IOM uint32_t  GTDTCR16;                     /*!< (@ 0x00000688) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU16;                      /*!< (@ 0x0000068C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED20[28];
  __IOM uint32_t  GTWP17;                       /*!< (@ 0x00000700) Universal PWM timer Write protect register                 */
  __IOM uint32_t  GTSTR17;                      /*!< (@ 0x00000704) Universal PWM timer Software start register                */
  __IOM uint32_t  GTSTP17;                      /*!< (@ 0x00000708) Universal PWM timer Software stop register                 */
  __OM  uint32_t  GTCLR17;                      /*!< (@ 0x0000070C) Universal PWM timer Software clear register                */
  __IOM uint32_t  GTSSR17;                      /*!< (@ 0x00000710) Universal PWM timer Start factor selection register        */
  __IOM uint32_t  GTPSR17;                      /*!< (@ 0x00000714) General PWM timer stop factor selection register           */
  __IOM uint32_t  GTCSR17;                      /*!< (@ 0x00000718) Universal PWM timer clear factor selection register        */
  __IOM uint32_t  GTUPSR17;                     /*!< (@ 0x0000071C) Universal PWM timer count factor selection register        */
  __IOM uint32_t  GTDNSR17;                     /*!< (@ 0x00000720) Universal PWM timer countdown factor selection
                                                                    register                                                   */
  __IOM uint32_t  GTICASR17;                    /*!< (@ 0x00000724) Universal PWM timer input capture factor selection
                                                                    register A                                                 */
  __IOM uint32_t  GTICBSR17;                    /*!< (@ 0x00000728) Universal PWM timer input capture factor selection
                                                                    register B                                                 */
  __IOM uint32_t  GTCR17;                       /*!< (@ 0x0000072C) General PWM timer control register                         */
  __IOM uint32_t  GTUDDTYC17;                   /*!< (@ 0x00000730) General PWM timer count direction and duty cycle
                                                                    setting register                                           */
  __IOM uint32_t  GTIOR17;                      /*!< (@ 0x00000734) Universal PWM timer I/O control register                   */
  __IOM uint32_t  GTINTAD17;                    /*!< (@ 0x00000738) General PWM timer interrupt output setting register        */
  __IOM uint32_t  GTST17;                       /*!< (@ 0x0000073C) General PWM timer status register                          */
  __IOM uint32_t  GTBER17;                      /*!< (@ 0x00000740) General PWM timer buffer enable register                   */
  __IM  uint32_t  RESERVED21;
  __IOM uint32_t  GTCNT17;                      /*!< (@ 0x00000748) Universal PWM timing counter register                      */
  __IOM uint32_t  GTCCRA17;                     /*!< (@ 0x0000074C) General PWM timer compare capture register A               */
  __IOM uint32_t  GTCCRB17;                     /*!< (@ 0x00000750) General PWM timer compare capture register B               */
  __IOM uint32_t  GTCCRC17;                     /*!< (@ 0x00000754) General PWM timer compare capture register C               */
  __IOM uint32_t  GTCCRE17;                     /*!< (@ 0x00000758) General PWM timer compare capture register E               */
  __IOM uint32_t  GTCCRD17;                     /*!< (@ 0x0000075C) General PWM timer compare capture register D               */
  __IOM uint32_t  GTCCRF17;                     /*!< (@ 0x00000760) General PWM timer compare capture register F               */
  __IOM uint32_t  GTPR17;                       /*!< (@ 0x00000764) General PWM timer cycle setting register                   */
  __IOM uint32_t  GTPBR17;                      /*!< (@ 0x00000768) General PWM timer cycle setting buffer register            */
  __IM  uint32_t  RESERVED22[7];
  __IOM uint32_t  GTDTCR17;                     /*!< (@ 0x00000788) Universal PWM timer dead time control register             */
  __IOM uint32_t  GTDVU17;                      /*!< (@ 0x0000078C) Universal PWM timer dead time value register
                                                                    U                                                          */
  __IM  uint32_t  RESERVED23[24];
  __IOM uint32_t  OPSCR;                        /*!< (@ 0x000007F0) Output phase switch control register                       */
} GPT1_Type;                                    /*!< Size = 2036 (0x7f4)                                                       */
#endif


/* =========================================================================================================================== */
/* ================                                            PGI                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief GPT port output enable (PGI)
  */

typedef struct {                                /*!< (@ 0x40090C00) PGI Structure                                              */
  __IOM uint32_t  POEGGA;                       /*!< (@ 0x00000000) POEG group A setting registe                               */
  __IM  uint32_t  RESERVED[3];
  __IOM uint32_t  POEGGB;                       /*!< (@ 0x00000010) POEG group B setting register                              */
  __IM  uint32_t  RESERVED1[3];
  __IOM uint32_t  POEGGC;                       /*!< (@ 0x00000020) POEG group C setting register                              */
  __IM  uint32_t  RESERVED2[3];
  __IOM uint32_t  POEGGD;                       /*!< (@ 0x00000030) POEG group D setting register                              */
} PGI_Type;                                     /*!< Size = 52 (0x34)                                                          */



/* =========================================================================================================================== */
/* ================                                            AES                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Advanced encryption engine (AES)
  */

typedef struct {                                /*!< (@ 0x40090E00) AES Structure                                              */
  __IOM uint32_t  MREG;                         /*!< (@ 0x00000000) Watchdog timer enable register                             */
  __IOM uint32_t  CREG;                         /*!< (@ 0x00000004) Control register                                           */
  __IOM uint32_t  DWIN;                         /*!< (@ 0x00000008) Data register                                              */
  __IOM uint32_t  IV;                           /*!< (@ 0x0000000C) Initial vector register                                    */
  __OM  uint32_t  KEY0;                         /*!< (@ 0x00000010) Key register 0                                             */
  __OM  uint32_t  KEY1;                         /*!< (@ 0x00000014) Key register 1                                             */
} AES_Type;                                     /*!< Size = 24 (0x18)                                                          */



/* =========================================================================================================================== */
/* ================                                            IIR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Infinite impulse response (IIR)
  */

typedef struct {                                /*!< (@ 0x40046800) IIR Structure                                              */
  __IOM uint16_t  I0IIRCTL;                     /*!< (@ 0x00000000) IIR0 control register                                      */
  __IM  uint16_t  RESERVED;
  __IOM uint8_t   I0A1COEF;                     /*!< (@ 0x00000004) IIR0 A1 coefficient register                               */
  __IM  uint8_t   RESERVED1;
  __IM  uint16_t  RESERVED2;
  __IOM uint8_t   I0A2COEF;                     /*!< (@ 0x00000008) IIR0 A2 coefficient register                               */
  __IM  uint8_t   RESERVED3;
  __IM  uint16_t  RESERVED4;
  __IOM uint8_t   I0B0COEF;                     /*!< (@ 0x0000000C) IIR0 B0 coefficient register                               */
  __IM  uint8_t   RESERVED5;
  __IM  uint16_t  RESERVED6;
  __IOM uint8_t   I0B1COEF;                     /*!< (@ 0x00000010) IIR0 B1 coefficient register                               */
  __IM  uint8_t   RESERVED7;
  __IM  uint16_t  RESERVED8;
  __IOM uint8_t   I0B2COEF;                     /*!< (@ 0x00000014) IIR0 B2 coefficient register                               */
  __IM  uint8_t   RESERVED9;
  __IM  uint16_t  RESERVED10;
  __IOM uint16_t  I0DATAIN;                     /*!< (@ 0x00000018) IIR0 data in register                                      */
  __IM  uint16_t  RESERVED11;
  __IOM uint32_t  I0DATAOUT;                    /*!< (@ 0x0000001C) IIR0 data in register                                      */
  __IOM uint16_t  I1IIRCTL;                     /*!< (@ 0x00000020) IIR1 control register                                      */
  __IM  uint16_t  RESERVED12;
  __IOM uint8_t   I1A1COEF;                     /*!< (@ 0x00000024) IIR1 A1 coefficient register                               */
  __IM  uint8_t   RESERVED13;
  __IM  uint16_t  RESERVED14;
  __IOM uint8_t   I1A2COEF;                     /*!< (@ 0x00000028) IIR1 A2 coefficient register                               */
  __IM  uint8_t   RESERVED15;
  __IM  uint16_t  RESERVED16;
  __IOM uint8_t   I1B0COEF;                     /*!< (@ 0x0000002C) IIR1 B0 coefficient register                               */
  __IM  uint8_t   RESERVED17;
  __IM  uint16_t  RESERVED18;
  __IOM uint8_t   I1B1COEF;                     /*!< (@ 0x00000030) IIR1 B1 coefficient register                               */
  __IM  uint8_t   RESERVED19;
  __IM  uint16_t  RESERVED20;
  __IOM uint8_t   I1B2COEF;                     /*!< (@ 0x00000034) IIR1 B2 coefficient register                               */
  __IM  uint8_t   RESERVED21;
  __IM  uint16_t  RESERVED22;
  __IOM uint16_t  I1DATAIN;                     /*!< (@ 0x00000038) IIR1 data in register                                      */
  __IM  uint16_t  RESERVED23;
  __IOM uint32_t  I1DATAOUT;                    /*!< (@ 0x0000003C) IIR1 data out register                                     */
  __IOM uint16_t  IIRMDCTL;                     /*!< (@ 0x00000040) IIR mode control register                                  */
  __IM  uint16_t  RESERVED24;
} IIR_Type;                                     /*!< Size = 68 (0x44)                                                          */



/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Event Link Controller (ELC)
  */

typedef struct {                                /*!< (@ 0x40091000) ELC Structure                                              */
  __IOM uint32_t  ELCR;                         /*!< (@ 0x00000000) EVENTC Enable control register                             */
  __IOM uint32_t  ELSR00;                       /*!< (@ 0x00000004) Event output destination select GPT EVENT A                */
  __IOM uint32_t  ELSR01;                       /*!< (@ 0x00000008) Event output destination select GPT EVENT B                */
  __IOM uint32_t  ELSR02;                       /*!< (@ 0x0000000C) Event output destination select GPT EVENT C                */
  __IOM uint32_t  ELSR03;                       /*!< (@ 0x00000010) Event output destination select GPT EVENT D                */
  __IOM uint32_t  ELSR04;                       /*!< (@ 0x00000014) Event output destination select ADCTL EVENT 0              */
  __IOM uint32_t  ELSR05;                       /*!< (@ 0x00000018) Event output destination select GPT EVENT 1                */
  __IOM uint32_t  ELSR06;                       /*!< (@ 0x0000001C) Event output destination select GPT EVENT 2                */
  __IOM uint32_t  ELSR07;                       /*!< (@ 0x00000020) Event output destination select GPT EVENT 3                */
  __IOM uint32_t  ELSR08;                       /*!< (@ 0x00000024) Event output destination select GPT EVENT 4                */
  __IOM uint32_t  ELSR09;                       /*!< (@ 0x00000028) Event output destination select GPT EVENT 5                */
  __IOM uint32_t  ELSR10;                       /*!< (@ 0x0000002C) Event output destination select GPT EVENT 6                */
  __IOM uint32_t  ELSR11;                       /*!< (@ 0x00000030) Event output destination select GPT EVENT 7                */
  __IOM uint32_t  ELSR12;                       /*!< (@ 0x00000034) Event output destination select GPT EVENT 8                */
  __IOM uint32_t  ELSR13;                       /*!< (@ 0x00000038) Event output destination select Timer80 0                  */
  __IOM uint32_t  ELSR14;                       /*!< (@ 0x0000003C) Event output destination select Timer80 1                  */
  __IOM uint32_t  ELSR15;                       /*!< (@ 0x00000040) Event output destination select DA0                        */
  __IOM uint32_t  ELSR16;                       /*!< (@ 0x00000044) Event output destination select DA1                        */
  __IOM uint32_t  ELSR17;                       /*!< (@ 0x00000048) Event output destination select DMA CH0                    */
  __IOM uint32_t  ELSR18;                       /*!< (@ 0x0000004C) Event output destination select DMA CH1                    */
  __IOM uint32_t  ELSR19;                       /*!< (@ 0x00000050) Event output destination select DMA CH2                    */
  __IOM uint32_t  ELSR20;                       /*!< (@ 0x00000054) Event output destination select DMA CH3                    */
  __IOM uint32_t  ELSR21;                       /*!< (@ 0x00000058) Event output destination select DMA CH4                    */
  __IOM uint32_t  ELSR22;                       /*!< (@ 0x0000005C) Event output destination select DMA CH5                    */
  __IOM uint32_t  ELSR23;                       /*!< (@ 0x00000060) Event output destination select DMA CH6                    */
  __IOM uint32_t  ELSR24;                       /*!< (@ 0x00000064) Event output destination select DMA CH7                    */
  __IOM uint32_t  ELSR25;                       /*!< (@ 0x00000068) Event output destination select DMA CH8                    */
  __IOM uint32_t  ELSR26;                       /*!< (@ 0x0000006C) Event output destination select DMA CH9                    */
  __IOM uint32_t  ELSR27;                       /*!< (@ 0x00000070) Event output destination select DMA CH10                   */
  __IOM uint32_t  ELSR28;                       /*!< (@ 0x00000074) Event output destination select DMA CH11                   */
  __IOM uint32_t  ELSR29;                       /*!< (@ 0x00000078) Event output destination select DMA CH12                   */
  __IOM uint32_t  ELSR30;                       /*!< (@ 0x0000007C) Event output destination select DMA CH13                   */
  __IOM uint32_t  ELSR31;                       /*!< (@ 0x00000080) Event output destination select DMA CH14                   */
  __IOM uint32_t  ELSR32;                       /*!< (@ 0x00000084) Event output destination select DMA CH15                   */
} ELC_Type;                                     /*!< Size = 136 (0x88)                                                         */



/* =========================================================================================================================== */
/* ================                                           ADC                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief A/D Converter 0 (ADC0, ADC1, ADC2)
  */

typedef struct {                                /*!< (@ 0x40091400) ADC0 Structure                                             */
  __IOM uint16_t  ADCSR;                        /*!< (@ 0x00000000) A/D control register                                       */
  __IM  uint16_t  RESERVED;
  __IOM uint16_t  ADANSA;                       /*!< (@ 0x00000004) A/D channel selection register A0                          */
  __IM  uint16_t  RESERVED1;
  __IOM uint16_t  ADADS;                        /*!< (@ 0x00000008) A/D conversion value addition/average function
                                                                    selection register                                         */
  __IM  uint16_t  RESERVED2;
  __IOM uint8_t   ADADC;                        /*!< (@ 0x0000000C) A/D conversion value addition/average count selection
                                                                    register                                                   */
  __IM  uint8_t   RESERVED3;
  __IOM uint16_t  ADCER;                        /*!< (@ 0x0000000E) A/D control extension register                             */
  __IOM uint16_t  ADSTRGR;                      /*!< (@ 0x00000010) A/D conversion start trigger selection register            */
  __IOM uint16_t  ADEXICR;                      /*!< (@ 0x00000012) A/D conversion extended input control register             */
  __IOM uint16_t  ADANSB;                       /*!< (@ 0x00000014) A/D channel selection register B0                          */
  __IM  uint16_t  RESERVED4[2];
  __IM  uint16_t  ADTSDR;                       /*!< (@ 0x0000001A) A/D internal Temperature sensor data register  (ADC2 only) */
  __IM  uint16_t  ADOCDR;                       /*!< (@ 0x0000001C) A/D internal reference voltage data register   (ADC2 only) */
  __IOM uint16_t  ADRD;                         /*!< (@ 0x0000001E) A/D self diagnostic data register                          */
  __IM  uint16_t  ADDR0;                        /*!< (@ 0x00000020) A/D data register 0                                        */
  __IM  uint16_t  ADDR1;                        /*!< (@ 0x00000022) A/D data register 1                                        */
  __IM  uint16_t  ADDR2;                        /*!< (@ 0x00000024) A/D data register 2                                        */
  __IM  uint16_t  ADDR3;                        /*!< (@ 0x00000026) A/D data register 3                                        */
  __IM  uint16_t  ADDR4;                        /*!< (@ 0x00000028) A/D data register 4                                        */
  __IM  uint16_t  ADDR5;                        /*!< (@ 0x0000002A) A/D data register 5                                        */
  __IM  uint16_t  ADDR6;                        /*!< (@ 0x0000002C) A/D data register 6                                        */
  __IM  uint16_t  ADDR7;                        /*!< (@ 0x0000002E) A/D data register 7                                        */
  __IM  uint16_t  ADDR8;                        /*!< (@ 0x00000030) A/D data register 8                                        */
  __IM  uint16_t  ADDR9;                        /*!< (@ 0x00000032) A/D data register 9                                        */
  __IM  uint16_t  ADDR10;                       /*!< (@ 0x00000034) A/D data register 10                                       */
  __IM  uint16_t  ADDR11;                       /*!< (@ 0x00000036) A/D data register 11                                       */
  __IM  uint16_t  ADDR12;                       /*!< (@ 0x00000038) A/D data register 12                                       */
  __IM  uint16_t  ADDR13;                       /*!< (@ 0x0000003A) A/D data register 13                                       */
  __IM  uint16_t  ADDR14;                       /*!< (@ 0x0000003C) A/D data register 14                                       */
  __IM  uint16_t  ADDR15;                       /*!< (@ 0x0000003E) A/D data register 15                                       */
  __IM  uint16_t  ADDR16;                       /*!< (@ 0x00000040) A/D data register 16                                       */
  __IM  uint16_t  ADDR17;                       /*!< (@ 0x00000042) A/D data register 17                                       */
  __IM  uint16_t  ADDR18;                       /*!< (@ 0x00000044) A/D data register 18                                       */
  __IM  uint16_t  ADDR19;                       /*!< (@ 0x00000046) A/D data register 19                                       */
  __IM  uint16_t  ADDR20;                       /*!< (@ 0x00000048) A/D data register 20                                       */
  __IM  uint16_t  ADDR21;                       /*!< (@ 0x0000004A) A/D data register 21                                       */
  __IM  uint16_t  ADDR22;                       /*!< (@ 0x0000004C) A/D data register 22                                       */
  __IM  uint16_t  ADDR23;                       /*!< (@ 0x0000004E) A/D data register 23                                       */
  __IM  uint16_t  ADDR24;                       /*!< (@ 0x00000050) A/D data register 24                                       */
  __IM  uint16_t  ADDR25;                       /*!< (@ 0x00000052) A/D data register 25                                       */
  __IM  uint16_t  ADDR26;                       /*!< (@ 0x00000054) A/D data register 26                                       */
  __IM  uint16_t  ADDR27;                       /*!< (@ 0x00000056) A/D data register 27                                       */
  __IM  uint16_t  ADDR28;                       /*!< (@ 0x00000058) A/D data register 28                                       */
  __IM  uint16_t  ADDR29;                       /*!< (@ 0x0000005A) A/D data register 29                                       */
  __IM  uint16_t  ADDR30;                       /*!< (@ 0x0000005C) A/D data register 30                                       */
  __IM  uint16_t  ADDR31;                       /*!< (@ 0x0000005E) A/D data register 31                                       */
  __IOM uint16_t  ADCLKDIV;                     /*!< (@ 0x00000060) A/D clock division control register                        */
  __IM  uint16_t  RESERVED5[2];
  __IOM uint16_t  ADSHCR;                       /*!< (@ 0x00000066) A/D sample and hold circuit control register               */
  __IM  uint16_t  RESERVED6[9];
  __IOM uint8_t   ADDISCR;                      /*!< (@ 0x0000007A) A/D sample and hold circuit control register               */
  __IM  uint8_t   RESERVED7;
  __IM  uint16_t  RESERVED8[2];
  __IOM uint16_t  ADGSPCR;                      /*!< (@ 0x00000080) Group A/D scan priority control register                   */
  __IM  uint16_t  RESERVED9;
  __IM  uint16_t  ADDBLDRA;                     /*!< (@ 0x00000084) A/D data copy register A                                   */
  __IM  uint16_t  ADDBLDRB;                     /*!< (@ 0x00000086) A/D data copy register B                                   */
  __IM  uint16_t  RESERVED10[38];
  __IOM uint16_t  ADANSC;                       /*!< (@ 0x000000D4) A/D channel selection register C0                          */
  __IM  uint16_t  RESERVED11;
  __IM  uint8_t   RESERVED12;
  __IOM uint8_t   ADGCTRGR;                     /*!< (@ 0x000000D9) A/D group C trigger selection register                     */
  __IM  uint16_t  RESERVED13;
  __IM  uint8_t   RESERVED14;
  __IOM uint8_t   ADSSTRL;                      /*!< (@ 0x000000DD) Sets the sampling time of the analog input                 */
  __IM  uint8_t   RESERVED15;
  __IOM uint8_t   ADSSTRO;                      /*!< (@ 0x000000DF) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR0;                      /*!< (@ 0x000000E0) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR1;                      /*!< (@ 0x000000E1) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR2;                      /*!< (@ 0x000000E2) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR3;                      /*!< (@ 0x000000E3) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR4;                      /*!< (@ 0x000000E4) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR5;                      /*!< (@ 0x000000E5) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR6;                      /*!< (@ 0x000000E6) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR7;                      /*!< (@ 0x000000E7) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR8;                      /*!< (@ 0x000000E8) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR9;                      /*!< (@ 0x000000E9) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR10;                     /*!< (@ 0x000000EA) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR11;                     /*!< (@ 0x000000EB) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR12;                     /*!< (@ 0x000000EC) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR13;                     /*!< (@ 0x000000ED) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR14;                     /*!< (@ 0x000000EE) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR15;                     /*!< (@ 0x000000EF) Sets the sampling time of the analog input                 */
  __IM  uint16_t  RESERVED16[88];
  __IOM uint16_t  ADPGACR;                      /*!< (@ 0x000001A0) A/D programmable gain amplifier control register 0         */
  __IOM uint16_t  ADPGAGS;                      /*!< (@ 0x000001A2) A/D programmable gain amplifier gain setting register 0    */
  __IM  uint16_t  RESERVED17[6];
  __IOM uint16_t  ADPGADCR;                     /*!< (@ 0x000001B0) A/D programmable gain amplifier differential
                                                                    input control register (ADC0, ADC1 only)                   */
} ADC_Type;                                    /*!< Size = 434 (0x1b2)                                                         */


#if 0
/* =========================================================================================================================== */
/* ================                                           ADC1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief A/D Converter 1 (ADC1)
  */

typedef struct {                                /*!< (@ 0x40091800) ADC1 Structure                                             */
  __IOM uint16_t  ADCSR;                        /*!< (@ 0x00000000) A/D control register                                       */
  __IM  uint16_t  RESERVED;
  __IOM uint16_t  ADANSA;                       /*!< (@ 0x00000004) A/D channel selection register A0                          */
  __IM  uint16_t  RESERVED1;
  __IOM uint16_t  ADADS;                        /*!< (@ 0x00000008) A/D conversion value addition/average function
                                                                    selection register                                         */
  __IM  uint16_t  RESERVED2;
  __IOM uint8_t   ADADC;                        /*!< (@ 0x0000000C) A/D conversion value addition/average count selection
                                                                    register                                                   */
  __IM  uint8_t   RESERVED3;
  __IOM uint16_t  ADCER;                        /*!< (@ 0x0000000E) A/D control extension register                             */
  __IOM uint16_t  ADSTRGR;                      /*!< (@ 0x00000010) A/D conversion start trigger selection register            */
  __IOM uint16_t  ADEXICR;                      /*!< (@ 0x00000012) A/D conversion extended input control register             */
  __IOM uint16_t  ADANSB;                       /*!< (@ 0x00000014) A/D channel selection register B0                          */
  __IM  uint16_t  RESERVED4[4];
  __IOM uint16_t  ADRD;                         /*!< (@ 0x0000001E) A/D self diagnostic data register                          */
  __IM  uint16_t  ADDR0;                        /*!< (@ 0x00000020) A/D data register 0                                        */
  __IM  uint16_t  ADDR1;                        /*!< (@ 0x00000022) A/D data register 1                                        */
  __IM  uint16_t  ADDR2;                        /*!< (@ 0x00000024) A/D data register 2                                        */
  __IM  uint16_t  ADDR3;                        /*!< (@ 0x00000026) A/D data register 3                                        */
  __IM  uint16_t  ADDR4;                        /*!< (@ 0x00000028) A/D data register 4                                        */
  __IM  uint16_t  ADDR5;                        /*!< (@ 0x0000002A) A/D data register 5                                        */
  __IM  uint16_t  ADDR6;                        /*!< (@ 0x0000002C) A/D data register 6                                        */
  __IM  uint16_t  ADDR7;                        /*!< (@ 0x0000002E) A/D data register 7                                        */
  __IM  uint16_t  ADDR8;                        /*!< (@ 0x00000030) A/D data register 8                                        */
  __IM  uint16_t  ADDR9;                        /*!< (@ 0x00000032) A/D data register 9                                        */
  __IM  uint16_t  ADDR10;                       /*!< (@ 0x00000034) A/D data register 10                                       */
  __IM  uint16_t  ADDR11;                       /*!< (@ 0x00000036) A/D data register 11                                       */
  __IM  uint16_t  ADDR12;                       /*!< (@ 0x00000038) A/D data register 12                                       */
  __IM  uint16_t  ADDR13;                       /*!< (@ 0x0000003A) A/D data register 13                                       */
  __IM  uint16_t  ADDR14;                       /*!< (@ 0x0000003C) A/D data register 14                                       */
  __IM  uint16_t  ADDR15;                       /*!< (@ 0x0000003E) A/D data register 15                                       */
  __IM  uint16_t  ADDR16;                       /*!< (@ 0x00000040) A/D data register 16                                       */
  __IM  uint16_t  ADDR17;                       /*!< (@ 0x00000042) A/D data register 17                                       */
  __IM  uint16_t  ADDR18;                       /*!< (@ 0x00000044) A/D data register 18                                       */
  __IM  uint16_t  ADDR19;                       /*!< (@ 0x00000046) A/D data register 19                                       */
  __IM  uint16_t  ADDR20;                       /*!< (@ 0x00000048) A/D data register 20                                       */
  __IM  uint16_t  ADDR21;                       /*!< (@ 0x0000004A) A/D data register 21                                       */
  __IM  uint16_t  ADDR22;                       /*!< (@ 0x0000004C) A/D data register 22                                       */
  __IM  uint16_t  ADDR23;                       /*!< (@ 0x0000004E) A/D data register 23                                       */
  __IM  uint16_t  ADDR24;                       /*!< (@ 0x00000050) A/D data register 24                                       */
  __IM  uint16_t  ADDR25;                       /*!< (@ 0x00000052) A/D data register 25                                       */
  __IM  uint16_t  ADDR26;                       /*!< (@ 0x00000054) A/D data register 26                                       */
  __IM  uint16_t  ADDR27;                       /*!< (@ 0x00000056) A/D data register 27                                       */
  __IM  uint16_t  ADDR28;                       /*!< (@ 0x00000058) A/D data register 28                                       */
  __IM  uint16_t  ADDR29;                       /*!< (@ 0x0000005A) A/D data register 29                                       */
  __IM  uint16_t  ADDR30;                       /*!< (@ 0x0000005C) A/D data register 30                                       */
  __IM  uint16_t  ADDR31;                       /*!< (@ 0x0000005E) A/D data register 31                                       */
  __IOM uint16_t  ADCLKDIV;                     /*!< (@ 0x00000060) A/D clock division control register                        */
  __IM  uint16_t  RESERVED5[2];
  __IOM uint16_t  ADSHCR;                       /*!< (@ 0x00000066) A/D sample and hold circuit control register               */
  __IM  uint16_t  RESERVED6[9];
  __IOM uint8_t   ADDISCR;                      /*!< (@ 0x0000007A) A/D sample and hold circuit control register               */
  __IM  uint8_t   RESERVED7;
  __IM  uint16_t  RESERVED8[2];
  __IOM uint16_t  ADGSPCR;                      /*!< (@ 0x00000080) Group A/D scan priority control register                   */
  __IM  uint16_t  RESERVED9;
  __IM  uint16_t  ADDBLDRA;                     /*!< (@ 0x00000084) A/D data copy register A                                   */
  __IM  uint16_t  ADDBLDRB;                     /*!< (@ 0x00000086) A/D data copy register B                                   */
  __IM  uint16_t  RESERVED10[38];
  __IOM uint16_t  ADANSC;                       /*!< (@ 0x000000D4) A/D channel selection register C0                          */
  __IM  uint16_t  RESERVED11;
  __IM  uint8_t   RESERVED12;
  __IOM uint8_t   ADGCTRGR;                     /*!< (@ 0x000000D9) A/D group C trigger selection register                     */
  __IM  uint16_t  RESERVED13;
  __IM  uint8_t   RESERVED14;
  __IOM uint8_t   ADSSTRL;                      /*!< (@ 0x000000DD) Sets the sampling time of the analog input                 */
  __IM  uint8_t   RESERVED15;
  __IOM uint8_t   ADSSTRO;                      /*!< (@ 0x000000DF) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR0;                      /*!< (@ 0x000000E0) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR1;                      /*!< (@ 0x000000E1) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR2;                      /*!< (@ 0x000000E2) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR3;                      /*!< (@ 0x000000E3) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR4;                      /*!< (@ 0x000000E4) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR5;                      /*!< (@ 0x000000E5) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR6;                      /*!< (@ 0x000000E6) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR7;                      /*!< (@ 0x000000E7) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR8;                      /*!< (@ 0x000000E8) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR9;                      /*!< (@ 0x000000E9) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR10;                     /*!< (@ 0x000000EA) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR11;                     /*!< (@ 0x000000EB) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR12;                     /*!< (@ 0x000000EC) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR13;                     /*!< (@ 0x000000ED) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR14;                     /*!< (@ 0x000000EE) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR15;                     /*!< (@ 0x000000EF) Sets the sampling time of the analog input                 */
  __IM  uint16_t  RESERVED16[88];
  __IOM uint16_t  ADPGACR;                      /*!< (@ 0x000001A0) A/D programmable gain amplifier control register
                                                                    1                                                          */
  __IOM uint16_t  ADPGAGS;                      /*!< (@ 0x000001A2) A/D programmable gain amplifier gain setting
                                                                    register 1                                                 */
  __IM  uint16_t  RESERVED17[6];
  __IOM uint16_t  ADPGADCR;                     /*!< (@ 0x000001B0) A/D programmable gain amplifier differential
                                                                    input control register 1                                   */
} ADC1_Type;                                    /*!< Size = 434 (0x1b2)                                                        */



/* =========================================================================================================================== */
/* ================                                           ADC2                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief A/D Converter 2 (ADC2)
  */

typedef struct {                                /*!< (@ 0x40091C00) ADC2 Structure                                             */
  __IOM uint16_t  ADCSR;                        /*!< (@ 0x00000000) A/D control register                                       */
  __IM  uint16_t  RESERVED;
  __IOM uint16_t  ADANSA;                       /*!< (@ 0x00000004) A/D channel selection register A0                          */
  __IM  uint16_t  RESERVED1;
  __IOM uint16_t  ADADS;                        /*!< (@ 0x00000008) A/D conversion value addition/average function
                                                                    selection register                                         */
  __IM  uint16_t  RESERVED2;
  __IOM uint8_t   ADADC;                        /*!< (@ 0x0000000C) A/D conversion value addition/average count selection
                                                                    register                                                   */
  __IM  uint8_t   RESERVED3;
  __IOM uint16_t  ADCER;                        /*!< (@ 0x0000000E) A/D control extension register                             */
  __IOM uint16_t  ADSTRGR;                      /*!< (@ 0x00000010) A/D conversion start trigger selection register            */
  __IOM uint16_t  ADEXICR;                      /*!< (@ 0x00000012) A/D conversion extended input control register             */
  __IOM uint16_t  ADANSB;                       /*!< (@ 0x00000014) A/D channel selection register B0                          */
  __IM  uint16_t  RESERVED4[2];
  __IM  uint16_t  ADTSDR;                       /*!< (@ 0x0000001A) A/D internal Temperature sensor data register              */
  __IM  uint16_t  ADOCDR;                       /*!< (@ 0x0000001C) A/D internal reference voltage data register               */
  __IOM uint16_t  ADRD;                         /*!< (@ 0x0000001E) A/D self diagnostic data register                          */
  __IM  uint16_t  ADDR0;                        /*!< (@ 0x00000020) A/D data register 0                                        */
  __IM  uint16_t  ADDR1;                        /*!< (@ 0x00000022) A/D data register 1                                        */
  __IM  uint16_t  ADDR2;                        /*!< (@ 0x00000024) A/D data register 2                                        */
  __IM  uint16_t  ADDR3;                        /*!< (@ 0x00000026) A/D data register 3                                        */
  __IM  uint16_t  ADDR4;                        /*!< (@ 0x00000028) A/D data register 4                                        */
  __IM  uint16_t  ADDR5;                        /*!< (@ 0x0000002A) A/D data register 5                                        */
  __IM  uint16_t  ADDR6;                        /*!< (@ 0x0000002C) A/D data register 6                                        */
  __IM  uint16_t  ADDR7;                        /*!< (@ 0x0000002E) A/D data register 7                                        */
  __IM  uint16_t  ADDR8;                        /*!< (@ 0x00000030) A/D data register 8                                        */
  __IM  uint16_t  ADDR9;                        /*!< (@ 0x00000032) A/D data register 9                                        */
  __IM  uint16_t  ADDR10;                       /*!< (@ 0x00000034) A/D data register 10                                       */
  __IM  uint16_t  ADDR11;                       /*!< (@ 0x00000036) A/D data register 11                                       */
  __IM  uint16_t  ADDR12;                       /*!< (@ 0x00000038) A/D data register 12                                       */
  __IM  uint16_t  ADDR13;                       /*!< (@ 0x0000003A) A/D data register 13                                       */
  __IM  uint16_t  ADDR14;                       /*!< (@ 0x0000003C) A/D data register 14                                       */
  __IM  uint16_t  ADDR15;                       /*!< (@ 0x0000003E) A/D data register 15                                       */
  __IM  uint16_t  ADDR16;                       /*!< (@ 0x00000040) A/D data register 16                                       */
  __IM  uint16_t  ADDR17;                       /*!< (@ 0x00000042) A/D data register 17                                       */
  __IM  uint16_t  ADDR18;                       /*!< (@ 0x00000044) A/D data register 18                                       */
  __IM  uint16_t  ADDR19;                       /*!< (@ 0x00000046) A/D data register 19                                       */
  __IM  uint16_t  ADDR20;                       /*!< (@ 0x00000048) A/D data register 20                                       */
  __IM  uint16_t  ADDR21;                       /*!< (@ 0x0000004A) A/D data register 21                                       */
  __IM  uint16_t  ADDR22;                       /*!< (@ 0x0000004C) A/D data register 22                                       */
  __IM  uint16_t  ADDR23;                       /*!< (@ 0x0000004E) A/D data register 23                                       */
  __IM  uint16_t  ADDR24;                       /*!< (@ 0x00000050) A/D data register 24                                       */
  __IM  uint16_t  ADDR25;                       /*!< (@ 0x00000052) A/D data register 25                                       */
  __IM  uint16_t  ADDR26;                       /*!< (@ 0x00000054) A/D data register 26                                       */
  __IM  uint16_t  ADDR27;                       /*!< (@ 0x00000056) A/D data register 27                                       */
  __IM  uint16_t  ADDR28;                       /*!< (@ 0x00000058) A/D data register 28                                       */
  __IM  uint16_t  ADDR29;                       /*!< (@ 0x0000005A) A/D data register 29                                       */
  __IM  uint16_t  ADDR30;                       /*!< (@ 0x0000005C) A/D data register 30                                       */
  __IM  uint16_t  ADDR31;                       /*!< (@ 0x0000005E) A/D data register 31                                       */
  __IOM uint16_t  ADCLKDIV;                     /*!< (@ 0x00000060) A/D clock division control register                        */
  __IM  uint16_t  RESERVED5[2];
  __IOM uint16_t  ADSHCR;                       /*!< (@ 0x00000066) A/D sample and hold circuit control register               */
  __IM  uint16_t  RESERVED6[9];
  __IOM uint8_t   ADDISCR;                      /*!< (@ 0x0000007A) A/D sample and hold circuit control register               */
  __IM  uint8_t   RESERVED7;
  __IM  uint16_t  RESERVED8[2];
  __IOM uint16_t  ADGSPCR;                      /*!< (@ 0x00000080) Group A/D scan priority control register                   */
  __IM  uint16_t  RESERVED9;
  __IM  uint16_t  ADDBLDRA;                     /*!< (@ 0x00000084) A/D data copy register A                                   */
  __IM  uint16_t  ADDBLDRB;                     /*!< (@ 0x00000086) A/D data copy register B                                   */
  __IM  uint16_t  RESERVED10[39];
  __IOM uint16_t  ADANSC1;                      /*!< (@ 0x000000D6) A/D channel selection register C1                          */
  __IM  uint8_t   RESERVED11;
  __IOM uint8_t   ADGCTRGR;                     /*!< (@ 0x000000D9) A/D group C trigger selection register                     */
  __IM  uint16_t  RESERVED12;
  __IM  uint8_t   RESERVED13;
  __IOM uint8_t   ADSSTRL;                      /*!< (@ 0x000000DD) Sets the sampling time of the analog input                 */
  __IM  uint8_t   RESERVED14;
  __IOM uint8_t   ADSSTRO;                      /*!< (@ 0x000000DF) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR0;                      /*!< (@ 0x000000E0) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR1;                      /*!< (@ 0x000000E1) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR2;                      /*!< (@ 0x000000E2) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR3;                      /*!< (@ 0x000000E3) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR4;                      /*!< (@ 0x000000E4) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR5;                      /*!< (@ 0x000000E5) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR6;                      /*!< (@ 0x000000E6) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR7;                      /*!< (@ 0x000000E7) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR8;                      /*!< (@ 0x000000E8) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR9;                      /*!< (@ 0x000000E9) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR10;                     /*!< (@ 0x000000EA) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR11;                     /*!< (@ 0x000000EB) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR12;                     /*!< (@ 0x000000EC) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR13;                     /*!< (@ 0x000000ED) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR14;                     /*!< (@ 0x000000EE) Sets the sampling time of the analog input                 */
  __IOM uint8_t   ADSSTR15;                     /*!< (@ 0x000000EF) Sets the sampling time of the analog input                 */
} ADC2_Type;                                    /*!< Size = 240 (0xf0)                                                         */

#endif

/* =========================================================================================================================== */
/* ================                                           QSPI                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief QSPI communication module (QSPI)
  */

typedef struct {                                /*!< (@ 0x64000000) QSPI Structure                                             */
  __IOM uint32_t  SFMSMD;                       /*!< (@ 0x00000000) Transfer Mode Control Register                             */
  __IOM uint32_t  SFMSSC;                       /*!< (@ 0x00000004) Chip Selection Control Register                            */
  __IOM uint32_t  SFMSKC;                       /*!< (@ 0x00000008) Clock Control Register                                     */
  __IM  uint32_t  SFMSST;                       /*!< (@ 0x0000000C) Status Register                                            */
  __IOM uint32_t  SFMCOM;                       /*!< (@ 0x00000010) Communication Port Register                                */
  __IOM uint32_t  SFMCMD;                       /*!< (@ 0x00000014) Communication Mode Control Register                        */
  __IOM uint32_t  SFMCST;                       /*!< (@ 0x00000018) Communication Status Register                              */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  SFMSIC;                       /*!< (@ 0x00000020) Instruction Code Register                                  */
  __IOM uint32_t  SFMSAC;                       /*!< (@ 0x00000024) Address Mode Control Register                              */
  __IOM uint32_t  SFMSDC;                       /*!< (@ 0x00000028) Dummy Cycle Control Register                               */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  SFMSPC;                       /*!< (@ 0x00000030) SPI Protocol Control Register                              */
  __IOM uint32_t  SFMPMD;                       /*!< (@ 0x00000034) Port Control Register                                      */
  __IM  uint32_t  RESERVED2[499];
  __IOM uint32_t  SFMCNT1;                      /*!< (@ 0x00000804) External QSPI Address Register                             */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  SFMDMA;                       /*!< (@ 0x0000080C) External QSPI DMA Transfer Software Trigger Register       */
  __IOM uint32_t  SFMCRPT;                      /*!< (@ 0x00000810) External QSPI Crypto Transfer Control Register             */
} QSPI_Type;                                    /*!< Size = 2068 (0x814)                                                       */



/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor calibration data (TSN)
  */

typedef struct {                                /*!< (@ 0x00500C68) TSN Structure                                              */
  __IM  int16_t   TSN85;                        /*!< (@ 0x00000000) The A/D conversion value of Temperature Sensor
                                                                    at 85 degrees and 3.0V reference voltage                   */
  __IM  uint16_t  RESERVED;
  __IM  int16_t   TSN25;                        /*!< (@ 0x00000004) The A/D conversion value of Temperature Sensor
                                                                    at 25 degrees and 3.0V reference voltage                   */
} TSN_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            BGR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor calibration data (BGR)
  */

typedef struct {                                /*!< (@ 0x08500C60) BGR Structure                                              */
  __IM  uint16_t  VBG85;                        /*!< (@ 0x00000000) The A/D conversion value of VBGR at 85 degrees
                                                                    and 3.0V reference voltage                                 */
  __IM  uint16_t  RESERVED;
  __IM  uint16_t  VBG25;                        /*!< (@ 0x00000004) The A/D conversion value of VBGR at 25 degrees
                                                                    and 3.0V reference voltage                                 */
} BGR_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief 128-bit Unique ID (UID)
  */

typedef struct {                                /*!< (@ 0x08500E4C) UID Structure                                              */
  __IM  uint32_t  UID0;                         /*!< (@ 0x00000000) UID word 0                                                 */
  __IM  uint32_t  UID1;                         /*!< (@ 0x00000004) UID word 1                                                 */
  __IM  uint32_t  UID2;                         /*!< (@ 0x00000008) UID word 2                                                 */
  __IM  uint32_t  UID3;                         /*!< (@ 0x0000000C) UID word 3                                                 */
} UID_Type;                                     /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define CGC_BASE                    0x40020400UL
#define RST_BASE                    0x40020420UL
#define SAF_BASE                    0x40020100UL
#define LVD_BASE                    0x40020440UL
#define SRAM_BASE                   0x40018000UL
#define DMA_BASE                    0x40005000UL
#define DMAVEC_BASE                 0x20000000UL
#define WDT_BASE                    0x40021000UL
#define IWDT_BASE                   0x40021100UL
#define OSDC_BASE                   0x40022200UL
#define OCRV_BASE                   0x40022400UL
#define FMC_BASE                    0x40020000UL
#define PORT_BASE                   0x40040000UL
#define MISC_BASE                   0x40040470UL
#define PPORGA_BASE                 0x4004087BUL
#define PCBZ_BASE                   0x40040FA0UL
#define SCI0_BASE                   0x40041000UL
#define SCI1_BASE                   0x40041200UL
#define SCI2_BASE                   0x40041400UL
#define SCI3_BASE                   0x40041600UL
#define TM80_BASE                   0x40041C00UL
#define TM81_BASE                   0x40042000UL
#define SPIHS0_BASE                 0x40042400UL
#define SPIHS1_BASE                 0x40042800UL
#define IICA0_BASE                  0x40041A30UL
#define IICA1_BASE                  0x40042E30UL
#define CMP0_BASE                   0x40043840UL
#define CMP1_BASE                   0x40043940UL
#define CMP2_BASE                   0x40043A40UL
#define CMP3_BASE                   0x40043B40UL
#define IRDA_BASE                   0x40043CA0UL
#define DAC_BASE                    0x40044334UL
#define LCDB_BASE                   0x40044400UL
#define KEY_BASE                    0x40044B37UL
#define RTC_BASE                    0x40044F00UL
#define INTM_BASE                   0x40045B38UL
#define CAN0_BASE                   0x40045C00UL
#define CAN0MSG00_BASE              0x40045D00UL
#define CAN0MSG01_BASE              0x40045D10UL
#define CAN0MSG02_BASE              0x40045D20UL
#define CAN0MSG03_BASE              0x40045D30UL
#define CAN0MSG04_BASE              0x40045D40UL
#define CAN0MSG05_BASE              0x40045D50UL
#define CAN0MSG06_BASE              0x40045D60UL
#define CAN0MSG07_BASE              0x40045D70UL
#define CAN0MSG08_BASE              0x40045D80UL
#define CAN0MSG09_BASE              0x40045D90UL
#define CAN0MSG10_BASE              0x40045DA0UL
#define CAN0MSG11_BASE              0x40045DB0UL
#define CAN0MSG12_BASE              0x40045DC0UL
#define CAN0MSG13_BASE              0x40045DD0UL
#define CAN0MSG14_BASE              0x40045DE0UL
#define CAN0MSG15_BASE              0x40045DF0UL
#define CAN1_BASE                   0x40046000UL
#define CAN1MSG00_BASE              0x40046100UL
#define CAN1MSG01_BASE              0x40046110UL
#define CAN1MSG02_BASE              0x40046120UL
#define CAN1MSG03_BASE              0x40046130UL
#define CAN1MSG04_BASE              0x40046140UL
#define CAN1MSG05_BASE              0x40046150UL
#define CAN1MSG06_BASE              0x40046160UL
#define CAN1MSG07_BASE              0x40046170UL
#define CAN1MSG08_BASE              0x40046180UL
#define CAN1MSG09_BASE              0x40046190UL
#define CAN1MSG10_BASE              0x400461A0UL
#define CAN1MSG11_BASE              0x400461B0UL
#define CAN1MSG12_BASE              0x400461C0UL
#define CAN1MSG13_BASE              0x400461D0UL
#define CAN1MSG14_BASE              0x400461E0UL
#define CAN1MSG15_BASE              0x400461F0UL
#define TRNG_BASE                   0x40046400UL
#define DBG_BASE                    0x4001B000UL
#define GPT0_BASE                   0x40090000UL
#define GPT1_BASE                   0x40090400UL
#define PGI_BASE                    0x40090C00UL
#define AES_BASE                    0x40090E00UL
#define IIR_BASE                    0x40046800UL
#define ELC_BASE                    0x40091000UL
#define ADC0_BASE                   0x40091400UL
#define ADC1_BASE                   0x40091800UL
#define ADC2_BASE                   0x40091C00UL
#define QSPI_BASE                   0x64000000UL
#define TSN_BASE                    0x00500C68UL
#define BGR_BASE                    0x00500C60UL
#define UID_BASE                    0x00500E4CUL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define CGC                         ((CGC_Type*)               CGC_BASE)
#define RST                         ((RST_Type*)               RST_BASE)
#define SAF                         ((SAF_Type*)               SAF_BASE)
#define LVD                         ((LVD_Type*)               LVD_BASE)
#define SRAM                        ((SRAM_Type*)              SRAM_BASE)
#define DMA                         ((DMA_Type*)               DMA_BASE)
#define DMAVEC                      ((DMAVEC_Type*)            DMAVEC_BASE)
#define WDT                         ((WDT_Type*)               WDT_BASE)
#define IWDT                        ((IWDT_Type*)              IWDT_BASE)
#define OSDC                        ((OSDC_Type*)              OSDC_BASE)
#define OCRV                        ((OCRV_Type*)              OCRV_BASE)
#define FMC                         ((FMC_Type*)               FMC_BASE)
#define PORT                        ((PORT_Type*)              PORT_BASE)
#define MISC                        ((MISC_Type*)              MISC_BASE)
#define PPORGA                      ((PPORGA_Type*)            PPORGA_BASE)
#define PCBZ                        ((PCBZ_Type*)              PCBZ_BASE)
#define SCI0                        ((SCI0_Type*)               SCI0_BASE)
#define SCI11                        ((SCI_Type*)               SCI1_BASE)
#define SCI1                        ((SCI1_Type*)               SCI1_BASE)
#define SCI2                        ((SCI2_Type*)               SCI2_BASE)
#define SCI3                        ((SCI3_Type*)               SCI3_BASE)
#define TM80                        ((TM80_Type*)              TM80_BASE)
#define TM81                        ((TM81_Type*)              TM81_BASE)
#define SPIHS0                      ((SPIHS_Type*)            SPIHS0_BASE)
#define SPIHS1                      ((SPIHS_Type*)            SPIHS1_BASE)
#define IICA0                       ((IICA_TypeDef*)             IICA0_BASE)
#define IICA1                       ((IICA_TypeDef*)             IICA1_BASE)
#define CMP0                        ((CMP0_Type*)              CMP0_BASE)
#define CMP1                        ((CMP1_Type*)              CMP1_BASE)
#define CMP2                        ((CMP2_Type*)              CMP2_BASE)
#define CMP3                        ((CMP3_Type*)              CMP3_BASE)
#define IRDA                        ((IRDA_Type*)              IRDA_BASE)
#define DAC                         ((DAC_Type*)               DAC_BASE)
#define LCDB                        ((LCDB_Type*)              LCDB_BASE)
#define KEY                         ((KEY_Type*)               KEY_BASE)
#define RTC                         ((RTC_Type*)               RTC_BASE)
#define INTM                        ((INTM_Type*)              INTM_BASE)
#define CAN0                        ((CAN_Type*)               CAN0_BASE)
#define CAN0MSG00                   ((CANMSG_Type*)            CAN0MSG00_BASE)
#define CAN0MSG01                   ((CANMSG_Type*)            CAN0MSG01_BASE)
#define CAN0MSG02                   ((CANMSG_Type*)            CAN0MSG02_BASE)
#define CAN0MSG03                   ((CANMSG_Type*)            CAN0MSG03_BASE)
#define CAN0MSG04                   ((CANMSG_Type*)            CAN0MSG04_BASE)
#define CAN0MSG05                   ((CANMSG_Type*)            CAN0MSG05_BASE)
#define CAN0MSG06                   ((CANMSG_Type*)            CAN0MSG06_BASE)
#define CAN0MSG07                   ((CANMSG_Type*)            CAN0MSG07_BASE)
#define CAN0MSG08                   ((CANMSG_Type*)            CAN0MSG08_BASE)
#define CAN0MSG09                   ((CANMSG_Type*)            CAN0MSG09_BASE)
#define CAN0MSG10                   ((CANMSG_Type*)            CAN0MSG10_BASE)
#define CAN0MSG11                   ((CANMSG_Type*)            CAN0MSG11_BASE)
#define CAN0MSG12                   ((CANMSG_Type*)            CAN0MSG12_BASE)
#define CAN0MSG13                   ((CANMSG_Type*)            CAN0MSG13_BASE)
#define CAN0MSG14                   ((CANMSG_Type*)            CAN0MSG14_BASE)
#define CAN0MSG15                   ((CANMSG_Type*)            CAN0MSG15_BASE)
#define CAN1                        ((CAN_Type*)               CAN1_BASE)
#define CAN1MSG00                   ((CANMSG_Type*)            CAN1MSG00_BASE)
#define CAN1MSG01                   ((CANMSG_Type*)            CAN1MSG01_BASE)
#define CAN1MSG02                   ((CANMSG_Type*)            CAN1MSG02_BASE)
#define CAN1MSG03                   ((CANMSG_Type*)            CAN1MSG03_BASE)
#define CAN1MSG04                   ((CANMSG_Type*)            CAN1MSG04_BASE)
#define CAN1MSG05                   ((CANMSG_Type*)            CAN1MSG05_BASE)
#define CAN1MSG06                   ((CANMSG_Type*)            CAN1MSG06_BASE)
#define CAN1MSG07                   ((CANMSG_Type*)            CAN1MSG07_BASE)
#define CAN1MSG08                   ((CANMSG_Type*)            CAN1MSG08_BASE)
#define CAN1MSG09                   ((CANMSG_Type*)            CAN1MSG09_BASE)
#define CAN1MSG10                   ((CANMSG_Type*)            CAN1MSG10_BASE)
#define CAN1MSG11                   ((CANMSG_Type*)            CAN1MSG11_BASE)
#define CAN1MSG12                   ((CANMSG_Type*)            CAN1MSG12_BASE)
#define CAN1MSG13                   ((CANMSG_Type*)            CAN1MSG13_BASE)
#define CAN1MSG14                   ((CANMSG_Type*)            CAN1MSG14_BASE)
#define CAN1MSG15                   ((CANMSG_Type*)            CAN1MSG15_BASE)
#define TRNG                        ((TRNG_Type*)              TRNG_BASE)
#define DBG                         ((DBG_Type*)               DBG_BASE)
/*#define GPT0                      ((GPT0_Type*)              GPT0_BASE)
#define GPT1                        ((GPT1_Type*)              GPT1_BASE)*/
#define GPT00                       ((GPT_Type*)               GPT0_BASE)
#define GPT01                       ((GPT_Type*)               (GPT0_BASE+0x100))
#define GPT02                       ((GPT_Type*)               (GPT0_BASE+0x200))
#define GPT03                       ((GPT_Type*)               (GPT0_BASE+0x300))
#define GPT10                       ((GPT_Type*)               GPT1_BASE)
#define GPT11                       ((GPT_Type*)               (GPT1_BASE+0x100))
#define GPT12                       ((GPT_Type*)               (GPT1_BASE+0x200))
#define GPT13                       ((GPT_Type*)               (GPT1_BASE+0x300))
#define GPT14                       ((GPT_Type*)               (GPT1_BASE+0x400))
#define GPT15                       ((GPT_Type*)               (GPT1_BASE+0x500))
#define GPT16                       ((GPT_Type*)               (GPT1_BASE+0x600))
#define GPT17                       ((GPT_Type*)               (GPT1_BASE+0x700))
#define GPT17                       ((GPT_Type*)               (GPT1_BASE+0x700))
#define GPT10OPS                    ((GPT10OPS_Type*)          (GPT1_BASE+0x7F0))
#define PGI                         ((PGI_Type*)               PGI_BASE)
#define AES                         ((AES_Type*)               AES_BASE)
#define IIR                         ((IIR_Type*)               IIR_BASE)
#define ELC                         ((ELC_Type*)               ELC_BASE)
#define ADC0                        ((ADC_Type*)               ADC0_BASE)
#define ADC1                        ((ADC_Type*)               ADC1_BASE)
#define ADC2                        ((ADC_Type*)               ADC2_BASE)
#define QSPI                        ((QSPI_Type*)              QSPI_BASE)
#define TSN                         ((TSN_Type*)               TSN_BASE)
#define BGR                         ((BGR_Type*)               BGR_BASE)
#define UID                         ((UID_Type*)               UID_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


/* =========================================  End of section using anonymous unions  ========================================= */
#if defined (__CC_ARM)
  #pragma pop
#elif defined (__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic pop
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning restore
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#endif


/* =========================================================================================================================== */
/* ================                                 Pos/Mask Cluster Section                                  ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_clusters
  * @{
  */



/* =========================================================================================================================== */
/* ================                                           CTRL                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DMACR  ========================================================= */
#define DMAVEC_CTRL_DMACR_FIFO_Pos        (8UL)                     /*!< FIFO (Bit 8)                                          */
#define DMAVEC_CTRL_DMACR_FIFO_Msk        (0x100UL)                 /*!< FIFO (Bitfield-Mask: 0x01)                            */
#define DMAVEC_CTRL_DMACR_SZ_Pos          (6UL)                     /*!< SZ (Bit 6)                                            */
#define DMAVEC_CTRL_DMACR_SZ_Msk          (0xc0UL)                  /*!< SZ (Bitfield-Mask: 0x03)                              */
#define DMAVEC_CTRL_DMACR_RPTINT_Pos      (5UL)                     /*!< RPTINT (Bit 5)                                        */
#define DMAVEC_CTRL_DMACR_RPTINT_Msk      (0x20UL)                  /*!< RPTINT (Bitfield-Mask: 0x01)                          */
#define DMAVEC_CTRL_DMACR_CHNE_Pos        (4UL)                     /*!< CHNE (Bit 4)                                          */
#define DMAVEC_CTRL_DMACR_CHNE_Msk        (0x10UL)                  /*!< CHNE (Bitfield-Mask: 0x01)                            */
#define DMAVEC_CTRL_DMACR_DAMOD_Pos       (3UL)                     /*!< DAMOD (Bit 3)                                         */
#define DMAVEC_CTRL_DMACR_DAMOD_Msk       (0x8UL)                   /*!< DAMOD (Bitfield-Mask: 0x01)                           */
#define DMAVEC_CTRL_DMACR_SAMOD_Pos       (2UL)                     /*!< SAMOD (Bit 2)                                         */
#define DMAVEC_CTRL_DMACR_SAMOD_Msk       (0x4UL)                   /*!< SAMOD (Bitfield-Mask: 0x01)                           */
#define DMAVEC_CTRL_DMACR_RPTSEL_Pos      (1UL)                     /*!< RPTSEL (Bit 1)                                        */
#define DMAVEC_CTRL_DMACR_RPTSEL_Msk      (0x2UL)                   /*!< RPTSEL (Bitfield-Mask: 0x01)                          */
#define DMAVEC_CTRL_DMACR_MODE_Pos        (0UL)                     /*!< MODE (Bit 0)                                          */
#define DMAVEC_CTRL_DMACR_MODE_Msk        (0x1UL)                   /*!< MODE (Bitfield-Mask: 0x01)                            */
/* =========================================================  DMBLS  ========================================================= */
/* =========================================================  DMACT  ========================================================= */
/* =========================================================  DMRLD  ========================================================= */
/* =========================================================  DMSAR  ========================================================= */
/* =========================================================  DMDAR  ========================================================= */

/** @} */ /* End of group PosMask_clusters */


/* =========================================================================================================================== */
/* ================                                Pos/Mask Peripheral Section                                ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CMC  ========================================================== */
#define CGC_CMC_AMPHS_Pos                 (1UL)                     /*!< AMPHS (Bit 1)                                         */
#define CGC_CMC_AMPHS_Msk                 (0x6UL)                   /*!< AMPHS (Bitfield-Mask: 0x03)                           */
#define CGC_CMC_MOSCDIV_Pos               (3UL)                     /*!< MOSCDIV (Bit 3)                                       */
#define CGC_CMC_MOSCDIV_Msk               (0x8UL)                   /*!< MOSCDIV (Bitfield-Mask: 0x01)                         */
#define CGC_CMC_OSCSELS_Pos               (4UL)                     /*!< OSCSELS (Bit 4)                                       */
#define CGC_CMC_OSCSELS_Msk               (0x10UL)                  /*!< OSCSELS (Bitfield-Mask: 0x01)                         */
#define CGC_CMC_EXCLKS_Pos                (5UL)                     /*!< EXCLKS (Bit 5)                                        */
#define CGC_CMC_EXCLKS_Msk                (0x20UL)                  /*!< EXCLKS (Bitfield-Mask: 0x01)                          */
#define CGC_CMC_OSCSEL_Pos                (6UL)                     /*!< OSCSEL (Bit 6)                                        */
#define CGC_CMC_OSCSEL_Msk                (0x40UL)                  /*!< OSCSEL (Bitfield-Mask: 0x01)                          */
#define CGC_CMC_EXCLK_Pos                 (7UL)                     /*!< EXCLK (Bit 7)                                         */
#define CGC_CMC_EXCLK_Msk                 (0x80UL)                  /*!< EXCLK (Bitfield-Mask: 0x01)                           */
/* ==========================================================  CSC  ========================================================== */
#define CGC_CSC_HIOSTOP_Pos               (0UL)                     /*!< HIOSTOP (Bit 0)                                       */
#define CGC_CSC_HIOSTOP_Msk               (0x1UL)                   /*!< HIOSTOP (Bitfield-Mask: 0x01)                         */
#define CGC_CSC_XTSTOP_Pos                (6UL)                     /*!< XTSTOP (Bit 6)                                        */
#define CGC_CSC_XTSTOP_Msk                (0x40UL)                  /*!< XTSTOP (Bitfield-Mask: 0x01)                          */
#define CGC_CSC_MSTOP_Pos                 (7UL)                     /*!< MSTOP (Bit 7)                                         */
#define CGC_CSC_MSTOP_Msk                 (0x80UL)                  /*!< MSTOP (Bitfield-Mask: 0x01)                           */
/* =========================================================  OSTC  ========================================================== */
/* =========================================================  OSTS  ========================================================== */
/* ==========================================================  CKC  ========================================================== */
#define CGC_CKC_MCM0_Pos                  (4UL)                     /*!< MCM0 (Bit 4)                                          */
#define CGC_CKC_MCM0_Msk                  (0x10UL)                  /*!< MCM0 (Bitfield-Mask: 0x01)                            */
#define CGC_CKC_MCS_Pos                   (5UL)                     /*!< MCS (Bit 5)                                           */
#define CGC_CKC_MCS_Msk                   (0x20UL)                  /*!< MCS (Bitfield-Mask: 0x01)                             */
#define CGC_CKC_CSS_Pos                   (6UL)                     /*!< CSS (Bit 6)                                           */
#define CGC_CKC_CSS_Msk                   (0x40UL)                  /*!< CSS (Bitfield-Mask: 0x01)                             */
#define CGC_CKC_CLS_Pos                   (7UL)                     /*!< CLS (Bit 7)                                           */
#define CGC_CKC_CLS_Msk                   (0x80UL)                  /*!< CLS (Bitfield-Mask: 0x01)                             */
/* ========================================================  LOCKCTL  ======================================================== */
/* =========================================================  PRCR  ========================================================== */
/* =======================================================  SUBCKSEL  ======================================================== */
#define CGC_SUBCKSEL_SELLOSC_Pos          (0UL)                     /*!< SELLOSC (Bit 0)                                       */
#define CGC_SUBCKSEL_SELLOSC_Msk          (0x1UL)                   /*!< SELLOSC (Bitfield-Mask: 0x01)                         */
#define CGC_SUBCKSEL_LOCOSEL_Pos          (1UL)                     /*!< LOCOSEL (Bit 1)                                       */
#define CGC_SUBCKSEL_LOCOSEL_Msk          (0x2UL)                   /*!< LOCOSEL (Bitfield-Mask: 0x01)                         */
/* =========================================================  RSTM  ========================================================== */
#define CGC_RSTM_RSTM_Pos                 (0UL)                     /*!< RSTM (Bit 0)                                          */
#define CGC_RSTM_RSTM_Msk                 (0x1UL)                   /*!< RSTM (Bitfield-Mask: 0x01)                            */
/* =========================================================  PERA  ========================================================== */
#define CGC_PERA_TM80EN_Pos               (0UL)                     /*!< TM80EN (Bit 0)                                        */
#define CGC_PERA_TM80EN_Msk               (0x1UL)                   /*!< TM80EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_TM81EN_Pos               (1UL)                     /*!< TM81EN (Bit 1)                                        */
#define CGC_PERA_TM81EN_Msk               (0x2UL)                   /*!< TM81EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_SCI0EN_Pos               (2UL)                     /*!< SCI0EN (Bit 2)                                        */
#define CGC_PERA_SCI0EN_Msk               (0x4UL)                   /*!< SCI0EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_SCI1EN_Pos               (3UL)                     /*!< SCI1EN (Bit 3)                                        */
#define CGC_PERA_SCI1EN_Msk               (0x8UL)                   /*!< SCI1EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_SCI2EN_Pos               (4UL)                     /*!< SCI2EN (Bit 4)                                        */
#define CGC_PERA_SCI2EN_Msk               (0x10UL)                  /*!< SCI2EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_SCI3EN_Pos               (5UL)                     /*!< SCI3EN (Bit 5)                                        */
#define CGC_PERA_SCI3EN_Msk               (0x20UL)                  /*!< SCI3EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_IRDAEN_Pos               (6UL)                     /*!< IRDAEN (Bit 6)                                        */
#define CGC_PERA_IRDAEN_Msk               (0x40UL)                  /*!< IRDAEN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_RTCEN_Pos                (7UL)                     /*!< RTCEN (Bit 7)                                         */
#define CGC_PERA_RTCEN_Msk                (0x80UL)                  /*!< RTCEN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_LCDBEN_Pos               (8UL)                     /*!< LCDBEN (Bit 8)                                        */
#define CGC_PERA_LCDBEN_Msk               (0x100UL)                 /*!< LCDBEN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_DMAEN_Pos                (9UL)                     /*!< DMAEN (Bit 9)                                         */
#define CGC_PERA_DMAEN_Msk                (0x200UL)                 /*!< DMAEN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_IICA0EN_Pos              (10UL)                    /*!< IICA0EN (Bit 10)                                      */
#define CGC_PERA_IICA0EN_Msk              (0x400UL)                 /*!< IICA0EN (Bitfield-Mask: 0x01)                         */
#define CGC_PERA_IICA1EN_Pos              (11UL)                    /*!< IICA1EN (Bit 11)                                      */
#define CGC_PERA_IICA1EN_Msk              (0x800UL)                 /*!< IICA1EN (Bitfield-Mask: 0x01)                         */
#define CGC_PERA_SPIHS0EN_Pos             (12UL)                    /*!< SPIHS0EN (Bit 12)                                     */
#define CGC_PERA_SPIHS0EN_Msk             (0x1000UL)                /*!< SPIHS0EN (Bitfield-Mask: 0x01)                        */
#define CGC_PERA_SPIHS1EN_Pos             (13UL)                    /*!< SPIHS1EN (Bit 13)                                     */
#define CGC_PERA_SPIHS1EN_Msk             (0x2000UL)                /*!< SPIHS1EN (Bitfield-Mask: 0x01)                        */
#define CGC_PERA_DACEN_Pos                (14UL)                    /*!< DACEN (Bit 14)                                        */
#define CGC_PERA_DACEN_Msk                (0x4000UL)                /*!< DACEN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_ADC0EN_Pos               (16UL)                    /*!< ADC0EN (Bit 16)                                       */
#define CGC_PERA_ADC0EN_Msk               (0x10000UL)               /*!< ADC0EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_ADC1EN_Pos               (17UL)                    /*!< ADC1EN (Bit 17)                                       */
#define CGC_PERA_ADC1EN_Msk               (0x20000UL)               /*!< ADC1EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_ADC2EN_Pos               (18UL)                    /*!< ADC2EN (Bit 18)                                       */
#define CGC_PERA_ADC2EN_Msk               (0x40000UL)               /*!< ADC2EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_CMPPGAEN_Pos             (19UL)                    /*!< CMPPGAEN (Bit 19)                                     */
#define CGC_PERA_CMPPGAEN_Msk             (0x80000UL)               /*!< CMPPGAEN (Bitfield-Mask: 0x01)                        */
#define CGC_PERA_GPT0EN_Pos               (20UL)                    /*!< GPT0EN (Bit 20)                                       */
#define CGC_PERA_GPT0EN_Msk               (0x100000UL)              /*!< GPT0EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_GPT1EN_Pos               (21UL)                    /*!< GPT1EN (Bit 21)                                       */
#define CGC_PERA_GPT1EN_Msk               (0x200000UL)              /*!< GPT1EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_PGIEN_Pos                (22UL)                    /*!< PGIEN (Bit 22)                                        */
#define CGC_PERA_PGIEN_Msk                (0x400000UL)              /*!< PGIEN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_IIREN_Pos                (23UL)                    /*!< IIREN (Bit 23)                                        */
#define CGC_PERA_IIREN_Msk                (0x800000UL)              /*!< IIREN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_OSDCEN_Pos               (24UL)                    /*!< OSDCEN (Bit 24)                                       */
#define CGC_PERA_OSDCEN_Msk               (0x1000000UL)             /*!< OSDCEN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_AESEN_Pos                (25UL)                    /*!< AESEN (Bit 25)                                        */
#define CGC_PERA_AESEN_Msk                (0x2000000UL)             /*!< AESEN (Bitfield-Mask: 0x01)                           */
#define CGC_PERA_TRNGEN_Pos               (26UL)                    /*!< TRNGEN (Bit 26)                                       */
#define CGC_PERA_TRNGEN_Msk               (0x4000000UL)             /*!< TRNGEN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_CAN0EN_Pos               (27UL)                    /*!< CAN0EN (Bit 27)                                       */
#define CGC_PERA_CAN0EN_Msk               (0x8000000UL)             /*!< CAN0EN (Bitfield-Mask: 0x01)                          */
#define CGC_PERA_CAN1EN_Pos               (28UL)                    /*!< CAN1EN (Bit 28)                                       */
#define CGC_PERA_CAN1EN_Msk               (0x10000000UL)            /*!< CAN1EN (Bitfield-Mask: 0x01)                          */
/* =========================================================  OSMC  ========================================================== */
#define CGC_OSMC_WUTMMCK0_Pos             (4UL)                     /*!< WUTMMCK0 (Bit 4)                                      */
#define CGC_OSMC_WUTMMCK0_Msk             (0x10UL)                  /*!< WUTMMCK0 (Bitfield-Mask: 0x01)                        */
#define CGC_OSMC_RTCLPC_Pos               (7UL)                     /*!< RTCLPC (Bit 7)                                        */
#define CGC_OSMC_RTCLPC_Msk               (0x80UL)                  /*!< RTCLPC (Bitfield-Mask: 0x01)                          */
/* ========================================================  WDTCFG  ========================================================= */
/* ========================================================  PMUKEY  ========================================================= */
/* ========================================================  PMUCTL  ========================================================= */
/* ========================================================  BG1CTL  ========================================================= */
/* ========================================================  IWDTCTL  ======================================================== */
/* ========================================================  HOCODIV  ======================================================== */
/* ========================================================  HIOTRM  ========================================================= */
/* =========================================================  MCKC  ========================================================== */
#define CGC_MCKC_CKSELR_Pos               (0UL)                     /*!< CKSELR (Bit 0)                                        */
#define CGC_MCKC_CKSELR_Msk               (0x1UL)                   /*!< CKSELR (Bitfield-Mask: 0x01)                          */
#define CGC_MCKC_PDIV_Pos                 (1UL)                     /*!< PDIV (Bit 1)                                          */
#define CGC_MCKC_PDIV_Msk                 (0x6UL)                   /*!< PDIV (Bitfield-Mask: 0x03)                            */
#define CGC_MCKC_CKSTR_Pos                (7UL)                     /*!< CKSTR (Bit 7)                                         */
#define CGC_MCKC_CKSTR_Msk                (0x80UL)                  /*!< CKSTR (Bitfield-Mask: 0x01)                           */
/* =========================================================  PLLCR  ========================================================= */
#define CGC_PLLCR_PLLON_Pos               (0UL)                     /*!< PLLON (Bit 0)                                         */
#define CGC_PLLCR_PLLON_Msk               (0x1UL)                   /*!< PLLON (Bitfield-Mask: 0x01)                           */
#define CGC_PLLCR_PLLM_Pos                (1UL)                     /*!< PLLM (Bit 1)                                          */
#define CGC_PLLCR_PLLM_Msk                (0x2UL)                   /*!< PLLM (Bitfield-Mask: 0x01)                            */
#define CGC_PLLCR_PLLD_Pos                (2UL)                     /*!< PLLD (Bit 2)                                          */
#define CGC_PLLCR_PLLD_Msk                (0xcUL)                   /*!< PLLD (Bitfield-Mask: 0x03)                            */
#define CGC_PLLCR_PLLSRSEL_Pos            (7UL)                     /*!< PLLSRSEL (Bit 7)                                      */
#define CGC_PLLCR_PLLSRSEL_Msk            (0x80UL)                  /*!< PLLSRSEL (Bitfield-Mask: 0x01)                        */


/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  RESF  ========================================================== */
#define RST_RESF_LVIRF_Pos                (0UL)                     /*!< LVIRF (Bit 0)                                         */
#define RST_RESF_LVIRF_Msk                (0x1UL)                   /*!< LVIRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_IAWRF_Pos                (1UL)                     /*!< IAWRF (Bit 1)                                         */
#define RST_RESF_IAWRF_Msk                (0x2UL)                   /*!< IAWRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_RPERF_Pos                (2UL)                     /*!< RPERF (Bit 2)                                         */
#define RST_RESF_RPERF_Msk                (0x4UL)                   /*!< RPERF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_OSDCRF_Pos               (3UL)                     /*!< OSDCRF (Bit 3)                                        */
#define RST_RESF_OSDCRF_Msk               (0x8UL)                   /*!< OSDCRF (Bitfield-Mask: 0x01)                          */
#define RST_RESF_WDTRF_Pos                (4UL)                     /*!< WDTRF (Bit 4)                                         */
#define RST_RESF_WDTRF_Msk                (0x10UL)                  /*!< WDTRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_IWDTRF_Pos               (5UL)                     /*!< IWDTRF (Bit 5)                                        */
#define RST_RESF_IWDTRF_Msk               (0x20UL)                  /*!< IWDTRF (Bitfield-Mask: 0x01)                          */
#define RST_RESF_SYSRF_Pos                (7UL)                     /*!< SYSRF (Bit 7)                                         */
#define RST_RESF_SYSRF_Msk                (0x80UL)                  /*!< SYSRF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  CRC0CTL  ======================================================== */
#define SAF_CRC0CTL_CRC0EN_Pos            (7UL)                     /*!< CRC0EN (Bit 7)                                        */
#define SAF_CRC0CTL_CRC0EN_Msk            (0x80UL)                  /*!< CRC0EN (Bitfield-Mask: 0x01)                          */
#define SAF_CRC0CTL_CRCCHK60_Pos          (6UL)                     /*!< CRCCHK60 (Bit 6)                                      */
#define SAF_CRC0CTL_CRCCHK60_Msk          (0x40UL)                  /*!< CRCCHK60 (Bitfield-Mask: 0x01)                        */
#define SAF_CRC0CTL_FEA_Pos               (0UL)                     /*!< FEA (Bit 0)                                           */
#define SAF_CRC0CTL_FEA_Msk               (0x7UL)                   /*!< FEA (Bitfield-Mask: 0x07)                             */
/* ========================================================  PGCRCL  ========================================================= */
/* =========================================================  CRCIN  ========================================================= */
/* =========================================================  CRCD  ========================================================== */
/* ========================================================  RPECTL  ========================================================= */
#define SAF_RPECTL_RPEF_Pos               (0UL)                     /*!< RPEF (Bit 0)                                          */
#define SAF_RPECTL_RPEF_Msk               (0x1UL)                   /*!< RPEF (Bitfield-Mask: 0x01)                            */
#define SAF_RPECTL_RPERDIS_Pos            (7UL)                     /*!< RPERDIS (Bit 7)                                       */
#define SAF_RPECTL_RPERDIS_Msk            (0x80UL)                  /*!< RPERDIS (Bitfield-Mask: 0x01)                         */
/* =========================================================  SFRGD  ========================================================= */
#define SAF_SFRGD_GCSC_Pos                (0UL)                     /*!< GCSC (Bit 0)                                          */
#define SAF_SFRGD_GCSC_Msk                (0x1UL)                   /*!< GCSC (Bitfield-Mask: 0x01)                            */
#define SAF_SFRGD_GINT_Pos                (1UL)                     /*!< GINT (Bit 1)                                          */
#define SAF_SFRGD_GINT_Msk                (0x2UL)                   /*!< GINT (Bitfield-Mask: 0x01)                            */
#define SAF_SFRGD_GPORT_Pos               (2UL)                     /*!< GPORT (Bit 2)                                         */
#define SAF_SFRGD_GPORT_Msk               (0x4UL)                   /*!< GPORT (Bitfield-Mask: 0x01)                           */
#define SAF_SFRGD_GCOMP_Pos               (3UL)                     /*!< GCOMP (Bit 3)                                         */
#define SAF_SFRGD_GCOMP_Msk               (0x8UL)                   /*!< GCOMP (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LVIM  ========================================================== */
#define LVD_LVIM_LVIF_Pos                 (0UL)                     /*!< LVIF (Bit 0)                                          */
#define LVD_LVIM_LVIF_Msk                 (0x1UL)                   /*!< LVIF (Bitfield-Mask: 0x01)                            */
#define LVD_LVIM_LVIOMSK_Pos              (1UL)                     /*!< LVIOMSK (Bit 1)                                       */
#define LVD_LVIM_LVIOMSK_Msk              (0x2UL)                   /*!< LVIOMSK (Bitfield-Mask: 0x01)                         */
#define LVD_LVIM_LVISEN_Pos               (7UL)                     /*!< LVISEN (Bit 7)                                        */
#define LVD_LVIM_LVISEN_Msk               (0x80UL)                  /*!< LVISEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  LVIS  ========================================================== */
#define LVD_LVIS_LVILV_Pos                (0UL)                     /*!< LVILV (Bit 0)                                         */
#define LVD_LVIS_LVILV_Msk                (0x1UL)                   /*!< LVILV (Bitfield-Mask: 0x01)                           */
#define LVD_LVIS_LVIMD_Pos                (7UL)                     /*!< LVIMD (Bit 7)                                         */
#define LVD_LVIS_LVIMD_Msk                (0x80UL)                  /*!< LVIMD (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           SRAM                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  PARIOAD  ======================================================== */
/* ========================================================  RAMPRCR  ======================================================== */


/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  DMAEN0  ========================================================= */
/* ========================================================  DMAEN1  ========================================================= */
/* ========================================================  DMAEN2  ========================================================= */
/* ========================================================  DMAEN3  ========================================================= */
/* ========================================================  DMAEN4  ========================================================= */
/* ========================================================  DMAEN5  ========================================================= */
/* ========================================================  DMAEN6  ========================================================= */
/* ========================================================  DMAEN7  ========================================================= */
/* ========================================================  DMABAR  ========================================================= */
/* ========================================================  IFPRCR  ========================================================= */
/* ========================================================  DMAIF0  ========================================================= */
/* ========================================================  DMAIF1  ========================================================= */
/* ========================================================  DMAIF2  ========================================================= */
/* ========================================================  DMAIF3  ========================================================= */
/* ========================================================  DMAIF4  ========================================================= */
/* ========================================================  DMAIF5  ========================================================= */
/* ========================================================  DMAIF6  ========================================================= */
/* ========================================================  DMAIF7  ========================================================= */
/* ========================================================  DMASET0  ======================================================== */
/* ========================================================  DMASET1  ======================================================== */
/* ========================================================  DMASET2  ======================================================== */
/* ========================================================  DMASET3  ======================================================== */
/* ========================================================  DMASET4  ======================================================== */
/* ========================================================  DMASET5  ======================================================== */
/* ========================================================  DMASET6  ======================================================== */
/* ========================================================  DMASET7  ======================================================== */
/* ========================================================  DMACLR0  ======================================================== */
/* ========================================================  DMACLR1  ======================================================== */
/* ========================================================  DMACLR2  ======================================================== */
/* ========================================================  DMACLR3  ======================================================== */
/* ========================================================  DMACLR4  ======================================================== */
/* ========================================================  DMACLR5  ======================================================== */
/* ========================================================  DMACLR6  ======================================================== */
/* ========================================================  DMACLR7  ======================================================== */


/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  VEC  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  WDTE  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           IWDT                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  WDTE  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           OSDC                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  SCMCTL  ========================================================= */
#define OSDC_SCMCTL_OSDCCMP_Pos           (0UL)                     /*!< OSDCCMP (Bit 0)                                       */
#define OSDC_SCMCTL_OSDCCMP_Msk           (0xfffUL)                 /*!< OSDCCMP (Bitfield-Mask: 0xfff)                        */
#define OSDC_SCMCTL_OSCDE_Pos             (15UL)                    /*!< OSCDE (Bit 15)                                        */
#define OSDC_SCMCTL_OSCDE_Msk             (0x8000UL)                /*!< OSCDE (Bitfield-Mask: 0x01)                           */
/* =========================================================  SCMMD  ========================================================= */
#define OSDC_SCMMD_CKSEL_Pos              (0UL)                     /*!< CKSEL (Bit 0)                                         */
#define OSDC_SCMMD_CKSEL_Msk              (0x1UL)                   /*!< CKSEL (Bitfield-Mask: 0x01)                           */
#define OSDC_SCMMD_MDSEL_Pos              (1UL)                     /*!< MDSEL (Bit 1)                                         */
#define OSDC_SCMMD_MDSEL_Msk              (0x2UL)                   /*!< MDSEL (Bitfield-Mask: 0x01)                           */
/* =========================================================  SCMST  ========================================================= */
#define OSDC_SCMST_OSTDF_Pos              (0UL)                     /*!< OSTDF (Bit 0)                                         */
#define OSDC_SCMST_OSTDF_Msk              (0x1UL)                   /*!< OSTDF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           OCRV                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  HOCOFC  ========================================================= */
#define OCRV_HOCOFC_FCST_Pos              (0UL)                     /*!< FCST (Bit 0)                                          */
#define OCRV_HOCOFC_FCST_Msk              (0x1UL)                   /*!< FCST (Bitfield-Mask: 0x01)                            */
#define OCRV_HOCOFC_FCREF_Pos             (5UL)                     /*!< FCREF (Bit 5)                                         */
#define OCRV_HOCOFC_FCREF_Msk             (0x20UL)                  /*!< FCREF (Bitfield-Mask: 0x01)                           */
#define OCRV_HOCOFC_FCIE_Pos              (6UL)                     /*!< FCIE (Bit 6)                                          */
#define OCRV_HOCOFC_FCIE_Msk              (0x40UL)                  /*!< FCIE (Bitfield-Mask: 0x01)                            */
#define OCRV_HOCOFC_FCMD_Pos              (7UL)                     /*!< FCMD (Bit 7)                                          */
#define OCRV_HOCOFC_FCMD_Msk              (0x80UL)                  /*!< FCMD (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  FLSTS  ========================================================= */
#define FMC_FLSTS_OVF_Pos                 (0UL)                     /*!< OVF (Bit 0)                                           */
#define FMC_FLSTS_OVF_Msk                 (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define FMC_FLSTS_EVF_Pos                 (2UL)                     /*!< EVF (Bit 2)                                           */
#define FMC_FLSTS_EVF_Msk                 (0x4UL)                   /*!< EVF (Bitfield-Mask: 0x01)                             */
/* ========================================================  FLOPMD1  ======================================================== */
/* ========================================================  FLOPMD2  ======================================================== */
/* ========================================================  FLERMD  ========================================================= */
/* =======================================================  FLCERCNT  ======================================================== */
/* =======================================================  FLSERCNT  ======================================================== */
/* =======================================================  FLNVSCNT  ======================================================== */
#define FMC_FLNVSCNT_Load0_Pos                 (15UL)                     /*!< OVF (Bit 0)                                           */
#define FMC_FLNVSCNT_Load0_Msk                 (0x8000UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define FMC_FLNVSCNT_Load1_Pos                 (31UL)                     /*!< EVF (Bit 2)                                           */
#define FMC_FLNVSCNT_Load1_Msk                 (0x80000000UL)                   /*!< EVF (Bitfield-Mask: 0x01)                             */
/* =======================================================  FLPROCNT  ======================================================== */
/* ========================================================  FLPROT  ========================================================= */
/* =======================================================  FLRCVCNT  ======================================================== */
#define FMC_FLRCVCNT_FLPRVCNT_Pos         (0UL)                     /*!< FLPRVCNT (Bit 0)                                      */
#define FMC_FLRCVCNT_FLPRVCNT_Msk         (0x1fffUL)                /*!< FLPRVCNT (Bitfield-Mask: 0x1fff)                      */
#define FMC_FLRCVCNT_LOAD0_Pos            (15UL)                    /*!< LOAD0 (Bit 15)                                        */
#define FMC_FLRCVCNT_LOAD0_Msk            (0x8000UL)                /*!< LOAD0 (Bitfield-Mask: 0x01)                           */
#define FMC_FLRCVCNT_FLERVCNT_Pos         (16UL)                    /*!< FLERVCNT (Bit 16)                                     */
#define FMC_FLRCVCNT_FLERVCNT_Msk         (0x7fff0000UL)            /*!< FLERVCNT (Bitfield-Mask: 0x7fff)                      */
#define FMC_FLRCVCNT_LOAD1_Pos            (31UL)                    /*!< LOAD1 (Bit 31)                                        */
#define FMC_FLRCVCNT_LOAD1_Msk            (0x80000000UL)            /*!< LOAD1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  FLSECPR  ======================================================== */
#define FMC_FLSECPR_SECPR_Pos             (0UL)                     /*!< SECPR (Bit 0)                                         */
#define FMC_FLSECPR_SECPR_Msk             (0xfUL)                   /*!< SECPR (Bitfield-Mask: 0x0f)                           */
#define FMC_FLSECPR_KEY_Pos               (8UL)                     /*!< KEY (Bit 8)                                           */
#define FMC_FLSECPR_KEY_Msk               (0xffffff00UL)            /*!< KEY (Bitfield-Mask: 0xffffff)                         */


/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  PMA  ========================================================== */
/* ==========================================================  PMB  ========================================================== */
/* ==========================================================  PMC  ========================================================== */
/* ==========================================================  PMD  ========================================================== */
/* ==========================================================  PME  ========================================================== */
/* ==========================================================  PMH  ========================================================== */
/* ==========================================================  PA  =========================================================== */
/* ==========================================================  PB  =========================================================== */
/* ==========================================================  PC  =========================================================== */
/* ==========================================================  PD  =========================================================== */
/* ==========================================================  PE  =========================================================== */
/* ==========================================================  PH  =========================================================== */
/* =========================================================  PSETA  ========================================================= */
/* =========================================================  PSETB  ========================================================= */
/* =========================================================  PSETC  ========================================================= */
/* =========================================================  PSETD  ========================================================= */
/* =========================================================  PSETE  ========================================================= */
/* =========================================================  PSETH  ========================================================= */
/* =========================================================  PCLRA  ========================================================= */
/* =========================================================  PCLRB  ========================================================= */
/* =========================================================  PCLRC  ========================================================= */
/* =========================================================  PCLRD  ========================================================= */
/* =========================================================  PCLRE  ========================================================= */
/* =========================================================  PCLRH  ========================================================= */
/* ==========================================================  PUA  ========================================================== */
/* ==========================================================  PUB  ========================================================== */
/* ==========================================================  PUC  ========================================================== */
/* ==========================================================  PUD  ========================================================== */
/* ==========================================================  PUE  ========================================================== */
/* ==========================================================  PUH  ========================================================== */
/* ==========================================================  PDA  ========================================================== */
/* ==========================================================  PDB  ========================================================== */
/* ==========================================================  PDC  ========================================================== */
/* ==========================================================  PDD  ========================================================== */
/* ==========================================================  PDE  ========================================================== */
/* =========================================================  POMA  ========================================================== */
/* =========================================================  POMB  ========================================================== */
/* =========================================================  POMC  ========================================================== */
/* =========================================================  POMD  ========================================================== */
/* =========================================================  POME  ========================================================== */
/* =========================================================  POMH  ========================================================== */
/* =========================================================  PMCA  ========================================================== */
/* =========================================================  PMCB  ========================================================== */
/* =========================================================  PMCC  ========================================================== */
/* =========================================================  PMCD  ========================================================== */
/* ========================================================  PREADA  ========================================================= */
/* ========================================================  PREADB  ========================================================= */
/* ========================================================  PREADC  ========================================================= */
/* ========================================================  PREADD  ========================================================= */
/* ========================================================  PREADH  ========================================================= */
/* ========================================================  PA00CFG  ======================================================== */
#define PORT_PA00CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA00CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA01CFG  ======================================================== */
#define PORT_PA01CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA01CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA02CFG  ======================================================== */
#define PORT_PA02CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA02CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA03CFG  ======================================================== */
#define PORT_PA03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA04CFG  ======================================================== */
#define PORT_PA04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA05CFG  ======================================================== */
#define PORT_PA05CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA05CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA06CFG  ======================================================== */
#define PORT_PA06CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA06CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA07CFG  ======================================================== */
#define PORT_PA07CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA07CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA08CFG  ======================================================== */
#define PORT_PA08CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA08CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA09CFG  ======================================================== */
#define PORT_PA09CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA09CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA10CFG  ======================================================== */
#define PORT_PA10CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA10CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA11CFG  ======================================================== */
#define PORT_PA11CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA11CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA12CFG  ======================================================== */
#define PORT_PA12CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA12CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA13CFG  ======================================================== */
#define PORT_PA13CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA13CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA14CFG  ======================================================== */
#define PORT_PA14CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA14CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PA15CFG  ======================================================== */
#define PORT_PA15CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PA15CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB00CFG  ======================================================== */
#define PORT_PB00CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB00CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB01CFG  ======================================================== */
#define PORT_PB01CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB01CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB02CFG  ======================================================== */
#define PORT_PB02CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB02CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB03CFG  ======================================================== */
#define PORT_PB03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB04CFG  ======================================================== */
#define PORT_PB04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB05CFG  ======================================================== */
#define PORT_PB05CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB05CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB06CFG  ======================================================== */
#define PORT_PB06CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB06CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB07CFG  ======================================================== */
#define PORT_PB07CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB07CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB08CFG  ======================================================== */
#define PORT_PB08CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB08CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB09CFG  ======================================================== */
#define PORT_PB09CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB09CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB10CFG  ======================================================== */
#define PORT_PB10CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB10CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB11CFG  ======================================================== */
#define PORT_PB11CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB11CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB12CFG  ======================================================== */
#define PORT_PB12CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB12CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB13CFG  ======================================================== */
#define PORT_PB13CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB13CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB14CFG  ======================================================== */
#define PORT_PB14CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB14CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PB15CFG  ======================================================== */
#define PORT_PB15CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PB15CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC00CFG  ======================================================== */
#define PORT_PC00CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC00CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC01CFG  ======================================================== */
#define PORT_PC01CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC01CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC02CFG  ======================================================== */
#define PORT_PC02CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC02CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC03CFG  ======================================================== */
#define PORT_PC03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC04CFG  ======================================================== */
#define PORT_PC04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC05CFG  ======================================================== */
#define PORT_PC05CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC05CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC06CFG  ======================================================== */
#define PORT_PC06CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC06CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC07CFG  ======================================================== */
#define PORT_PC07CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC07CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC08CFG  ======================================================== */
#define PORT_PC08CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC08CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC09CFG  ======================================================== */
#define PORT_PC09CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC09CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC10CFG  ======================================================== */
#define PORT_PC10CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC10CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC11CFG  ======================================================== */
#define PORT_PC11CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC11CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC12CFG  ======================================================== */
#define PORT_PC12CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC12CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC13CFG  ======================================================== */
#define PORT_PC13CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC13CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC14CFG  ======================================================== */
#define PORT_PC14CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC14CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PC15CFG  ======================================================== */
#define PORT_PC15CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PC15CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD00CFG  ======================================================== */
#define PORT_PD00CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD00CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD01CFG  ======================================================== */
#define PORT_PD01CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD01CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD02CFG  ======================================================== */
#define PORT_PD02CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD02CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD03CFG  ======================================================== */
#define PORT_PD03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD04CFG  ======================================================== */
#define PORT_PD04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD05CFG  ======================================================== */
#define PORT_PD05CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD05CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD06CFG  ======================================================== */
#define PORT_PD06CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD06CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD07CFG  ======================================================== */
#define PORT_PD07CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD07CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD08CFG  ======================================================== */
#define PORT_PD08CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD08CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD09CFG  ======================================================== */
#define PORT_PD09CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD09CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD10CFG  ======================================================== */
#define PORT_PD10CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD10CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD11CFG  ======================================================== */
#define PORT_PD11CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD11CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD12CFG  ======================================================== */
#define PORT_PD12CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD12CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD13CFG  ======================================================== */
#define PORT_PD13CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD13CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD14CFG  ======================================================== */
#define PORT_PD14CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD14CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PD15CFG  ======================================================== */
#define PORT_PD15CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PD15CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE00CFG  ======================================================== */
#define PORT_PE00CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE00CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE01CFG  ======================================================== */
#define PORT_PE01CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE01CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE02CFG  ======================================================== */
#define PORT_PE02CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE02CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE03CFG  ======================================================== */
#define PORT_PE03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE04CFG  ======================================================== */
#define PORT_PE04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE05CFG  ======================================================== */
#define PORT_PE05CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE05CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE06CFG  ======================================================== */
#define PORT_PE06CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE06CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE07CFG  ======================================================== */
#define PORT_PE07CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE07CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE08CFG  ======================================================== */
#define PORT_PE08CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE08CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE09CFG  ======================================================== */
#define PORT_PE09CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE09CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE10CFG  ======================================================== */
#define PORT_PE10CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE10CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE11CFG  ======================================================== */
#define PORT_PE11CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE11CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE12CFG  ======================================================== */
#define PORT_PE12CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE12CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE13CFG  ======================================================== */
#define PORT_PE13CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE13CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE14CFG  ======================================================== */
#define PORT_PE14CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE14CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PE15CFG  ======================================================== */
#define PORT_PE15CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PE15CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PH03CFG  ======================================================== */
#define PORT_PH03CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PH03CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* ========================================================  PH04CFG  ======================================================== */
#define PORT_PH04CFG_CFG_Pos              (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_PH04CFG_CFG_Msk              (0x7UL)                   /*!< CFG (Bitfield-Mask: 0x07)                             */
/* =======================================================  INTP0PCFG  ======================================================= */
#define PORT_INTP0PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP0PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP1PCFG  ======================================================= */
#define PORT_INTP1PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP1PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP2PCFG  ======================================================= */
#define PORT_INTP2PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP2PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP3PCFG  ======================================================= */
#define PORT_INTP3PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP3PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP4PCFG  ======================================================= */
#define PORT_INTP4PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP4PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP5PCFG  ======================================================= */
#define PORT_INTP5PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP5PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP6PCFG  ======================================================= */
#define PORT_INTP6PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP6PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */
/* =======================================================  INTP7PCFG  ======================================================= */
#define PORT_INTP7PCFG_CFG_Pos            (0UL)                     /*!< CFG (Bit 0)                                           */
#define PORT_INTP7PCFG_CFG_Msk            (0x3UL)                   /*!< CFG (Bitfield-Mask: 0x03)                             */


/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  NFEN0  ========================================================= */
#define MISC_NFEN0_SNFEN00_Pos            (0UL)                     /*!< SNFEN00 (Bit 0)                                       */
#define MISC_NFEN0_SNFEN00_Msk            (0x1UL)                   /*!< SNFEN00 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN0_SNFEN10_Pos            (2UL)                     /*!< SNFEN10 (Bit 2)                                       */
#define MISC_NFEN0_SNFEN10_Msk            (0x4UL)                   /*!< SNFEN10 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN0_SNFEN20_Pos            (4UL)                     /*!< SNFEN20 (Bit 4)                                       */
#define MISC_NFEN0_SNFEN20_Msk            (0x10UL)                  /*!< SNFEN20 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN0_SNFEN30_Pos            (6UL)                     /*!< SNFEN30 (Bit 6)                                       */
#define MISC_NFEN0_SNFEN30_Msk            (0x40UL)                  /*!< SNFEN30 (Bitfield-Mask: 0x01)                         */
/* =========================================================  NFEN1  ========================================================= */
#define MISC_NFEN1_TNFEN00_Pos            (0UL)                     /*!< TNFEN00 (Bit 0)                                       */
#define MISC_NFEN1_TNFEN00_Msk            (0x1UL)                   /*!< TNFEN00 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN01_Pos            (1UL)                     /*!< TNFEN01 (Bit 1)                                       */
#define MISC_NFEN1_TNFEN01_Msk            (0x2UL)                   /*!< TNFEN01 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN02_Pos            (2UL)                     /*!< TNFEN02 (Bit 2)                                       */
#define MISC_NFEN1_TNFEN02_Msk            (0x4UL)                   /*!< TNFEN02 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN03_Pos            (3UL)                     /*!< TNFEN03 (Bit 3)                                       */
#define MISC_NFEN1_TNFEN03_Msk            (0x8UL)                   /*!< TNFEN03 (Bitfield-Mask: 0x01)                         */
/* =========================================================  NFEN2  ========================================================= */
#define MISC_NFEN2_TNFEN10_Pos            (0UL)                     /*!< TNFEN10 (Bit 0)                                       */
#define MISC_NFEN2_TNFEN10_Msk            (0x1UL)                   /*!< TNFEN10 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN11_Pos            (1UL)                     /*!< TNFEN11 (Bit 1)                                       */
#define MISC_NFEN2_TNFEN11_Msk            (0x2UL)                   /*!< TNFEN11 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN12_Pos            (2UL)                     /*!< TNFEN12 (Bit 2)                                       */
#define MISC_NFEN2_TNFEN12_Msk            (0x4UL)                   /*!< TNFEN12 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN13_Pos            (3UL)                     /*!< TNFEN13 (Bit 3)                                       */
#define MISC_NFEN2_TNFEN13_Msk            (0x8UL)                   /*!< TNFEN13 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN14_Pos            (4UL)                     /*!< TNFEN14 (Bit 4)                                       */
#define MISC_NFEN2_TNFEN14_Msk            (0x10UL)                  /*!< TNFEN14 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN15_Pos            (5UL)                     /*!< TNFEN15 (Bit 5)                                       */
#define MISC_NFEN2_TNFEN15_Msk            (0x20UL)                  /*!< TNFEN15 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN16_Pos            (6UL)                     /*!< TNFEN16 (Bit 6)                                       */
#define MISC_NFEN2_TNFEN16_Msk            (0x40UL)                  /*!< TNFEN16 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN2_TNFEN17_Pos            (7UL)                     /*!< TNFEN17 (Bit 7)                                       */
#define MISC_NFEN2_TNFEN17_Msk            (0x80UL)                  /*!< TNFEN17 (Bitfield-Mask: 0x01)                         */
/* ==========================================================  ISC  ========================================================== */
#define MISC_ISC_SSIE30_Pos               (4UL)                     /*!< SSIE30 (Bit 7)                                        */
#define MISC_ISC_SSIE30_Msk               (0x10UL)                  /*!< SSIE30 (Bitfield-Mask: 0x01)                          */
#define MISC_ISC_SSIE20_Pos               (5UL)                     /*!< SSIE20 (Bit 6)                                        */
#define MISC_ISC_SSIE20_Msk               (0x20UL)                  /*!< SSIE20 (Bitfield-Mask: 0x01)                          */
#define MISC_ISC_SSIE10_Pos               (6UL)                     /*!< SSIE10 (Bit 5)                                        */
#define MISC_ISC_SSIE10_Msk               (0x40UL)                  /*!< SSIE10 (Bitfield-Mask: 0x01)                          */
#define MISC_ISC_SSIE00_Pos               (7UL)                     /*!< SSIE00 (Bit 4)                                        */
#define MISC_ISC_SSIE00_Msk               (0x80UL)                  /*!< SSIE00 (Bitfield-Mask: 0x01)                          */
#define MISC_ISC_ISC1_Pos                 (1UL)                     /*!< ISC1 (Bit 1)                                          */
#define MISC_ISC_ISC1_Msk                 (0x2UL)                   /*!< ISC1 (Bitfield-Mask: 0x01)                            */
#define MISC_ISC_ISC0_Pos                 (0UL)                     /*!< ISC0 (Bit 0)                                          */
#define MISC_ISC_ISC0_Msk                 (0x1UL)                   /*!< ISC0 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TIOS0  ========================================================= */
/* =========================================================  TIOS1  ========================================================= */
/* =========================================================  RTCCL  ========================================================= */
/* ========================================================  TRNGCKS  ======================================================== */
#define MISC_TRNGCKS_CKS_Pos              (0UL)                     /*!< CKS (Bit 0)                                           */
#define MISC_TRNGCKS_CKS_Msk              (0x7UL)                   /*!< CKS (Bitfield-Mask: 0x07)                             */


/* =========================================================================================================================== */
/* ================                                          PPORGA                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  PMS  ========================================================== */
#define PPORGA_PMS_PMS0_Pos               (0UL)                     /*!< PMS0 (Bit 0)                                          */
#define PPORGA_PMS_PMS0_Msk               (0x1UL)                   /*!< PMS0 (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CKS0  ========================================================== */
#define PCBZ_CKS0_CCS_Pos                 (0UL)                     /*!< CCS (Bit 0)                                           */
#define PCBZ_CKS0_CCS_Msk                 (0x7UL)                   /*!< CCS (Bitfield-Mask: 0x07)                             */
#define PCBZ_CKS0_CSEL_Pos                (3UL)                     /*!< CSEL (Bit 3)                                          */
#define PCBZ_CKS0_CSEL_Msk                (0x8UL)                   /*!< CSEL (Bitfield-Mask: 0x01)                            */
#define PCBZ_CKS0_PCLOE_Pos               (7UL)                     /*!< PCLOE (Bit 7)                                         */
#define PCBZ_CKS0_PCLOE_Msk               (0x80UL)                  /*!< PCLOE (Bitfield-Mask: 0x01)                           */
/* =========================================================  CKS1  ========================================================== */
#define PCBZ_CKS1_CCS_Pos                 (0UL)                     /*!< CCS (Bit 0)                                           */
#define PCBZ_CKS1_CCS_Msk                 (0x7UL)                   /*!< CCS (Bitfield-Mask: 0x07)                             */
#define PCBZ_CKS1_CSEL_Pos                (3UL)                     /*!< CSEL (Bit 3)                                          */
#define PCBZ_CKS1_CSEL_Msk                (0x8UL)                   /*!< CSEL (Bitfield-Mask: 0x01)                            */
#define PCBZ_CKS1_PCLOE_Pos               (7UL)                     /*!< PCLOE (Bit 7)                                         */
#define PCBZ_CKS1_PCLOE_Msk               (0x80UL)                  /*!< PCLOE (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR00  ========================================================= */
#define SCI0_SSR00_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI0_SSR00_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI0_SSR00_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI0_SSR00_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI0_SSR00_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI0_SSR00_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR01  ========================================================= */
#define SCI0_SSR01_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI0_SSR01_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI0_SSR01_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI0_SSR01_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI0_SSR01_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI0_SSR01_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR00  ========================================================= */
#define SCI0_SIR00_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI0_SIR00_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR00_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI0_SIR00_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR00_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI0_SIR00_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR01  ========================================================= */
#define SCI0_SIR01_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI0_SIR01_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR01_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI0_SIR01_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR01_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI0_SIR01_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR00  ========================================================= */
#define SCI0_SMR00_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI0_SMR00_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI0_SMR00_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI0_SMR00_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI0_SMR00_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI0_SMR00_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI0_SMR00_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR01  ========================================================= */
#define SCI0_SMR01_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI0_SMR01_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI0_SMR01_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI0_SMR01_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI0_SMR01_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI0_SMR01_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI0_SMR01_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR00  ========================================================= */
#define SCI0_SCR00_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI0_SCR00_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI0_SCR00_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI0_SCR00_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR00_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI0_SCR00_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI0_SCR00_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR00_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI0_SCR00_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI0_SCR00_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI0_SCR00_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI0_SCR00_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI0_SCR00_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR01  ========================================================= */
#define SCI0_SCR01_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI0_SCR01_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI0_SCR01_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI0_SCR01_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR01_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI0_SCR01_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI0_SCR01_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR01_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI0_SCR01_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI0_SCR01_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI0_SCR01_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI0_SCR01_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI0_SCR01_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE0  ========================================================== */
#define SCI0_SE0_SE00_Pos                 (0UL)                     /*!< SE00 (Bit 0)                                          */
#define SCI0_SE0_SE00_Msk                 (0x1UL)                   /*!< SE00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SE0_SE01_Pos                 (1UL)                     /*!< SE01 (Bit 1)                                          */
#define SCI0_SE0_SE01_Msk                 (0x2UL)                   /*!< SE01 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS0  ========================================================== */
#define SCI0_SS0_SS00_Pos                 (0UL)                     /*!< SS00 (Bit 0)                                          */
#define SCI0_SS0_SS00_Msk                 (0x1UL)                   /*!< SS00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SS0_SS01_Pos                 (1UL)                     /*!< SS01 (Bit 1)                                          */
#define SCI0_SS0_SS01_Msk                 (0x2UL)                   /*!< SS01 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST0  ========================================================== */
#define SCI0_ST0_ST00_Pos                 (0UL)                     /*!< ST00 (Bit 0)                                          */
#define SCI0_ST0_ST00_Msk                 (0x1UL)                   /*!< ST00 (Bitfield-Mask: 0x01)                            */
#define SCI0_ST0_ST01_Pos                 (1UL)                     /*!< ST01 (Bit 1)                                          */
#define SCI0_ST0_ST01_Msk                 (0x2UL)                   /*!< ST01 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS0  ========================================================== */
#define SCI0_SPS0_PRS00_Pos               (0UL)                     /*!< PRS00 (Bit 0)                                         */
#define SCI0_SPS0_PRS00_Msk               (0xfUL)                   /*!< PRS00 (Bitfield-Mask: 0x0f)                           */
#define SCI0_SPS0_PRS01_Pos               (4UL)                     /*!< PRS01 (Bit 4)                                         */
#define SCI0_SPS0_PRS01_Msk               (0xf0UL)                  /*!< PRS01 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO0  ========================================================== */
#define SCI0_SO0_SO00_Pos                 (0UL)                     /*!< SO00 (Bit 0)                                          */
#define SCI0_SO0_SO00_Msk                 (0x1UL)                   /*!< SO00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SO0_SO01_Pos                 (1UL)                     /*!< SO01 (Bit 1)                                          */
#define SCI0_SO0_SO01_Msk                 (0x2UL)                   /*!< SO01 (Bitfield-Mask: 0x01)                            */
#define SCI0_SO0_CKO00_Pos                (8UL)                     /*!< CKO00 (Bit 8)                                         */
#define SCI0_SO0_CKO00_Msk                (0x100UL)                 /*!< CKO00 (Bitfield-Mask: 0x01)                           */
#define SCI0_SO0_CKO01_Pos                (9UL)                     /*!< CKO01 (Bit 9)                                         */
#define SCI0_SO0_CKO01_Msk                (0x200UL)                 /*!< CKO01 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE0  ========================================================== */
#define SCI0_SOE0_SOE00_Pos               (0UL)                     /*!< SOE00 (Bit 0)                                         */
#define SCI0_SOE0_SOE00_Msk               (0x1UL)                   /*!< SOE00 (Bitfield-Mask: 0x01)                           */
#define SCI0_SOE0_SOE01_Pos               (1UL)                     /*!< SOE01 (Bit 1)                                         */
#define SCI0_SOE0_SOE01_Msk               (0x2UL)                   /*!< SOE01 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL0  ========================================================== */
#define SCI0_SOL0_SOL00_Pos               (0UL)                     /*!< SOL00 (Bit 0)                                         */
#define SCI0_SOL0_SOL00_Msk               (0x1UL)                   /*!< SOL00 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SDR00  ========================================================= */
/* =========================================================  SDR01  ========================================================= */
/* =========================================================  SIO00  ========================================================= */
/* =========================================================  SIO01  ========================================================= */
/* =========================================================  TXD0  ========================================================== */
/* =========================================================  RXD0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI1                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR10  ========================================================= */
#define SCI1_SSR10_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI1_SSR10_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI1_SSR10_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI1_SSR10_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI1_SSR10_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI1_SSR10_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR11  ========================================================= */
#define SCI1_SSR11_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI1_SSR11_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI1_SSR11_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI1_SSR11_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI1_SSR11_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI1_SSR11_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR10  ========================================================= */
#define SCI1_SIR10_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI1_SIR10_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR10_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI1_SIR10_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR10_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI1_SIR10_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR11  ========================================================= */
#define SCI1_SIR11_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI1_SIR11_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR11_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI1_SIR11_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR11_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI1_SIR11_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR10  ========================================================= */
#define SCI1_SMR10_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI1_SMR10_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI1_SMR10_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI1_SMR10_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI1_SMR10_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI1_SMR10_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI1_SMR10_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR11  ========================================================= */
#define SCI1_SMR11_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI1_SMR11_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI1_SMR11_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI1_SMR11_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI1_SMR11_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI1_SMR11_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI1_SMR11_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR10  ========================================================= */
#define SCI1_SCR10_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI1_SCR10_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI1_SCR10_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI1_SCR10_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR10_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI1_SCR10_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI1_SCR10_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR10_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI1_SCR10_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI1_SCR10_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI1_SCR10_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI1_SCR10_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI1_SCR10_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR11  ========================================================= */
#define SCI1_SCR11_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI1_SCR11_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI1_SCR11_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI1_SCR11_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR11_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI1_SCR11_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI1_SCR11_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR11_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI1_SCR11_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI1_SCR11_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI1_SCR11_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI1_SCR11_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI1_SCR11_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE1  ========================================================== */
#define SCI1_SE1_SE10_Pos                 (0UL)                     /*!< SE10 (Bit 0)                                          */
#define SCI1_SE1_SE10_Msk                 (0x1UL)                   /*!< SE10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SE1_SE11_Pos                 (1UL)                     /*!< SE11 (Bit 1)                                          */
#define SCI1_SE1_SE11_Msk                 (0x2UL)                   /*!< SE11 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS1  ========================================================== */
#define SCI1_SS1_SS10_Pos                 (0UL)                     /*!< SS10 (Bit 0)                                          */
#define SCI1_SS1_SS10_Msk                 (0x1UL)                   /*!< SS10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SS1_SS11_Pos                 (1UL)                     /*!< SS11 (Bit 1)                                          */
#define SCI1_SS1_SS11_Msk                 (0x2UL)                   /*!< SS11 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST1  ========================================================== */
#define SCI1_ST1_ST10_Pos                 (0UL)                     /*!< ST10 (Bit 0)                                          */
#define SCI1_ST1_ST10_Msk                 (0x1UL)                   /*!< ST10 (Bitfield-Mask: 0x01)                            */
#define SCI1_ST1_ST11_Pos                 (1UL)                     /*!< ST11 (Bit 1)                                          */
#define SCI1_ST1_ST11_Msk                 (0x2UL)                   /*!< ST11 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS1  ========================================================== */
#define SCI1_SPS1_PRS10_Pos               (0UL)                     /*!< PRS10 (Bit 0)                                         */
#define SCI1_SPS1_PRS10_Msk               (0xfUL)                   /*!< PRS10 (Bitfield-Mask: 0x0f)                           */
#define SCI1_SPS1_PRS11_Pos               (4UL)                     /*!< PRS11 (Bit 4)                                         */
#define SCI1_SPS1_PRS11_Msk               (0xf0UL)                  /*!< PRS11 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO1  ========================================================== */
#define SCI1_SO1_SO10_Pos                 (0UL)                     /*!< SO10 (Bit 0)                                          */
#define SCI1_SO1_SO10_Msk                 (0x1UL)                   /*!< SO10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SO1_SO11_Pos                 (1UL)                     /*!< SO11 (Bit 1)                                          */
#define SCI1_SO1_SO11_Msk                 (0x2UL)                   /*!< SO11 (Bitfield-Mask: 0x01)                            */
#define SCI1_SO1_CKO10_Pos                (8UL)                     /*!< CKO10 (Bit 8)                                         */
#define SCI1_SO1_CKO10_Msk                (0x100UL)                 /*!< CKO10 (Bitfield-Mask: 0x01)                           */
#define SCI1_SO1_CKO11_Pos                (9UL)                     /*!< CKO11 (Bit 9)                                         */
#define SCI1_SO1_CKO11_Msk                (0x200UL)                 /*!< CKO11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE1  ========================================================== */
#define SCI1_SOE1_SOE10_Pos               (0UL)                     /*!< SOE10 (Bit 0)                                         */
#define SCI1_SOE1_SOE10_Msk               (0x1UL)                   /*!< SOE10 (Bitfield-Mask: 0x01)                           */
#define SCI1_SOE1_SOE11_Pos               (1UL)                     /*!< SOE11 (Bit 1)                                         */
#define SCI1_SOE1_SOE11_Msk               (0x2UL)                   /*!< SOE11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL1  ========================================================== */
#define SCI1_SOL1_SOL10_Pos               (0UL)                     /*!< SOL10 (Bit 0)                                         */
#define SCI1_SOL1_SOL10_Msk               (0x1UL)                   /*!< SOL10 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SDR10  ========================================================= */
/* =========================================================  SDR11  ========================================================= */
/* =========================================================  SIO10  ========================================================= */
/* =========================================================  SIO11  ========================================================= */
/* =========================================================  TXD1  ========================================================== */
/* =========================================================  RXD1  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI2                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR20  ========================================================= */
#define SCI2_SSR20_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI2_SSR20_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR20_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI2_SSR20_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR20_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI2_SSR20_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR20_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI2_SSR20_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR20_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI2_SSR20_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR21  ========================================================= */
#define SCI2_SSR21_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI2_SSR21_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR21_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI2_SSR21_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR21_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI2_SSR21_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR21_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI2_SSR21_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI2_SSR21_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI2_SSR21_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR20  ========================================================= */
#define SCI2_SIR20_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI2_SIR20_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI2_SIR20_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI2_SIR20_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI2_SIR20_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI2_SIR20_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR21  ========================================================= */
#define SCI2_SIR21_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI2_SIR21_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI2_SIR21_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI2_SIR21_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI2_SIR21_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI2_SIR21_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR20  ========================================================= */
#define SCI2_SMR20_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI2_SMR20_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI2_SMR20_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI2_SMR20_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR20_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI2_SMR20_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR20_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI2_SMR20_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR20_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI2_SMR20_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR21  ========================================================= */
#define SCI2_SMR21_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI2_SMR21_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI2_SMR21_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI2_SMR21_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR21_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI2_SMR21_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR21_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI2_SMR21_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI2_SMR21_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI2_SMR21_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR20  ========================================================= */
#define SCI2_SCR20_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI2_SCR20_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI2_SCR20_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI2_SCR20_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI2_SCR20_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI2_SCR20_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR20_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI2_SCR20_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI2_SCR20_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI2_SCR20_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR20_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI2_SCR20_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR20_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI2_SCR20_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR20_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI2_SCR20_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR20_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI2_SCR20_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR21  ========================================================= */
#define SCI2_SCR21_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI2_SCR21_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI2_SCR21_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI2_SCR21_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI2_SCR21_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI2_SCR21_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR21_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI2_SCR21_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI2_SCR21_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI2_SCR21_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR21_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI2_SCR21_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR21_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI2_SCR21_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR21_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI2_SCR21_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI2_SCR21_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI2_SCR21_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE2  ========================================================== */
#define SCI2_SE2_SE20_Pos                 (0UL)                     /*!< SE20 (Bit 0)                                          */
#define SCI2_SE2_SE20_Msk                 (0x1UL)                   /*!< SE20 (Bitfield-Mask: 0x01)                            */
#define SCI2_SE2_SE21_Pos                 (1UL)                     /*!< SE21 (Bit 1)                                          */
#define SCI2_SE2_SE21_Msk                 (0x2UL)                   /*!< SE21 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS2  ========================================================== */
#define SCI2_SS2_SS20_Pos                 (0UL)                     /*!< SS20 (Bit 0)                                          */
#define SCI2_SS2_SS20_Msk                 (0x1UL)                   /*!< SS20 (Bitfield-Mask: 0x01)                            */
#define SCI2_SS2_SS21_Pos                 (1UL)                     /*!< SS21 (Bit 1)                                          */
#define SCI2_SS2_SS21_Msk                 (0x2UL)                   /*!< SS21 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST2  ========================================================== */
#define SCI2_ST2_ST20_Pos                 (0UL)                     /*!< ST20 (Bit 0)                                          */
#define SCI2_ST2_ST20_Msk                 (0x1UL)                   /*!< ST20 (Bitfield-Mask: 0x01)                            */
#define SCI2_ST2_ST21_Pos                 (1UL)                     /*!< ST21 (Bit 1)                                          */
#define SCI2_ST2_ST21_Msk                 (0x2UL)                   /*!< ST21 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS2  ========================================================== */
#define SCI2_SPS2_PRS20_Pos               (0UL)                     /*!< PRS20 (Bit 0)                                         */
#define SCI2_SPS2_PRS20_Msk               (0xfUL)                   /*!< PRS20 (Bitfield-Mask: 0x0f)                           */
#define SCI2_SPS2_PRS21_Pos               (4UL)                     /*!< PRS21 (Bit 4)                                         */
#define SCI2_SPS2_PRS21_Msk               (0xf0UL)                  /*!< PRS21 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO2  ========================================================== */
#define SCI2_SO2_SO20_Pos                 (0UL)                     /*!< SO20 (Bit 0)                                          */
#define SCI2_SO2_SO20_Msk                 (0x1UL)                   /*!< SO20 (Bitfield-Mask: 0x01)                            */
#define SCI2_SO2_SO21_Pos                 (1UL)                     /*!< SO21 (Bit 1)                                          */
#define SCI2_SO2_SO21_Msk                 (0x2UL)                   /*!< SO21 (Bitfield-Mask: 0x01)                            */
#define SCI2_SO2_CKO20_Pos                (8UL)                     /*!< CKO20 (Bit 8)                                         */
#define SCI2_SO2_CKO20_Msk                (0x100UL)                 /*!< CKO20 (Bitfield-Mask: 0x01)                           */
#define SCI2_SO2_CKO11_Pos                (9UL)                     /*!< CKO11 (Bit 9)                                         */
#define SCI2_SO2_CKO11_Msk                (0x200UL)                 /*!< CKO11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE2  ========================================================== */
#define SCI2_SOE2_SOE20_Pos               (0UL)                     /*!< SOE20 (Bit 0)                                         */
#define SCI2_SOE2_SOE20_Msk               (0x1UL)                   /*!< SOE20 (Bitfield-Mask: 0x01)                           */
#define SCI2_SOE2_SOE21_Pos               (1UL)                     /*!< SOE21 (Bit 1)                                         */
#define SCI2_SOE2_SOE21_Msk               (0x2UL)                   /*!< SOE21 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL2  ========================================================== */
#define SCI2_SOL2_SOL20_Pos               (0UL)                     /*!< SOL20 (Bit 0)                                         */
#define SCI2_SOL2_SOL20_Msk               (0x1UL)                   /*!< SOL20 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SDR20  ========================================================= */
/* =========================================================  SDR21  ========================================================= */
/* =========================================================  SIO20  ========================================================= */
/* =========================================================  SIO21  ========================================================= */
/* =========================================================  TXD2  ========================================================== */
/* =========================================================  RXD2  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI3                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR30  ========================================================= */
#define SCI3_SSR30_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI3_SSR30_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR30_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI3_SSR30_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR30_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI3_SSR30_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR30_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI3_SSR30_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR30_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI3_SSR30_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR31  ========================================================= */
#define SCI3_SSR31_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI3_SSR31_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR31_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI3_SSR31_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR31_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI3_SSR31_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR31_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI3_SSR31_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI3_SSR31_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI3_SSR31_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR30  ========================================================= */
#define SCI3_SIR30_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI3_SIR30_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI3_SIR30_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI3_SIR30_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI3_SIR30_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI3_SIR30_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR31  ========================================================= */
#define SCI3_SIR31_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI3_SIR31_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI3_SIR31_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI3_SIR31_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI3_SIR31_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI3_SIR31_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR30  ========================================================= */
#define SCI3_SMR30_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI3_SMR30_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI3_SMR30_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI3_SMR30_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR30_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI3_SMR30_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR30_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI3_SMR30_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR30_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI3_SMR30_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR31  ========================================================= */
#define SCI3_SMR31_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI3_SMR31_MD_Msk                 (0x7UL)                   /*!< MD (Bitfield-Mask: 0x07)                              */
#define SCI3_SMR31_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI3_SMR31_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR31_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI3_SMR31_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR31_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI3_SMR31_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI3_SMR31_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI3_SMR31_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR30  ========================================================= */
#define SCI3_SCR30_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI3_SCR30_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI3_SCR30_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI3_SCR30_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI3_SCR30_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI3_SCR30_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR30_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI3_SCR30_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI3_SCR30_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI3_SCR30_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR30_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI3_SCR30_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR30_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI3_SCR30_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR30_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI3_SCR30_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR30_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI3_SCR30_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR31  ========================================================= */
#define SCI3_SCR31_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI3_SCR31_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI3_SCR31_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI3_SCR31_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI3_SCR31_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI3_SCR31_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR31_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI3_SCR31_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI3_SCR31_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI3_SCR31_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR31_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI3_SCR31_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR31_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI3_SCR31_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR31_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI3_SCR31_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI3_SCR31_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI3_SCR31_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE3  ========================================================== */
#define SCI3_SE3_SE30_Pos                 (0UL)                     /*!< SE30 (Bit 0)                                          */
#define SCI3_SE3_SE30_Msk                 (0x1UL)                   /*!< SE30 (Bitfield-Mask: 0x01)                            */
#define SCI3_SE3_SE31_Pos                 (1UL)                     /*!< SE31 (Bit 1)                                          */
#define SCI3_SE3_SE31_Msk                 (0x2UL)                   /*!< SE31 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS3  ========================================================== */
#define SCI3_SS3_SS30_Pos                 (0UL)                     /*!< SS30 (Bit 0)                                          */
#define SCI3_SS3_SS30_Msk                 (0x1UL)                   /*!< SS30 (Bitfield-Mask: 0x01)                            */
#define SCI3_SS3_SS31_Pos                 (1UL)                     /*!< SS31 (Bit 1)                                          */
#define SCI3_SS3_SS31_Msk                 (0x2UL)                   /*!< SS31 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST3  ========================================================== */
#define SCI3_ST3_ST30_Pos                 (0UL)                     /*!< ST30 (Bit 0)                                          */
#define SCI3_ST3_ST30_Msk                 (0x1UL)                   /*!< ST30 (Bitfield-Mask: 0x01)                            */
#define SCI3_ST3_ST31_Pos                 (1UL)                     /*!< ST31 (Bit 1)                                          */
#define SCI3_ST3_ST31_Msk                 (0x2UL)                   /*!< ST31 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS3  ========================================================== */
#define SCI3_SPS3_PRS20_Pos               (0UL)                     /*!< PRS20 (Bit 0)                                         */
#define SCI3_SPS3_PRS20_Msk               (0xfUL)                   /*!< PRS20 (Bitfield-Mask: 0x0f)                           */
#define SCI3_SPS3_PRS21_Pos               (4UL)                     /*!< PRS21 (Bit 4)                                         */
#define SCI3_SPS3_PRS21_Msk               (0xf0UL)                  /*!< PRS21 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO3  ========================================================== */
#define SCI3_SO3_SO30_Pos                 (0UL)                     /*!< SO30 (Bit 0)                                          */
#define SCI3_SO3_SO30_Msk                 (0x1UL)                   /*!< SO30 (Bitfield-Mask: 0x01)                            */
#define SCI3_SO3_SO31_Pos                 (1UL)                     /*!< SO31 (Bit 1)                                          */
#define SCI3_SO3_SO31_Msk                 (0x2UL)                   /*!< SO31 (Bitfield-Mask: 0x01)                            */
#define SCI3_SO3_CKO30_Pos                (8UL)                     /*!< CKO30 (Bit 8)                                         */
#define SCI3_SO3_CKO30_Msk                (0x100UL)                 /*!< CKO30 (Bitfield-Mask: 0x01)                           */
#define SCI3_SO3_CKO31_Pos                (9UL)                     /*!< CKO31 (Bit 9)                                         */
#define SCI3_SO3_CKO31_Msk                (0x200UL)                 /*!< CKO31 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE3  ========================================================== */
#define SCI3_SOE3_SOE30_Pos               (0UL)                     /*!< SOE30 (Bit 0)                                         */
#define SCI3_SOE3_SOE30_Msk               (0x1UL)                   /*!< SOE30 (Bitfield-Mask: 0x01)                           */
#define SCI3_SOE3_SOE31_Pos               (1UL)                     /*!< SOE31 (Bit 1)                                         */
#define SCI3_SOE3_SOE31_Msk               (0x2UL)                   /*!< SOE31 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL3  ========================================================== */
#define SCI3_SOL3_SOL30_Pos               (0UL)                     /*!< SOL30 (Bit 0)                                         */
#define SCI3_SOL3_SOL30_Msk               (0x1UL)                   /*!< SOL30 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SDR30  ========================================================= */
/* =========================================================  SDR31  ========================================================= */
/* =========================================================  SIO30  ========================================================= */
/* =========================================================  SIO31  ========================================================= */
/* =========================================================  TXD3  ========================================================== */
/* =========================================================  RXD3  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           TM80                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TCR00  ========================================================= */
/* =========================================================  TCR01  ========================================================= */
/* =========================================================  TCR02  ========================================================= */
/* =========================================================  TCR03  ========================================================= */
/* =========================================================  TCR04  ========================================================= */
/* =========================================================  TCR05  ========================================================= */
/* =========================================================  TCR06  ========================================================= */
/* =========================================================  TCR07  ========================================================= */
/* =========================================================  TMR00  ========================================================= */
#define TM80_TMR00_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR00_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR00_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR00_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR00_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR00_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR00_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR00_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR00_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR00_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR01  ========================================================= */
#define TM80_TMR01_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR01_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR01_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR01_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR01_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR01_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR01_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM80_TMR01_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM80_TMR01_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR01_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR01_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR01_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR02  ========================================================= */
#define TM80_TMR02_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR02_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR02_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR02_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR02_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR02_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR02_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM80_TMR02_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM80_TMR02_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR02_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR02_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR02_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR03  ========================================================= */
#define TM80_TMR03_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR03_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR03_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR03_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR03_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR03_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR03_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM80_TMR03_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM80_TMR03_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR03_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR03_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR03_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR04  ========================================================= */
#define TM80_TMR04_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR04_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR04_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR04_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR04_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR04_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR04_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM80_TMR04_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM80_TMR04_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR04_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR04_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR04_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR05  ========================================================= */
#define TM80_TMR05_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR05_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR05_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR05_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR05_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR05_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR05_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR05_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR05_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR05_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR06  ========================================================= */
#define TM80_TMR06_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR06_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR06_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR06_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR06_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR06_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR06_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM80_TMR06_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM80_TMR06_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR06_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR06_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR06_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR07  ========================================================= */
#define TM80_TMR07_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM80_TMR07_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM80_TMR07_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM80_TMR07_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM80_TMR07_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM80_TMR07_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM80_TMR07_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM80_TMR07_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM80_TMR07_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM80_TMR07_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TSR00  ========================================================= */
#define TM80_TSR00_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR00_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR01  ========================================================= */
#define TM80_TSR01_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR01_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR02  ========================================================= */
#define TM80_TSR02_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR02_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR03  ========================================================= */
#define TM80_TSR03_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR03_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR04  ========================================================= */
#define TM80_TSR04_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR04_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR05  ========================================================= */
#define TM80_TSR05_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR05_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR06  ========================================================= */
#define TM80_TSR06_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR06_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR07  ========================================================= */
#define TM80_TSR07_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM80_TSR07_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* ==========================================================  TE0  ========================================================== */
#define TM80_TE0_TE00_Pos                 (0UL)                     /*!< TE00 (Bit 0)                                          */
#define TM80_TE0_TE00_Msk                 (0x1UL)                   /*!< TE00 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE01_Pos                 (1UL)                     /*!< TE01 (Bit 1)                                          */
#define TM80_TE0_TE01_Msk                 (0x2UL)                   /*!< TE01 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE02_Pos                 (2UL)                     /*!< TE02 (Bit 2)                                          */
#define TM80_TE0_TE02_Msk                 (0x4UL)                   /*!< TE02 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE03_Pos                 (3UL)                     /*!< TE03 (Bit 3)                                          */
#define TM80_TE0_TE03_Msk                 (0x8UL)                   /*!< TE03 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE04_Pos                 (4UL)                     /*!< TE04 (Bit 4)                                          */
#define TM80_TE0_TE04_Msk                 (0x10UL)                  /*!< TE04 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE05_Pos                 (5UL)                     /*!< TE05 (Bit 5)                                          */
#define TM80_TE0_TE05_Msk                 (0x20UL)                  /*!< TE05 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE06_Pos                 (6UL)                     /*!< TE06 (Bit 6)                                          */
#define TM80_TE0_TE06_Msk                 (0x40UL)                  /*!< TE06 (Bitfield-Mask: 0x01)                            */
#define TM80_TE0_TE07_Pos                 (7UL)                     /*!< TE07 (Bit 7)                                          */
#define TM80_TE0_TE07_Msk                 (0x80UL)                  /*!< TE07 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  TS0  ========================================================== */
#define TM80_TS0_TS00_Pos                 (0UL)                     /*!< TS00 (Bit 0)                                          */
#define TM80_TS0_TS00_Msk                 (0x1UL)                   /*!< TS00 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS01_Pos                 (1UL)                     /*!< TS01 (Bit 1)                                          */
#define TM80_TS0_TS01_Msk                 (0x2UL)                   /*!< TS01 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS02_Pos                 (2UL)                     /*!< TS02 (Bit 2)                                          */
#define TM80_TS0_TS02_Msk                 (0x4UL)                   /*!< TS02 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS03_Pos                 (3UL)                     /*!< TS03 (Bit 3)                                          */
#define TM80_TS0_TS03_Msk                 (0x8UL)                   /*!< TS03 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS04_Pos                 (4UL)                     /*!< TS04 (Bit 4)                                          */
#define TM80_TS0_TS04_Msk                 (0x10UL)                  /*!< TS04 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS05_Pos                 (5UL)                     /*!< TS05 (Bit 5)                                          */
#define TM80_TS0_TS05_Msk                 (0x20UL)                  /*!< TS05 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS06_Pos                 (6UL)                     /*!< TS06 (Bit 6)                                          */
#define TM80_TS0_TS06_Msk                 (0x40UL)                  /*!< TS06 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TS07_Pos                 (7UL)                     /*!< TS07 (Bit 7)                                          */
#define TM80_TS0_TS07_Msk                 (0x80UL)                  /*!< TS07 (Bitfield-Mask: 0x01)                            */
#define TM80_TS0_TSH01_Pos                (9UL)                     /*!< TSH01 (Bit 9)                                         */
#define TM80_TS0_TSH01_Msk                (0x200UL)                 /*!< TSH01 (Bitfield-Mask: 0x01)                           */
#define TM80_TS0_TSH03_Pos                (11UL)                    /*!< TSH03 (Bit 11)                                        */
#define TM80_TS0_TSH03_Msk                (0x800UL)                 /*!< TSH03 (Bitfield-Mask: 0x01)                           */
/* ==========================================================  TT0  ========================================================== */
#define TM80_TT0_TT00_Pos                 (0UL)                     /*!< TT00 (Bit 0)                                          */
#define TM80_TT0_TT00_Msk                 (0x1UL)                   /*!< TT00 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT01_Pos                 (1UL)                     /*!< TT01 (Bit 1)                                          */
#define TM80_TT0_TT01_Msk                 (0x2UL)                   /*!< TT01 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT02_Pos                 (2UL)                     /*!< TT02 (Bit 2)                                          */
#define TM80_TT0_TT02_Msk                 (0x4UL)                   /*!< TT02 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT03_Pos                 (3UL)                     /*!< TT03 (Bit 3)                                          */
#define TM80_TT0_TT03_Msk                 (0x8UL)                   /*!< TT03 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT04_Pos                 (4UL)                     /*!< TT04 (Bit 4)                                          */
#define TM80_TT0_TT04_Msk                 (0x10UL)                  /*!< TT04 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT05_Pos                 (5UL)                     /*!< TT05 (Bit 5)                                          */
#define TM80_TT0_TT05_Msk                 (0x20UL)                  /*!< TT05 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT06_Pos                 (6UL)                     /*!< TT06 (Bit 6)                                          */
#define TM80_TT0_TT06_Msk                 (0x40UL)                  /*!< TT06 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TT07_Pos                 (7UL)                     /*!< TT07 (Bit 7)                                          */
#define TM80_TT0_TT07_Msk                 (0x80UL)                  /*!< TT07 (Bitfield-Mask: 0x01)                            */
#define TM80_TT0_TTH01_Pos                (9UL)                     /*!< TTH01 (Bit 9)                                         */
#define TM80_TT0_TTH01_Msk                (0x200UL)                 /*!< TTH01 (Bitfield-Mask: 0x01)                           */
#define TM80_TT0_TTH03_Pos                (11UL)                    /*!< TTH03 (Bit 11)                                        */
#define TM80_TT0_TTH03_Msk                (0x800UL)                 /*!< TTH03 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TPS0  ========================================================== */
#define TM80_TPS0_PRS00_Pos               (0UL)                     /*!< PRS00 (Bit 0)                                         */
#define TM80_TPS0_PRS00_Msk               (0xfUL)                   /*!< PRS00 (Bitfield-Mask: 0x0f)                           */
#define TM80_TPS0_PRS01_Pos               (4UL)                     /*!< PRS01 (Bit 4)                                         */
#define TM80_TPS0_PRS01_Msk               (0xf0UL)                  /*!< PRS01 (Bitfield-Mask: 0x0f)                           */
#define TM80_TPS0_PRS02_Pos               (8UL)                     /*!< PRS02 (Bit 8)                                         */
#define TM80_TPS0_PRS02_Msk               (0x300UL)                 /*!< PRS02 (Bitfield-Mask: 0x03)                           */
#define TM80_TPS0_PRS03_Pos               (12UL)                    /*!< PRS03 (Bit 12)                                        */
#define TM80_TPS0_PRS03_Msk               (0x3000UL)                /*!< PRS03 (Bitfield-Mask: 0x03)                           */
/* ==========================================================  TO0  ========================================================== */
#define TM80_TO0_TO00_Pos                 (0UL)                     /*!< TO00 (Bit 0)                                          */
#define TM80_TO0_TO00_Msk                 (0x1UL)                   /*!< TO00 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO01_Pos                 (1UL)                     /*!< TO01 (Bit 1)                                          */
#define TM80_TO0_TO01_Msk                 (0x2UL)                   /*!< TO01 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO02_Pos                 (2UL)                     /*!< TO02 (Bit 2)                                          */
#define TM80_TO0_TO02_Msk                 (0x4UL)                   /*!< TO02 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO03_Pos                 (3UL)                     /*!< TO03 (Bit 3)                                          */
#define TM80_TO0_TO03_Msk                 (0x8UL)                   /*!< TO03 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO04_Pos                 (4UL)                     /*!< TO04 (Bit 4)                                          */
#define TM80_TO0_TO04_Msk                 (0x10UL)                  /*!< TO04 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO05_Pos                 (5UL)                     /*!< TO05 (Bit 5)                                          */
#define TM80_TO0_TO05_Msk                 (0x20UL)                  /*!< TO05 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO06_Pos                 (6UL)                     /*!< TO06 (Bit 6)                                          */
#define TM80_TO0_TO06_Msk                 (0x40UL)                  /*!< TO06 (Bitfield-Mask: 0x01)                            */
#define TM80_TO0_TO07_Pos                 (7UL)                     /*!< TO07 (Bit 7)                                          */
#define TM80_TO0_TO07_Msk                 (0x80UL)                  /*!< TO07 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TOE0  ========================================================== */
#define TM80_TOE0_TOE00_Pos               (0UL)                     /*!< TOE00 (Bit 0)                                         */
#define TM80_TOE0_TOE00_Msk               (0x1UL)                   /*!< TOE00 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE01_Pos               (1UL)                     /*!< TOE01 (Bit 1)                                         */
#define TM80_TOE0_TOE01_Msk               (0x2UL)                   /*!< TOE01 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE02_Pos               (2UL)                     /*!< TOE02 (Bit 2)                                         */
#define TM80_TOE0_TOE02_Msk               (0x4UL)                   /*!< TOE02 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE03_Pos               (3UL)                     /*!< TOE03 (Bit 3)                                         */
#define TM80_TOE0_TOE03_Msk               (0x8UL)                   /*!< TOE03 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE14_Pos               (4UL)                     /*!< TOE14 (Bit 4)                                         */
#define TM80_TOE0_TOE14_Msk               (0x10UL)                  /*!< TOE14 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE05_Pos               (5UL)                     /*!< TOE05 (Bit 5)                                         */
#define TM80_TOE0_TOE05_Msk               (0x20UL)                  /*!< TOE05 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE06_Pos               (6UL)                     /*!< TOE06 (Bit 6)                                         */
#define TM80_TOE0_TOE06_Msk               (0x40UL)                  /*!< TOE06 (Bitfield-Mask: 0x01)                           */
#define TM80_TOE0_TOE07_Pos               (7UL)                     /*!< TOE07 (Bit 7)                                         */
#define TM80_TOE0_TOE07_Msk               (0x80UL)                  /*!< TOE07 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOL0  ========================================================== */
#define TM80_TOL0_TOL01_Pos               (1UL)                     /*!< TOL01 (Bit 1)                                         */
#define TM80_TOL0_TOL01_Msk               (0x2UL)                   /*!< TOL01 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL02_Pos               (2UL)                     /*!< TOL02 (Bit 2)                                         */
#define TM80_TOL0_TOL02_Msk               (0x4UL)                   /*!< TOL02 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL03_Pos               (3UL)                     /*!< TOL03 (Bit 3)                                         */
#define TM80_TOL0_TOL03_Msk               (0x8UL)                   /*!< TOL03 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL04_Pos               (4UL)                     /*!< TOL04 (Bit 4)                                         */
#define TM80_TOL0_TOL04_Msk               (0x10UL)                  /*!< TOL04 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL05_Pos               (5UL)                     /*!< TOL05 (Bit 5)                                         */
#define TM80_TOL0_TOL05_Msk               (0x20UL)                  /*!< TOL05 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL06_Pos               (6UL)                     /*!< TOL06 (Bit 6)                                         */
#define TM80_TOL0_TOL06_Msk               (0x40UL)                  /*!< TOL06 (Bitfield-Mask: 0x01)                           */
#define TM80_TOL0_TOL07_Pos               (7UL)                     /*!< TOL07 (Bit 7)                                         */
#define TM80_TOL0_TOL07_Msk               (0x80UL)                  /*!< TOL07 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOM0  ========================================================== */
#define TM80_TOM0_TOM01_Pos               (1UL)                     /*!< TOM01 (Bit 1)                                         */
#define TM80_TOM0_TOM01_Msk               (0x2UL)                   /*!< TOM01 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TOM02_Pos               (2UL)                     /*!< TOM02 (Bit 2)                                         */
#define TM80_TOM0_TOM02_Msk               (0x4UL)                   /*!< TOM02 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TOM03_Pos               (3UL)                     /*!< TOM03 (Bit 3)                                         */
#define TM80_TOM0_TOM03_Msk               (0x8UL)                   /*!< TOM03 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TOM04_Pos               (4UL)                     /*!< TOM04 (Bit 4)                                         */
#define TM80_TOM0_TOM04_Msk               (0x10UL)                  /*!< TOM04 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TOM05_Pos               (5UL)                     /*!< TOM05 (Bit 5)                                         */
#define TM80_TOM0_TOM05_Msk               (0x20UL)                  /*!< TOM05 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TOM06_Pos               (6UL)                     /*!< TOM06 (Bit 6)                                         */
#define TM80_TOM0_TOM06_Msk               (0x40UL)                  /*!< TOM06 (Bitfield-Mask: 0x01)                           */
#define TM80_TOM0_TO07_Pos                (7UL)                     /*!< TO07 (Bit 7)                                          */
#define TM80_TOM0_TO07_Msk                (0x80UL)                  /*!< TO07 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TDR00  ========================================================= */
/* =========================================================  TDR01  ========================================================= */
/* ========================================================  TDR01L  ========================================================= */
/* ========================================================  TDR01H  ========================================================= */
/* =========================================================  TDR02  ========================================================= */
/* =========================================================  TDR03  ========================================================= */
/* ========================================================  TDR03L  ========================================================= */
/* ========================================================  TDR03H  ========================================================= */
/* =========================================================  TDR04  ========================================================= */
/* =========================================================  TDR05  ========================================================= */
/* =========================================================  TDR06  ========================================================= */
/* =========================================================  TDR07  ========================================================= */


/* =========================================================================================================================== */
/* ================                                           TM81                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TCR10  ========================================================= */
/* =========================================================  TCR11  ========================================================= */
/* =========================================================  TCR12  ========================================================= */
/* =========================================================  TCR13  ========================================================= */
/* =========================================================  TCR14  ========================================================= */
/* =========================================================  TCR15  ========================================================= */
/* =========================================================  TCR16  ========================================================= */
/* =========================================================  TCR17  ========================================================= */
/* =========================================================  TMR10  ========================================================= */
#define TM81_TMR10_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR10_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR10_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR10_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR10_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR10_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR10_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR10_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR10_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR10_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR11  ========================================================= */
#define TM81_TMR11_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR11_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR11_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR11_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR11_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR11_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR11_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM81_TMR11_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM81_TMR11_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR11_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR11_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR11_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR12  ========================================================= */
#define TM81_TMR12_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR12_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR12_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR12_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR12_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR12_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR12_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM81_TMR12_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM81_TMR12_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR12_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR12_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR12_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR13  ========================================================= */
#define TM81_TMR13_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR13_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR13_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR13_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR13_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR13_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR13_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM81_TMR13_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM81_TMR13_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR13_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR13_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR13_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR14  ========================================================= */
#define TM81_TMR14_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR14_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR14_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR14_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR14_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR14_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR14_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM81_TMR14_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM81_TMR14_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR14_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR14_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR14_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR15  ========================================================= */
#define TM81_TMR15_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR15_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR15_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR15_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR15_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR15_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR15_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR15_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR15_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR15_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR16  ========================================================= */
#define TM81_TMR16_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR16_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR16_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR16_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR16_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR16_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR16_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM81_TMR16_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM81_TMR16_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR16_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR16_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR16_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR17  ========================================================= */
#define TM81_TMR17_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM81_TMR17_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM81_TMR17_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM81_TMR17_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM81_TMR17_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM81_TMR17_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM81_TMR17_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM81_TMR17_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM81_TMR17_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM81_TMR17_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TSR10  ========================================================= */
#define TM81_TSR10_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR10_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR11  ========================================================= */
#define TM81_TSR11_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR11_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR12  ========================================================= */
#define TM81_TSR12_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR12_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR13  ========================================================= */
#define TM81_TSR13_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR13_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR14  ========================================================= */
#define TM81_TSR14_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR14_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR15  ========================================================= */
#define TM81_TSR15_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR15_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR16  ========================================================= */
#define TM81_TSR16_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR16_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR17  ========================================================= */
#define TM81_TSR17_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM81_TSR17_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* ==========================================================  TE1  ========================================================== */
#define TM81_TE1_TE10_Pos                 (0UL)                     /*!< TE10 (Bit 0)                                          */
#define TM81_TE1_TE10_Msk                 (0x1UL)                   /*!< TE10 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE11_Pos                 (1UL)                     /*!< TE11 (Bit 1)                                          */
#define TM81_TE1_TE11_Msk                 (0x2UL)                   /*!< TE11 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE12_Pos                 (2UL)                     /*!< TE12 (Bit 2)                                          */
#define TM81_TE1_TE12_Msk                 (0x4UL)                   /*!< TE12 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE13_Pos                 (3UL)                     /*!< TE13 (Bit 3)                                          */
#define TM81_TE1_TE13_Msk                 (0x8UL)                   /*!< TE13 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE14_Pos                 (4UL)                     /*!< TE14 (Bit 4)                                          */
#define TM81_TE1_TE14_Msk                 (0x10UL)                  /*!< TE14 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE15_Pos                 (5UL)                     /*!< TE15 (Bit 5)                                          */
#define TM81_TE1_TE15_Msk                 (0x20UL)                  /*!< TE15 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE16_Pos                 (6UL)                     /*!< TE16 (Bit 6)                                          */
#define TM81_TE1_TE16_Msk                 (0x40UL)                  /*!< TE16 (Bitfield-Mask: 0x01)                            */
#define TM81_TE1_TE17_Pos                 (7UL)                     /*!< TE17 (Bit 7)                                          */
#define TM81_TE1_TE17_Msk                 (0x80UL)                  /*!< TE17 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  TS1  ========================================================== */
#define TM81_TS1_TS10_Pos                 (0UL)                     /*!< TS10 (Bit 0)                                          */
#define TM81_TS1_TS10_Msk                 (0x1UL)                   /*!< TS10 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS11_Pos                 (1UL)                     /*!< TS11 (Bit 1)                                          */
#define TM81_TS1_TS11_Msk                 (0x2UL)                   /*!< TS11 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS12_Pos                 (2UL)                     /*!< TS12 (Bit 2)                                          */
#define TM81_TS1_TS12_Msk                 (0x4UL)                   /*!< TS12 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS13_Pos                 (3UL)                     /*!< TS13 (Bit 3)                                          */
#define TM81_TS1_TS13_Msk                 (0x8UL)                   /*!< TS13 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS14_Pos                 (4UL)                     /*!< TS14 (Bit 4)                                          */
#define TM81_TS1_TS14_Msk                 (0x10UL)                  /*!< TS14 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS15_Pos                 (5UL)                     /*!< TS15 (Bit 5)                                          */
#define TM81_TS1_TS15_Msk                 (0x20UL)                  /*!< TS15 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS16_Pos                 (6UL)                     /*!< TS16 (Bit 6)                                          */
#define TM81_TS1_TS16_Msk                 (0x40UL)                  /*!< TS16 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TS17_Pos                 (7UL)                     /*!< TS17 (Bit 7)                                          */
#define TM81_TS1_TS17_Msk                 (0x80UL)                  /*!< TS17 (Bitfield-Mask: 0x01)                            */
#define TM81_TS1_TSH11_Pos                (9UL)                     /*!< TSH11 (Bit 9)                                         */
#define TM81_TS1_TSH11_Msk                (0x200UL)                 /*!< TSH11 (Bitfield-Mask: 0x01)                           */
#define TM81_TS1_TSH13_Pos                (11UL)                    /*!< TSH13 (Bit 11)                                        */
#define TM81_TS1_TSH13_Msk                (0x800UL)                 /*!< TSH13 (Bitfield-Mask: 0x01)                           */
/* ==========================================================  TT1  ========================================================== */
#define TM81_TT1_TT10_Pos                 (0UL)                     /*!< TT10 (Bit 0)                                          */
#define TM81_TT1_TT10_Msk                 (0x1UL)                   /*!< TT10 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT11_Pos                 (1UL)                     /*!< TT11 (Bit 1)                                          */
#define TM81_TT1_TT11_Msk                 (0x2UL)                   /*!< TT11 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT12_Pos                 (2UL)                     /*!< TT12 (Bit 2)                                          */
#define TM81_TT1_TT12_Msk                 (0x4UL)                   /*!< TT12 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT13_Pos                 (3UL)                     /*!< TT13 (Bit 3)                                          */
#define TM81_TT1_TT13_Msk                 (0x8UL)                   /*!< TT13 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT14_Pos                 (4UL)                     /*!< TT14 (Bit 4)                                          */
#define TM81_TT1_TT14_Msk                 (0x10UL)                  /*!< TT14 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT15_Pos                 (5UL)                     /*!< TT15 (Bit 5)                                          */
#define TM81_TT1_TT15_Msk                 (0x20UL)                  /*!< TT15 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT16_Pos                 (6UL)                     /*!< TT16 (Bit 6)                                          */
#define TM81_TT1_TT16_Msk                 (0x40UL)                  /*!< TT16 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TT17_Pos                 (7UL)                     /*!< TT17 (Bit 7)                                          */
#define TM81_TT1_TT17_Msk                 (0x80UL)                  /*!< TT17 (Bitfield-Mask: 0x01)                            */
#define TM81_TT1_TTH11_Pos                (9UL)                     /*!< TTH11 (Bit 9)                                         */
#define TM81_TT1_TTH11_Msk                (0x200UL)                 /*!< TTH11 (Bitfield-Mask: 0x01)                           */
#define TM81_TT1_TTH13_Pos                (11UL)                    /*!< TTH13 (Bit 11)                                        */
#define TM81_TT1_TTH13_Msk                (0x800UL)                 /*!< TTH13 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TPS1  ========================================================== */
#define TM81_TPS1_PRS10_Pos               (0UL)                     /*!< PRS10 (Bit 0)                                         */
#define TM81_TPS1_PRS10_Msk               (0xfUL)                   /*!< PRS10 (Bitfield-Mask: 0x0f)                           */
#define TM81_TPS1_PRS11_Pos               (4UL)                     /*!< PRS11 (Bit 4)                                         */
#define TM81_TPS1_PRS11_Msk               (0xf0UL)                  /*!< PRS11 (Bitfield-Mask: 0x0f)                           */
#define TM81_TPS1_PRS12_Pos               (8UL)                     /*!< PRS12 (Bit 8)                                         */
#define TM81_TPS1_PRS12_Msk               (0x300UL)                 /*!< PRS12 (Bitfield-Mask: 0x03)                           */
#define TM81_TPS1_PRS13_Pos               (12UL)                    /*!< PRS13 (Bit 12)                                        */
#define TM81_TPS1_PRS13_Msk               (0x3000UL)                /*!< PRS13 (Bitfield-Mask: 0x03)                           */
/* ==========================================================  TO1  ========================================================== */
#define TM81_TO1_TO10_Pos                 (0UL)                     /*!< TO10 (Bit 0)                                          */
#define TM81_TO1_TO10_Msk                 (0x1UL)                   /*!< TO10 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO11_Pos                 (1UL)                     /*!< TO11 (Bit 1)                                          */
#define TM81_TO1_TO11_Msk                 (0x2UL)                   /*!< TO11 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO12_Pos                 (2UL)                     /*!< TO12 (Bit 2)                                          */
#define TM81_TO1_TO12_Msk                 (0x4UL)                   /*!< TO12 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO13_Pos                 (3UL)                     /*!< TO13 (Bit 3)                                          */
#define TM81_TO1_TO13_Msk                 (0x8UL)                   /*!< TO13 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO14_Pos                 (4UL)                     /*!< TO14 (Bit 4)                                          */
#define TM81_TO1_TO14_Msk                 (0x10UL)                  /*!< TO14 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO15_Pos                 (5UL)                     /*!< TO15 (Bit 5)                                          */
#define TM81_TO1_TO15_Msk                 (0x20UL)                  /*!< TO15 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO16_Pos                 (6UL)                     /*!< TO16 (Bit 6)                                          */
#define TM81_TO1_TO16_Msk                 (0x40UL)                  /*!< TO16 (Bitfield-Mask: 0x01)                            */
#define TM81_TO1_TO17_Pos                 (7UL)                     /*!< TO17 (Bit 7)                                          */
#define TM81_TO1_TO17_Msk                 (0x80UL)                  /*!< TO17 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TOE1  ========================================================== */
#define TM81_TOE1_TOE10_Pos               (0UL)                     /*!< TOE10 (Bit 0)                                         */
#define TM81_TOE1_TOE10_Msk               (0x1UL)                   /*!< TOE10 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE11_Pos               (1UL)                     /*!< TOE11 (Bit 1)                                         */
#define TM81_TOE1_TOE11_Msk               (0x2UL)                   /*!< TOE11 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE12_Pos               (2UL)                     /*!< TOE12 (Bit 2)                                         */
#define TM81_TOE1_TOE12_Msk               (0x4UL)                   /*!< TOE12 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE13_Pos               (3UL)                     /*!< TOE13 (Bit 3)                                         */
#define TM81_TOE1_TOE13_Msk               (0x8UL)                   /*!< TOE13 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE14_Pos               (4UL)                     /*!< TOE14 (Bit 4)                                         */
#define TM81_TOE1_TOE14_Msk               (0x10UL)                  /*!< TOE14 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE15_Pos               (5UL)                     /*!< TOE15 (Bit 5)                                         */
#define TM81_TOE1_TOE15_Msk               (0x20UL)                  /*!< TOE15 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE16_Pos               (6UL)                     /*!< TOE16 (Bit 6)                                         */
#define TM81_TOE1_TOE16_Msk               (0x40UL)                  /*!< TOE16 (Bitfield-Mask: 0x01)                           */
#define TM81_TOE1_TOE17_Pos               (7UL)                     /*!< TOE17 (Bit 7)                                         */
#define TM81_TOE1_TOE17_Msk               (0x80UL)                  /*!< TOE17 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOL1  ========================================================== */
#define TM81_TOL1_TOL11_Pos               (1UL)                     /*!< TOL11 (Bit 1)                                         */
#define TM81_TOL1_TOL11_Msk               (0x2UL)                   /*!< TOL11 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL12_Pos               (2UL)                     /*!< TOL12 (Bit 2)                                         */
#define TM81_TOL1_TOL12_Msk               (0x4UL)                   /*!< TOL12 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL13_Pos               (3UL)                     /*!< TOL13 (Bit 3)                                         */
#define TM81_TOL1_TOL13_Msk               (0x8UL)                   /*!< TOL13 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL14_Pos               (4UL)                     /*!< TOL14 (Bit 4)                                         */
#define TM81_TOL1_TOL14_Msk               (0x10UL)                  /*!< TOL14 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL15_Pos               (5UL)                     /*!< TOL15 (Bit 5)                                         */
#define TM81_TOL1_TOL15_Msk               (0x20UL)                  /*!< TOL15 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL16_Pos               (6UL)                     /*!< TOL16 (Bit 6)                                         */
#define TM81_TOL1_TOL16_Msk               (0x40UL)                  /*!< TOL16 (Bitfield-Mask: 0x01)                           */
#define TM81_TOL1_TOL17_Pos               (7UL)                     /*!< TOL17 (Bit 7)                                         */
#define TM81_TOL1_TOL17_Msk               (0x80UL)                  /*!< TOL17 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOM1  ========================================================== */
#define TM81_TOM1_TOM11_Pos               (1UL)                     /*!< TOM11 (Bit 1)                                         */
#define TM81_TOM1_TOM11_Msk               (0x2UL)                   /*!< TOM11 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM12_Pos               (2UL)                     /*!< TOM12 (Bit 2)                                         */
#define TM81_TOM1_TOM12_Msk               (0x4UL)                   /*!< TOM12 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM13_Pos               (3UL)                     /*!< TOM13 (Bit 3)                                         */
#define TM81_TOM1_TOM13_Msk               (0x8UL)                   /*!< TOM13 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM14_Pos               (4UL)                     /*!< TOM14 (Bit 4)                                         */
#define TM81_TOM1_TOM14_Msk               (0x10UL)                  /*!< TOM14 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM15_Pos               (5UL)                     /*!< TOM15 (Bit 5)                                         */
#define TM81_TOM1_TOM15_Msk               (0x20UL)                  /*!< TOM15 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM16_Pos               (6UL)                     /*!< TOM16 (Bit 6)                                         */
#define TM81_TOM1_TOM16_Msk               (0x40UL)                  /*!< TOM16 (Bitfield-Mask: 0x01)                           */
#define TM81_TOM1_TOM17_Pos               (7UL)                     /*!< TOM17 (Bit 7)                                         */
#define TM81_TOM1_TOM17_Msk               (0x80UL)                  /*!< TOM17 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TDR10  ========================================================= */
/* =========================================================  TDR11  ========================================================= */
/* ========================================================  TDR11L  ========================================================= */
/* ========================================================  TDR11H  ========================================================= */
/* =========================================================  TDR12  ========================================================= */
/* =========================================================  TDR13  ========================================================= */
/* ========================================================  TDR13L  ========================================================= */
/* ========================================================  TDR13H  ========================================================= */
/* =========================================================  TDR14  ========================================================= */
/* =========================================================  TDR15  ========================================================= */
/* =========================================================  TDR16  ========================================================= */
/* =========================================================  TDR17  ========================================================= */


/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */

/* =========================================================  SPIM0  ========================================================= */
#define SPIHS0_SPIM0_RECMD_Pos            (1UL)                     /*!< RECMD (Bit 1)                                         */
#define SPIHS0_SPIM0_RECMD_Msk            (0x2UL)                   /*!< RECMD (Bitfield-Mask: 0x01)                           */
#define SPIHS0_SPIM0_DLS_Pos              (2UL)                     /*!< DLS (Bit 2)                                           */
#define SPIHS0_SPIM0_DLS_Msk              (0x4UL)                   /*!< DLS (Bitfield-Mask: 0x01)                             */
#define SPIHS0_SPIM0_INTMD_Pos            (3UL)                     /*!< INTMD (Bit 3)                                         */
#define SPIHS0_SPIM0_INTMD_Msk            (0x8UL)                   /*!< INTMD (Bitfield-Mask: 0x01)                           */
#define SPIHS0_SPIM0_DIR_Pos              (4UL)                     /*!< DIR (Bit 4)                                           */
#define SPIHS0_SPIM0_DIR_Msk              (0x10UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SPIHS0_SPIM0_NSSE_Pos             (5UL)                     /*!< NSSE (Bit 5)                                          */
#define SPIHS0_SPIM0_NSSE_Msk             (0x20UL)                  /*!< NSSE (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIM0_TRMD_Pos             (6UL)                     /*!< TRMD (Bit 6)                                          */
#define SPIHS0_SPIM0_TRMD_Msk             (0x40UL)                  /*!< TRMD (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIM0_SPIE_Pos             (7UL)                     /*!< SPIE (Bit 7)                                          */
#define SPIHS0_SPIM0_SPIE_Msk             (0x80UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPIC0  ========================================================= */
#define SPIHS0_SPIC0_CKS_Pos              (0UL)                     /*!< CKS (Bit 0)                                           */
#define SPIHS0_SPIC0_CKS_Msk              (0x7UL)                   /*!< CKS (Bitfield-Mask: 0x07)                             */
#define SPIHS0_SPIC0_CPHA_Pos             (3UL)                     /*!< CPHA (Bit 3)                                          */
#define SPIHS0_SPIC0_CPHA_Msk             (0x8UL)                   /*!< CPHA (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIC0_CPOL_Pos             (4UL)                     /*!< CPOL (Bit 4)                                          */
#define SPIHS0_SPIC0_CPOL_Msk             (0x10UL)                  /*!< CPOL (Bitfield-Mask: 0x01)                            */
/* =========================================================  SDRO0  ========================================================= */
/* =========================================================  SDRI0  ========================================================= */
/* =========================================================  SPIS0  ========================================================= */
#define SPIHS0_SPIS0_SPTF_Pos             (0UL)                     /*!< SPTF (Bit 0)                                          */
#define SPIHS0_SPIS0_SPTF_Msk             (0x1UL)                   /*!< SPTF (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIS0_SDRIF_Pos            (1UL)                     /*!< SDRIF (Bit 1)                                         */
#define SPIHS0_SPIS0_SDRIF_Msk            (0x2UL)                   /*!< SDRIF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                          SPIHS1                                           ================ */
/* =========================================================================================================================== */

/* =========================================================  SPIM1  ========================================================= */
#define SPIHS1_SPIM1_RECMD_Pos            (1UL)                     /*!< RECMD (Bit 1)                                         */
#define SPIHS1_SPIM1_RECMD_Msk            (0x2UL)                   /*!< RECMD (Bitfield-Mask: 0x01)                           */
#define SPIHS1_SPIM1_DLS_Pos              (2UL)                     /*!< DLS (Bit 2)                                           */
#define SPIHS1_SPIM1_DLS_Msk              (0x4UL)                   /*!< DLS (Bitfield-Mask: 0x01)                             */
#define SPIHS1_SPIM1_INTMD_Pos            (3UL)                     /*!< INTMD (Bit 3)                                         */
#define SPIHS1_SPIM1_INTMD_Msk            (0x8UL)                   /*!< INTMD (Bitfield-Mask: 0x01)                           */
#define SPIHS1_SPIM1_DIR_Pos              (4UL)                     /*!< DIR (Bit 4)                                           */
#define SPIHS1_SPIM1_DIR_Msk              (0x10UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SPIHS1_SPIM1_NSSE_Pos             (5UL)                     /*!< NSSE (Bit 5)                                          */
#define SPIHS1_SPIM1_NSSE_Msk             (0x20UL)                  /*!< NSSE (Bitfield-Mask: 0x01)                            */
#define SPIHS1_SPIM1_TRMD_Pos             (6UL)                     /*!< TRMD (Bit 6)                                          */
#define SPIHS1_SPIM1_TRMD_Msk             (0x40UL)                  /*!< TRMD (Bitfield-Mask: 0x01)                            */
#define SPIHS1_SPIM1_SPIE_Pos             (7UL)                     /*!< SPIE (Bit 7)                                          */
#define SPIHS1_SPIM1_SPIE_Msk             (0x80UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPIC1  ========================================================= */
#define SPIHS1_SPIC1_CKS_Pos              (0UL)                     /*!< CKS (Bit 0)                                           */
#define SPIHS1_SPIC1_CKS_Msk              (0x7UL)                   /*!< CKS (Bitfield-Mask: 0x07)                             */
#define SPIHS1_SPIC1_CPHA_Pos             (3UL)                     /*!< CPHA (Bit 3)                                          */
#define SPIHS1_SPIC1_CPHA_Msk             (0x8UL)                   /*!< CPHA (Bitfield-Mask: 0x01)                            */
#define SPIHS1_SPIC1_CPOL_Pos             (4UL)                     /*!< CPOL (Bit 4)                                          */
#define SPIHS1_SPIC1_CPOL_Msk             (0x10UL)                  /*!< CPOL (Bitfield-Mask: 0x01)                            */
/* =========================================================  SDRO1  ========================================================= */
/* =========================================================  SDRI1  ========================================================= */
/* =========================================================  SPIS1  ========================================================= */
#define SPIHS1_SPIS1_SPTF_Pos             (0UL)                     /*!< SPTF (Bit 0)                                          */
#define SPIHS1_SPIS1_SPTF_Msk             (0x1UL)                   /*!< SPTF (Bitfield-Mask: 0x01)                            */
#define SPIHS1_SPIS1_SDRIF_Pos            (1UL)                     /*!< SDRIF (Bit 1)                                         */
#define SPIHS1_SPIS1_SDRIF_Msk            (0x2UL)                   /*!< SDRIF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           IICA0                                           ================ */
/* =========================================================================================================================== */

/* =======================================================  IICCTL00  ======================================================== */
#define IICA0_IICCTL00_SPT_Pos            (0UL)                     /*!< SPT (Bit 0)                                           */
#define IICA0_IICCTL00_SPT_Msk            (0x1UL)                   /*!< SPT (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL00_STT_Pos            (1UL)                     /*!< STT (Bit 1)                                           */
#define IICA0_IICCTL00_STT_Msk            (0x2UL)                   /*!< STT (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL00_ACKE_Pos           (2UL)                     /*!< ACKE (Bit 2)                                          */
#define IICA0_IICCTL00_ACKE_Msk           (0x4UL)                   /*!< ACKE (Bitfield-Mask: 0x01)                            */
#define IICA0_IICCTL00_WTIM_Pos           (3UL)                     /*!< WTIM (Bit 3)                                          */
#define IICA0_IICCTL00_WTIM_Msk           (0x8UL)                   /*!< WTIM (Bitfield-Mask: 0x01)                            */
#define IICA0_IICCTL00_SPIE_Pos           (4UL)                     /*!< SPIE (Bit 4)                                          */
#define IICA0_IICCTL00_SPIE_Msk           (0x10UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
#define IICA0_IICCTL00_WREL_Pos           (5UL)                     /*!< WREL (Bit 5)                                          */
#define IICA0_IICCTL00_WREL_Msk           (0x20UL)                  /*!< WREL (Bitfield-Mask: 0x01)                            */
#define IICA0_IICCTL00_LREL_Pos           (6UL)                     /*!< LREL (Bit 6)                                          */
#define IICA0_IICCTL00_LREL_Msk           (0x40UL)                  /*!< LREL (Bitfield-Mask: 0x01)                            */
#define IICA0_IICCTL00_IICE_Pos           (7UL)                     /*!< IICE (Bit 7)                                          */
#define IICA0_IICCTL00_IICE_Msk           (0x80UL)                  /*!< IICE (Bitfield-Mask: 0x01)                            */
/* =======================================================  IICCTL01  ======================================================== */
#define IICA0_IICCTL01_PRS_Pos            (0UL)                     /*!< PRS (Bit 0)                                           */
#define IICA0_IICCTL01_PRS_Msk            (0x1UL)                   /*!< PRS (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL01_DFC_Pos            (2UL)                     /*!< DFC (Bit 2)                                           */
#define IICA0_IICCTL01_DFC_Msk            (0x4UL)                   /*!< DFC (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL01_SMC_Pos            (3UL)                     /*!< SMC (Bit 3)                                           */
#define IICA0_IICCTL01_SMC_Msk            (0x8UL)                   /*!< SMC (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL01_DAD_Pos            (4UL)                     /*!< DAD (Bit 4)                                           */
#define IICA0_IICCTL01_DAD_Msk            (0x10UL)                  /*!< DAD (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL01_CLD_Pos            (5UL)                     /*!< CLD (Bit 5)                                           */
#define IICA0_IICCTL01_CLD_Msk            (0x20UL)                  /*!< CLD (Bitfield-Mask: 0x01)                             */
#define IICA0_IICCTL01_WUP_Pos            (7UL)                     /*!< WUP (Bit 7)                                           */
#define IICA0_IICCTL01_WUP_Msk            (0x80UL)                  /*!< WUP (Bitfield-Mask: 0x01)                             */
/* ========================================================  IICWL0  ========================================================= */
/* ========================================================  IICWH0  ========================================================= */
/* =========================================================  SVA0  ========================================================== */
/* ========================================================  IICA00  ========================================================= */
/* =========================================================  IICS0  ========================================================= */
#define IICA0_IICS0_MSTS_Pos              (7UL)                     /*!< MSTS (Bit 7)                                          */
#define IICA0_IICS0_MSTS_Msk              (0x80UL)                  /*!< MSTS (Bitfield-Mask: 0x01)                            */
#define IICA0_IICS0_ALD_Pos               (6UL)                     /*!< ALD (Bit 6)                                           */
#define IICA0_IICS0_ALD_Msk               (0x40UL)                  /*!< ALD (Bitfield-Mask: 0x01)                             */
#define IICA0_IICS0_EXC_Pos               (5UL)                     /*!< EXC (Bit 5)                                           */
#define IICA0_IICS0_EXC_Msk               (0x20UL)                  /*!< EXC (Bitfield-Mask: 0x01)                             */
#define IICA0_IICS0_COI_Pos               (4UL)                     /*!< COI (Bit 4)                                           */
#define IICA0_IICS0_COI_Msk               (0x10UL)                  /*!< COI (Bitfield-Mask: 0x01)                             */
#define IICA0_IICS0_TRC_Pos               (3UL)                     /*!< TRC (Bit 3)                                           */
#define IICA0_IICS0_TRC_Msk               (0x8UL)                   /*!< TRC (Bitfield-Mask: 0x01)                             */
#define IICA0_IICS0_ACKD_Pos              (2UL)                     /*!< ACKD (Bit 2)                                          */
#define IICA0_IICS0_ACKD_Msk              (0x4UL)                   /*!< ACKD (Bitfield-Mask: 0x01)                            */
#define IICA0_IICS0_STD_Pos               (1UL)                     /*!< STD (Bit 1)                                           */
#define IICA0_IICS0_STD_Msk               (0x2UL)                   /*!< STD (Bitfield-Mask: 0x01)                             */
#define IICA0_IICS0_SPD_Pos               (0UL)                     /*!< SPD (Bit 0)                                           */
#define IICA0_IICS0_SPD_Msk               (0x1UL)                   /*!< SPD (Bitfield-Mask: 0x01)                             */
/* =========================================================  IICF0  ========================================================= */
#define IICA0_IICF0_STCF_Pos              (7UL)                     /*!< STCF (Bit 7)                                          */
#define IICA0_IICF0_STCF_Msk              (0x80UL)                  /*!< STCF (Bitfield-Mask: 0x01)                            */
#define IICA0_IICF0_IICBSY_Pos            (6UL)                     /*!< IICBSY (Bit 6)                                        */
#define IICA0_IICF0_IICBSY_Msk            (0x40UL)                  /*!< IICBSY (Bitfield-Mask: 0x01)                          */
#define IICA0_IICF0_STCEN_Pos             (1UL)                     /*!< STCEN (Bit 1)                                         */
#define IICA0_IICF0_STCEN_Msk             (0x2UL)                   /*!< STCEN (Bitfield-Mask: 0x01)                           */
#define IICA0_IICF0_IICRSV_Pos            (0UL)                     /*!< IICRSV (Bit 0)                                        */
#define IICA0_IICF0_IICRSV_Msk            (0x1UL)                   /*!< IICRSV (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                           IICA1                                           ================ */
/* =========================================================================================================================== */

/* =======================================================  IICCTL10  ======================================================== */
#define IICA1_IICCTL10_SPT_Pos            (0UL)                     /*!< SPT (Bit 0)                                           */
#define IICA1_IICCTL10_SPT_Msk            (0x1UL)                   /*!< SPT (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL10_STT_Pos            (1UL)                     /*!< STT (Bit 1)                                           */
#define IICA1_IICCTL10_STT_Msk            (0x2UL)                   /*!< STT (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL10_ACKE_Pos           (2UL)                     /*!< ACKE (Bit 2)                                          */
#define IICA1_IICCTL10_ACKE_Msk           (0x4UL)                   /*!< ACKE (Bitfield-Mask: 0x01)                            */
#define IICA1_IICCTL10_WTIM_Pos           (3UL)                     /*!< WTIM (Bit 3)                                          */
#define IICA1_IICCTL10_WTIM_Msk           (0x8UL)                   /*!< WTIM (Bitfield-Mask: 0x01)                            */
#define IICA1_IICCTL10_SPIE_Pos           (4UL)                     /*!< SPIE (Bit 4)                                          */
#define IICA1_IICCTL10_SPIE_Msk           (0x10UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
#define IICA1_IICCTL10_WREL_Pos           (5UL)                     /*!< WREL (Bit 5)                                          */
#define IICA1_IICCTL10_WREL_Msk           (0x20UL)                  /*!< WREL (Bitfield-Mask: 0x01)                            */
#define IICA1_IICCTL10_LREL_Pos           (6UL)                     /*!< LREL (Bit 6)                                          */
#define IICA1_IICCTL10_LREL_Msk           (0x40UL)                  /*!< LREL (Bitfield-Mask: 0x01)                            */
#define IICA1_IICCTL10_IICE_Pos           (7UL)                     /*!< IICE (Bit 7)                                          */
#define IICA1_IICCTL10_IICE_Msk           (0x80UL)                  /*!< IICE (Bitfield-Mask: 0x01)                            */
/* =======================================================  IICCTL11  ======================================================== */
#define IICA1_IICCTL11_PRS_Pos            (0UL)                     /*!< PRS (Bit 0)                                           */
#define IICA1_IICCTL11_PRS_Msk            (0x1UL)                   /*!< PRS (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL11_DFC_Pos            (2UL)                     /*!< DFC (Bit 2)                                           */
#define IICA1_IICCTL11_DFC_Msk            (0x4UL)                   /*!< DFC (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL11_SMC_Pos            (3UL)                     /*!< SMC (Bit 3)                                           */
#define IICA1_IICCTL11_SMC_Msk            (0x8UL)                   /*!< SMC (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL11_DAD_Pos            (4UL)                     /*!< DAD (Bit 4)                                           */
#define IICA1_IICCTL11_DAD_Msk            (0x10UL)                  /*!< DAD (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL11_CLD_Pos            (5UL)                     /*!< CLD (Bit 5)                                           */
#define IICA1_IICCTL11_CLD_Msk            (0x20UL)                  /*!< CLD (Bitfield-Mask: 0x01)                             */
#define IICA1_IICCTL11_WUP_Pos            (7UL)                     /*!< WUP (Bit 7)                                           */
#define IICA1_IICCTL11_WUP_Msk            (0x80UL)                  /*!< WUP (Bitfield-Mask: 0x01)                             */
/* ========================================================  IICWL1  ========================================================= */
/* ========================================================  IICWH1  ========================================================= */
/* =========================================================  SVA1  ========================================================== */
/* ========================================================  IICA10  ========================================================= */
/* =========================================================  IICS1  ========================================================= */
#define IICA1_IICS1_MSTS_Pos              (7UL)                     /*!< MSTS (Bit 7)                                          */
#define IICA1_IICS1_MSTS_Msk              (0x80UL)                  /*!< MSTS (Bitfield-Mask: 0x01)                            */
#define IICA1_IICS1_ALD_Pos               (6UL)                     /*!< ALD (Bit 6)                                           */
#define IICA1_IICS1_ALD_Msk               (0x40UL)                  /*!< ALD (Bitfield-Mask: 0x01)                             */
#define IICA1_IICS1_EXC_Pos               (5UL)                     /*!< EXC (Bit 5)                                           */
#define IICA1_IICS1_EXC_Msk               (0x20UL)                  /*!< EXC (Bitfield-Mask: 0x01)                             */
#define IICA1_IICS1_COI_Pos               (4UL)                     /*!< COI (Bit 4)                                           */
#define IICA1_IICS1_COI_Msk               (0x10UL)                  /*!< COI (Bitfield-Mask: 0x01)                             */
#define IICA1_IICS1_TRC_Pos               (3UL)                     /*!< TRC (Bit 3)                                           */
#define IICA1_IICS1_TRC_Msk               (0x8UL)                   /*!< TRC (Bitfield-Mask: 0x01)                             */
#define IICA1_IICS1_ACKD_Pos              (2UL)                     /*!< ACKD (Bit 2)                                          */
#define IICA1_IICS1_ACKD_Msk              (0x4UL)                   /*!< ACKD (Bitfield-Mask: 0x01)                            */
#define IICA1_IICS1_STD_Pos               (1UL)                     /*!< STD (Bit 1)                                           */
#define IICA1_IICS1_STD_Msk               (0x2UL)                   /*!< STD (Bitfield-Mask: 0x01)                             */
#define IICA1_IICS1_SPD_Pos               (0UL)                     /*!< SPD (Bit 0)                                           */
#define IICA1_IICS1_SPD_Msk               (0x1UL)                   /*!< SPD (Bitfield-Mask: 0x01)                             */
/* =========================================================  IICF1  ========================================================= */
#define IICA1_IICF1_STCF_Pos              (7UL)                     /*!< STCF (Bit 7)                                          */
#define IICA1_IICF1_STCF_Msk              (0x80UL)                  /*!< STCF (Bitfield-Mask: 0x01)                            */
#define IICA1_IICF1_IICBSY_Pos            (6UL)                     /*!< IICBSY (Bit 6)                                        */
#define IICA1_IICF1_IICBSY_Msk            (0x40UL)                  /*!< IICBSY (Bitfield-Mask: 0x01)                          */
#define IICA1_IICF1_STCEN_Pos             (1UL)                     /*!< STCEN (Bit 1)                                         */
#define IICA1_IICF1_STCEN_Msk             (0x2UL)                   /*!< STCEN (Bitfield-Mask: 0x01)                           */
#define IICA1_IICF1_IICRSV_Pos            (0UL)                     /*!< IICRSV (Bit 0)                                        */
#define IICA1_IICF1_IICRSV_Msk            (0x1UL)                   /*!< IICRSV (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                           CMP0                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  COMP0MDR  ======================================================== */
#define CMP0_COMP0MDR_C0ENB_Pos           (0UL)                     /*!< C0ENB (Bit 0)                                         */
#define CMP0_COMP0MDR_C0ENB_Msk           (0x1UL)                   /*!< C0ENB (Bitfield-Mask: 0x01)                           */
#define CMP0_COMP0MDR_C0MON_Pos           (3UL)                     /*!< C0MON (Bit 3)                                         */
#define CMP0_COMP0MDR_C0MON_Msk           (0x8UL)                   /*!< C0MON (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP0FIR  ======================================================== */
#define CMP0_COMP0FIR_C0FCK_Pos           (0UL)                     /*!< C0FCK (Bit 0)                                         */
#define CMP0_COMP0FIR_C0FCK_Msk           (0x3UL)                   /*!< C0FCK (Bitfield-Mask: 0x03)                           */
#define CMP0_COMP0FIR_C0EPO_Pos           (2UL)                     /*!< C0EPO (Bit 2)                                         */
#define CMP0_COMP0FIR_C0EPO_Msk           (0x4UL)                   /*!< C0EPO (Bitfield-Mask: 0x01)                           */
#define CMP0_COMP0FIR_C0EDG_Pos           (3UL)                     /*!< C0EDG (Bit 3)                                         */
#define CMP0_COMP0FIR_C0EDG_Msk           (0x8UL)                   /*!< C0EDG (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP0OCR  ======================================================== */
#define CMP0_COMP0OCR_C0IE_Pos            (0UL)                     /*!< C0IE (Bit 0)                                          */
#define CMP0_COMP0OCR_C0IE_Msk            (0x1UL)                   /*!< C0IE (Bitfield-Mask: 0x01)                            */
#define CMP0_COMP0OCR_C0OE_Pos            (1UL)                     /*!< C0OE (Bit 1)                                          */
#define CMP0_COMP0OCR_C0OE_Msk            (0x2UL)                   /*!< C0OE (Bitfield-Mask: 0x01)                            */
#define CMP0_COMP0OCR_C0OP_Pos            (2UL)                     /*!< C0OP (Bit 2)                                          */
#define CMP0_COMP0OCR_C0OP_Msk            (0x4UL)                   /*!< C0OP (Bitfield-Mask: 0x01)                            */
#define CMP0_COMP0OCR_C0OTWMD_Pos         (7UL)                     /*!< C0OTWMD (Bit 7)                                       */
#define CMP0_COMP0OCR_C0OTWMD_Msk         (0x80UL)                  /*!< C0OTWMD (Bitfield-Mask: 0x01)                         */
/* =======================================================  COMP0SEL  ======================================================== */
#define CMP0_COMP0SEL_C0REFS_Pos          (0UL)                     /*!< C0REFS (Bit 0)                                        */
#define CMP0_COMP0SEL_C0REFS_Msk          (0x3UL)                   /*!< C0REFS (Bitfield-Mask: 0x03)                          */
#define CMP0_COMP0SEL_CMPSEL_Pos          (6UL)                     /*!< CMPSEL (Bit 6)                                        */
#define CMP0_COMP0SEL_CMPSEL_Msk          (0xc0UL)                  /*!< CMPSEL (Bitfield-Mask: 0x03)                          */
/* ========================================================  COMP0HY  ======================================================== */
#define CMP0_COMP0HY_C0HYSLS_Pos          (0UL)                     /*!< C0HYSLS (Bit 0)                                       */
#define CMP0_COMP0HY_C0HYSLS_Msk          (0x3UL)                   /*!< C0HYSLS (Bitfield-Mask: 0x03)                         */
#define CMP0_COMP0HY_C0HYSVS_Pos          (4UL)                     /*!< C0HYSVS (Bit 4)                                       */
#define CMP0_COMP0HY_C0HYSVS_Msk          (0x30UL)                  /*!< C0HYSVS (Bitfield-Mask: 0x03)                         */


/* =========================================================================================================================== */
/* ================                                           CMP1                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  COMP1MDR  ======================================================== */
#define CMP1_COMP1MDR_C1ENB_Pos           (0UL)                     /*!< C1ENB (Bit 0)                                         */
#define CMP1_COMP1MDR_C1ENB_Msk           (0x1UL)                   /*!< C1ENB (Bitfield-Mask: 0x01)                           */
#define CMP1_COMP1MDR_C1MON_Pos           (3UL)                     /*!< C1MON (Bit 3)                                         */
#define CMP1_COMP1MDR_C1MON_Msk           (0x8UL)                   /*!< C1MON (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP1FIR  ======================================================== */
#define CMP1_COMP1FIR_C1FCK_Pos           (0UL)                     /*!< C1FCK (Bit 0)                                         */
#define CMP1_COMP1FIR_C1FCK_Msk           (0x3UL)                   /*!< C1FCK (Bitfield-Mask: 0x03)                           */
#define CMP1_COMP1FIR_C1EPO_Pos           (2UL)                     /*!< C1EPO (Bit 2)                                         */
#define CMP1_COMP1FIR_C1EPO_Msk           (0x4UL)                   /*!< C1EPO (Bitfield-Mask: 0x01)                           */
#define CMP1_COMP1FIR_C1EDG_Pos           (3UL)                     /*!< C1EDG (Bit 3)                                         */
#define CMP1_COMP1FIR_C1EDG_Msk           (0x8UL)                   /*!< C1EDG (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP1OCR  ======================================================== */
#define CMP1_COMP1OCR_C1IE_Pos            (0UL)                     /*!< C1IE (Bit 0)                                          */
#define CMP1_COMP1OCR_C1IE_Msk            (0x1UL)                   /*!< C1IE (Bitfield-Mask: 0x01)                            */
#define CMP1_COMP1OCR_C1OE_Pos            (1UL)                     /*!< C1OE (Bit 1)                                          */
#define CMP1_COMP1OCR_C1OE_Msk            (0x2UL)                   /*!< C1OE (Bitfield-Mask: 0x01)                            */
#define CMP1_COMP1OCR_C1OP_Pos            (2UL)                     /*!< C1OP (Bit 2)                                          */
#define CMP1_COMP1OCR_C1OP_Msk            (0x4UL)                   /*!< C1OP (Bitfield-Mask: 0x01)                            */
#define CMP1_COMP1OCR_C1OTWMD_Pos         (7UL)                     /*!< C1OTWMD (Bit 7)                                       */
#define CMP1_COMP1OCR_C1OTWMD_Msk         (0x80UL)                  /*!< C1OTWMD (Bitfield-Mask: 0x01)                         */
/* =======================================================  COMP1SEL  ======================================================== */
#define CMP1_COMP1SEL_C1REFS_Pos          (0UL)                     /*!< C1REFS (Bit 0)                                        */
#define CMP1_COMP1SEL_C1REFS_Msk          (0x3UL)                   /*!< C1REFS (Bitfield-Mask: 0x03)                          */
#define CMP1_COMP1SEL_CMPSEL_Pos          (6UL)                     /*!< CMPSEL (Bit 6)                                        */
#define CMP1_COMP1SEL_CMPSEL_Msk          (0xc0UL)                  /*!< CMPSEL (Bitfield-Mask: 0x03)                          */
/* ========================================================  COMP1HY  ======================================================== */
#define CMP1_COMP1HY_C1HYSLS_Pos          (0UL)                     /*!< C1HYSLS (Bit 0)                                       */
#define CMP1_COMP1HY_C1HYSLS_Msk          (0x3UL)                   /*!< C1HYSLS (Bitfield-Mask: 0x03)                         */
#define CMP1_COMP1HY_C1HYSVS_Pos          (4UL)                     /*!< C1HYSVS (Bit 4)                                       */
#define CMP1_COMP1HY_C1HYSVS_Msk          (0x30UL)                  /*!< C1HYSVS (Bitfield-Mask: 0x03)                         */


/* =========================================================================================================================== */
/* ================                                           CMP2                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  COMP2MDR  ======================================================== */
#define CMP2_COMP2MDR_C2ENB_Pos           (0UL)                     /*!< C2ENB (Bit 0)                                         */
#define CMP2_COMP2MDR_C2ENB_Msk           (0x1UL)                   /*!< C2ENB (Bitfield-Mask: 0x01)                           */
#define CMP2_COMP2MDR_C2MON_Pos           (3UL)                     /*!< C2MON (Bit 3)                                         */
#define CMP2_COMP2MDR_C2MON_Msk           (0x8UL)                   /*!< C2MON (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP2FIR  ======================================================== */
#define CMP2_COMP2FIR_C2FCK_Pos           (0UL)                     /*!< C2FCK (Bit 0)                                         */
#define CMP2_COMP2FIR_C2FCK_Msk           (0x3UL)                   /*!< C2FCK (Bitfield-Mask: 0x03)                           */
#define CMP2_COMP2FIR_C2EPO_Pos           (2UL)                     /*!< C2EPO (Bit 2)                                         */
#define CMP2_COMP2FIR_C2EPO_Msk           (0x4UL)                   /*!< C2EPO (Bitfield-Mask: 0x01)                           */
#define CMP2_COMP2FIR_C2EDG_Pos           (3UL)                     /*!< C2EDG (Bit 3)                                         */
#define CMP2_COMP2FIR_C2EDG_Msk           (0x8UL)                   /*!< C2EDG (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP2OCR  ======================================================== */
#define CMP2_COMP2OCR_C2IE_Pos            (0UL)                     /*!< C2IE (Bit 0)                                          */
#define CMP2_COMP2OCR_C2IE_Msk            (0x1UL)                   /*!< C2IE (Bitfield-Mask: 0x01)                            */
#define CMP2_COMP2OCR_C2OE_Pos            (1UL)                     /*!< C2OE (Bit 1)                                          */
#define CMP2_COMP2OCR_C2OE_Msk            (0x2UL)                   /*!< C2OE (Bitfield-Mask: 0x01)                            */
#define CMP2_COMP2OCR_C2OP_Pos            (2UL)                     /*!< C2OP (Bit 2)                                          */
#define CMP2_COMP2OCR_C2OP_Msk            (0x4UL)                   /*!< C2OP (Bitfield-Mask: 0x01)                            */
#define CMP2_COMP2OCR_C2OTWMD_Pos         (7UL)                     /*!< C2OTWMD (Bit 7)                                       */
#define CMP2_COMP2OCR_C2OTWMD_Msk         (0x80UL)                  /*!< C2OTWMD (Bitfield-Mask: 0x01)                         */
/* =======================================================  COMP2SEL  ======================================================== */
#define CMP2_COMP2SEL_C2REFS_Pos          (0UL)                     /*!< C2REFS (Bit 0)                                        */
#define CMP2_COMP2SEL_C2REFS_Msk          (0x3UL)                   /*!< C2REFS (Bitfield-Mask: 0x03)                          */
#define CMP2_COMP2SEL_CMPSEL_Pos          (6UL)                     /*!< CMPSEL (Bit 6)                                        */
#define CMP2_COMP2SEL_CMPSEL_Msk          (0xc0UL)                  /*!< CMPSEL (Bitfield-Mask: 0x03)                          */
/* ========================================================  COMP2HY  ======================================================== */
#define CMP2_COMP2HY_C2HYSLS_Pos          (0UL)                     /*!< C2HYSLS (Bit 0)                                       */
#define CMP2_COMP2HY_C2HYSLS_Msk          (0x3UL)                   /*!< C2HYSLS (Bitfield-Mask: 0x03)                         */
#define CMP2_COMP2HY_C2HYSVS_Pos          (4UL)                     /*!< C2HYSVS (Bit 4)                                       */
#define CMP2_COMP2HY_C2HYSVS_Msk          (0x30UL)                  /*!< C2HYSVS (Bitfield-Mask: 0x03)                         */


/* =========================================================================================================================== */
/* ================                                           CMP3                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  COMP3MDR  ======================================================== */
#define CMP3_COMP3MDR_C3ENB_Pos           (0UL)                     /*!< C3ENB (Bit 0)                                         */
#define CMP3_COMP3MDR_C3ENB_Msk           (0x1UL)                   /*!< C3ENB (Bitfield-Mask: 0x01)                           */
#define CMP3_COMP3MDR_C3MON_Pos           (3UL)                     /*!< C3MON (Bit 3)                                         */
#define CMP3_COMP3MDR_C3MON_Msk           (0x8UL)                   /*!< C3MON (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP3FIR  ======================================================== */
#define CMP3_COMP3FIR_C3FCK_Pos           (0UL)                     /*!< C3FCK (Bit 0)                                         */
#define CMP3_COMP3FIR_C3FCK_Msk           (0x3UL)                   /*!< C3FCK (Bitfield-Mask: 0x03)                           */
#define CMP3_COMP3FIR_C3EPO_Pos           (2UL)                     /*!< C3EPO (Bit 2)                                         */
#define CMP3_COMP3FIR_C3EPO_Msk           (0x4UL)                   /*!< C3EPO (Bitfield-Mask: 0x01)                           */
#define CMP3_COMP3FIR_C3EDG_Pos           (3UL)                     /*!< C3EDG (Bit 3)                                         */
#define CMP3_COMP3FIR_C3EDG_Msk           (0x8UL)                   /*!< C3EDG (Bitfield-Mask: 0x01)                           */
/* =======================================================  COMP3OCR  ======================================================== */
#define CMP3_COMP3OCR_C3IE_Pos            (0UL)                     /*!< C3IE (Bit 0)                                          */
#define CMP3_COMP3OCR_C3IE_Msk            (0x1UL)                   /*!< C3IE (Bitfield-Mask: 0x01)                            */
#define CMP3_COMP3OCR_C3OE_Pos            (1UL)                     /*!< C3OE (Bit 1)                                          */
#define CMP3_COMP3OCR_C3OE_Msk            (0x2UL)                   /*!< C3OE (Bitfield-Mask: 0x01)                            */
#define CMP3_COMP3OCR_C3OP_Pos            (2UL)                     /*!< C3OP (Bit 2)                                          */
#define CMP3_COMP3OCR_C3OP_Msk            (0x4UL)                   /*!< C3OP (Bitfield-Mask: 0x01)                            */
#define CMP3_COMP3OCR_C3OTWMD_Pos         (7UL)                     /*!< C3OTWMD (Bit 7)                                       */
#define CMP3_COMP3OCR_C3OTWMD_Msk         (0x80UL)                  /*!< C3OTWMD (Bitfield-Mask: 0x01)                         */
/* =======================================================  COMP3SEL  ======================================================== */
#define CMP3_COMP3SEL_C3REFS_Pos          (0UL)                     /*!< C3REFS (Bit 0)                                        */
#define CMP3_COMP3SEL_C3REFS_Msk          (0x3UL)                   /*!< C3REFS (Bitfield-Mask: 0x03)                          */
#define CMP3_COMP3SEL_CMPSEL_Pos          (6UL)                     /*!< CMPSEL (Bit 6)                                        */
#define CMP3_COMP3SEL_CMPSEL_Msk          (0xc0UL)                  /*!< CMPSEL (Bitfield-Mask: 0x03)                          */
/* ========================================================  COMP3HY  ======================================================== */
#define CMP3_COMP3HY_C3HYSLS_Pos          (0UL)                     /*!< C3HYSLS (Bit 0)                                       */
#define CMP3_COMP3HY_C3HYSLS_Msk          (0x3UL)                   /*!< C3HYSLS (Bitfield-Mask: 0x03)                         */
#define CMP3_COMP3HY_C3HYSVS_Pos          (4UL)                     /*!< C3HYSVS (Bit 4)                                       */
#define CMP3_COMP3HY_C3HYSVS_Msk          (0x30UL)                  /*!< C3HYSVS (Bitfield-Mask: 0x03)                         */


/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  IRCR  ========================================================== */
#define IRDA_IRCR_IRRXINV_Pos             (2UL)                     /*!< IRRXINV (Bit 2)                                       */
#define IRDA_IRCR_IRRXINV_Msk             (0x4UL)                   /*!< IRRXINV (Bitfield-Mask: 0x01)                         */
#define IRDA_IRCR_IRTXINV_Pos             (3UL)                     /*!< IRTXINV (Bit 3)                                       */
#define IRDA_IRCR_IRTXINV_Msk             (0x8UL)                   /*!< IRTXINV (Bitfield-Mask: 0x01)                         */
#define IRDA_IRCR_IRCKS_Pos               (4UL)                     /*!< IRCKS (Bit 4)                                         */
#define IRDA_IRCR_IRCKS_Msk               (0x70UL)                  /*!< IRCKS (Bitfield-Mask: 0x07)                           */
#define IRDA_IRCR_IRE_Pos                 (7UL)                     /*!< IRE (Bit 7)                                           */
#define IRDA_IRCR_IRE_Msk                 (0x80UL)                  /*!< IRE (Bitfield-Mask: 0x01)                             */


/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DACS0  ========================================================= */
#define DAC_DACS0_DACS0_Pos               (0UL)                     /*!< DACS0 (Bit 0)                                         */
#define DAC_DACS0_DACS0_Msk               (0xffUL)                  /*!< DACS0 (Bitfield-Mask: 0xff)                           */
/* =========================================================  DACS1  ========================================================= */
#define DAC_DACS1_DACS1_Pos               (0UL)                     /*!< DACS1 (Bit 0)                                         */
#define DAC_DACS1_DACS1_Msk               (0xffUL)                  /*!< DACS1 (Bitfield-Mask: 0xff)                           */
/* ==========================================================  DAM  ========================================================== */
#define DAC_DAM_DAMD0_Pos                 (0UL)                     /*!< DAMD0 (Bit 0)                                         */
#define DAC_DAM_DAMD0_Msk                 (0x1UL)                   /*!< DAMD0 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DAMD1_Pos                 (1UL)                     /*!< DAMD1 (Bit 1)                                         */
#define DAC_DAM_DAMD1_Msk                 (0x2UL)                   /*!< DAMD1 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DACE0_Pos                 (4UL)                     /*!< DACE0 (Bit 4)                                         */
#define DAC_DAM_DACE0_Msk                 (0x10UL)                  /*!< DACE0 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DACE1_Pos                  (5UL)                     /*!< DACE (Bit 5)                                          */
#define DAC_DAM_DACE1_Msk                  (0x20UL)                  /*!< DACE (Bitfield-Mask: 0x01)                            */
#define DAC_DAM_DACOENB0_Pos              (6UL)                     /*!< DACOENB0 (Bit 6)                                      */
#define DAC_DAM_DACOENB0_Msk              (0x40UL)                  /*!< DACOENB0 (Bitfield-Mask: 0x01)                        */
#define DAC_DAM_DACOENB1_Pos              (7UL)                     /*!< DACOENB1 (Bit 7)                                      */
#define DAC_DAM_DACOENB1_Msk              (0x80UL)                  /*!< DACOENB1 (Bitfield-Mask: 0x01)                        */


/* =========================================================================================================================== */
/* ================                                           LCDB                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LBCTL  ========================================================= */
#define LCDB_LBCTL_BYF_Pos                (0UL)                     /*!< BYF (Bit 0)                                           */
#define LCDB_LBCTL_BYF_Msk                (0x1UL)                   /*!< BYF (Bitfield-Mask: 0x01)                             */
#define LCDB_LBCTL_TPF_Pos                (1UL)                     /*!< TPF (Bit 1)                                           */
#define LCDB_LBCTL_TPF_Msk                (0x2UL)                   /*!< TPF (Bitfield-Mask: 0x01)                             */
#define LCDB_LBCTL_MODE_Pos               (2UL)                     /*!< MODE (Bit 2)                                          */
#define LCDB_LBCTL_MODE_Msk               (0x4UL)                   /*!< MODE (Bitfield-Mask: 0x01)                            */
#define LCDB_LBCTL_TCIS_Pos               (3UL)                     /*!< TCIS (Bit 3)                                          */
#define LCDB_LBCTL_TCIS_Msk               (0x8UL)                   /*!< TCIS (Bitfield-Mask: 0x01)                            */
#define LCDB_LBCTL_LBC_Pos                (4UL)                     /*!< LBC (Bit 4)                                           */
#define LCDB_LBCTL_LBC_Msk                (0x30UL)                  /*!< LBC (Bitfield-Mask: 0x03)                             */
#define LCDB_LBCTL_IMD_Pos                (6UL)                     /*!< IMD (Bit 6)                                           */
#define LCDB_LBCTL_IMD_Msk                (0x40UL)                  /*!< IMD (Bitfield-Mask: 0x01)                             */
#define LCDB_LBCTL_EL_Pos                 (7UL)                     /*!< EL (Bit 7)                                            */
#define LCDB_LBCTL_EL_Msk                 (0x80UL)                  /*!< EL (Bitfield-Mask: 0x01)                              */
/* =========================================================  LBCYC  ========================================================= */
/* =========================================================  LBWST  ========================================================= */
/* ========================================================  LBDATA  ========================================================= */
/* ========================================================  LBDATAL  ======================================================== */
/* ========================================================  LBDATAR  ======================================================== */
/* =======================================================  LBDATARL  ======================================================== */


/* =========================================================================================================================== */
/* ================                                            KEY                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  KRM  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  SUBCUD  ========================================================= */
#define RTC_SUBCUD_F_Pos                  (0UL)                     /*!< F (Bit 0)                                             */
#define RTC_SUBCUD_F_Msk                  (0x1fffUL)                /*!< F (Bitfield-Mask: 0x1fff)                             */
#define RTC_SUBCUD_DEV_Pos                (15UL)                    /*!< DEV (Bit 15)                                          */
#define RTC_SUBCUD_DEV_Msk                (0x8000UL)                /*!< DEV (Bitfield-Mask: 0x01)                             */
/* =========================================================  ITMC  ========================================================== */
#define RTC_ITMC_ITCMP_Pos                (0UL)                     /*!< ITCMP (Bit 0)                                         */
#define RTC_ITMC_ITCMP_Msk                (0x7fffUL)                /*!< ITCMP (Bitfield-Mask: 0x7fff)                         */
#define RTC_ITMC_RINTE_Pos                (15UL)                    /*!< RINTE (Bit 15)                                        */
#define RTC_ITMC_RINTE_Msk                (0x8000UL)                /*!< RINTE (Bitfield-Mask: 0x01)                           */
/* ==========================================================  SEC  ========================================================== */
/* ==========================================================  MIN  ========================================================== */
/* =========================================================  HOUR  ========================================================== */
/* =========================================================  WEEK  ========================================================== */
/* ==========================================================  DAY  ========================================================== */
/* =========================================================  MONTH  ========================================================= */
/* =========================================================  YEAR  ========================================================== */
/* ========================================================  ALARMWM  ======================================================== */
/* ========================================================  ALARMWH  ======================================================== */
/* ========================================================  ALARMWW  ======================================================== */
/* =========================================================  RTCC0  ========================================================= */
#define RTC_RTCC0_CT_Pos                  (0UL)                     /*!< CT (Bit 0)                                            */
#define RTC_RTCC0_CT_Msk                  (0x7UL)                   /*!< CT (Bitfield-Mask: 0x07)                              */
#define RTC_RTCC0_AMPM_Pos                (3UL)                     /*!< AMPM (Bit 3)                                          */
#define RTC_RTCC0_AMPM_Msk                (0x8UL)                   /*!< AMPM (Bitfield-Mask: 0x01)                            */
#define RTC_RTCC0_RCLOE_Pos               (5UL)                     /*!< RCLOE (Bit 5)                                         */
#define RTC_RTCC0_RCLOE_Msk               (0x20UL)                  /*!< RCLOE (Bitfield-Mask: 0x01)                           */
#define RTC_RTCC0_RTCE_Pos                (7UL)                     /*!< RTCE (Bit 7)                                          */
#define RTC_RTCC0_RTCE_Msk                (0x80UL)                  /*!< RTCE (Bitfield-Mask: 0x01)                            */
/* =========================================================  RTCC1  ========================================================= */
#define RTC_RTCC1_RWAIT_Pos               (0UL)                     /*!< RWAIT (Bit 0)                                         */
#define RTC_RTCC1_RWAIT_Msk               (0x1UL)                   /*!< RWAIT (Bitfield-Mask: 0x01)                           */
#define RTC_RTCC1_RWST_Pos                (1UL)                     /*!< RWST (Bit 1)                                          */
#define RTC_RTCC1_RWST_Msk                (0x2UL)                   /*!< RWST (Bitfield-Mask: 0x01)                            */
#define RTC_RTCC1_RIFG_Pos                (3UL)                     /*!< RIFG (Bit 3)                                          */
#define RTC_RTCC1_RIFG_Msk                (0x8UL)                   /*!< RIFG (Bitfield-Mask: 0x01)                            */
#define RTC_RTCC1_WAFG_Pos                (4UL)                     /*!< WAFG (Bit 4)                                          */
#define RTC_RTCC1_WAFG_Msk                (0x10UL)                  /*!< WAFG (Bitfield-Mask: 0x01)                            */
#define RTC_RTCC1_WALIE_Pos               (6UL)                     /*!< WALIE (Bit 6)                                         */
#define RTC_RTCC1_WALIE_Msk               (0x40UL)                  /*!< WALIE (Bitfield-Mask: 0x01)                           */
#define RTC_RTCC1_WALE_Pos                (7UL)                     /*!< WALE (Bit 7)                                          */
#define RTC_RTCC1_WALE_Msk                (0x80UL)                  /*!< WALE (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  EGP0  ========================================================== */
/* =========================================================  EGN0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           CAN0                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  CGMCTRL  ======================================================== */
/* =========================================================  CGMCS  ========================================================= */
/* ========================================================  CGMABT  ========================================================= */
/* ========================================================  CGMABTD  ======================================================== */
/* ========================================================  CMASK1L  ======================================================== */
/* ========================================================  CMASK1H  ======================================================== */
/* ========================================================  CMASK2L  ======================================================== */
/* ========================================================  CMASK2H  ======================================================== */
/* ========================================================  CMASK3L  ======================================================== */
/* ========================================================  CMASK3H  ======================================================== */
/* ========================================================  CMASK4L  ======================================================== */
/* ========================================================  CMASK4H  ======================================================== */
/* =========================================================  CCTRL  ========================================================= */
/* =========================================================  CLEC  ========================================================== */
/* =========================================================  CINFO  ========================================================= */
/* =========================================================  CERC  ========================================================== */
/* ==========================================================  CIE  ========================================================== */
/* =========================================================  CINTS  ========================================================= */
/* =========================================================  CBRP  ========================================================== */
/* =========================================================  CBTR  ========================================================== */
/* =========================================================  CLIPT  ========================================================= */
/* =========================================================  CRGPT  ========================================================= */
/* =========================================================  CLOPT  ========================================================= */
/* =========================================================  CTGPT  ========================================================= */
/* ==========================================================  CTS  ========================================================== */


/* =========================================================================================================================== */
/* ================                                         CAN0MSG00                                         ================ */
/* =========================================================================================================================== */

/* ========================================================  CMDB01  ========================================================= */
/* ========================================================  CMDB23  ========================================================= */
/* ========================================================  CMDB45  ========================================================= */
/* ========================================================  CMDB67  ========================================================= */
/* =========================================================  CMDB0  ========================================================= */
/* =========================================================  CMDB1  ========================================================= */
/* =========================================================  CMDB2  ========================================================= */
/* =========================================================  CMDB3  ========================================================= */
/* =========================================================  CMDB4  ========================================================= */
/* =========================================================  CMDB5  ========================================================= */
/* =========================================================  CMDB6  ========================================================= */
/* =========================================================  CMDB7  ========================================================= */
/* =========================================================  CMDLC  ========================================================= */
/* ========================================================  CMCONF  ========================================================= */
/* =========================================================  CMIDL  ========================================================= */
/* =========================================================  CMIDH  ========================================================= */
/* ========================================================  CMCTRL  ========================================================= */


/* =========================================================================================================================== */
/* ================                                           TRNG                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  SDR  ========================================================== */
/* ==========================================================  SCR  ========================================================== */
#define TRNG_SCR_TRNGST_Pos               (2UL)                     /*!< TRNGST (Bit 2)                                        */
#define TRNG_SCR_TRNGST_Msk               (0x4UL)                   /*!< TRNGST (Bitfield-Mask: 0x01)                          */
#define TRNG_SCR_TRNGEN_Pos               (3UL)                     /*!< TRNGEN (Bit 3)                                        */
#define TRNG_SCR_TRNGEN_Msk               (0x8UL)                   /*!< TRNGEN (Bitfield-Mask: 0x01)                          */
#define TRNG_SCR_TRNGRDY_Pos              (7UL)                     /*!< TRNGRDY (Bit 7)                                       */
#define TRNG_SCR_TRNGRDY_Msk              (0x80UL)                  /*!< TRNGRDY (Bitfield-Mask: 0x01)                         */


/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  DBGSTR  ========================================================= */
#define DBG_DBGSTR_CDBGPWRUPACK_Pos       (29UL)                    /*!< CDBGPWRUPACK (Bit 29)                                 */
#define DBG_DBGSTR_CDBGPWRUPACK_Msk       (0x20000000UL)            /*!< CDBGPWRUPACK (Bitfield-Mask: 0x01)                    */
#define DBG_DBGSTR_CDBGPWRUPREQ_Pos       (28UL)                    /*!< CDBGPWRUPREQ (Bit 28)                                 */
#define DBG_DBGSTR_CDBGPWRUPREQ_Msk       (0x10000000UL)            /*!< CDBGPWRUPREQ (Bitfield-Mask: 0x01)                    */
/* =======================================================  DBGSTOPCR  ======================================================= */
#define DBG_DBGSTOPCR_SWDIS_Pos           (24UL)                    /*!< SWDIS (Bit 24)                                        */
#define DBG_DBGSTOPCR_SWDIS_Msk           (0x1000000UL)             /*!< SWDIS (Bitfield-Mask: 0x01)                           */
#define DBG_DBGSTOPCR_RPERMSK_Pos         (16UL)                    /*!< RPERMSK (Bit 16)                                      */
#define DBG_DBGSTOPCR_RPERMSK_Msk         (0x10000UL)               /*!< RPERMSK (Bitfield-Mask: 0x01)                         */
#define DBG_DBGSTOPCR_RESMSK_Pos          (2UL)                     /*!< RESMSK (Bit 2)                                        */
#define DBG_DBGSTOPCR_RESMSK_Msk          (0x4UL)                   /*!< RESMSK (Bitfield-Mask: 0x01)                          */
#define DBG_DBGSTOPCR_FRZEN1_Pos          (1UL)                     /*!< FRZEN1 (Bit 1)                                        */
#define DBG_DBGSTOPCR_FRZEN1_Msk          (0x2UL)                   /*!< FRZEN1 (Bitfield-Mask: 0x01)                          */
#define DBG_DBGSTOPCR_FRZEN0_Pos          (0UL)                     /*!< FRZEN0 (Bit 0)                                        */
#define DBG_DBGSTOPCR_FRZEN0_Msk          (0x1UL)                   /*!< FRZEN0 (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                           GPT0                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  GTWP00  ========================================================= */
#define GPT0_GTWP00_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT0_GTWP00_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT0_GTWP00_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT0_GTWP00_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP01  ========================================================= */
#define GPT0_GTWP01_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT0_GTWP01_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT0_GTWP01_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT0_GTWP01_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP02  ========================================================= */
#define GPT0_GTWP02_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT0_GTWP02_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT0_GTWP02_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT0_GTWP02_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP03  ========================================================= */
#define GPT0_GTWP03_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT0_GTWP03_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT0_GTWP03_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT0_GTWP03_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTSTR00  ======================================================== */
#define GPT0_GTSTR00_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT0_GTSTR00_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR01  ======================================================== */
#define GPT0_GTSTR01_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT0_GTSTR01_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR02  ======================================================== */
#define GPT0_GTSTR02_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT0_GTSTR02_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR03  ======================================================== */
#define GPT0_GTSTR03_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT0_GTSTR03_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP00  ======================================================== */
#define GPT0_GTSTP00_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT0_GTSTP00_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP01  ======================================================== */
#define GPT0_GTSTP01_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT0_GTSTP01_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP02  ======================================================== */
#define GPT0_GTSTP02_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT0_GTSTP02_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP03  ======================================================== */
#define GPT0_GTSTP03_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT0_GTSTP03_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTCLR00  ======================================================== */
#define GPT0_GTCLR00_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT0_GTCLR00_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR01  ======================================================== */
#define GPT0_GTCLR01_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT0_GTCLR01_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR02  ======================================================== */
#define GPT0_GTCLR02_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT0_GTCLR02_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR03  ======================================================== */
#define GPT0_GTCLR03_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT0_GTCLR03_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTSSR00  ======================================================== */
#define GPT0_GTSSR00_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT0_GTSSR00_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR00_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT0_GTSSR00_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR00_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT0_GTSSR00_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR00_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT0_GTSSR00_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR00_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT0_GTSSR00_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT0_GTSSR00_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT0_GTSSR00_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT0_GTSSR00_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT0_GTSSR00_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT0_GTSSR00_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT0_GTSSR00_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT0_GTSSR00_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR00_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT0_GTSSR00_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR00_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT0_GTSSR00_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR00_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT0_GTSSR00_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR00_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT0_GTSSR00_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR00_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT0_GTSSR00_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR01  ======================================================== */
#define GPT0_GTSSR01_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT0_GTSSR01_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR01_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT0_GTSSR01_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR01_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT0_GTSSR01_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR01_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT0_GTSSR01_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR01_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT0_GTSSR01_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT0_GTSSR01_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT0_GTSSR01_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT0_GTSSR01_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT0_GTSSR01_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT0_GTSSR01_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT0_GTSSR01_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT0_GTSSR01_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR01_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT0_GTSSR01_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR01_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT0_GTSSR01_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR01_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT0_GTSSR01_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR01_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT0_GTSSR01_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR01_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT0_GTSSR01_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR02  ======================================================== */
#define GPT0_GTSSR02_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT0_GTSSR02_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR02_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT0_GTSSR02_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR02_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT0_GTSSR02_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR02_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT0_GTSSR02_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR02_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT0_GTSSR02_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT0_GTSSR02_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT0_GTSSR02_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT0_GTSSR02_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT0_GTSSR02_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT0_GTSSR02_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT0_GTSSR02_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT0_GTSSR02_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR02_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT0_GTSSR02_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR02_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT0_GTSSR02_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR02_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT0_GTSSR02_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR02_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT0_GTSSR02_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR02_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT0_GTSSR02_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR03  ======================================================== */
#define GPT0_GTSSR03_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT0_GTSSR03_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR03_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT0_GTSSR03_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR03_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT0_GTSSR03_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR03_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT0_GTSSR03_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTSSR03_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT0_GTSSR03_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT0_GTSSR03_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT0_GTSSR03_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT0_GTSSR03_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT0_GTSSR03_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT0_GTSSR03_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT0_GTSSR03_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT0_GTSSR03_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTSSR03_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT0_GTSSR03_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR03_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT0_GTSSR03_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR03_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT0_GTSSR03_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR03_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT0_GTSSR03_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTSSR03_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT0_GTSSR03_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR00  ======================================================== */
#define GPT0_GTPSR00_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT0_GTPSR00_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR00_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT0_GTPSR00_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR00_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT0_GTPSR00_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR00_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT0_GTPSR00_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR00_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT0_GTPSR00_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT0_GTPSR00_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT0_GTPSR00_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT0_GTPSR00_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT0_GTPSR00_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT0_GTPSR00_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT0_GTPSR00_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT0_GTPSR00_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR00_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT0_GTPSR00_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR00_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT0_GTPSR00_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR00_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT0_GTPSR00_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR00_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT0_GTPSR00_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR00_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT0_GTPSR00_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR01  ======================================================== */
#define GPT0_GTPSR01_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT0_GTPSR01_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR01_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT0_GTPSR01_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR01_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT0_GTPSR01_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR01_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT0_GTPSR01_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR01_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT0_GTPSR01_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT0_GTPSR01_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT0_GTPSR01_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT0_GTPSR01_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT0_GTPSR01_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT0_GTPSR01_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT0_GTPSR01_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT0_GTPSR01_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR01_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT0_GTPSR01_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR01_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT0_GTPSR01_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR01_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT0_GTPSR01_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR01_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT0_GTPSR01_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR01_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT0_GTPSR01_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR02  ======================================================== */
#define GPT0_GTPSR02_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT0_GTPSR02_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR02_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT0_GTPSR02_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR02_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT0_GTPSR02_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR02_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT0_GTPSR02_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR02_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT0_GTPSR02_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT0_GTPSR02_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT0_GTPSR02_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT0_GTPSR02_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT0_GTPSR02_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT0_GTPSR02_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT0_GTPSR02_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT0_GTPSR02_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR02_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT0_GTPSR02_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR02_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT0_GTPSR02_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR02_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT0_GTPSR02_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR02_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT0_GTPSR02_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR02_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT0_GTPSR02_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR03  ======================================================== */
#define GPT0_GTPSR03_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT0_GTPSR03_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR03_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT0_GTPSR03_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR03_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT0_GTPSR03_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR03_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT0_GTPSR03_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTPSR03_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT0_GTPSR03_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT0_GTPSR03_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT0_GTPSR03_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT0_GTPSR03_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT0_GTPSR03_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT0_GTPSR03_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT0_GTPSR03_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT0_GTPSR03_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTPSR03_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT0_GTPSR03_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR03_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT0_GTPSR03_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR03_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT0_GTPSR03_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR03_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT0_GTPSR03_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTPSR03_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT0_GTPSR03_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTCSR00  ======================================================== */
#define GPT0_GTCSR00_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT0_GTCSR00_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR00_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT0_GTCSR00_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR00_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT0_GTCSR00_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR00_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT0_GTCSR00_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR00_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT0_GTCSR00_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT0_GTCSR00_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT0_GTCSR00_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT0_GTCSR00_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT0_GTCSR00_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT0_GTCSR00_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT0_GTCSR00_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT0_GTCSR00_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR00_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT0_GTCSR00_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR00_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT0_GTCSR00_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR00_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT0_GTCSR00_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR00_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT0_GTCSR00_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR00_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT0_GTCSR00_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR01  ======================================================== */
#define GPT0_GTCSR01_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT0_GTCSR01_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR01_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT0_GTCSR01_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR01_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT0_GTCSR01_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR01_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT0_GTCSR01_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR01_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT0_GTCSR01_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT0_GTCSR01_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT0_GTCSR01_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT0_GTCSR01_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT0_GTCSR01_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT0_GTCSR01_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT0_GTCSR01_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT0_GTCSR01_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR01_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT0_GTCSR01_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR01_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT0_GTCSR01_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR01_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT0_GTCSR01_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR01_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT0_GTCSR01_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR01_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT0_GTCSR01_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR02  ======================================================== */
#define GPT0_GTCSR02_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT0_GTCSR02_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR02_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT0_GTCSR02_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR02_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT0_GTCSR02_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR02_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT0_GTCSR02_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR02_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT0_GTCSR02_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT0_GTCSR02_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT0_GTCSR02_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT0_GTCSR02_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT0_GTCSR02_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT0_GTCSR02_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT0_GTCSR02_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT0_GTCSR02_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR02_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT0_GTCSR02_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR02_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT0_GTCSR02_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR02_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT0_GTCSR02_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR02_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT0_GTCSR02_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR02_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT0_GTCSR02_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR03  ======================================================== */
#define GPT0_GTCSR03_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT0_GTCSR03_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR03_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT0_GTCSR03_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR03_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT0_GTCSR03_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR03_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT0_GTCSR03_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTCSR03_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT0_GTCSR03_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT0_GTCSR03_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT0_GTCSR03_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT0_GTCSR03_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT0_GTCSR03_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT0_GTCSR03_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT0_GTCSR03_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT0_GTCSR03_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTCSR03_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT0_GTCSR03_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR03_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT0_GTCSR03_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR03_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT0_GTCSR03_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR03_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT0_GTCSR03_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT0_GTCSR03_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT0_GTCSR03_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* =======================================================  GTUPSR00  ======================================================== */
#define GPT0_GTUPSR00_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT0_GTUPSR00_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR00_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT0_GTUPSR00_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR00_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT0_GTUPSR00_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR00_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT0_GTUPSR00_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR00_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT0_GTUPSR00_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT0_GTUPSR00_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT0_GTUPSR00_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT0_GTUPSR00_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT0_GTUPSR00_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT0_GTUPSR00_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT0_GTUPSR00_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT0_GTUPSR00_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR00_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT0_GTUPSR00_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR00_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT0_GTUPSR00_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR00_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT0_GTUPSR00_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR00_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT0_GTUPSR00_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR01  ======================================================== */
#define GPT0_GTUPSR01_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT0_GTUPSR01_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR01_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT0_GTUPSR01_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR01_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT0_GTUPSR01_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR01_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT0_GTUPSR01_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR01_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT0_GTUPSR01_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT0_GTUPSR01_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT0_GTUPSR01_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT0_GTUPSR01_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT0_GTUPSR01_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT0_GTUPSR01_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT0_GTUPSR01_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT0_GTUPSR01_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR01_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT0_GTUPSR01_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR01_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT0_GTUPSR01_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR01_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT0_GTUPSR01_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR01_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT0_GTUPSR01_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR02  ======================================================== */
#define GPT0_GTUPSR02_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT0_GTUPSR02_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR02_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT0_GTUPSR02_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR02_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT0_GTUPSR02_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR02_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT0_GTUPSR02_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR02_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT0_GTUPSR02_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT0_GTUPSR02_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT0_GTUPSR02_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT0_GTUPSR02_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT0_GTUPSR02_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT0_GTUPSR02_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT0_GTUPSR02_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT0_GTUPSR02_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR02_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT0_GTUPSR02_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR02_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT0_GTUPSR02_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR02_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT0_GTUPSR02_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR02_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT0_GTUPSR02_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR03  ======================================================== */
#define GPT0_GTUPSR03_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT0_GTUPSR03_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR03_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT0_GTUPSR03_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR03_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT0_GTUPSR03_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR03_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT0_GTUPSR03_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTUPSR03_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT0_GTUPSR03_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT0_GTUPSR03_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT0_GTUPSR03_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT0_GTUPSR03_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT0_GTUPSR03_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT0_GTUPSR03_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT0_GTUPSR03_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT0_GTUPSR03_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTUPSR03_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT0_GTUPSR03_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR03_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT0_GTUPSR03_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR03_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT0_GTUPSR03_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUPSR03_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT0_GTUPSR03_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR00  ======================================================== */
#define GPT0_GTDNSR00_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT0_GTDNSR00_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR00_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT0_GTDNSR00_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR00_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT0_GTDNSR00_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR00_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT0_GTDNSR00_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR00_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT0_GTDNSR00_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT0_GTDNSR00_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT0_GTDNSR00_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT0_GTDNSR00_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT0_GTDNSR00_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT0_GTDNSR00_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT0_GTDNSR00_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT0_GTDNSR00_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR00_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT0_GTDNSR00_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR00_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT0_GTDNSR00_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR00_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT0_GTDNSR00_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR00_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT0_GTDNSR00_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR01  ======================================================== */
#define GPT0_GTDNSR01_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT0_GTDNSR01_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR01_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT0_GTDNSR01_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR01_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT0_GTDNSR01_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR01_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT0_GTDNSR01_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR01_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT0_GTDNSR01_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT0_GTDNSR01_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT0_GTDNSR01_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT0_GTDNSR01_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT0_GTDNSR01_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT0_GTDNSR01_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT0_GTDNSR01_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT0_GTDNSR01_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR01_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT0_GTDNSR01_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR01_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT0_GTDNSR01_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR01_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT0_GTDNSR01_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR01_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT0_GTDNSR01_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR02  ======================================================== */
#define GPT0_GTDNSR02_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT0_GTDNSR02_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR02_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT0_GTDNSR02_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR02_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT0_GTDNSR02_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR02_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT0_GTDNSR02_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR02_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT0_GTDNSR02_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT0_GTDNSR02_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT0_GTDNSR02_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT0_GTDNSR02_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT0_GTDNSR02_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT0_GTDNSR02_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT0_GTDNSR02_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT0_GTDNSR02_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR02_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT0_GTDNSR02_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR02_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT0_GTDNSR02_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR02_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT0_GTDNSR02_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR02_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT0_GTDNSR02_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR03  ======================================================== */
#define GPT0_GTDNSR03_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT0_GTDNSR03_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR03_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT0_GTDNSR03_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR03_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT0_GTDNSR03_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR03_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT0_GTDNSR03_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTDNSR03_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT0_GTDNSR03_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT0_GTDNSR03_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT0_GTDNSR03_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT0_GTDNSR03_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT0_GTDNSR03_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT0_GTDNSR03_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT0_GTDNSR03_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT0_GTDNSR03_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTDNSR03_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT0_GTDNSR03_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR03_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT0_GTDNSR03_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR03_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT0_GTDNSR03_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTDNSR03_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT0_GTDNSR03_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR00  ======================================================= */
#define GPT0_GTICASR00_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT0_GTICASR00_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR00_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT0_GTICASR00_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR00_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT0_GTICASR00_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR00_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT0_GTICASR00_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR00_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT0_GTICASR00_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT0_GTICASR00_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT0_GTICASR00_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT0_GTICASR00_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT0_GTICASR00_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT0_GTICASR00_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT0_GTICASR00_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT0_GTICASR00_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR00_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT0_GTICASR00_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR00_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT0_GTICASR00_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR00_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT0_GTICASR00_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR00_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT0_GTICASR00_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR01  ======================================================= */
#define GPT0_GTICASR01_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT0_GTICASR01_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR01_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT0_GTICASR01_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR01_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT0_GTICASR01_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR01_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT0_GTICASR01_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR01_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT0_GTICASR01_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT0_GTICASR01_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT0_GTICASR01_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT0_GTICASR01_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT0_GTICASR01_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT0_GTICASR01_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT0_GTICASR01_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT0_GTICASR01_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR01_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT0_GTICASR01_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR01_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT0_GTICASR01_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR01_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT0_GTICASR01_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR01_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT0_GTICASR01_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR02  ======================================================= */
#define GPT0_GTICASR02_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT0_GTICASR02_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR02_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT0_GTICASR02_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR02_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT0_GTICASR02_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR02_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT0_GTICASR02_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR02_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT0_GTICASR02_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT0_GTICASR02_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT0_GTICASR02_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT0_GTICASR02_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT0_GTICASR02_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT0_GTICASR02_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT0_GTICASR02_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT0_GTICASR02_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR02_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT0_GTICASR02_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR02_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT0_GTICASR02_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR02_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT0_GTICASR02_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR02_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT0_GTICASR02_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR03  ======================================================= */
#define GPT0_GTICASR03_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT0_GTICASR03_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR03_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT0_GTICASR03_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR03_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT0_GTICASR03_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR03_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT0_GTICASR03_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICASR03_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT0_GTICASR03_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT0_GTICASR03_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT0_GTICASR03_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT0_GTICASR03_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT0_GTICASR03_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT0_GTICASR03_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT0_GTICASR03_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT0_GTICASR03_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICASR03_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT0_GTICASR03_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR03_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT0_GTICASR03_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR03_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT0_GTICASR03_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICASR03_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT0_GTICASR03_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR00  ======================================================= */
#define GPT0_GTICBSR00_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT0_GTICBSR00_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR00_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT0_GTICBSR00_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR00_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT0_GTICBSR00_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR00_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT0_GTICBSR00_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR00_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT0_GTICBSR00_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT0_GTICBSR00_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT0_GTICBSR00_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT0_GTICBSR00_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT0_GTICBSR00_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT0_GTICBSR00_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT0_GTICBSR00_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT0_GTICBSR00_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR00_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT0_GTICBSR00_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR00_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT0_GTICBSR00_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR00_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT0_GTICBSR00_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR00_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT0_GTICBSR00_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR01  ======================================================= */
#define GPT0_GTICBSR01_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT0_GTICBSR01_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR01_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT0_GTICBSR01_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR01_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT0_GTICBSR01_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR01_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT0_GTICBSR01_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR01_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT0_GTICBSR01_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT0_GTICBSR01_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT0_GTICBSR01_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT0_GTICBSR01_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT0_GTICBSR01_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT0_GTICBSR01_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT0_GTICBSR01_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT0_GTICBSR01_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR01_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT0_GTICBSR01_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR01_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT0_GTICBSR01_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR01_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT0_GTICBSR01_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR01_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT0_GTICBSR01_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR02  ======================================================= */
#define GPT0_GTICBSR02_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT0_GTICBSR02_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR02_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT0_GTICBSR02_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR02_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT0_GTICBSR02_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR02_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT0_GTICBSR02_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR02_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT0_GTICBSR02_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT0_GTICBSR02_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT0_GTICBSR02_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT0_GTICBSR02_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT0_GTICBSR02_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT0_GTICBSR02_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT0_GTICBSR02_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT0_GTICBSR02_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR02_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT0_GTICBSR02_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR02_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT0_GTICBSR02_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR02_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT0_GTICBSR02_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR02_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT0_GTICBSR02_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR03  ======================================================= */
#define GPT0_GTICBSR03_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT0_GTICBSR03_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR03_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT0_GTICBSR03_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR03_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT0_GTICBSR03_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR03_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT0_GTICBSR03_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT0_GTICBSR03_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT0_GTICBSR03_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT0_GTICBSR03_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT0_GTICBSR03_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT0_GTICBSR03_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT0_GTICBSR03_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT0_GTICBSR03_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT0_GTICBSR03_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT0_GTICBSR03_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT0_GTICBSR03_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT0_GTICBSR03_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR03_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT0_GTICBSR03_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR03_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT0_GTICBSR03_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT0_GTICBSR03_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT0_GTICBSR03_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTCR00  ========================================================= */
#define GPT0_GTCR00_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT0_GTCR00_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT0_GTCR00_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT0_GTCR00_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT0_GTCR00_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT0_GTCR00_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR01  ========================================================= */
#define GPT0_GTCR01_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT0_GTCR01_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT0_GTCR01_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT0_GTCR01_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT0_GTCR01_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT0_GTCR01_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR02  ========================================================= */
#define GPT0_GTCR02_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT0_GTCR02_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT0_GTCR02_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT0_GTCR02_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT0_GTCR02_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT0_GTCR02_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR03  ========================================================= */
#define GPT0_GTCR03_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT0_GTCR03_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT0_GTCR03_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT0_GTCR03_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT0_GTCR03_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT0_GTCR03_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ======================================================  GTUDDTYC00  ======================================================= */
#define GPT0_GTUDDTYC00_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT0_GTUDDTYC00_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT0_GTUDDTYC00_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT0_GTUDDTYC00_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTUDDTYC00_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT0_GTUDDTYC00_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC00_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT0_GTUDDTYC00_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC00_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT0_GTUDDTYC00_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC00_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT0_GTUDDTYC00_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC00_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT0_GTUDDTYC00_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC00_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT0_GTUDDTYC00_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC01  ======================================================= */
#define GPT0_GTUDDTYC01_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT0_GTUDDTYC01_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT0_GTUDDTYC01_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT0_GTUDDTYC01_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTUDDTYC01_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT0_GTUDDTYC01_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC01_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT0_GTUDDTYC01_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC01_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT0_GTUDDTYC01_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC01_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT0_GTUDDTYC01_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC01_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT0_GTUDDTYC01_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC01_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT0_GTUDDTYC01_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC02  ======================================================= */
#define GPT0_GTUDDTYC02_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT0_GTUDDTYC02_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT0_GTUDDTYC02_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT0_GTUDDTYC02_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTUDDTYC02_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT0_GTUDDTYC02_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC02_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT0_GTUDDTYC02_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC02_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT0_GTUDDTYC02_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC02_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT0_GTUDDTYC02_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC02_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT0_GTUDDTYC02_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC02_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT0_GTUDDTYC02_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC03  ======================================================= */
#define GPT0_GTUDDTYC03_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT0_GTUDDTYC03_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT0_GTUDDTYC03_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT0_GTUDDTYC03_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTUDDTYC03_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT0_GTUDDTYC03_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC03_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT0_GTUDDTYC03_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC03_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT0_GTUDDTYC03_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC03_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT0_GTUDDTYC03_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT0_GTUDDTYC03_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT0_GTUDDTYC03_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT0_GTUDDTYC03_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT0_GTUDDTYC03_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTIOR00  ======================================================== */
#define GPT0_GTIOR00_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT0_GTIOR00_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR00_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT0_GTIOR00_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR00_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT0_GTIOR00_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR00_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT0_GTIOR00_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR00_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT0_GTIOR00_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR00_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT0_GTIOR00_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR00_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT0_GTIOR00_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT0_GTIOR00_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT0_GTIOR00_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR00_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT0_GTIOR00_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR00_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT0_GTIOR00_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR00_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT0_GTIOR00_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR00_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT0_GTIOR00_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR00_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT0_GTIOR00_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR00_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT0_GTIOR00_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR01  ======================================================== */
#define GPT0_GTIOR01_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT0_GTIOR01_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR01_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT0_GTIOR01_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR01_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT0_GTIOR01_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR01_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT0_GTIOR01_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR01_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT0_GTIOR01_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR01_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT0_GTIOR01_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR01_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT0_GTIOR01_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT0_GTIOR01_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT0_GTIOR01_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR01_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT0_GTIOR01_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR01_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT0_GTIOR01_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR01_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT0_GTIOR01_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR01_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT0_GTIOR01_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR01_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT0_GTIOR01_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR01_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT0_GTIOR01_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR02  ======================================================== */
#define GPT0_GTIOR02_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT0_GTIOR02_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR02_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT0_GTIOR02_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR02_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT0_GTIOR02_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR02_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT0_GTIOR02_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR02_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT0_GTIOR02_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR02_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT0_GTIOR02_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR02_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT0_GTIOR02_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT0_GTIOR02_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT0_GTIOR02_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR02_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT0_GTIOR02_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR02_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT0_GTIOR02_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR02_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT0_GTIOR02_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR02_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT0_GTIOR02_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR02_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT0_GTIOR02_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR02_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT0_GTIOR02_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR03  ======================================================== */
#define GPT0_GTIOR03_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT0_GTIOR03_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR03_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT0_GTIOR03_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR03_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT0_GTIOR03_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR03_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT0_GTIOR03_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR03_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT0_GTIOR03_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR03_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT0_GTIOR03_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR03_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT0_GTIOR03_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT0_GTIOR03_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT0_GTIOR03_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT0_GTIOR03_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT0_GTIOR03_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT0_GTIOR03_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT0_GTIOR03_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR03_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT0_GTIOR03_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT0_GTIOR03_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT0_GTIOR03_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT0_GTIOR03_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT0_GTIOR03_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT0_GTIOR03_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT0_GTIOR03_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* =======================================================  GTINTAD00  ======================================================= */
#define GPT0_GTINTAD00_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT0_GTINTAD00_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT0_GTINTAD00_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT0_GTINTAD00_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT0_GTINTAD00_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT0_GTINTAD00_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD01  ======================================================= */
#define GPT0_GTINTAD01_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT0_GTINTAD01_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT0_GTINTAD01_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT0_GTINTAD01_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT0_GTINTAD01_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT0_GTINTAD01_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD02  ======================================================= */
#define GPT0_GTINTAD02_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT0_GTINTAD02_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT0_GTINTAD02_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT0_GTINTAD02_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT0_GTINTAD02_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT0_GTINTAD02_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD03  ======================================================= */
#define GPT0_GTINTAD03_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT0_GTINTAD03_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT0_GTINTAD03_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT0_GTINTAD03_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT0_GTINTAD03_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT0_GTINTAD03_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTST00  ========================================================= */
#define GPT0_GTST00_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT0_GTST00_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST00_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT0_GTST00_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST00_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT0_GTST00_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST00_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT0_GTST00_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST00_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT0_GTST00_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST00_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT0_GTST00_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST00_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT0_GTST00_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST00_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT0_GTST00_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTST00_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT0_GTST00_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST00_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT0_GTST00_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST01  ========================================================= */
#define GPT0_GTST01_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT0_GTST01_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST01_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT0_GTST01_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST01_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT0_GTST01_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST01_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT0_GTST01_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST01_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT0_GTST01_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST01_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT0_GTST01_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST01_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT0_GTST01_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST01_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT0_GTST01_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTST01_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT0_GTST01_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST01_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT0_GTST01_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST02  ========================================================= */
#define GPT0_GTST02_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT0_GTST02_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST02_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT0_GTST02_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST02_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT0_GTST02_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST02_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT0_GTST02_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST02_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT0_GTST02_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST02_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT0_GTST02_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST02_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT0_GTST02_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST02_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT0_GTST02_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTST02_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT0_GTST02_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST02_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT0_GTST02_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST03  ========================================================= */
#define GPT0_GTST03_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT0_GTST03_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST03_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT0_GTST03_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST03_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT0_GTST03_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST03_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT0_GTST03_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST03_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT0_GTST03_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST03_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT0_GTST03_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST03_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT0_GTST03_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT0_GTST03_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT0_GTST03_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT0_GTST03_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT0_GTST03_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT0_GTST03_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT0_GTST03_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTBER00  ======================================================== */
#define GPT0_GTBER00_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT0_GTBER00_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER00_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT0_GTBER00_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER00_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT0_GTBER00_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER00_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT0_GTBER00_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER00_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT0_GTBER00_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT0_GTBER00_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT0_GTBER00_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER01  ======================================================== */
#define GPT0_GTBER01_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT0_GTBER01_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER01_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT0_GTBER01_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER01_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT0_GTBER01_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER01_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT0_GTBER01_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER01_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT0_GTBER01_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT0_GTBER01_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT0_GTBER01_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER02  ======================================================== */
#define GPT0_GTBER02_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT0_GTBER02_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER02_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT0_GTBER02_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER02_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT0_GTBER02_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER02_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT0_GTBER02_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER02_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT0_GTBER02_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT0_GTBER02_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT0_GTBER02_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER03  ======================================================== */
#define GPT0_GTBER03_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT0_GTBER03_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER03_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT0_GTBER03_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT0_GTBER03_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT0_GTBER03_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER03_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT0_GTBER03_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT0_GTBER03_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT0_GTBER03_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT0_GTBER03_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT0_GTBER03_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTCNT00  ======================================================== */
/* ========================================================  GTCNT01  ======================================================== */
/* ========================================================  GTCNT02  ======================================================== */
/* ========================================================  GTCNT03  ======================================================== */
/* =======================================================  GTCCRA00  ======================================================== */
/* =======================================================  GTCCRA01  ======================================================== */
/* =======================================================  GTCCRA02  ======================================================== */
/* =======================================================  GTCCRA03  ======================================================== */
/* =======================================================  GTCCRB00  ======================================================== */
/* =======================================================  GTCCRB01  ======================================================== */
/* =======================================================  GTCCRB02  ======================================================== */
/* =======================================================  GTCCRB03  ======================================================== */
/* =======================================================  GTCCRC00  ======================================================== */
/* =======================================================  GTCCRC01  ======================================================== */
/* =======================================================  GTCCRC02  ======================================================== */
/* =======================================================  GTCCRC03  ======================================================== */
/* =======================================================  GTCCRD00  ======================================================== */
/* =======================================================  GTCCRD01  ======================================================== */
/* =======================================================  GTCCRD02  ======================================================== */
/* =======================================================  GTCCRD03  ======================================================== */
/* =======================================================  GTCCRE00  ======================================================== */
/* =======================================================  GTCCRE01  ======================================================== */
/* =======================================================  GTCCRE02  ======================================================== */
/* =======================================================  GTCCRE03  ======================================================== */
/* =======================================================  GTCCRF00  ======================================================== */
/* =======================================================  GTCCRF01  ======================================================== */
/* =======================================================  GTCCRF02  ======================================================== */
/* =======================================================  GTCCRF03  ======================================================== */
/* ========================================================  GTPR00  ========================================================= */
/* ========================================================  GTPR01  ========================================================= */
/* ========================================================  GTPR02  ========================================================= */
/* ========================================================  GTPR03  ========================================================= */
/* ========================================================  GTPBR00  ======================================================== */
/* ========================================================  GTPBR01  ======================================================== */
/* ========================================================  GTPBR02  ======================================================== */
/* ========================================================  GTPBR03  ======================================================== */
/* =======================================================  GTDTCR00  ======================================================== */
#define GPT0_GTDTCR00_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT0_GTDTCR00_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR01  ======================================================== */
#define GPT0_GTDTCR01_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT0_GTDTCR01_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR02  ======================================================== */
#define GPT0_GTDTCR02_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT0_GTDTCR02_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR03  ======================================================== */
#define GPT0_GTDTCR03_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT0_GTDTCR03_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* ========================================================  GTDVU00  ======================================================== */
/* ========================================================  GTDVU01  ======================================================== */
/* ========================================================  GTDVU02  ======================================================== */
/* ========================================================  GTDVU03  ======================================================== */


/* =========================================================================================================================== */
/* ================                                           GPT1                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  GTWP10  ========================================================= */
#define GPT1_GTWP10_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP10_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP10_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP10_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP11  ========================================================= */
#define GPT1_GTWP11_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP11_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP11_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP11_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP12  ========================================================= */
#define GPT1_GTWP12_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP12_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP12_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP12_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP13  ========================================================= */
#define GPT1_GTWP13_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP13_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP13_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP13_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP14  ========================================================= */
#define GPT1_GTWP14_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP14_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP14_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP14_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP15  ========================================================= */
#define GPT1_GTWP15_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP15_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP15_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP15_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP16  ========================================================= */
#define GPT1_GTWP16_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP16_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP16_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP16_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTWP17  ========================================================= */
#define GPT1_GTWP17_WP_Pos                (0UL)                     /*!< WP (Bit 0)                                            */
#define GPT1_GTWP17_WP_Msk                (0x1UL)                   /*!< WP (Bitfield-Mask: 0x01)                              */
#define GPT1_GTWP17_PRKEY_Pos             (8UL)                     /*!< PRKEY (Bit 8)                                         */
#define GPT1_GTWP17_PRKEY_Msk             (0xff00UL)                /*!< PRKEY (Bitfield-Mask: 0xff)                           */
/* ========================================================  GTSTR10  ======================================================== */
#define GPT1_GTSTR10_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR10_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR11  ======================================================== */
#define GPT1_GTSTR11_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR11_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR12  ======================================================== */
#define GPT1_GTSTR12_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR12_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR13  ======================================================== */
#define GPT1_GTSTR13_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR13_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR14  ======================================================== */
#define GPT1_GTSTR14_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR14_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR15  ======================================================== */
#define GPT1_GTSTR15_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR15_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR16  ======================================================== */
#define GPT1_GTSTR16_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR16_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTR17  ======================================================== */
#define GPT1_GTSTR17_CSTRT_Pos            (0UL)                     /*!< CSTRT (Bit 0)                                         */
#define GPT1_GTSTR17_CSTRT_Msk            (0x7fUL)                  /*!< CSTRT (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP10  ======================================================== */
#define GPT1_GTSTP10_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP10_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP11  ======================================================== */
#define GPT1_GTSTP11_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP11_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP12  ======================================================== */
#define GPT1_GTSTP12_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP12_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP13  ======================================================== */
#define GPT1_GTSTP13_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP13_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP14  ======================================================== */
#define GPT1_GTSTP14_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP14_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP15  ======================================================== */
#define GPT1_GTSTP15_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP15_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP16  ======================================================== */
#define GPT1_GTSTP16_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP16_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTSTP17  ======================================================== */
#define GPT1_GTSTP17_CSTOP_Pos            (0UL)                     /*!< CSTOP (Bit 0)                                         */
#define GPT1_GTSTP17_CSTOP_Msk            (0x7fUL)                  /*!< CSTOP (Bitfield-Mask: 0x7f)                           */
/* ========================================================  GTCLR10  ======================================================== */
#define GPT1_GTCLR10_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR10_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR11  ======================================================== */
#define GPT1_GTCLR11_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR11_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR12  ======================================================== */
#define GPT1_GTCLR12_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR12_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR13  ======================================================== */
#define GPT1_GTCLR13_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR13_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR14  ======================================================== */
#define GPT1_GTCLR14_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR14_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR15  ======================================================== */
#define GPT1_GTCLR15_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR15_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR16  ======================================================== */
#define GPT1_GTCLR16_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR16_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTCLR17  ======================================================== */
#define GPT1_GTCLR17_CCLR_Pos             (0UL)                     /*!< CCLR (Bit 0)                                          */
#define GPT1_GTCLR17_CCLR_Msk             (0x7fUL)                  /*!< CCLR (Bitfield-Mask: 0x7f)                            */
/* ========================================================  GTSSR10  ======================================================== */
#define GPT1_GTSSR10_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR10_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR10_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR10_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR10_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR10_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR10_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR10_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR10_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR10_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR10_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR10_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR10_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR10_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR10_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR10_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR10_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR10_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR10_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR10_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR10_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR10_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR10_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR10_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR10_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR10_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR10_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR11  ======================================================== */
#define GPT1_GTSSR11_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR11_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR11_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR11_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR11_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR11_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR11_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR11_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR11_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR11_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR11_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR11_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR11_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR11_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR11_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR11_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR11_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR11_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR11_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR11_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR11_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR11_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR11_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR11_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR11_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR11_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR11_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR12  ======================================================== */
#define GPT1_GTSSR12_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR12_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR12_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR12_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR12_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR12_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR12_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR12_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR12_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR12_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR12_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR12_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR12_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR12_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR12_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR12_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR12_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR12_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR12_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR12_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR12_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR12_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR12_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR12_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR12_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR12_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR12_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR13  ======================================================== */
#define GPT1_GTSSR13_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR13_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR13_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR13_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR13_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR13_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR13_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR13_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR13_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR13_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR13_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR13_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR13_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR13_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR13_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR13_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR13_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR13_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR13_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR13_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR13_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR13_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR13_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR13_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR13_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR13_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR13_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR14  ======================================================== */
#define GPT1_GTSSR14_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR14_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR14_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR14_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR14_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR14_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR14_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR14_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR14_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR14_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR14_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR14_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR14_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR14_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR14_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR14_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR14_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR14_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR14_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR14_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR14_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR14_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR14_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR14_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR14_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR14_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR14_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR15  ======================================================== */
#define GPT1_GTSSR15_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR15_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR15_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR15_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR15_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR15_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR15_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR15_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR15_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR15_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR15_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR15_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR15_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR15_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR15_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR15_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR15_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR15_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR15_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR15_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR15_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR15_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR15_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR15_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR15_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR15_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR15_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR16  ======================================================== */
#define GPT1_GTSSR16_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR16_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR16_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR16_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR16_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR16_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR16_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR16_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR16_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR16_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR16_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR16_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR16_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR16_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR16_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR16_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR16_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR16_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR16_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR16_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR16_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR16_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR16_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR16_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR16_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR16_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR16_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTSSR17  ======================================================== */
#define GPT1_GTSSR17_SSGTRGAR_Pos         (0UL)                     /*!< SSGTRGAR (Bit 0)                                      */
#define GPT1_GTSSR17_SSGTRGAR_Msk         (0x1UL)                   /*!< SSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR17_SSGTRGAF_Pos         (1UL)                     /*!< SSGTRGAF (Bit 1)                                      */
#define GPT1_GTSSR17_SSGTRGAF_Msk         (0x2UL)                   /*!< SSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR17_SSGTRGBR_Pos         (2UL)                     /*!< SSGTRGBR (Bit 2)                                      */
#define GPT1_GTSSR17_SSGTRGBR_Msk         (0x4UL)                   /*!< SSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR17_SSGTRGBF_Pos         (3UL)                     /*!< SSGTRGBF (Bit 3)                                      */
#define GPT1_GTSSR17_SSGTRGBF_Msk         (0x8UL)                   /*!< SSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTSSR17_SSCARBL_Pos          (8UL)                     /*!< SSCARBL (Bit 8)                                       */
#define GPT1_GTSSR17_SSCARBL_Msk          (0x100UL)                 /*!< SSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCARBH_Pos          (9UL)                     /*!< SSCARBH (Bit 9)                                       */
#define GPT1_GTSSR17_SSCARBH_Msk          (0x200UL)                 /*!< SSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCAFBL_Pos          (10UL)                    /*!< SSCAFBL (Bit 10)                                      */
#define GPT1_GTSSR17_SSCAFBL_Msk          (0x400UL)                 /*!< SSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCAFBH_Pos          (11UL)                    /*!< SSCAFBH (Bit 11)                                      */
#define GPT1_GTSSR17_SSCAFBH_Msk          (0x800UL)                 /*!< SSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCBRAL_Pos          (12UL)                    /*!< SSCBRAL (Bit 12)                                      */
#define GPT1_GTSSR17_SSCBRAL_Msk          (0x1000UL)                /*!< SSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCBRAH_Pos          (13UL)                    /*!< SSCBRAH (Bit 13)                                      */
#define GPT1_GTSSR17_SSCBRAH_Msk          (0x2000UL)                /*!< SSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCBFAL_Pos          (14UL)                    /*!< SSCBFAL (Bit 14)                                      */
#define GPT1_GTSSR17_SSCBFAL_Msk          (0x4000UL)                /*!< SSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSCBFAH_Pos          (15UL)                    /*!< SSCBFAH (Bit 15)                                      */
#define GPT1_GTSSR17_SSCBFAH_Msk          (0x8000UL)                /*!< SSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTSSR17_SSELCA_Pos           (16UL)                    /*!< SSELCA (Bit 16)                                       */
#define GPT1_GTSSR17_SSELCA_Msk           (0x10000UL)               /*!< SSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR17_SSELCB_Pos           (17UL)                    /*!< SSELCB (Bit 17)                                       */
#define GPT1_GTSSR17_SSELCB_Msk           (0x20000UL)               /*!< SSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR17_SSELCC_Pos           (18UL)                    /*!< SSELCC (Bit 18)                                       */
#define GPT1_GTSSR17_SSELCC_Msk           (0x40000UL)               /*!< SSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR17_SSELCD_Pos           (19UL)                    /*!< SSELCD (Bit 19)                                       */
#define GPT1_GTSSR17_SSELCD_Msk           (0x80000UL)               /*!< SSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTSSR17_CSTRT_Pos            (31UL)                    /*!< CSTRT (Bit 31)                                        */
#define GPT1_GTSSR17_CSTRT_Msk            (0x80000000UL)            /*!< CSTRT (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR10  ======================================================== */
#define GPT1_GTPSR10_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR10_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR10_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR10_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR10_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR10_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR10_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR10_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR10_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR10_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR10_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR10_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR10_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR10_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR10_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR10_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR10_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR10_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR10_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR10_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR10_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR10_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR10_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR10_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR10_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR10_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR10_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR11  ======================================================== */
#define GPT1_GTPSR11_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR11_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR11_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR11_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR11_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR11_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR11_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR11_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR11_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR11_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR11_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR11_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR11_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR11_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR11_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR11_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR11_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR11_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR11_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR11_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR11_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR11_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR11_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR11_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR11_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR11_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR11_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR12  ======================================================== */
#define GPT1_GTPSR12_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR12_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR12_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR12_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR12_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR12_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR12_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR12_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR12_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR12_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR12_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR12_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR12_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR12_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR12_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR12_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR12_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR12_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR12_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR12_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR12_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR12_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR12_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR12_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR12_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR12_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR12_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR13  ======================================================== */
#define GPT1_GTPSR13_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR13_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR13_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR13_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR13_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR13_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR13_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR13_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR13_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR13_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR13_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR13_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR13_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR13_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR13_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR13_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR13_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR13_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR13_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR13_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR13_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR13_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR13_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR13_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR13_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR13_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR13_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR14  ======================================================== */
#define GPT1_GTPSR14_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR14_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR14_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR14_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR14_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR14_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR14_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR14_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR14_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR14_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR14_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR14_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR14_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR14_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR14_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR14_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR14_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR14_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR14_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR14_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR14_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR14_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR14_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR14_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR14_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR14_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR14_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR15  ======================================================== */
#define GPT1_GTPSR15_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR15_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR15_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR15_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR15_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR15_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR15_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR15_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR15_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR15_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR15_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR15_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR15_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR15_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR15_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR15_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR15_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR15_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR15_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR15_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR15_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR15_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR15_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR15_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR15_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR15_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR15_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR16  ======================================================== */
#define GPT1_GTPSR16_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR16_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR16_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR16_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR16_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR16_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR16_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR16_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR16_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR16_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR16_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR16_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR16_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR16_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR16_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR16_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR16_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR16_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR16_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR16_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR16_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR16_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR16_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR16_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR16_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR16_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR16_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTPSR17  ======================================================== */
#define GPT1_GTPSR17_PSGTRGAR_Pos         (0UL)                     /*!< PSGTRGAR (Bit 0)                                      */
#define GPT1_GTPSR17_PSGTRGAR_Msk         (0x1UL)                   /*!< PSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR17_PSGTRGAF_Pos         (1UL)                     /*!< PSGTRGAF (Bit 1)                                      */
#define GPT1_GTPSR17_PSGTRGAF_Msk         (0x2UL)                   /*!< PSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR17_PSGTRGBR_Pos         (2UL)                     /*!< PSGTRGBR (Bit 2)                                      */
#define GPT1_GTPSR17_PSGTRGBR_Msk         (0x4UL)                   /*!< PSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR17_PSGTRGBF_Pos         (3UL)                     /*!< PSGTRGBF (Bit 3)                                      */
#define GPT1_GTPSR17_PSGTRGBF_Msk         (0x8UL)                   /*!< PSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTPSR17_PSCARBL_Pos          (8UL)                     /*!< PSCARBL (Bit 8)                                       */
#define GPT1_GTPSR17_PSCARBL_Msk          (0x100UL)                 /*!< PSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCARBH_Pos          (9UL)                     /*!< PSCARBH (Bit 9)                                       */
#define GPT1_GTPSR17_PSCARBH_Msk          (0x200UL)                 /*!< PSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCAFBL_Pos          (10UL)                    /*!< PSCAFBL (Bit 10)                                      */
#define GPT1_GTPSR17_PSCAFBL_Msk          (0x400UL)                 /*!< PSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCAFBH_Pos          (11UL)                    /*!< PSCAFBH (Bit 11)                                      */
#define GPT1_GTPSR17_PSCAFBH_Msk          (0x800UL)                 /*!< PSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCBRAL_Pos          (12UL)                    /*!< PSCBRAL (Bit 12)                                      */
#define GPT1_GTPSR17_PSCBRAL_Msk          (0x1000UL)                /*!< PSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCBRAH_Pos          (13UL)                    /*!< PSCBRAH (Bit 13)                                      */
#define GPT1_GTPSR17_PSCBRAH_Msk          (0x2000UL)                /*!< PSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCBFAL_Pos          (14UL)                    /*!< PSCBFAL (Bit 14)                                      */
#define GPT1_GTPSR17_PSCBFAL_Msk          (0x4000UL)                /*!< PSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSCBFAH_Pos          (15UL)                    /*!< PSCBFAH (Bit 15)                                      */
#define GPT1_GTPSR17_PSCBFAH_Msk          (0x8000UL)                /*!< PSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTPSR17_PSELCA_Pos           (16UL)                    /*!< PSELCA (Bit 16)                                       */
#define GPT1_GTPSR17_PSELCA_Msk           (0x10000UL)               /*!< PSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR17_PSELCB_Pos           (17UL)                    /*!< PSELCB (Bit 17)                                       */
#define GPT1_GTPSR17_PSELCB_Msk           (0x20000UL)               /*!< PSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR17_PSELCC_Pos           (18UL)                    /*!< PSELCC (Bit 18)                                       */
#define GPT1_GTPSR17_PSELCC_Msk           (0x40000UL)               /*!< PSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR17_PSELCD_Pos           (19UL)                    /*!< PSELCD (Bit 19)                                       */
#define GPT1_GTPSR17_PSELCD_Msk           (0x80000UL)               /*!< PSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTPSR17_CSTOP_Pos            (31UL)                    /*!< CSTOP (Bit 31)                                        */
#define GPT1_GTPSR17_CSTOP_Msk            (0x80000000UL)            /*!< CSTOP (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTCSR10  ======================================================== */
#define GPT1_GTCSR10_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR10_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR10_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR10_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR10_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR10_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR10_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR10_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR10_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR10_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR10_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR10_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR10_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR10_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR10_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR10_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR10_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR10_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR10_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR10_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR10_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR10_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR10_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR10_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR10_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR10_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR10_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR11  ======================================================== */
#define GPT1_GTCSR11_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR11_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR11_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR11_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR11_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR11_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR11_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR11_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR11_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR11_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR11_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR11_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR11_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR11_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR11_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR11_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR11_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR11_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR11_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR11_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR11_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR11_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR11_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR11_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR11_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR11_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR11_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR12  ======================================================== */
#define GPT1_GTCSR12_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR12_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR12_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR12_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR12_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR12_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR12_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR12_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR12_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR12_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR12_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR12_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR12_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR12_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR12_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR12_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR12_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR12_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR12_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR12_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR12_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR12_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR12_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR12_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR12_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR12_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR12_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR13  ======================================================== */
#define GPT1_GTCSR13_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR13_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR13_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR13_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR13_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR13_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR13_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR13_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR13_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR13_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR13_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR13_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR13_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR13_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR13_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR13_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR13_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR13_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR13_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR13_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR13_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR13_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR13_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR13_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR13_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR13_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR13_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR14  ======================================================== */
#define GPT1_GTCSR14_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR14_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR14_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR14_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR14_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR14_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR14_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR14_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR14_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR14_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR14_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR14_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR14_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR14_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR14_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR14_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR14_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR14_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR14_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR14_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR14_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR14_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR14_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR14_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR14_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR14_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR14_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR15  ======================================================== */
#define GPT1_GTCSR15_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR15_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR15_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR15_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR15_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR15_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR15_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR15_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR15_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR15_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR15_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR15_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR15_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR15_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR15_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR15_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR15_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR15_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR15_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR15_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR15_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR15_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR15_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR15_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR15_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR15_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR15_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR16  ======================================================== */
#define GPT1_GTCSR16_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR16_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR16_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR16_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR16_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR16_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR16_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR16_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR16_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR16_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR16_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR16_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR16_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR16_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR16_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR16_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR16_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR16_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR16_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR16_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR16_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR16_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR16_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR16_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR16_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR16_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR16_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* ========================================================  GTCSR17  ======================================================== */
#define GPT1_GTCSR17_CSGTRGAR_Pos         (0UL)                     /*!< CSGTRGAR (Bit 0)                                      */
#define GPT1_GTCSR17_CSGTRGAR_Msk         (0x1UL)                   /*!< CSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR17_CSGTRGAF_Pos         (1UL)                     /*!< CSGTRGAF (Bit 1)                                      */
#define GPT1_GTCSR17_CSGTRGAF_Msk         (0x2UL)                   /*!< CSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR17_CSGTRGBR_Pos         (2UL)                     /*!< CSGTRGBR (Bit 2)                                      */
#define GPT1_GTCSR17_CSGTRGBR_Msk         (0x4UL)                   /*!< CSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR17_CSGTRGBF_Pos         (3UL)                     /*!< CSGTRGBF (Bit 3)                                      */
#define GPT1_GTCSR17_CSGTRGBF_Msk         (0x8UL)                   /*!< CSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTCSR17_CSCARBL_Pos          (8UL)                     /*!< CSCARBL (Bit 8)                                       */
#define GPT1_GTCSR17_CSCARBL_Msk          (0x100UL)                 /*!< CSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCARBH_Pos          (9UL)                     /*!< CSCARBH (Bit 9)                                       */
#define GPT1_GTCSR17_CSCARBH_Msk          (0x200UL)                 /*!< CSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCAFBL_Pos          (10UL)                    /*!< CSCAFBL (Bit 10)                                      */
#define GPT1_GTCSR17_CSCAFBL_Msk          (0x400UL)                 /*!< CSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCAFBH_Pos          (11UL)                    /*!< CSCAFBH (Bit 11)                                      */
#define GPT1_GTCSR17_CSCAFBH_Msk          (0x800UL)                 /*!< CSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCBRAL_Pos          (12UL)                    /*!< CSCBRAL (Bit 12)                                      */
#define GPT1_GTCSR17_CSCBRAL_Msk          (0x1000UL)                /*!< CSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCBRAH_Pos          (13UL)                    /*!< CSCBRAH (Bit 13)                                      */
#define GPT1_GTCSR17_CSCBRAH_Msk          (0x2000UL)                /*!< CSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCBFAL_Pos          (14UL)                    /*!< CSCBFAL (Bit 14)                                      */
#define GPT1_GTCSR17_CSCBFAL_Msk          (0x4000UL)                /*!< CSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSCBFAH_Pos          (15UL)                    /*!< CSCBFAH (Bit 15)                                      */
#define GPT1_GTCSR17_CSCBFAH_Msk          (0x8000UL)                /*!< CSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTCSR17_CSELCA_Pos           (16UL)                    /*!< CSELCA (Bit 16)                                       */
#define GPT1_GTCSR17_CSELCA_Msk           (0x10000UL)               /*!< CSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR17_CSELCB_Pos           (17UL)                    /*!< CSELCB (Bit 17)                                       */
#define GPT1_GTCSR17_CSELCB_Msk           (0x20000UL)               /*!< CSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR17_CSELCC_Pos           (18UL)                    /*!< CSELCC (Bit 18)                                       */
#define GPT1_GTCSR17_CSELCC_Msk           (0x40000UL)               /*!< CSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR17_CSELCD_Pos           (19UL)                    /*!< CSELCD (Bit 19)                                       */
#define GPT1_GTCSR17_CSELCD_Msk           (0x80000UL)               /*!< CSELCD (Bitfield-Mask: 0x01)                          */
#define GPT1_GTCSR17_CCLR_Pos             (31UL)                    /*!< CCLR (Bit 31)                                         */
#define GPT1_GTCSR17_CCLR_Msk             (0x80000000UL)            /*!< CCLR (Bitfield-Mask: 0x01)                            */
/* =======================================================  GTUPSR10  ======================================================== */
#define GPT1_GTUPSR10_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR10_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR10_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR10_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR10_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR10_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR10_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR10_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR10_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR10_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR10_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR10_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR10_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR10_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR10_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR10_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR10_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR10_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR10_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR10_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR10_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR10_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR10_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR10_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR10_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR11  ======================================================== */
#define GPT1_GTUPSR11_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR11_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR11_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR11_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR11_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR11_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR11_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR11_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR11_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR11_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR11_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR11_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR11_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR11_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR11_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR11_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR11_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR11_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR11_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR11_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR11_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR11_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR11_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR11_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR11_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR12  ======================================================== */
#define GPT1_GTUPSR12_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR12_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR12_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR12_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR12_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR12_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR12_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR12_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR12_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR12_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR12_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR12_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR12_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR12_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR12_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR12_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR12_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR12_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR12_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR12_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR12_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR12_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR12_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR12_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR12_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR13  ======================================================== */
#define GPT1_GTUPSR13_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR13_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR13_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR13_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR13_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR13_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR13_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR13_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR13_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR13_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR13_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR13_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR13_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR13_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR13_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR13_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR13_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR13_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR13_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR13_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR13_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR13_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR13_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR13_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR13_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR14  ======================================================== */
#define GPT1_GTUPSR14_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR14_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR14_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR14_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR14_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR14_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR14_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR14_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR14_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR14_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR14_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR14_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR14_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR14_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR14_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR14_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR14_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR14_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR14_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR14_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR14_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR14_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR14_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR14_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR14_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR15  ======================================================== */
#define GPT1_GTUPSR15_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR15_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR15_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR15_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR15_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR15_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR15_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR15_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR15_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR15_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR15_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR15_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR15_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR15_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR15_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR15_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR15_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR15_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR15_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR15_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR15_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR15_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR15_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR15_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR15_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR16  ======================================================== */
#define GPT1_GTUPSR16_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR16_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR16_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR16_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR16_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR16_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR16_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR16_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR16_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR16_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR16_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR16_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR16_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR16_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR16_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR16_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR16_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR16_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR16_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR16_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR16_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR16_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR16_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR16_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR16_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTUPSR17  ======================================================== */
#define GPT1_GTUPSR17_USGTRGAR_Pos        (0UL)                     /*!< USGTRGAR (Bit 0)                                      */
#define GPT1_GTUPSR17_USGTRGAR_Msk        (0x1UL)                   /*!< USGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR17_USGTRGAF_Pos        (1UL)                     /*!< USGTRGAF (Bit 1)                                      */
#define GPT1_GTUPSR17_USGTRGAF_Msk        (0x2UL)                   /*!< USGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR17_USGTRGBR_Pos        (2UL)                     /*!< USGTRGBR (Bit 2)                                      */
#define GPT1_GTUPSR17_USGTRGBR_Msk        (0x4UL)                   /*!< USGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR17_USGTRGBF_Pos        (3UL)                     /*!< USGTRGBF (Bit 3)                                      */
#define GPT1_GTUPSR17_USGTRGBF_Msk        (0x8UL)                   /*!< USGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTUPSR17_USCARBL_Pos         (8UL)                     /*!< USCARBL (Bit 8)                                       */
#define GPT1_GTUPSR17_USCARBL_Msk         (0x100UL)                 /*!< USCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCARBH_Pos         (9UL)                     /*!< USCARBH (Bit 9)                                       */
#define GPT1_GTUPSR17_USCARBH_Msk         (0x200UL)                 /*!< USCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCAFBL_Pos         (10UL)                    /*!< USCAFBL (Bit 10)                                      */
#define GPT1_GTUPSR17_USCAFBL_Msk         (0x400UL)                 /*!< USCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCAFBH_Pos         (11UL)                    /*!< USCAFBH (Bit 11)                                      */
#define GPT1_GTUPSR17_USCAFBH_Msk         (0x800UL)                 /*!< USCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCBRAL_Pos         (12UL)                    /*!< USCBRAL (Bit 12)                                      */
#define GPT1_GTUPSR17_USCBRAL_Msk         (0x1000UL)                /*!< USCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCBRAH_Pos         (13UL)                    /*!< USCBRAH (Bit 13)                                      */
#define GPT1_GTUPSR17_USCBRAH_Msk         (0x2000UL)                /*!< USCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCBFAL_Pos         (14UL)                    /*!< USCBFAL (Bit 14)                                      */
#define GPT1_GTUPSR17_USCBFAL_Msk         (0x4000UL)                /*!< USCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USCBFAH_Pos         (15UL)                    /*!< USCBFAH (Bit 15)                                      */
#define GPT1_GTUPSR17_USCBFAH_Msk         (0x8000UL)                /*!< USCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTUPSR17_USELCA_Pos          (16UL)                    /*!< USELCA (Bit 16)                                       */
#define GPT1_GTUPSR17_USELCA_Msk          (0x10000UL)               /*!< USELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR17_USELCB_Pos          (17UL)                    /*!< USELCB (Bit 17)                                       */
#define GPT1_GTUPSR17_USELCB_Msk          (0x20000UL)               /*!< USELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR17_USELCC_Pos          (18UL)                    /*!< USELCC (Bit 18)                                       */
#define GPT1_GTUPSR17_USELCC_Msk          (0x40000UL)               /*!< USELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUPSR17_USELCD_Pos          (19UL)                    /*!< USELCD (Bit 19)                                       */
#define GPT1_GTUPSR17_USELCD_Msk          (0x80000UL)               /*!< USELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR10  ======================================================== */
#define GPT1_GTDNSR10_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR10_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR10_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR10_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR10_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR10_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR10_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR10_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR10_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR10_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR10_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR10_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR10_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR10_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR10_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR10_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR10_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR10_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR10_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR10_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR10_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR10_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR10_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR10_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR10_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR11  ======================================================== */
#define GPT1_GTDNSR11_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR11_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR11_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR11_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR11_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR11_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR11_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR11_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR11_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR11_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR11_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR11_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR11_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR11_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR11_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR11_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR11_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR11_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR11_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR11_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR11_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR11_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR11_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR11_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR11_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR12  ======================================================== */
#define GPT1_GTDNSR12_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR12_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR12_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR12_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR12_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR12_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR12_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR12_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR12_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR12_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR12_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR12_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR12_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR12_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR12_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR12_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR12_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR12_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR12_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR12_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR12_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR12_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR12_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR12_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR12_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR13  ======================================================== */
#define GPT1_GTDNSR13_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR13_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR13_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR13_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR13_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR13_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR13_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR13_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR13_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR13_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR13_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR13_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR13_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR13_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR13_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR13_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR13_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR13_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR13_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR13_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR13_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR13_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR13_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR13_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR13_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR14  ======================================================== */
#define GPT1_GTDNSR14_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR14_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR14_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR14_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR14_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR14_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR14_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR14_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR14_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR14_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR14_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR14_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR14_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR14_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR14_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR14_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR14_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR14_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR14_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR14_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR14_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR14_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR14_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR14_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR14_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR15  ======================================================== */
#define GPT1_GTDNSR15_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR15_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR15_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR15_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR15_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR15_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR15_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR15_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR15_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR15_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR15_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR15_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR15_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR15_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR15_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR15_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR15_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR15_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR15_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR15_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR15_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR15_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR15_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR15_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR15_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR16  ======================================================== */
#define GPT1_GTDNSR16_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR16_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR16_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR16_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR16_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR16_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR16_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR16_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR16_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR16_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR16_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR16_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR16_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR16_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR16_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR16_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR16_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR16_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR16_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR16_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR16_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR16_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR16_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR16_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR16_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTDNSR17  ======================================================== */
#define GPT1_GTDNSR17_DSGTRGAR_Pos        (0UL)                     /*!< DSGTRGAR (Bit 0)                                      */
#define GPT1_GTDNSR17_DSGTRGAR_Msk        (0x1UL)                   /*!< DSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR17_DSGTRGAF_Pos        (1UL)                     /*!< DSGTRGAF (Bit 1)                                      */
#define GPT1_GTDNSR17_DSGTRGAF_Msk        (0x2UL)                   /*!< DSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR17_DSGTRGBR_Pos        (2UL)                     /*!< DSGTRGBR (Bit 2)                                      */
#define GPT1_GTDNSR17_DSGTRGBR_Msk        (0x4UL)                   /*!< DSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR17_DSGTRGBF_Pos        (3UL)                     /*!< DSGTRGBF (Bit 3)                                      */
#define GPT1_GTDNSR17_DSGTRGBF_Msk        (0x8UL)                   /*!< DSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTDNSR17_DSCARBL_Pos         (8UL)                     /*!< DSCARBL (Bit 8)                                       */
#define GPT1_GTDNSR17_DSCARBL_Msk         (0x100UL)                 /*!< DSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCARBH_Pos         (9UL)                     /*!< DSCARBH (Bit 9)                                       */
#define GPT1_GTDNSR17_DSCARBH_Msk         (0x200UL)                 /*!< DSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCAFBL_Pos         (10UL)                    /*!< DSCAFBL (Bit 10)                                      */
#define GPT1_GTDNSR17_DSCAFBL_Msk         (0x400UL)                 /*!< DSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCAFBH_Pos         (11UL)                    /*!< DSCAFBH (Bit 11)                                      */
#define GPT1_GTDNSR17_DSCAFBH_Msk         (0x800UL)                 /*!< DSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCBRAL_Pos         (12UL)                    /*!< DSCBRAL (Bit 12)                                      */
#define GPT1_GTDNSR17_DSCBRAL_Msk         (0x1000UL)                /*!< DSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCBRAH_Pos         (13UL)                    /*!< DSCBRAH (Bit 13)                                      */
#define GPT1_GTDNSR17_DSCBRAH_Msk         (0x2000UL)                /*!< DSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCBFAL_Pos         (14UL)                    /*!< DSCBFAL (Bit 14)                                      */
#define GPT1_GTDNSR17_DSCBFAL_Msk         (0x4000UL)                /*!< DSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSCBFAH_Pos         (15UL)                    /*!< DSCBFAH (Bit 15)                                      */
#define GPT1_GTDNSR17_DSCBFAH_Msk         (0x8000UL)                /*!< DSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTDNSR17_DSELCA_Pos          (16UL)                    /*!< DSELCA (Bit 16)                                       */
#define GPT1_GTDNSR17_DSELCA_Msk          (0x10000UL)               /*!< DSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR17_DSELCB_Pos          (17UL)                    /*!< DSELCB (Bit 17)                                       */
#define GPT1_GTDNSR17_DSELCB_Msk          (0x20000UL)               /*!< DSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR17_DSELCC_Pos          (18UL)                    /*!< DSELCC (Bit 18)                                       */
#define GPT1_GTDNSR17_DSELCC_Msk          (0x40000UL)               /*!< DSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTDNSR17_DSELCD_Pos          (19UL)                    /*!< DSELCD (Bit 19)                                       */
#define GPT1_GTDNSR17_DSELCD_Msk          (0x80000UL)               /*!< DSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR10  ======================================================= */
#define GPT1_GTICASR10_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR10_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR10_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR10_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR10_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR10_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR10_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR10_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR10_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR10_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR10_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR10_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR10_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR10_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR10_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR10_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR10_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR10_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR10_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR10_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR10_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR10_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR10_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR10_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR10_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR11  ======================================================= */
#define GPT1_GTICASR11_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR11_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR11_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR11_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR11_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR11_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR11_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR11_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR11_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR11_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR11_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR11_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR11_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR11_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR11_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR11_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR11_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR11_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR11_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR11_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR11_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR11_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR11_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR11_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR11_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR12  ======================================================= */
#define GPT1_GTICASR12_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR12_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR12_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR12_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR12_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR12_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR12_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR12_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR12_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR12_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR12_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR12_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR12_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR12_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR12_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR12_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR12_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR12_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR12_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR12_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR12_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR12_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR12_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR12_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR12_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR13  ======================================================= */
#define GPT1_GTICASR13_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR13_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR13_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR13_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR13_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR13_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR13_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR13_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR13_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR13_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR13_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR13_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR13_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR13_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR13_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR13_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR13_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR13_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR13_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR13_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR13_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR13_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR13_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR13_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR13_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR14  ======================================================= */
#define GPT1_GTICASR14_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR14_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR14_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR14_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR14_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR14_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR14_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR14_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR14_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR14_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR14_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR14_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR14_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR14_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR14_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR14_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR14_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR14_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR14_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR14_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR14_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR14_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR14_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR14_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR14_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR15  ======================================================= */
#define GPT1_GTICASR15_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR15_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR15_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR15_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR15_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR15_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR15_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR15_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR15_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR15_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR15_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR15_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR15_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR15_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR15_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR15_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR15_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR15_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR15_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR15_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR15_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR15_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR15_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR15_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR15_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR16  ======================================================= */
#define GPT1_GTICASR16_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR16_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR16_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR16_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR16_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR16_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR16_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR16_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR16_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR16_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR16_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR16_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR16_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR16_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR16_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR16_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR16_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR16_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR16_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR16_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR16_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR16_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR16_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR16_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR16_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICASR17  ======================================================= */
#define GPT1_GTICASR17_ASGTRGAR_Pos       (0UL)                     /*!< ASGTRGAR (Bit 0)                                      */
#define GPT1_GTICASR17_ASGTRGAR_Msk       (0x1UL)                   /*!< ASGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR17_ASGTRGAF_Pos       (1UL)                     /*!< ASGTRGAF (Bit 1)                                      */
#define GPT1_GTICASR17_ASGTRGAF_Msk       (0x2UL)                   /*!< ASGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR17_ASGTRGBR_Pos       (2UL)                     /*!< ASGTRGBR (Bit 2)                                      */
#define GPT1_GTICASR17_ASGTRGBR_Msk       (0x4UL)                   /*!< ASGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR17_ASGTRGBF_Pos       (3UL)                     /*!< ASGTRGBF (Bit 3)                                      */
#define GPT1_GTICASR17_ASGTRGBF_Msk       (0x8UL)                   /*!< ASGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICASR17_ASCARBL_Pos        (8UL)                     /*!< ASCARBL (Bit 8)                                       */
#define GPT1_GTICASR17_ASCARBL_Msk        (0x100UL)                 /*!< ASCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCARBH_Pos        (9UL)                     /*!< ASCARBH (Bit 9)                                       */
#define GPT1_GTICASR17_ASCARBH_Msk        (0x200UL)                 /*!< ASCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCAFBL_Pos        (10UL)                    /*!< ASCAFBL (Bit 10)                                      */
#define GPT1_GTICASR17_ASCAFBL_Msk        (0x400UL)                 /*!< ASCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCAFBH_Pos        (11UL)                    /*!< ASCAFBH (Bit 11)                                      */
#define GPT1_GTICASR17_ASCAFBH_Msk        (0x800UL)                 /*!< ASCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCBRAL_Pos        (12UL)                    /*!< ASCBRAL (Bit 12)                                      */
#define GPT1_GTICASR17_ASCBRAL_Msk        (0x1000UL)                /*!< ASCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCBRAH_Pos        (13UL)                    /*!< ASCBRAH (Bit 13)                                      */
#define GPT1_GTICASR17_ASCBRAH_Msk        (0x2000UL)                /*!< ASCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCBFAL_Pos        (14UL)                    /*!< ASCBFAL (Bit 14)                                      */
#define GPT1_GTICASR17_ASCBFAL_Msk        (0x4000UL)                /*!< ASCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASCBFAH_Pos        (15UL)                    /*!< ASCBFAH (Bit 15)                                      */
#define GPT1_GTICASR17_ASCBFAH_Msk        (0x8000UL)                /*!< ASCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICASR17_ASELCA_Pos         (16UL)                    /*!< ASELCA (Bit 16)                                       */
#define GPT1_GTICASR17_ASELCA_Msk         (0x10000UL)               /*!< ASELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR17_ASELCB_Pos         (17UL)                    /*!< ASELCB (Bit 17)                                       */
#define GPT1_GTICASR17_ASELCB_Msk         (0x20000UL)               /*!< ASELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR17_ASELCC_Pos         (18UL)                    /*!< ASELCC (Bit 18)                                       */
#define GPT1_GTICASR17_ASELCC_Msk         (0x40000UL)               /*!< ASELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICASR17_ASELCD_Pos         (19UL)                    /*!< ASELCD (Bit 19)                                       */
#define GPT1_GTICASR17_ASELCD_Msk         (0x80000UL)               /*!< ASELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR10  ======================================================= */
#define GPT1_GTICBSR10_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR10_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR10_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR10_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR10_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR10_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR10_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR10_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR10_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR10_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR10_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR10_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR10_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR10_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR10_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR10_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR10_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR10_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR10_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR10_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR10_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR10_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR10_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR10_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR10_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR11  ======================================================= */
#define GPT1_GTICBSR11_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR11_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR11_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR11_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR11_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR11_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR11_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR11_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR11_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR11_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR11_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR11_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR11_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR11_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR11_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR11_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR11_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR11_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR11_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR11_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR11_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR11_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR11_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR11_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR11_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR12  ======================================================= */
#define GPT1_GTICBSR12_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR12_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR12_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR12_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR12_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR12_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR12_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR12_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR12_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR12_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR12_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR12_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR12_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR12_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR12_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR12_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR12_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR12_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR12_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR12_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR12_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR12_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR12_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR12_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR12_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR13  ======================================================= */
#define GPT1_GTICBSR13_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR13_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR13_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR13_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR13_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR13_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR13_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR13_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR13_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR13_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR13_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR13_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR13_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR13_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR13_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR13_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR13_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR13_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR13_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR13_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR13_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR13_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR13_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR13_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR13_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR14  ======================================================= */
#define GPT1_GTICBSR14_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR14_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR14_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR14_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR14_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR14_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR14_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR14_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR14_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR14_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR14_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR14_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR14_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR14_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR14_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR14_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR14_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR14_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR14_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR14_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR14_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR14_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR14_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR14_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR14_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR15  ======================================================= */
#define GPT1_GTICBSR15_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR15_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR15_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR15_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR15_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR15_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR15_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR15_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR15_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR15_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR15_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR15_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR15_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR15_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR15_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR15_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR15_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR15_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR15_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR15_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR15_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR15_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR15_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR15_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR15_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR16  ======================================================= */
#define GPT1_GTICBSR16_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR16_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR16_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR16_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR16_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR16_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR16_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR16_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR16_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR16_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR16_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR16_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR16_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR16_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR16_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR16_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR16_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR16_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR16_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR16_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR16_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR16_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR16_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR16_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR16_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTICBSR17  ======================================================= */
#define GPT1_GTICBSR17_BSGTRGAR_Pos       (0UL)                     /*!< BSGTRGAR (Bit 0)                                      */
#define GPT1_GTICBSR17_BSGTRGAR_Msk       (0x1UL)                   /*!< BSGTRGAR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR17_BSGTRGAF_Pos       (1UL)                     /*!< BSGTRGAF (Bit 1)                                      */
#define GPT1_GTICBSR17_BSGTRGAF_Msk       (0x2UL)                   /*!< BSGTRGAF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR17_BSGTRGBR_Pos       (2UL)                     /*!< BSGTRGBR (Bit 2)                                      */
#define GPT1_GTICBSR17_BSGTRGBR_Msk       (0x4UL)                   /*!< BSGTRGBR (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR17_BSGTRGBF_Pos       (3UL)                     /*!< BSGTRGBF (Bit 3)                                      */
#define GPT1_GTICBSR17_BSGTRGBF_Msk       (0x8UL)                   /*!< BSGTRGBF (Bitfield-Mask: 0x01)                        */
#define GPT1_GTICBSR17_BSCARBL_Pos        (8UL)                     /*!< BSCARBL (Bit 8)                                       */
#define GPT1_GTICBSR17_BSCARBL_Msk        (0x100UL)                 /*!< BSCARBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCARBH_Pos        (9UL)                     /*!< BSCARBH (Bit 9)                                       */
#define GPT1_GTICBSR17_BSCARBH_Msk        (0x200UL)                 /*!< BSCARBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCAFBL_Pos        (10UL)                    /*!< BSCAFBL (Bit 10)                                      */
#define GPT1_GTICBSR17_BSCAFBL_Msk        (0x400UL)                 /*!< BSCAFBL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCAFBH_Pos        (11UL)                    /*!< BSCAFBH (Bit 11)                                      */
#define GPT1_GTICBSR17_BSCAFBH_Msk        (0x800UL)                 /*!< BSCAFBH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCBRAL_Pos        (12UL)                    /*!< BSCBRAL (Bit 12)                                      */
#define GPT1_GTICBSR17_BSCBRAL_Msk        (0x1000UL)                /*!< BSCBRAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCBRAH_Pos        (13UL)                    /*!< BSCBRAH (Bit 13)                                      */
#define GPT1_GTICBSR17_BSCBRAH_Msk        (0x2000UL)                /*!< BSCBRAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCBFAL_Pos        (14UL)                    /*!< BSCBFAL (Bit 14)                                      */
#define GPT1_GTICBSR17_BSCBFAL_Msk        (0x4000UL)                /*!< BSCBFAL (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSCBFAH_Pos        (15UL)                    /*!< BSCBFAH (Bit 15)                                      */
#define GPT1_GTICBSR17_BSCBFAH_Msk        (0x8000UL)                /*!< BSCBFAH (Bitfield-Mask: 0x01)                         */
#define GPT1_GTICBSR17_BSELCA_Pos         (16UL)                    /*!< BSELCA (Bit 16)                                       */
#define GPT1_GTICBSR17_BSELCA_Msk         (0x10000UL)               /*!< BSELCA (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR17_BSELCB_Pos         (17UL)                    /*!< BSELCB (Bit 17)                                       */
#define GPT1_GTICBSR17_BSELCB_Msk         (0x20000UL)               /*!< BSELCB (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR17_BSELCC_Pos         (18UL)                    /*!< BSELCC (Bit 18)                                       */
#define GPT1_GTICBSR17_BSELCC_Msk         (0x40000UL)               /*!< BSELCC (Bitfield-Mask: 0x01)                          */
#define GPT1_GTICBSR17_BSELCD_Pos         (19UL)                    /*!< BSELCD (Bit 19)                                       */
#define GPT1_GTICBSR17_BSELCD_Msk         (0x80000UL)               /*!< BSELCD (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTCR10  ========================================================= */
#define GPT1_GTCR10_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR10_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR10_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR10_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR10_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR10_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR11  ========================================================= */
#define GPT1_GTCR11_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR11_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR11_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR11_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR11_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR11_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR12  ========================================================= */
#define GPT1_GTCR12_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR12_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR12_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR12_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR12_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR12_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR13  ========================================================= */
#define GPT1_GTCR13_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR13_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR13_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR13_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR13_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR13_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR14  ========================================================= */
#define GPT1_GTCR14_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR14_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR14_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR14_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR14_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR14_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR15  ========================================================= */
#define GPT1_GTCR15_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR15_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR15_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR15_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR15_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR15_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR16  ========================================================= */
#define GPT1_GTCR16_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR16_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR16_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR16_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR16_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR16_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ========================================================  GTCR17  ========================================================= */
#define GPT1_GTCR17_CST_Pos               (0UL)                     /*!< CST (Bit 0)                                           */
#define GPT1_GTCR17_CST_Msk               (0x1UL)                   /*!< CST (Bitfield-Mask: 0x01)                             */
#define GPT1_GTCR17_MD_Pos                (16UL)                    /*!< MD (Bit 16)                                           */
#define GPT1_GTCR17_MD_Msk                (0x70000UL)               /*!< MD (Bitfield-Mask: 0x07)                              */
#define GPT1_GTCR17_TPCS_Pos              (24UL)                    /*!< TPCS (Bit 24)                                         */
#define GPT1_GTCR17_TPCS_Msk              (0x7000000UL)             /*!< TPCS (Bitfield-Mask: 0x07)                            */
/* ======================================================  GTUDDTYC10  ======================================================= */
#define GPT1_GTUDDTYC10_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC10_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC10_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC10_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC10_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC10_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC10_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC10_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC10_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC10_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC10_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC10_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC10_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC10_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC10_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC10_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC11  ======================================================= */
#define GPT1_GTUDDTYC11_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC11_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC11_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC11_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC11_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC11_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC11_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC11_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC11_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC11_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC11_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC11_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC11_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC11_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC11_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC11_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC12  ======================================================= */
#define GPT1_GTUDDTYC12_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC12_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC12_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC12_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC12_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC12_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC12_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC12_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC12_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC12_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC12_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC12_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC12_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC12_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC12_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC12_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC13  ======================================================= */
#define GPT1_GTUDDTYC13_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC13_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC13_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC13_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC13_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC13_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC13_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC13_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC13_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC13_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC13_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC13_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC13_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC13_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC13_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC13_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC14  ======================================================= */
#define GPT1_GTUDDTYC14_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC14_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC14_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC14_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC14_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC14_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC14_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC14_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC14_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC14_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC14_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC14_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC14_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC14_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC14_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC14_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC15  ======================================================= */
#define GPT1_GTUDDTYC15_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC15_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC15_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC15_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC15_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC15_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC15_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC15_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC15_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC15_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC15_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC15_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC15_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC15_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC15_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC15_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC16  ======================================================= */
#define GPT1_GTUDDTYC16_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC16_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC16_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC16_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC16_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC16_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC16_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC16_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC16_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC16_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC16_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC16_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC16_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC16_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC16_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC16_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ======================================================  GTUDDTYC17  ======================================================= */
#define GPT1_GTUDDTYC17_UD_Pos            (0UL)                     /*!< UD (Bit 0)                                            */
#define GPT1_GTUDDTYC17_UD_Msk            (0x1UL)                   /*!< UD (Bitfield-Mask: 0x01)                              */
#define GPT1_GTUDDTYC17_UDF_Pos           (1UL)                     /*!< UDF (Bit 1)                                           */
#define GPT1_GTUDDTYC17_UDF_Msk           (0x2UL)                   /*!< UDF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTUDDTYC17_OADTY_Pos         (16UL)                    /*!< OADTY (Bit 16)                                        */
#define GPT1_GTUDDTYC17_OADTY_Msk         (0x30000UL)               /*!< OADTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC17_OADTYF_Pos        (18UL)                    /*!< OADTYF (Bit 18)                                       */
#define GPT1_GTUDDTYC17_OADTYF_Msk        (0x40000UL)               /*!< OADTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC17_OADTYR_Pos        (19UL)                    /*!< OADTYR (Bit 19)                                       */
#define GPT1_GTUDDTYC17_OADTYR_Msk        (0x80000UL)               /*!< OADTYR (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC17_OBDTY_Pos         (24UL)                    /*!< OBDTY (Bit 24)                                        */
#define GPT1_GTUDDTYC17_OBDTY_Msk         (0x3000000UL)             /*!< OBDTY (Bitfield-Mask: 0x03)                           */
#define GPT1_GTUDDTYC17_OBDTYF_Pos        (26UL)                    /*!< OBDTYF (Bit 26)                                       */
#define GPT1_GTUDDTYC17_OBDTYF_Msk        (0x4000000UL)             /*!< OBDTYF (Bitfield-Mask: 0x01)                          */
#define GPT1_GTUDDTYC17_OBDTYR_Pos        (27UL)                    /*!< OBDTYR (Bit 27)                                       */
#define GPT1_GTUDDTYC17_OBDTYR_Msk        (0x8000000UL)             /*!< OBDTYR (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTIOR10  ======================================================== */
#define GPT1_GTIOR10_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR10_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR10_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR10_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR10_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR10_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR10_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR10_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR10_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR10_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR10_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR10_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR10_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR10_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR10_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR10_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR10_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR10_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR10_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR10_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR10_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR10_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR10_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR10_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR10_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR10_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR10_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR10_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR11  ======================================================== */
#define GPT1_GTIOR11_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR11_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR11_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR11_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR11_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR11_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR11_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR11_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR11_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR11_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR11_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR11_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR11_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR11_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR11_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR11_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR11_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR11_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR11_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR11_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR11_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR11_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR11_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR11_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR11_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR11_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR11_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR11_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR12  ======================================================== */
#define GPT1_GTIOR12_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR12_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR12_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR12_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR12_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR12_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR12_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR12_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR12_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR12_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR12_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR12_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR12_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR12_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR12_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR12_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR12_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR12_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR12_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR12_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR12_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR12_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR12_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR12_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR12_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR12_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR12_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR12_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR13  ======================================================== */
#define GPT1_GTIOR13_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR13_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR13_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR13_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR13_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR13_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR13_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR13_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR13_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR13_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR13_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR13_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR13_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR13_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR13_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR13_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR13_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR13_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR13_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR13_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR13_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR13_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR13_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR13_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR13_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR13_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR13_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR13_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR14  ======================================================== */
#define GPT1_GTIOR14_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR14_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR14_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR14_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR14_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR14_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR14_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR14_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR14_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR14_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR14_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR14_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR14_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR14_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR14_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR14_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR14_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR14_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR14_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR14_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR14_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR14_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR14_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR14_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR14_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR14_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR14_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR14_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR15  ======================================================== */
#define GPT1_GTIOR15_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR15_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR15_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR15_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR15_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR15_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR15_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR15_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR15_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR15_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR15_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR15_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR15_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR15_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR15_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR15_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR15_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR15_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR15_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR15_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR15_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR15_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR15_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR15_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR15_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR15_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR15_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR15_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR16  ======================================================== */
#define GPT1_GTIOR16_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR16_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR16_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR16_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR16_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR16_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR16_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR16_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR16_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR16_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR16_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR16_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR16_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR16_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR16_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR16_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR16_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR16_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR16_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR16_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR16_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR16_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR16_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR16_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR16_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR16_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR16_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR16_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* ========================================================  GTIOR17  ======================================================== */
#define GPT1_GTIOR17_GTIOA_Pos            (0UL)                     /*!< GTIOA (Bit 0)                                         */
#define GPT1_GTIOR17_GTIOA_Msk            (0x1fUL)                  /*!< GTIOA (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR17_OADFLT_Pos           (6UL)                     /*!< OADFLT (Bit 6)                                        */
#define GPT1_GTIOR17_OADFLT_Msk           (0x40UL)                  /*!< OADFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR17_OAHLD_Pos            (7UL)                     /*!< OAHLD (Bit 7)                                         */
#define GPT1_GTIOR17_OAHLD_Msk            (0x80UL)                  /*!< OAHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR17_OAE_Pos              (8UL)                     /*!< OAE (Bit 8)                                           */
#define GPT1_GTIOR17_OAE_Msk              (0x100UL)                 /*!< OAE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR17_OADF_Pos             (9UL)                     /*!< OADF (Bit 9)                                          */
#define GPT1_GTIOR17_OADF_Msk             (0x600UL)                 /*!< OADF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR17_NFAEN_Pos            (13UL)                    /*!< NFAEN (Bit 13)                                        */
#define GPT1_GTIOR17_NFAEN_Msk            (0x2000UL)                /*!< NFAEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR17_NFCSA_Pos            (14UL)                    /*!< NFCSA (Bit 14)                                        */
#define GPT1_GTIOR17_NFCSA_Msk            (0xc000UL)                /*!< NFCSA (Bitfield-Mask: 0x03)                           */
#define GPT1_GTIOR17_GTIOB_Pos            (16UL)                    /*!< GTIOB (Bit 16)                                        */
#define GPT1_GTIOR17_GTIOB_Msk            (0x1f0000UL)              /*!< GTIOB (Bitfield-Mask: 0x1f)                           */
#define GPT1_GTIOR17_OBDFLT_Pos           (22UL)                    /*!< OBDFLT (Bit 22)                                       */
#define GPT1_GTIOR17_OBDFLT_Msk           (0x400000UL)              /*!< OBDFLT (Bitfield-Mask: 0x01)                          */
#define GPT1_GTIOR17_OBHLD_Pos            (23UL)                    /*!< OBHLD (Bit 23)                                        */
#define GPT1_GTIOR17_OBHLD_Msk            (0x800000UL)              /*!< OBHLD (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR17_OBE_Pos              (24UL)                    /*!< OBE (Bit 24)                                          */
#define GPT1_GTIOR17_OBE_Msk              (0x1000000UL)             /*!< OBE (Bitfield-Mask: 0x01)                             */
#define GPT1_GTIOR17_OBDF_Pos             (25UL)                    /*!< OBDF (Bit 25)                                         */
#define GPT1_GTIOR17_OBDF_Msk             (0x6000000UL)             /*!< OBDF (Bitfield-Mask: 0x03)                            */
#define GPT1_GTIOR17_NFBEN_Pos            (29UL)                    /*!< NFBEN (Bit 29)                                        */
#define GPT1_GTIOR17_NFBEN_Msk            (0x20000000UL)            /*!< NFBEN (Bitfield-Mask: 0x01)                           */
#define GPT1_GTIOR17_NFCSB_Pos            (30UL)                    /*!< NFCSB (Bit 30)                                        */
#define GPT1_GTIOR17_NFCSB_Msk            (0xc0000000UL)            /*!< NFCSB (Bitfield-Mask: 0x03)                           */
/* =======================================================  GTINTAD10  ======================================================= */
#define GPT1_GTINTAD10_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD10_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD10_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD10_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD10_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD10_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD11  ======================================================= */
#define GPT1_GTINTAD11_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD11_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD11_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD11_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD11_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD11_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD12  ======================================================= */
#define GPT1_GTINTAD12_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD12_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD12_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD12_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD12_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD12_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD13  ======================================================= */
#define GPT1_GTINTAD13_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD13_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD13_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD13_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD13_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD13_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD14  ======================================================= */
#define GPT1_GTINTAD14_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD14_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD14_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD14_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD14_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD14_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD15  ======================================================= */
#define GPT1_GTINTAD15_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD15_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD15_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD15_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD15_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD15_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD16  ======================================================= */
#define GPT1_GTINTAD16_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD16_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD16_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD16_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD16_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD16_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* =======================================================  GTINTAD17  ======================================================= */
#define GPT1_GTINTAD17_GRP_Pos            (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_GTINTAD17_GRP_Msk            (0x3000000UL)             /*!< GRP (Bitfield-Mask: 0x03)                             */
#define GPT1_GTINTAD17_GRPABH_Pos         (29UL)                    /*!< GRPABH (Bit 29)                                       */
#define GPT1_GTINTAD17_GRPABH_Msk         (0x20000000UL)            /*!< GRPABH (Bitfield-Mask: 0x01)                          */
#define GPT1_GTINTAD17_GRPABL_Pos         (30UL)                    /*!< GRPABL (Bit 30)                                       */
#define GPT1_GTINTAD17_GRPABL_Msk         (0x40000000UL)            /*!< GRPABL (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTST10  ========================================================= */
#define GPT1_GTST10_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST10_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST10_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST10_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST10_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST10_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST10_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST10_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST10_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST10_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST10_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST10_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST10_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST10_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST10_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST10_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST10_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST10_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST10_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST10_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST11  ========================================================= */
#define GPT1_GTST11_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST11_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST11_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST11_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST11_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST11_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST11_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST11_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST11_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST11_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST11_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST11_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST11_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST11_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST11_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST11_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST11_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST11_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST11_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST11_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST12  ========================================================= */
#define GPT1_GTST12_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST12_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST12_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST12_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST12_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST12_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST12_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST12_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST12_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST12_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST12_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST12_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST12_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST12_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST12_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST12_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST12_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST12_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST12_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST12_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST13  ========================================================= */
#define GPT1_GTST13_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST13_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST13_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST13_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST13_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST13_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST13_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST13_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST13_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST13_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST13_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST13_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST13_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST13_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST13_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST13_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST13_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST13_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST13_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST13_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST14  ========================================================= */
#define GPT1_GTST14_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST14_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST14_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST14_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST14_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST14_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST14_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST14_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST14_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST14_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST14_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST14_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST14_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST14_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST14_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST14_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST14_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST14_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST14_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST14_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST15  ========================================================= */
#define GPT1_GTST15_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST15_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST15_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST15_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST15_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST15_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST15_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST15_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST15_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST15_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST15_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST15_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST15_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST15_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST15_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST15_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST15_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST15_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST15_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST15_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST16  ========================================================= */
#define GPT1_GTST16_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST16_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST16_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST16_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST16_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST16_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST16_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST16_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST16_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST16_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST16_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST16_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST16_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST16_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST16_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST16_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST16_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST16_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST16_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST16_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTST17  ========================================================= */
#define GPT1_GTST17_TCFA_Pos              (0UL)                     /*!< TCFA (Bit 0)                                          */
#define GPT1_GTST17_TCFA_Msk              (0x1UL)                   /*!< TCFA (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST17_TCFB_Pos              (1UL)                     /*!< TCFB (Bit 1)                                          */
#define GPT1_GTST17_TCFB_Msk              (0x2UL)                   /*!< TCFB (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST17_TCFC_Pos              (2UL)                     /*!< TCFC (Bit 2)                                          */
#define GPT1_GTST17_TCFC_Msk              (0x4UL)                   /*!< TCFC (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST17_TCFD_Pos              (3UL)                     /*!< TCFD (Bit 3)                                          */
#define GPT1_GTST17_TCFD_Msk              (0x8UL)                   /*!< TCFD (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST17_TCFPO_Pos             (6UL)                     /*!< TCFPO (Bit 6)                                         */
#define GPT1_GTST17_TCFPO_Msk             (0x40UL)                  /*!< TCFPO (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST17_TCFPU_Pos             (7UL)                     /*!< TCFPU (Bit 7)                                         */
#define GPT1_GTST17_TCFPU_Msk             (0x80UL)                  /*!< TCFPU (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST17_TUCF_Pos              (15UL)                    /*!< TUCF (Bit 15)                                         */
#define GPT1_GTST17_TUCF_Msk              (0x8000UL)                /*!< TUCF (Bitfield-Mask: 0x01)                            */
#define GPT1_GTST17_ODF_Pos               (24UL)                    /*!< ODF (Bit 24)                                          */
#define GPT1_GTST17_ODF_Msk               (0x1000000UL)             /*!< ODF (Bitfield-Mask: 0x01)                             */
#define GPT1_GTST17_OABHF_Pos             (29UL)                    /*!< OABHF (Bit 29)                                        */
#define GPT1_GTST17_OABHF_Msk             (0x20000000UL)            /*!< OABHF (Bitfield-Mask: 0x01)                           */
#define GPT1_GTST17_OABLF_Pos             (30UL)                    /*!< OABLF (Bit 30)                                        */
#define GPT1_GTST17_OABLF_Msk             (0x40000000UL)            /*!< OABLF (Bitfield-Mask: 0x01)                           */
/* ========================================================  GTBER10  ======================================================== */
#define GPT1_GTBER10_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER10_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER10_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER10_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER10_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER10_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER10_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER10_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER10_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER10_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER10_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER10_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER11  ======================================================== */
#define GPT1_GTBER11_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER11_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER11_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER11_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER11_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER11_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER11_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER11_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER11_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER11_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER11_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER11_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER12  ======================================================== */
#define GPT1_GTBER12_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER12_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER12_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER12_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER12_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER12_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER12_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER12_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER12_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER12_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER12_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER12_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER13  ======================================================== */
#define GPT1_GTBER13_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER13_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER13_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER13_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER13_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER13_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER13_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER13_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER13_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER13_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER13_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER13_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER14  ======================================================== */
#define GPT1_GTBER14_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER14_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER14_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER14_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER14_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER14_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER14_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER14_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER14_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER14_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER14_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER14_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER15  ======================================================== */
#define GPT1_GTBER15_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER15_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER15_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER15_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER15_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER15_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER15_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER15_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER15_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER15_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER15_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER15_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER16  ======================================================== */
#define GPT1_GTBER16_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER16_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER16_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER16_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER16_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER16_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER16_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER16_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER16_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER16_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER16_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER16_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTBER17  ======================================================== */
#define GPT1_GTBER17_BD0_Pos              (0UL)                     /*!< BD0 (Bit 0)                                           */
#define GPT1_GTBER17_BD0_Msk              (0x1UL)                   /*!< BD0 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER17_BD1_Pos              (1UL)                     /*!< BD1 (Bit 1)                                           */
#define GPT1_GTBER17_BD1_Msk              (0x2UL)                   /*!< BD1 (Bitfield-Mask: 0x01)                             */
#define GPT1_GTBER17_CCRA_Pos             (16UL)                    /*!< CCRA (Bit 16)                                         */
#define GPT1_GTBER17_CCRA_Msk             (0x30000UL)               /*!< CCRA (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER17_CCRB_Pos             (18UL)                    /*!< CCRB (Bit 18)                                         */
#define GPT1_GTBER17_CCRB_Msk             (0xc0000UL)               /*!< CCRB (Bitfield-Mask: 0x03)                            */
#define GPT1_GTBER17_PR_Pos               (20UL)                    /*!< PR (Bit 20)                                           */
#define GPT1_GTBER17_PR_Msk               (0x300000UL)              /*!< PR (Bitfield-Mask: 0x03)                              */
#define GPT1_GTBER17_CCRSWT_Pos           (22UL)                    /*!< CCRSWT (Bit 22)                                       */
#define GPT1_GTBER17_CCRSWT_Msk           (0x400000UL)              /*!< CCRSWT (Bitfield-Mask: 0x01)                          */
/* ========================================================  GTCNT10  ======================================================== */
/* ========================================================  GTCNT11  ======================================================== */
/* ========================================================  GTCNT12  ======================================================== */
/* ========================================================  GTCNT13  ======================================================== */
/* ========================================================  GTCNT14  ======================================================== */
/* ========================================================  GTCNT15  ======================================================== */
/* ========================================================  GTCNT16  ======================================================== */
/* ========================================================  GTCNT17  ======================================================== */
/* =======================================================  GTCCRA10  ======================================================== */
/* =======================================================  GTCCRA11  ======================================================== */
/* =======================================================  GTCCRA12  ======================================================== */
/* =======================================================  GTCCRA13  ======================================================== */
/* =======================================================  GTCCRA14  ======================================================== */
/* =======================================================  GTCCRA15  ======================================================== */
/* =======================================================  GTCCRA16  ======================================================== */
/* =======================================================  GTCCRA17  ======================================================== */
/* =======================================================  GTCCRB10  ======================================================== */
/* =======================================================  GTCCRB11  ======================================================== */
/* =======================================================  GTCCRB12  ======================================================== */
/* =======================================================  GTCCRB13  ======================================================== */
/* =======================================================  GTCCRB14  ======================================================== */
/* =======================================================  GTCCRB15  ======================================================== */
/* =======================================================  GTCCRB16  ======================================================== */
/* =======================================================  GTCCRB17  ======================================================== */
/* =======================================================  GTCCRC10  ======================================================== */
/* =======================================================  GTCCRC11  ======================================================== */
/* =======================================================  GTCCRC12  ======================================================== */
/* =======================================================  GTCCRC13  ======================================================== */
/* =======================================================  GTCCRC14  ======================================================== */
/* =======================================================  GTCCRC15  ======================================================== */
/* =======================================================  GTCCRC16  ======================================================== */
/* =======================================================  GTCCRC17  ======================================================== */
/* =======================================================  GTCCRD10  ======================================================== */
/* =======================================================  GTCCRD11  ======================================================== */
/* =======================================================  GTCCRD12  ======================================================== */
/* =======================================================  GTCCRD13  ======================================================== */
/* =======================================================  GTCCRD14  ======================================================== */
/* =======================================================  GTCCRD15  ======================================================== */
/* =======================================================  GTCCRD16  ======================================================== */
/* =======================================================  GTCCRD17  ======================================================== */
/* =======================================================  GTCCRE10  ======================================================== */
/* =======================================================  GTCCRE11  ======================================================== */
/* =======================================================  GTCCRE12  ======================================================== */
/* =======================================================  GTCCRE13  ======================================================== */
/* =======================================================  GTCCRE14  ======================================================== */
/* =======================================================  GTCCRE15  ======================================================== */
/* =======================================================  GTCCRE16  ======================================================== */
/* =======================================================  GTCCRE17  ======================================================== */
/* =======================================================  GTCCRF10  ======================================================== */
/* =======================================================  GTCCRF11  ======================================================== */
/* =======================================================  GTCCRF12  ======================================================== */
/* =======================================================  GTCCRF13  ======================================================== */
/* =======================================================  GTCCRF14  ======================================================== */
/* =======================================================  GTCCRF15  ======================================================== */
/* =======================================================  GTCCRF16  ======================================================== */
/* =======================================================  GTCCRF17  ======================================================== */
/* ========================================================  GTPR10  ========================================================= */
/* ========================================================  GTPR11  ========================================================= */
/* ========================================================  GTPR12  ========================================================= */
/* ========================================================  GTPR13  ========================================================= */
/* ========================================================  GTPR14  ========================================================= */
/* ========================================================  GTPR15  ========================================================= */
/* ========================================================  GTPR16  ========================================================= */
/* ========================================================  GTPR17  ========================================================= */
/* ========================================================  GTPBR10  ======================================================== */
/* ========================================================  GTPBR11  ======================================================== */
/* ========================================================  GTPBR12  ======================================================== */
/* ========================================================  GTPBR13  ======================================================== */
/* ========================================================  GTPBR14  ======================================================== */
/* ========================================================  GTPBR15  ======================================================== */
/* ========================================================  GTPBR16  ======================================================== */
/* ========================================================  GTPBR17  ======================================================== */
/* =======================================================  GTDTCR10  ======================================================== */
#define GPT1_GTDTCR10_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR10_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR11  ======================================================== */
#define GPT1_GTDTCR11_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR11_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR12  ======================================================== */
#define GPT1_GTDTCR12_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR12_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR13  ======================================================== */
#define GPT1_GTDTCR13_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR13_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR14  ======================================================== */
#define GPT1_GTDTCR14_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR14_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR15  ======================================================== */
#define GPT1_GTDTCR15_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR15_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR16  ======================================================== */
#define GPT1_GTDTCR16_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR16_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* =======================================================  GTDTCR17  ======================================================== */
#define GPT1_GTDTCR17_TDE_Pos             (0UL)                     /*!< TDE (Bit 0)                                           */
#define GPT1_GTDTCR17_TDE_Msk             (0x1UL)                   /*!< TDE (Bitfield-Mask: 0x01)                             */
/* ========================================================  GTDVU10  ======================================================== */
/* ========================================================  GTDVU11  ======================================================== */
/* ========================================================  GTDVU12  ======================================================== */
/* ========================================================  GTDVU13  ======================================================== */
/* ========================================================  GTDVU14  ======================================================== */
/* ========================================================  GTDVU15  ======================================================== */
/* ========================================================  GTDVU16  ======================================================== */
/* ========================================================  GTDVU17  ======================================================== */
/* =========================================================  OPSCR  ========================================================= */
#define GPT1_OPSCR_UF_Pos                 (0UL)                     /*!< UF (Bit 0)                                            */
#define GPT1_OPSCR_UF_Msk                 (0x1UL)                   /*!< UF (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_VF_Pos                 (1UL)                     /*!< VF (Bit 1)                                            */
#define GPT1_OPSCR_VF_Msk                 (0x2UL)                   /*!< VF (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_WF_Pos                 (2UL)                     /*!< WF (Bit 2)                                            */
#define GPT1_OPSCR_WF_Msk                 (0x4UL)                   /*!< WF (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_U_Pos                  (4UL)                     /*!< U (Bit 4)                                             */
#define GPT1_OPSCR_U_Msk                  (0x10UL)                  /*!< U (Bitfield-Mask: 0x01)                               */
#define GPT1_OPSCR_V_Pos                  (5UL)                     /*!< V (Bit 5)                                             */
#define GPT1_OPSCR_V_Msk                  (0x20UL)                  /*!< V (Bitfield-Mask: 0x01)                               */
#define GPT1_OPSCR_W_Pos                  (6UL)                     /*!< W (Bit 6)                                             */
#define GPT1_OPSCR_W_Msk                  (0x40UL)                  /*!< W (Bitfield-Mask: 0x01)                               */
#define GPT1_OPSCR_EN_Pos                 (8UL)                     /*!< EN (Bit 8)                                            */
#define GPT1_OPSCR_EN_Msk                 (0x100UL)                 /*!< EN (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_FB_Pos                 (16UL)                    /*!< FB (Bit 16)                                           */
#define GPT1_OPSCR_FB_Msk                 (0x10000UL)               /*!< FB (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_P_Pos                  (17UL)                    /*!< P (Bit 17)                                            */
#define GPT1_OPSCR_P_Msk                  (0x20000UL)               /*!< P (Bitfield-Mask: 0x01)                               */
#define GPT1_OPSCR_N_Pos                  (18UL)                    /*!< N (Bit 18)                                            */
#define GPT1_OPSCR_N_Msk                  (0x40000UL)               /*!< N (Bitfield-Mask: 0x01)                               */
#define GPT1_OPSCR_INV_Pos                (19UL)                    /*!< INV (Bit 19)                                          */
#define GPT1_OPSCR_INV_Msk                (0x80000UL)               /*!< INV (Bitfield-Mask: 0x01)                             */
#define GPT1_OPSCR_RV_Pos                 (20UL)                    /*!< RV (Bit 20)                                           */
#define GPT1_OPSCR_RV_Msk                 (0x100000UL)              /*!< RV (Bitfield-Mask: 0x01)                              */
#define GPT1_OPSCR_ALIGN_Pos              (21UL)                    /*!< ALIGN (Bit 21)                                        */
#define GPT1_OPSCR_ALIGN_Msk              (0x200000UL)              /*!< ALIGN (Bitfield-Mask: 0x01)                           */
#define GPT1_OPSCR_GRP_Pos                (24UL)                    /*!< GRP (Bit 24)                                          */
#define GPT1_OPSCR_GRP_Msk                (0x1000000UL)             /*!< GRP (Bitfield-Mask: 0x01)                             */
#define GPT1_OPSCR_GODF_Pos               (26UL)                    /*!< GODF (Bit 26)                                         */
#define GPT1_OPSCR_GODF_Msk               (0x4000000UL)             /*!< GODF (Bitfield-Mask: 0x01)                            */
#define GPT1_OPSCR_NFEN_Pos               (29UL)                    /*!< NFEN (Bit 29)                                         */
#define GPT1_OPSCR_NFEN_Msk               (0x20000000UL)            /*!< NFEN (Bitfield-Mask: 0x01)                            */
#define GPT1_OPSCR_NFCS_Pos               (30UL)                    /*!< NFCS (Bit 30)                                         */
#define GPT1_OPSCR_NFCS_Msk               (0xc0000000UL)            /*!< NFCS (Bitfield-Mask: 0x03)                            */


/* =========================================================================================================================== */
/* ================                                            PGI                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  POEGGA  ========================================================= */
#define PGI_POEGGA_PIDF_Pos               (0UL)                     /*!< PIDF (Bit 0)                                          */
#define PGI_POEGGA_PIDF_Msk               (0x1UL)                   /*!< PIDF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGA_IOCF_Pos               (1UL)                     /*!< IOCF (Bit 1)                                          */
#define PGI_POEGGA_IOCF_Msk               (0x2UL)                   /*!< IOCF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGA_OSTPF_Pos              (2UL)                     /*!< OSTPF (Bit 2)                                         */
#define PGI_POEGGA_OSTPF_Msk              (0x4UL)                   /*!< OSTPF (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGA_SSF_Pos                (3UL)                     /*!< SSF (Bit 3)                                           */
#define PGI_POEGGA_SSF_Msk                (0x8UL)                   /*!< SSF (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGA_PIDE_Pos               (4UL)                     /*!< PIDE (Bit 4)                                          */
#define PGI_POEGGA_PIDE_Msk               (0x10UL)                  /*!< PIDE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGA_IOCE_Pos               (5UL)                     /*!< IOCE (Bit 5)                                          */
#define PGI_POEGGA_IOCE_Msk               (0x20UL)                  /*!< IOCE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGA_OSTPE_Pos              (6UL)                     /*!< OSTPE (Bit 6)                                         */
#define PGI_POEGGA_OSTPE_Msk              (0x40UL)                  /*!< OSTPE (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGA_ST_Pos                 (16UL)                    /*!< ST (Bit 16)                                           */
#define PGI_POEGGA_ST_Msk                 (0x10000UL)               /*!< ST (Bitfield-Mask: 0x01)                              */
#define PGI_POEGGA_INV_Pos                (28UL)                    /*!< INV (Bit 28)                                          */
#define PGI_POEGGA_INV_Msk                (0x10000000UL)            /*!< INV (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGA_NFEN_Pos               (29UL)                    /*!< NFEN (Bit 29)                                         */
#define PGI_POEGGA_NFEN_Msk               (0x20000000UL)            /*!< NFEN (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGA_NFCS_Pos               (30UL)                    /*!< NFCS (Bit 30)                                         */
#define PGI_POEGGA_NFCS_Msk               (0xc0000000UL)            /*!< NFCS (Bitfield-Mask: 0x03)                            */
/* ========================================================  POEGGB  ========================================================= */
#define PGI_POEGGB_PIDF_Pos               (0UL)                     /*!< PIDF (Bit 0)                                          */
#define PGI_POEGGB_PIDF_Msk               (0x1UL)                   /*!< PIDF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGB_IOCF_Pos               (1UL)                     /*!< IOCF (Bit 1)                                          */
#define PGI_POEGGB_IOCF_Msk               (0x2UL)                   /*!< IOCF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGB_OSTPF_Pos              (2UL)                     /*!< OSTPF (Bit 2)                                         */
#define PGI_POEGGB_OSTPF_Msk              (0x4UL)                   /*!< OSTPF (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGB_SSF_Pos                (3UL)                     /*!< SSF (Bit 3)                                           */
#define PGI_POEGGB_SSF_Msk                (0x8UL)                   /*!< SSF (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGB_PIDE_Pos               (4UL)                     /*!< PIDE (Bit 4)                                          */
#define PGI_POEGGB_PIDE_Msk               (0x10UL)                  /*!< PIDE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGB_IOCE_Pos               (5UL)                     /*!< IOCE (Bit 5)                                          */
#define PGI_POEGGB_IOCE_Msk               (0x20UL)                  /*!< IOCE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGB_OSTPE_Pos              (6UL)                     /*!< OSTPE (Bit 6)                                         */
#define PGI_POEGGB_OSTPE_Msk              (0x40UL)                  /*!< OSTPE (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGB_ST_Pos                 (16UL)                    /*!< ST (Bit 16)                                           */
#define PGI_POEGGB_ST_Msk                 (0x10000UL)               /*!< ST (Bitfield-Mask: 0x01)                              */
#define PGI_POEGGB_INV_Pos                (28UL)                    /*!< INV (Bit 28)                                          */
#define PGI_POEGGB_INV_Msk                (0x10000000UL)            /*!< INV (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGB_NFEN_Pos               (29UL)                    /*!< NFEN (Bit 29)                                         */
#define PGI_POEGGB_NFEN_Msk               (0x20000000UL)            /*!< NFEN (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGB_NFCS_Pos               (30UL)                    /*!< NFCS (Bit 30)                                         */
#define PGI_POEGGB_NFCS_Msk               (0xc0000000UL)            /*!< NFCS (Bitfield-Mask: 0x03)                            */
/* ========================================================  POEGGC  ========================================================= */
#define PGI_POEGGC_PIDF_Pos               (0UL)                     /*!< PIDF (Bit 0)                                          */
#define PGI_POEGGC_PIDF_Msk               (0x1UL)                   /*!< PIDF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGC_IOCF_Pos               (1UL)                     /*!< IOCF (Bit 1)                                          */
#define PGI_POEGGC_IOCF_Msk               (0x2UL)                   /*!< IOCF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGC_OSTPF_Pos              (2UL)                     /*!< OSTPF (Bit 2)                                         */
#define PGI_POEGGC_OSTPF_Msk              (0x4UL)                   /*!< OSTPF (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGC_SSF_Pos                (3UL)                     /*!< SSF (Bit 3)                                           */
#define PGI_POEGGC_SSF_Msk                (0x8UL)                   /*!< SSF (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGC_PIDE_Pos               (4UL)                     /*!< PIDE (Bit 4)                                          */
#define PGI_POEGGC_PIDE_Msk               (0x10UL)                  /*!< PIDE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGC_IOCE_Pos               (5UL)                     /*!< IOCE (Bit 5)                                          */
#define PGI_POEGGC_IOCE_Msk               (0x20UL)                  /*!< IOCE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGC_OSTPE_Pos              (6UL)                     /*!< OSTPE (Bit 6)                                         */
#define PGI_POEGGC_OSTPE_Msk              (0x40UL)                  /*!< OSTPE (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGC_ST_Pos                 (16UL)                    /*!< ST (Bit 16)                                           */
#define PGI_POEGGC_ST_Msk                 (0x10000UL)               /*!< ST (Bitfield-Mask: 0x01)                              */
#define PGI_POEGGC_INV_Pos                (28UL)                    /*!< INV (Bit 28)                                          */
#define PGI_POEGGC_INV_Msk                (0x10000000UL)            /*!< INV (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGC_NFEN_Pos               (29UL)                    /*!< NFEN (Bit 29)                                         */
#define PGI_POEGGC_NFEN_Msk               (0x20000000UL)            /*!< NFEN (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGC_NFCS_Pos               (30UL)                    /*!< NFCS (Bit 30)                                         */
#define PGI_POEGGC_NFCS_Msk               (0xc0000000UL)            /*!< NFCS (Bitfield-Mask: 0x03)                            */
/* ========================================================  POEGGD  ========================================================= */
#define PGI_POEGGD_PIDF_Pos               (0UL)                     /*!< PIDF (Bit 0)                                          */
#define PGI_POEGGD_PIDF_Msk               (0x1UL)                   /*!< PIDF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGD_IOCF_Pos               (1UL)                     /*!< IOCF (Bit 1)                                          */
#define PGI_POEGGD_IOCF_Msk               (0x2UL)                   /*!< IOCF (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGD_OSTPF_Pos              (2UL)                     /*!< OSTPF (Bit 2)                                         */
#define PGI_POEGGD_OSTPF_Msk              (0x4UL)                   /*!< OSTPF (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGD_SSF_Pos                (3UL)                     /*!< SSF (Bit 3)                                           */
#define PGI_POEGGD_SSF_Msk                (0x8UL)                   /*!< SSF (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGD_PIDE_Pos               (4UL)                     /*!< PIDE (Bit 4)                                          */
#define PGI_POEGGD_PIDE_Msk               (0x10UL)                  /*!< PIDE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGD_IOCE_Pos               (5UL)                     /*!< IOCE (Bit 5)                                          */
#define PGI_POEGGD_IOCE_Msk               (0x20UL)                  /*!< IOCE (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGD_OSTPE_Pos              (6UL)                     /*!< OSTPE (Bit 6)                                         */
#define PGI_POEGGD_OSTPE_Msk              (0x40UL)                  /*!< OSTPE (Bitfield-Mask: 0x01)                           */
#define PGI_POEGGD_ST_Pos                 (16UL)                    /*!< ST (Bit 16)                                           */
#define PGI_POEGGD_ST_Msk                 (0x10000UL)               /*!< ST (Bitfield-Mask: 0x01)                              */
#define PGI_POEGGD_INV_Pos                (28UL)                    /*!< INV (Bit 28)                                          */
#define PGI_POEGGD_INV_Msk                (0x10000000UL)            /*!< INV (Bitfield-Mask: 0x01)                             */
#define PGI_POEGGD_NFEN_Pos               (29UL)                    /*!< NFEN (Bit 29)                                         */
#define PGI_POEGGD_NFEN_Msk               (0x20000000UL)            /*!< NFEN (Bitfield-Mask: 0x01)                            */
#define PGI_POEGGD_NFCS_Pos               (30UL)                    /*!< NFCS (Bit 30)                                         */
#define PGI_POEGGD_NFCS_Msk               (0xc0000000UL)            /*!< NFCS (Bitfield-Mask: 0x03)                            */


/* =========================================================================================================================== */
/* ================                                            AES                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  MREG  ========================================================== */
#define AES_MREG_core_en_Pos              (0UL)                     /*!< core_en (Bit 0)                                       */
#define AES_MREG_core_en_Msk              (0x1UL)                   /*!< core_en (Bitfield-Mask: 0x01)                         */
#define AES_MREG_rdreq_en_Pos             (8UL)                     /*!< rdreq_en (Bit 8)                                      */
#define AES_MREG_rdreq_en_Msk             (0x100UL)                 /*!< rdreq_en (Bitfield-Mask: 0x01)                        */
#define AES_MREG_wrreq_en_Pos             (9UL)                     /*!< wrreq_en (Bit 9)                                      */
#define AES_MREG_wrreq_en_Msk             (0x200UL)                 /*!< wrreq_en (Bitfield-Mask: 0x01)                        */
#define AES_MREG_rdrdy_en_Pos             (10UL)                    /*!< rdrdy_en (Bit 10)                                     */
#define AES_MREG_rdrdy_en_Msk             (0x400UL)                 /*!< rdrdy_en (Bitfield-Mask: 0x01)                        */
#define AES_MREG_wrrdy_Pos                (11UL)                    /*!< wrrdy (Bit 11)                                        */
#define AES_MREG_wrrdy_Msk                (0x800UL)                 /*!< wrrdy (Bitfield-Mask: 0x01)                           */
/* =========================================================  CREG  ========================================================== */
#define AES_CREG_inv_cipher_Pos           (0UL)                     /*!< inv_cipher (Bit 0)                                    */
#define AES_CREG_inv_cipher_Msk           (0x1UL)                   /*!< inv_cipher (Bitfield-Mask: 0x01)                      */
#define AES_CREG_key_len_Pos              (1UL)                     /*!< key_len (Bit 1)                                       */
#define AES_CREG_key_len_Msk              (0x2UL)                   /*!< key_len (Bitfield-Mask: 0x01)                         */
#define AES_CREG_chain_Pos                (4UL)                     /*!< chain (Bit 4)                                         */
#define AES_CREG_chain_Msk                (0x30UL)                  /*!< chain (Bitfield-Mask: 0x03)                           */
#define AES_CREG_store_Pos                (8UL)                     /*!< store (Bit 8)                                         */
#define AES_CREG_store_Msk                (0x300UL)                 /*!< store (Bitfield-Mask: 0x03)                           */
#define AES_CREG_key_sel_pre_Pos          (12UL)                    /*!< key_sel_pre (Bit 12)                                  */
#define AES_CREG_key_sel_pre_Msk          (0x1000UL)                /*!< key_sel_pre (Bitfield-Mask: 0x01)                     */
#define AES_CREG_sel_basekey_Pos          (14UL)                    /*!< sel_basekey (Bit 14)                                  */
#define AES_CREG_sel_basekey_Msk          (0x4000UL)                /*!< sel_basekey (Bitfield-Mask: 0x01)                     */
#define AES_CREG_sel_id_Pos               (15UL)                    /*!< sel_id (Bit 15)                                       */
#define AES_CREG_sel_id_Msk               (0x8000UL)                /*!< sel_id (Bitfield-Mask: 0x01)                          */
#define AES_CREG_wrrdy_Pos                (24UL)                    /*!< wrrdy (Bit 24)                                        */
#define AES_CREG_wrrdy_Msk                (0x1000000UL)             /*!< wrrdy (Bitfield-Mask: 0x01)                           */
#define AES_CREG_rdrdy_Pos                (25UL)                    /*!< rdrdy (Bit 25)                                        */
#define AES_CREG_rdrdy_Msk                (0x2000000UL)             /*!< rdrdy (Bitfield-Mask: 0x01)                           */
#define AES_CREG_c_wrrdy_Pos              (26UL)                    /*!< c_wrrdy (Bit 26)                                      */
#define AES_CREG_c_wrrdy_Msk              (0x4000000UL)             /*!< c_wrrdy (Bitfield-Mask: 0x01)                         */
#define AES_CREG_iv_wrrdy_Pos             (27UL)                    /*!< iv_wrrdy (Bit 27)                                     */
#define AES_CREG_iv_wrrdy_Msk             (0x8000000UL)             /*!< iv_wrrdy (Bitfield-Mask: 0x01)                        */
#define AES_CREG_iv_rdrdy_Pos             (28UL)                    /*!< iv_rdrdy (Bit 28)                                     */
#define AES_CREG_iv_rdrdy_Msk             (0x10000000UL)            /*!< iv_rdrdy (Bitfield-Mask: 0x01)                        */
#define AES_CREG_k0_wrrdy_Pos             (29UL)                    /*!< k0_wrrdy (Bit 29)                                     */
#define AES_CREG_k0_wrrdy_Msk             (0x20000000UL)            /*!< k0_wrrdy (Bitfield-Mask: 0x01)                        */
#define AES_CREG_k1_wrrdy_Pos             (30UL)                    /*!< k1_wrrdy (Bit 30)                                     */
#define AES_CREG_k1_wrrdy_Msk             (0x40000000UL)            /*!< k1_wrrdy (Bitfield-Mask: 0x01)                        */
#define AES_CREG_illegal_op_Pos           (31UL)                    /*!< illegal_op (Bit 31)                                   */
#define AES_CREG_illegal_op_Msk           (0x80000000UL)            /*!< illegal_op (Bitfield-Mask: 0x01)                      */
/* =========================================================  DWIN  ========================================================== */
/* ==========================================================  IV  =========================================================== */
/* =========================================================  KEY0  ========================================================== */
/* =========================================================  KEY1  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            IIR                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  I0IIRCTL  ======================================================== */
#define IIR_I0IIRCTL_IIREN_Pos            (0UL)                     /*!< IIREN (Bit 0)                                         */
#define IIR_I0IIRCTL_IIREN_Msk            (0x1UL)                   /*!< IIREN (Bitfield-Mask: 0x01)                           */
#define IIR_I0IIRCTL_WRFULL_Pos           (8UL)                     /*!< WRFULL (Bit 8)                                        */
#define IIR_I0IIRCTL_WRFULL_Msk           (0x100UL)                 /*!< WRFULL (Bitfield-Mask: 0x01)                          */
#define IIR_I0IIRCTL_WREMPT_Pos           (9UL)                     /*!< WREMPT (Bit 9)                                        */
#define IIR_I0IIRCTL_WREMPT_Msk           (0x200UL)                 /*!< WREMPT (Bitfield-Mask: 0x01)                          */
#define IIR_I0IIRCTL_RDFULL_Pos           (10UL)                    /*!< RDFULL (Bit 10)                                       */
#define IIR_I0IIRCTL_RDFULL_Msk           (0x400UL)                 /*!< RDFULL (Bitfield-Mask: 0x01)                          */
#define IIR_I0IIRCTL_RDEMPT_Pos           (11UL)                    /*!< RDEMPT (Bit 11)                                       */
#define IIR_I0IIRCTL_RDEMPT_Msk           (0x800UL)                 /*!< RDEMPT (Bitfield-Mask: 0x01)                          */
#define IIR_I0IIRCTL_SATURATION_Pos       (12UL)                    /*!< SATURATION (Bit 12)                                   */
#define IIR_I0IIRCTL_SATURATION_Msk       (0x1000UL)                /*!< SATURATION (Bitfield-Mask: 0x01)                      */
/* =======================================================  I1IIRCTL  ======================================================== */
#define IIR_I1IIRCTL_IIREN_Pos            (0UL)                     /*!< IIREN (Bit 0)                                         */
#define IIR_I1IIRCTL_IIREN_Msk            (0x1UL)                   /*!< IIREN (Bitfield-Mask: 0x01)                           */
#define IIR_I1IIRCTL_WRFULL_Pos           (8UL)                     /*!< WRFULL (Bit 8)                                        */
#define IIR_I1IIRCTL_WRFULL_Msk           (0x100UL)                 /*!< WRFULL (Bitfield-Mask: 0x01)                          */
#define IIR_I1IIRCTL_WREMPT_Pos           (9UL)                     /*!< WREMPT (Bit 9)                                        */
#define IIR_I1IIRCTL_WREMPT_Msk           (0x200UL)                 /*!< WREMPT (Bitfield-Mask: 0x01)                          */
#define IIR_I1IIRCTL_RDFULL_Pos           (10UL)                    /*!< RDFULL (Bit 10)                                       */
#define IIR_I1IIRCTL_RDFULL_Msk           (0x400UL)                 /*!< RDFULL (Bitfield-Mask: 0x01)                          */
#define IIR_I1IIRCTL_RDEMPT_Pos           (11UL)                    /*!< RDEMPT (Bit 11)                                       */
#define IIR_I1IIRCTL_RDEMPT_Msk           (0x800UL)                 /*!< RDEMPT (Bitfield-Mask: 0x01)                          */
#define IIR_I1IIRCTL_SATURATION_Pos       (12UL)                    /*!< SATURATION (Bit 12)                                   */
#define IIR_I1IIRCTL_SATURATION_Msk       (0x1000UL)                /*!< SATURATION (Bitfield-Mask: 0x01)                      */
/* =======================================================  I0A1COEF  ======================================================== */
#define IIR_I0A1COEF_A1COEF_Pos           (0UL)                     /*!< A1COEF (Bit 0)                                        */
#define IIR_I0A1COEF_A1COEF_Msk           (0xfUL)                   /*!< A1COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I1A1COEF  ======================================================== */
#define IIR_I1A1COEF_A1COEF_Pos           (0UL)                     /*!< A1COEF (Bit 0)                                        */
#define IIR_I1A1COEF_A1COEF_Msk           (0xfUL)                   /*!< A1COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I0A2COEF  ======================================================== */
#define IIR_I0A2COEF_A2COEF_Pos           (0UL)                     /*!< A2COEF (Bit 0)                                        */
#define IIR_I0A2COEF_A2COEF_Msk           (0xfUL)                   /*!< A2COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I1A2COEF  ======================================================== */
#define IIR_I1A2COEF_A2COEF_Pos           (0UL)                     /*!< A2COEF (Bit 0)                                        */
#define IIR_I1A2COEF_A2COEF_Msk           (0xfUL)                   /*!< A2COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I0B0COEF  ======================================================== */
#define IIR_I0B0COEF_B0COEF_Pos           (0UL)                     /*!< B0COEF (Bit 0)                                        */
#define IIR_I0B0COEF_B0COEF_Msk           (0xfUL)                   /*!< B0COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I1B0COEF  ======================================================== */
#define IIR_I1B0COEF_B0COEF_Pos           (0UL)                     /*!< B0COEF (Bit 0)                                        */
#define IIR_I1B0COEF_B0COEF_Msk           (0xfUL)                   /*!< B0COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I0B1COEF  ======================================================== */
#define IIR_I0B1COEF_B1COEF_Pos           (0UL)                     /*!< B1COEF (Bit 0)                                        */
#define IIR_I0B1COEF_B1COEF_Msk           (0xfUL)                   /*!< B1COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I1B1COEF  ======================================================== */
#define IIR_I1B1COEF_B1COEF_Pos           (0UL)                     /*!< B1COEF (Bit 0)                                        */
#define IIR_I1B1COEF_B1COEF_Msk           (0xfUL)                   /*!< B1COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I0B2COEF  ======================================================== */
#define IIR_I0B2COEF_B2COEF_Pos           (0UL)                     /*!< B2COEF (Bit 0)                                        */
#define IIR_I0B2COEF_B2COEF_Msk           (0xfUL)                   /*!< B2COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I1B2COEF  ======================================================== */
#define IIR_I1B2COEF_B2COEF_Pos           (0UL)                     /*!< B2COEF (Bit 0)                                        */
#define IIR_I1B2COEF_B2COEF_Msk           (0xfUL)                   /*!< B2COEF (Bitfield-Mask: 0x0f)                          */
/* =======================================================  I0DATAIN  ======================================================== */
/* =======================================================  I1DATAIN  ======================================================== */
/* =======================================================  I0DATAOUT  ======================================================= */
/* =======================================================  I1DATAOUT  ======================================================= */
/* =======================================================  IIRMDCTL  ======================================================== */
#define IIR_IIRMDCTL_IIRMD_Pos            (0UL)                     /*!< IIRMD (Bit 0)                                         */
#define IIR_IIRMDCTL_IIRMD_Msk            (0x1UL)                   /*!< IIRMD (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ELCR  ========================================================== */
#define ELC_ELCR_ELCON_Pos                (15UL)                    /*!< ELCON (Bit 15)                                        */
#define ELC_ELCR_ELCON_Msk                (0x8000UL)                /*!< ELCON (Bitfield-Mask: 0x01)                           */
/* ========================================================  ELSR00  ========================================================= */
/* ========================================================  ELSR01  ========================================================= */
/* ========================================================  ELSR02  ========================================================= */
/* ========================================================  ELSR03  ========================================================= */
/* ========================================================  ELSR04  ========================================================= */
/* ========================================================  ELSR05  ========================================================= */
/* ========================================================  ELSR06  ========================================================= */
/* ========================================================  ELSR07  ========================================================= */
/* ========================================================  ELSR08  ========================================================= */
/* ========================================================  ELSR09  ========================================================= */
/* ========================================================  ELSR10  ========================================================= */
/* ========================================================  ELSR11  ========================================================= */
/* ========================================================  ELSR12  ========================================================= */
/* ========================================================  ELSR13  ========================================================= */
/* ========================================================  ELSR14  ========================================================= */
/* ========================================================  ELSR15  ========================================================= */
/* ========================================================  ELSR16  ========================================================= */
/* ========================================================  ELSR17  ========================================================= */
/* ========================================================  ELSR18  ========================================================= */
/* ========================================================  ELSR19  ========================================================= */
/* ========================================================  ELSR20  ========================================================= */
/* ========================================================  ELSR21  ========================================================= */
/* ========================================================  ELSR22  ========================================================= */
/* ========================================================  ELSR23  ========================================================= */
/* ========================================================  ELSR24  ========================================================= */
/* ========================================================  ELSR25  ========================================================= */
/* ========================================================  ELSR26  ========================================================= */
/* ========================================================  ELSR27  ========================================================= */
/* ========================================================  ELSR28  ========================================================= */
/* ========================================================  ELSR29  ========================================================= */
/* ========================================================  ELSR30  ========================================================= */
/* ========================================================  ELSR31  ========================================================= */
/* ========================================================  ELSR32  ========================================================= */


/* =========================================================================================================================== */
/* ================                                           ADC0                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ADCSR  ========================================================= */
#define ADC0_ADCSR_DBLANS_Pos             (0UL)                     /*!< DBLANS (Bit 0)                                        */
#define ADC0_ADCSR_DBLANS_Msk             (0x1fUL)                  /*!< DBLANS (Bitfield-Mask: 0x1f)                          */
#define ADC0_ADCSR_GBADIE_Pos             (6UL)                     /*!< GBADIE (Bit 6)                                        */
#define ADC0_ADCSR_GBADIE_Msk             (0x40UL)                  /*!< GBADIE (Bitfield-Mask: 0x01)                          */
#define ADC0_ADCSR_DBLE_Pos               (7UL)                     /*!< DBLE (Bit 7)                                          */
#define ADC0_ADCSR_DBLE_Msk               (0x80UL)                  /*!< DBLE (Bitfield-Mask: 0x01)                            */
#define ADC0_ADCSR_EXTRG_Pos              (8UL)                     /*!< EXTRG (Bit 8)                                         */
#define ADC0_ADCSR_EXTRG_Msk              (0x100UL)                 /*!< EXTRG (Bitfield-Mask: 0x01)                           */
#define ADC0_ADCSR_TRGE_Pos               (9UL)                     /*!< TRGE (Bit 9)                                          */
#define ADC0_ADCSR_TRGE_Msk               (0x200UL)                 /*!< TRGE (Bitfield-Mask: 0x01)                            */
#define ADC0_ADCSR_ADIE_Pos               (12UL)                    /*!< ADIE (Bit 12)                                         */
#define ADC0_ADCSR_ADIE_Msk               (0x1000UL)                /*!< ADIE (Bitfield-Mask: 0x01)                            */
#define ADC0_ADCSR_ADCS_Pos               (13UL)                    /*!< ADCS (Bit 13)                                         */
#define ADC0_ADCSR_ADCS_Msk               (0x6000UL)                /*!< ADCS (Bitfield-Mask: 0x03)                            */
#define ADC0_ADCSR_ADST_Pos               (15UL)                    /*!< ADST (Bit 15)                                         */
#define ADC0_ADCSR_ADST_Msk               (0x8000UL)                /*!< ADST (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSA0  ======================================================== */
#define ADC0_ADANSA_ANSA0_Pos            (0UL)                     /*!< ANSA0 (Bit 0)                                         */
#define ADC0_ADANSA_ANSA0_Msk            (0xffUL)                  /*!< ANSA0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSA1  ======================================================== */
//#define ADC0_ADANSA1_ANSA1_Pos            (0UL)                     /*!< ANSA1 (Bit 0)                                         */
//#define ADC0_ADANSA1_ANSA1_Msk            (0x1UL)                   /*!< ANSA1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  ADADS0  ========================================================= */
#define ADC0_ADADS_ADS00_Pos             (0UL)                     /*!< ADS00 (Bit 0)                                         */
#define ADC0_ADADS_ADS00_Msk             (0xffUL)                  /*!< ADS00 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADADS1  ========================================================= */
//#define ADC0_ADADS1_ADS10_Pos             (0UL)                     /*!< ADS10 (Bit 0)                                         */
//#define ADC0_ADADS1_ADS10_Msk             (0x1UL)                   /*!< ADS10 (Bitfield-Mask: 0x01)                           */
/* =========================================================  ADADC  ========================================================= */
#define ADC0_ADADC_ADC_Pos                (0UL)                     /*!< ADC (Bit 0)                                           */
#define ADC0_ADADC_ADC_Msk                (0x7UL)                   /*!< ADC (Bitfield-Mask: 0x07)                             */
#define ADC0_ADADC_AVEE_Pos               (7UL)                     /*!< AVEE (Bit 7)                                          */
#define ADC0_ADADC_AVEE_Msk               (0x80UL)                  /*!< AVEE (Bitfield-Mask: 0x01)                            */
/* =========================================================  ADCER  ========================================================= */
#define ADC0_ADCER_ACE_Pos                (5UL)                     /*!< ACE (Bit 5)                                           */
#define ADC0_ADCER_ACE_Msk                (0x20UL)                  /*!< ACE (Bitfield-Mask: 0x01)                             */
#define ADC0_ADCER_DLAGVAL_Pos            (8UL)                     /*!< DLAGVAL (Bit 8)                                       */
#define ADC0_ADCER_DLAGVAL_Msk            (0x300UL)                 /*!< DLAGVAL (Bitfield-Mask: 0x03)                         */
#define ADC0_ADCER_DIAGLD_Pos             (10UL)                    /*!< DIAGLD (Bit 10)                                       */
#define ADC0_ADCER_DIAGLD_Msk             (0x400UL)                 /*!< DIAGLD (Bitfield-Mask: 0x01)                          */
#define ADC0_ADCER_DIAGM_Pos              (11UL)                    /*!< DIAGM (Bit 11)                                        */
#define ADC0_ADCER_DIAGM_Msk              (0x800UL)                 /*!< DIAGM (Bitfield-Mask: 0x01)                           */
#define ADC0_ADCER_ADRFMT_Pos             (15UL)                    /*!< ADRFMT (Bit 15)                                       */
#define ADC0_ADCER_ADRFMT_Msk             (0x8000UL)                /*!< ADRFMT (Bitfield-Mask: 0x01)                          */
/* ========================================================  ADSTRGR  ======================================================== */
#define ADC0_ADSTRGR_TRSB_Pos             (0UL)                     /*!< TRSB (Bit 0)                                          */
#define ADC0_ADSTRGR_TRSB_Msk             (0x3fUL)                  /*!< TRSB (Bitfield-Mask: 0x3f)                            */
#define ADC0_ADSTRGR_TRSA_Pos             (8UL)                     /*!< TRSA (Bit 8)                                          */
#define ADC0_ADSTRGR_TRSA_Msk             (0x3f00UL)                /*!< TRSA (Bitfield-Mask: 0x3f)                            */
/* ========================================================  ADEXICR  ======================================================== */
#define ADC0_ADEXICR_OCSAD_Pos            (1UL)                     /*!< OCSAD (Bit 1)                                         */
#define ADC0_ADEXICR_OCSAD_Msk            (0x2UL)                   /*!< OCSAD (Bitfield-Mask: 0x01)                           */
#define ADC0_ADEXICR_OCSA_Pos             (9UL)                     /*!< OCSA (Bit 9)                                          */
#define ADC0_ADEXICR_OCSA_Msk             (0x200UL)                 /*!< OCSA (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSB0  ======================================================== */
#define ADC0_ADANSB_ANSB0_Pos            (0UL)                     /*!< ANSB0 (Bit 0)                                         */
#define ADC0_ADANSB_ANSB0_Msk            (0xfUL)                   /*!< ANSB0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSB1  ======================================================== */
//#define ADC0_ADANSB1_ANSB1_Pos            (0UL)                     /*!< ANSB1 (Bit 0)                                         */
//#define ADC0_ADANSB1_ANSB1_Msk            (0x1UL)                   /*!< ANSB1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  ADDBLDR  ======================================================== */
/* =========================================================  ADRD  ========================================================== */
/* =========================================================  ADDR0  ========================================================= */
/* =========================================================  ADDR1  ========================================================= */
/* =========================================================  ADDR2  ========================================================= */
/* =========================================================  ADDR3  ========================================================= */
/* =========================================================  ADDR4  ========================================================= */
/* =========================================================  ADDR5  ========================================================= */
/* =========================================================  ADDR6  ========================================================= */
/* =========================================================  ADDR7  ========================================================= */
/* =========================================================  ADDR8  ========================================================= */
/* =========================================================  ADDR9  ========================================================= */
/* ========================================================  ADDR10  ========================================================= */
/* ========================================================  ADDR11  ========================================================= */
/* ========================================================  ADDR12  ========================================================= */
/* ========================================================  ADDR13  ========================================================= */
/* ========================================================  ADDR14  ========================================================= */
/* ========================================================  ADDR15  ========================================================= */
/* ========================================================  ADDR16  ========================================================= */
/* ========================================================  ADDR17  ========================================================= */
/* ========================================================  ADDR18  ========================================================= */
/* ========================================================  ADDR19  ========================================================= */
/* ========================================================  ADDR20  ========================================================= */
/* ========================================================  ADDR21  ========================================================= */
/* ========================================================  ADDR22  ========================================================= */
/* ========================================================  ADDR23  ========================================================= */
/* ========================================================  ADDR24  ========================================================= */
/* ========================================================  ADDR25  ========================================================= */
/* ========================================================  ADDR26  ========================================================= */
/* ========================================================  ADDR27  ========================================================= */
/* ========================================================  ADDR28  ========================================================= */
/* ========================================================  ADDR29  ========================================================= */
/* ========================================================  ADDR30  ========================================================= */
/* ========================================================  ADDR31  ========================================================= */
/* =======================================================  ADCLKDIV  ======================================================== */
/* ========================================================  ADSHCR  ========================================================= */
#define ADC0_ADSHCR_SSTSH_Pos             (0UL)                     /*!< SSTSH (Bit 0)                                         */
#define ADC0_ADSHCR_SSTSH_Msk             (0xffUL)                  /*!< SSTSH (Bitfield-Mask: 0xff)                           */
#define ADC0_ADSHCR_SHANS_Pos             (8UL)                     /*!< SHANS (Bit 8)                                         */
#define ADC0_ADSHCR_SHANS_Msk             (0x700UL)                 /*!< SHANS (Bitfield-Mask: 0x07)                           */
/* ========================================================  ADDISCR  ======================================================== */
#define ADC0_ADDISCR_ADNDIS_Pos           (0UL)                     /*!< ADNDIS (Bit 0)                                        */
#define ADC0_ADDISCR_ADNDIS_Msk           (0x1fUL)                  /*!< ADNDIS (Bitfield-Mask: 0x1f)                          */
/* ========================================================  ADGSPCR  ======================================================== */
#define ADC0_ADGSPCR_PGS_Pos              (0UL)                     /*!< PGS (Bit 0)                                           */
#define ADC0_ADGSPCR_PGS_Msk              (0x1UL)                   /*!< PGS (Bitfield-Mask: 0x01)                             */
#define ADC0_ADGSPCR_GBRSCN_Pos           (1UL)                     /*!< GBRSCN (Bit 1)                                        */
#define ADC0_ADGSPCR_GBRSCN_Msk           (0x2UL)                   /*!< GBRSCN (Bitfield-Mask: 0x01)                          */
#define ADC0_ADGSPCR_LGRRS_Pos            (14UL)                    /*!< LGRRS (Bit 14)                                        */
#define ADC0_ADGSPCR_LGRRS_Msk            (0x4000UL)                /*!< LGRRS (Bitfield-Mask: 0x01)                           */
#define ADC0_ADGSPCR_GBRP_Pos             (15UL)                    /*!< GBRP (Bit 15)                                         */
#define ADC0_ADGSPCR_GBRP_Msk             (0x8000UL)                /*!< GBRP (Bitfield-Mask: 0x01)                            */
/* =======================================================  ADDBLDRA  ======================================================== */
/* =======================================================  ADDBLDRB  ======================================================== */
/* ========================================================  ADANSC0  ======================================================== */
#define ADC0_ADANSC_ANSC0_Pos            (0UL)                     /*!< ANSC0 (Bit 0)                                         */
#define ADC0_ADANSC_ANSC0_Msk            (0xfUL)                   /*!< ANSC0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSC1  ======================================================== */
//#define ADC0_ADANSC1_ANSC1_Pos            (0UL)                     /*!< ANSC1 (Bit 0)                                         */
//#define ADC0_ADANSC1_ANSC1_Msk            (0x1UL)                   /*!< ANSC1 (Bitfield-Mask: 0x01)                           */
/* =======================================================  ADGCTRGR  ======================================================== */
#define ADC0_ADGCTRGR_TRSC_Pos            (0UL)                     /*!< TRSC (Bit 0)                                          */
#define ADC0_ADGCTRGR_TRSC_Msk            (0x3fUL)                  /*!< TRSC (Bitfield-Mask: 0x3f)                            */
#define ADC0_ADGCTRGR_GCADIE_Pos          (6UL)                     /*!< GCADIE (Bit 6)                                        */
#define ADC0_ADGCTRGR_GCADIE_Msk          (0x40UL)                  /*!< GCADIE (Bitfield-Mask: 0x01)                          */
#define ADC0_ADGCTRGR_GRCE_Pos            (7UL)                     /*!< GRCE (Bit 7)                                          */
#define ADC0_ADGCTRGR_GRCE_Msk            (0x80UL)                  /*!< GRCE (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADSSTRL  ======================================================== */
/* ========================================================  ADSSTRO  ======================================================== */
/* ========================================================  ADSSTR0  ======================================================== */
/* ========================================================  ADSSTR1  ======================================================== */
/* ========================================================  ADSSTR2  ======================================================== */
/* ========================================================  ADSSTR3  ======================================================== */
/* ========================================================  ADSSTR4  ======================================================== */
/* ========================================================  ADSSTR5  ======================================================== */
/* ========================================================  ADSSTR6  ======================================================== */
/* ========================================================  ADSSTR7  ======================================================== */
/* ========================================================  ADSSTR8  ======================================================== */
/* ========================================================  ADSSTR9  ======================================================== */
/* =======================================================  ADSSTR10  ======================================================== */
/* =======================================================  ADSSTR11  ======================================================== */
/* =======================================================  ADSSTR12  ======================================================== */
/* =======================================================  ADSSTR13  ======================================================== */
/* =======================================================  ADSSTR14  ======================================================== */
/* =======================================================  ADSSTR15  ======================================================== */
/* ========================================================  ADPGACR  ======================================================== */
#define ADC0_ADPGACR_P00SW_Pos            (1UL)                     /*!< P00SW (Bit 1)                                         */
#define ADC0_ADPGACR_P00SW_Msk            (0x2UL)                   /*!< P00SW (Bitfield-Mask: 0x01)                           */
#define ADC0_ADPGACR_P00EN_Pos            (2UL)                     /*!< P00EN (Bit 2)                                         */
#define ADC0_ADPGACR_P00EN_Msk            (0x4UL)                   /*!< P00EN (Bitfield-Mask: 0x01)                           */
#define ADC0_ADPGACR_P00MODE_Pos          (3UL)                     /*!< P00MODE (Bit 3)                                       */
#define ADC0_ADPGACR_P00MODE_Msk          (0x8UL)                   /*!< P00MODE (Bitfield-Mask: 0x01)                         */
/* ========================================================  ADPGAGS  ======================================================== */
#define ADC0_ADPGAGS_P00GAIN_Pos          (0UL)                     /*!< P00GAIN (Bit 0)                                       */
#define ADC0_ADPGAGS_P00GAIN_Msk          (0xfUL)                   /*!< P00GAIN (Bitfield-Mask: 0x0f)                         */
/* =======================================================  ADPGADCR  ======================================================== */
#define ADC0_ADPGADCR_P00GNDSEL_Pos       (3UL)                     /*!< P00GNDSEL (Bit 3)                                     */
#define ADC0_ADPGADCR_P00GNDSEL_Msk       (0x8UL)                   /*!< P00GNDSEL (Bitfield-Mask: 0x01)                       */


/* =========================================================================================================================== */
/* ================                                           ADC1                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ADCSR  ========================================================= */
#define ADC1_ADCSR_DBLANS_Pos             (0UL)                     /*!< DBLANS (Bit 0)                                        */
#define ADC1_ADCSR_DBLANS_Msk             (0x1fUL)                  /*!< DBLANS (Bitfield-Mask: 0x1f)                          */
#define ADC1_ADCSR_GBADIE_Pos             (6UL)                     /*!< GBADIE (Bit 6)                                        */
#define ADC1_ADCSR_GBADIE_Msk             (0x40UL)                  /*!< GBADIE (Bitfield-Mask: 0x01)                          */
#define ADC1_ADCSR_DBLE_Pos               (7UL)                     /*!< DBLE (Bit 7)                                          */
#define ADC1_ADCSR_DBLE_Msk               (0x80UL)                  /*!< DBLE (Bitfield-Mask: 0x01)                            */
#define ADC1_ADCSR_EXTRG_Pos              (8UL)                     /*!< EXTRG (Bit 8)                                         */
#define ADC1_ADCSR_EXTRG_Msk              (0x100UL)                 /*!< EXTRG (Bitfield-Mask: 0x01)                           */
#define ADC1_ADCSR_TRGE_Pos               (9UL)                     /*!< TRGE (Bit 9)                                          */
#define ADC1_ADCSR_TRGE_Msk               (0x200UL)                 /*!< TRGE (Bitfield-Mask: 0x01)                            */
#define ADC1_ADCSR_ADIE_Pos               (12UL)                    /*!< ADIE (Bit 12)                                         */
#define ADC1_ADCSR_ADIE_Msk               (0x1000UL)                /*!< ADIE (Bitfield-Mask: 0x01)                            */
#define ADC1_ADCSR_ADCS_Pos               (13UL)                    /*!< ADCS (Bit 13)                                         */
#define ADC1_ADCSR_ADCS_Msk               (0x6000UL)                /*!< ADCS (Bitfield-Mask: 0x03)                            */
#define ADC1_ADCSR_ADST_Pos               (15UL)                    /*!< ADST (Bit 15)                                         */
#define ADC1_ADCSR_ADST_Msk               (0x8000UL)                /*!< ADST (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSA0  ======================================================== */
#define ADC1_ADANSA_ANSA0_Pos            (0UL)                     /*!< ANSA0 (Bit 0)                                         */
#define ADC1_ADANSA_ANSA0_Msk            (0xffUL)                  /*!< ANSA0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSA1  ======================================================== */
//#define ADC1_ADANSA1_ANSA1_Pos            (0UL)                     /*!< ANSA1 (Bit 0)                                         */
//#define ADC1_ADANSA1_ANSA1_Msk            (0x1UL)                   /*!< ANSA1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  ADADS0  ========================================================= */
#define ADC1_ADADS_ADS00_Pos             (0UL)                     /*!< ADS00 (Bit 0)                                         */
#define ADC1_ADADS_ADS00_Msk             (0xffUL)                  /*!< ADS00 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADADS1  ========================================================= */
//#define ADC1_ADADS1_ADS10_Pos             (0UL)                     /*!< ADS10 (Bit 0)                                         */
//#define ADC1_ADADS1_ADS10_Msk             (0x1UL)                   /*!< ADS10 (Bitfield-Mask: 0x01)                           */
/* =========================================================  ADADC  ========================================================= */
#define ADC1_ADADC_ADC_Pos                (0UL)                     /*!< ADC (Bit 0)                                           */
#define ADC1_ADADC_ADC_Msk                (0x7UL)                   /*!< ADC (Bitfield-Mask: 0x07)                             */
#define ADC1_ADADC_AVEE_Pos               (7UL)                     /*!< AVEE (Bit 7)                                          */
#define ADC1_ADADC_AVEE_Msk               (0x80UL)                  /*!< AVEE (Bitfield-Mask: 0x01)                            */
/* =========================================================  ADCER  ========================================================= */
#define ADC1_ADCER_ACE_Pos                (5UL)                     /*!< ACE (Bit 5)                                           */
#define ADC1_ADCER_ACE_Msk                (0x20UL)                  /*!< ACE (Bitfield-Mask: 0x01)                             */
#define ADC1_ADCER_DLAGVAL_Pos            (8UL)                     /*!< DLAGVAL (Bit 8)                                       */
#define ADC1_ADCER_DLAGVAL_Msk            (0x300UL)                 /*!< DLAGVAL (Bitfield-Mask: 0x03)                         */
#define ADC1_ADCER_DIAGLD_Pos             (10UL)                    /*!< DIAGLD (Bit 10)                                       */
#define ADC1_ADCER_DIAGLD_Msk             (0x400UL)                 /*!< DIAGLD (Bitfield-Mask: 0x01)                          */
#define ADC1_ADCER_DIAGM_Pos              (11UL)                    /*!< DIAGM (Bit 11)                                        */
#define ADC1_ADCER_DIAGM_Msk              (0x800UL)                 /*!< DIAGM (Bitfield-Mask: 0x01)                           */
#define ADC1_ADCER_ADRFMT_Pos             (15UL)                    /*!< ADRFMT (Bit 15)                                       */
#define ADC1_ADCER_ADRFMT_Msk             (0x8000UL)                /*!< ADRFMT (Bitfield-Mask: 0x01)                          */
/* ========================================================  ADSTRGR  ======================================================== */
#define ADC1_ADSTRGR_TRSB_Pos             (0UL)                     /*!< TRSB (Bit 0)                                          */
#define ADC1_ADSTRGR_TRSB_Msk             (0x3fUL)                  /*!< TRSB (Bitfield-Mask: 0x3f)                            */
#define ADC1_ADSTRGR_TRSA_Pos             (8UL)                     /*!< TRSA (Bit 8)                                          */
#define ADC1_ADSTRGR_TRSA_Msk             (0x3f00UL)                /*!< TRSA (Bitfield-Mask: 0x3f)                            */
/* ========================================================  ADEXICR  ======================================================== */
#define ADC1_ADEXICR_OCSAD_Pos            (1UL)                     /*!< OCSAD (Bit 1)                                         */
#define ADC1_ADEXICR_OCSAD_Msk            (0x2UL)                   /*!< OCSAD (Bitfield-Mask: 0x01)                           */
#define ADC1_ADEXICR_OCSA_Pos             (9UL)                     /*!< OCSA (Bit 9)                                          */
#define ADC1_ADEXICR_OCSA_Msk             (0x200UL)                 /*!< OCSA (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSB0  ======================================================== */
#define ADC1_ADANSB_ANSB0_Pos            (0UL)                     /*!< ANSB0 (Bit 0)                                         */
#define ADC1_ADANSB_ANSB0_Msk            (0xfUL)                   /*!< ANSB0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSB1  ======================================================== */
//#define ADC1_ADANSB1_ANSB1_Pos            (0UL)                     /*!< ANSB1 (Bit 0)                                         */
//#define ADC1_ADANSB1_ANSB1_Msk            (0x1UL)                   /*!< ANSB1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  ADDBLDR  ======================================================== */
/* =========================================================  ADRD  ========================================================== */
/* =========================================================  ADDR0  ========================================================= */
/* =========================================================  ADDR1  ========================================================= */
/* =========================================================  ADDR2  ========================================================= */
/* =========================================================  ADDR3  ========================================================= */
/* =========================================================  ADDR4  ========================================================= */
/* =========================================================  ADDR5  ========================================================= */
/* =========================================================  ADDR6  ========================================================= */
/* =========================================================  ADDR7  ========================================================= */
/* =========================================================  ADDR8  ========================================================= */
/* =========================================================  ADDR9  ========================================================= */
/* ========================================================  ADDR10  ========================================================= */
/* ========================================================  ADDR11  ========================================================= */
/* ========================================================  ADDR12  ========================================================= */
/* ========================================================  ADDR13  ========================================================= */
/* ========================================================  ADDR14  ========================================================= */
/* ========================================================  ADDR15  ========================================================= */
/* ========================================================  ADDR16  ========================================================= */
/* ========================================================  ADDR17  ========================================================= */
/* ========================================================  ADDR18  ========================================================= */
/* ========================================================  ADDR19  ========================================================= */
/* ========================================================  ADDR20  ========================================================= */
/* ========================================================  ADDR21  ========================================================= */
/* ========================================================  ADDR22  ========================================================= */
/* ========================================================  ADDR23  ========================================================= */
/* ========================================================  ADDR24  ========================================================= */
/* ========================================================  ADDR25  ========================================================= */
/* ========================================================  ADDR26  ========================================================= */
/* ========================================================  ADDR27  ========================================================= */
/* ========================================================  ADDR28  ========================================================= */
/* ========================================================  ADDR29  ========================================================= */
/* ========================================================  ADDR30  ========================================================= */
/* ========================================================  ADDR31  ========================================================= */
/* =======================================================  ADCLKDIV  ======================================================== */
/* ========================================================  ADSHCR  ========================================================= */
#define ADC1_ADSHCR_SSTSH_Pos             (0UL)                     /*!< SSTSH (Bit 0)                                         */
#define ADC1_ADSHCR_SSTSH_Msk             (0xffUL)                  /*!< SSTSH (Bitfield-Mask: 0xff)                           */
#define ADC1_ADSHCR_SHANS_Pos             (8UL)                     /*!< SHANS (Bit 8)                                         */
#define ADC1_ADSHCR_SHANS_Msk             (0x700UL)                 /*!< SHANS (Bitfield-Mask: 0x07)                           */
/* ========================================================  ADDISCR  ======================================================== */
#define ADC1_ADDISCR_ADNDIS_Pos           (0UL)                     /*!< ADNDIS (Bit 0)                                        */
#define ADC1_ADDISCR_ADNDIS_Msk           (0x1fUL)                  /*!< ADNDIS (Bitfield-Mask: 0x1f)                          */
/* ========================================================  ADGSPCR  ======================================================== */
#define ADC1_ADGSPCR_PGS_Pos              (0UL)                     /*!< PGS (Bit 0)                                           */
#define ADC1_ADGSPCR_PGS_Msk              (0x1UL)                   /*!< PGS (Bitfield-Mask: 0x01)                             */
#define ADC1_ADGSPCR_GBRSCN_Pos           (1UL)                     /*!< GBRSCN (Bit 1)                                        */
#define ADC1_ADGSPCR_GBRSCN_Msk           (0x2UL)                   /*!< GBRSCN (Bitfield-Mask: 0x01)                          */
#define ADC1_ADGSPCR_LGRRS_Pos            (14UL)                    /*!< LGRRS (Bit 14)                                        */
#define ADC1_ADGSPCR_LGRRS_Msk            (0x4000UL)                /*!< LGRRS (Bitfield-Mask: 0x01)                           */
#define ADC1_ADGSPCR_GBRP_Pos             (15UL)                    /*!< GBRP (Bit 15)                                         */
#define ADC1_ADGSPCR_GBRP_Msk             (0x8000UL)                /*!< GBRP (Bitfield-Mask: 0x01)                            */
/* =======================================================  ADDBLDRA  ======================================================== */
/* =======================================================  ADDBLDRB  ======================================================== */
/* ========================================================  ADANSC0  ======================================================== */
#define ADC1_ADANSC_ANSC0_Pos            (0UL)                     /*!< ANSC0 (Bit 0)                                         */
#define ADC1_ADANSC_ANSC0_Msk            (0xfUL)                   /*!< ANSC0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  ADANSC1  ======================================================== */
//#define ADC1_ADANSC1_ANSC1_Pos            (0UL)                     /*!< ANSC1 (Bit 0)                                         */
//#define ADC1_ADANSC1_ANSC1_Msk            (0x1UL)                   /*!< ANSC1 (Bitfield-Mask: 0x01)                           */
/* =======================================================  ADGCTRGR  ======================================================== */
#define ADC1_ADGCTRGR_TRSC_Pos            (0UL)                     /*!< TRSC (Bit 0)                                          */
#define ADC1_ADGCTRGR_TRSC_Msk            (0x3fUL)                  /*!< TRSC (Bitfield-Mask: 0x3f)                            */
#define ADC1_ADGCTRGR_GCADIE_Pos          (6UL)                     /*!< GCADIE (Bit 6)                                        */
#define ADC1_ADGCTRGR_GCADIE_Msk          (0x40UL)                  /*!< GCADIE (Bitfield-Mask: 0x01)                          */
#define ADC1_ADGCTRGR_GRCE_Pos            (7UL)                     /*!< GRCE (Bit 7)                                          */
#define ADC1_ADGCTRGR_GRCE_Msk            (0x80UL)                  /*!< GRCE (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADSSTRL  ======================================================== */
/* ========================================================  ADSSTRO  ======================================================== */
/* ========================================================  ADSSTR0  ======================================================== */
/* ========================================================  ADSSTR1  ======================================================== */
/* ========================================================  ADSSTR2  ======================================================== */
/* ========================================================  ADSSTR3  ======================================================== */
/* ========================================================  ADSSTR4  ======================================================== */
/* ========================================================  ADSSTR5  ======================================================== */
/* ========================================================  ADSSTR6  ======================================================== */
/* ========================================================  ADSSTR7  ======================================================== */
/* ========================================================  ADSSTR8  ======================================================== */
/* ========================================================  ADSSTR9  ======================================================== */
/* =======================================================  ADSSTR10  ======================================================== */
/* =======================================================  ADSSTR11  ======================================================== */
/* =======================================================  ADSSTR12  ======================================================== */
/* =======================================================  ADSSTR13  ======================================================== */
/* =======================================================  ADSSTR14  ======================================================== */
/* =======================================================  ADSSTR15  ======================================================== */
/* ========================================================  ADPGACR  ======================================================== */
#define ADC1_ADPGACR_P10SW_Pos            (1UL)                     /*!< P10SW (Bit 1)                                         */
#define ADC1_ADPGACR_P10SW_Msk            (0x2UL)                   /*!< P10SW (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P10EN_Pos            (2UL)                     /*!< P10EN (Bit 2)                                         */
#define ADC1_ADPGACR_P10EN_Msk            (0x4UL)                   /*!< P10EN (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P10MODE_Pos          (3UL)                     /*!< P10MODE (Bit 3)                                       */
#define ADC1_ADPGACR_P10MODE_Msk          (0x8UL)                   /*!< P10MODE (Bitfield-Mask: 0x01)                         */
#define ADC1_ADPGACR_P11SW_Pos            (5UL)                     /*!< P11SW (Bit 5)                                         */
#define ADC1_ADPGACR_P11SW_Msk            (0x20UL)                  /*!< P11SW (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P11EN_Pos            (6UL)                     /*!< P11EN (Bit 6)                                         */
#define ADC1_ADPGACR_P11EN_Msk            (0x40UL)                  /*!< P11EN (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P11MODE_Pos          (7UL)                     /*!< P11MODE (Bit 7)                                       */
#define ADC1_ADPGACR_P11MODE_Msk          (0x80UL)                  /*!< P11MODE (Bitfield-Mask: 0x01)                         */
#define ADC1_ADPGACR_P12SW_Pos            (9UL)                     /*!< P12SW (Bit 9)                                         */
#define ADC1_ADPGACR_P12SW_Msk            (0x200UL)                 /*!< P12SW (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P12EN_Pos            (10UL)                    /*!< P12EN (Bit 10)                                        */
#define ADC1_ADPGACR_P12EN_Msk            (0x400UL)                 /*!< P12EN (Bitfield-Mask: 0x01)                           */
#define ADC1_ADPGACR_P12MODE_Pos          (11UL)                    /*!< P12MODE (Bit 11)                                      */
#define ADC1_ADPGACR_P12MODE_Msk          (0x800UL)                 /*!< P12MODE (Bitfield-Mask: 0x01)                         */
/* ========================================================  ADPGAGS  ======================================================== */
#define ADC1_ADPGAGS_P10GAIN_Pos          (0UL)                     /*!< P10GAIN (Bit 0)                                       */
#define ADC1_ADPGAGS_P10GAIN_Msk          (0xfUL)                   /*!< P10GAIN (Bitfield-Mask: 0x0f)                         */
#define ADC1_ADPGAGS_P11GAIN_Pos          (4UL)                     /*!< P11GAIN (Bit 4)                                       */
#define ADC1_ADPGAGS_P11GAIN_Msk          (0xf0UL)                  /*!< P11GAIN (Bitfield-Mask: 0x0f)                         */
#define ADC1_ADPGAGS_P12GAIN_Pos          (8UL)                     /*!< P12GAIN (Bit 8)                                       */
#define ADC1_ADPGAGS_P12GAIN_Msk          (0xf00UL)                 /*!< P12GAIN (Bitfield-Mask: 0x0f)                         */
/* =======================================================  ADPGADCR  ======================================================== */
#define ADC1_ADPGADCR_P10GNDSEL_Pos       (3UL)                     /*!< P10GNDSEL (Bit 3)                                     */
#define ADC1_ADPGADCR_P10GNDSEL_Msk       (0x8UL)                   /*!< P10GNDSEL (Bitfield-Mask: 0x01)                       */
#define ADC1_ADPGADCR_P11GNDSEL_Pos       (7UL)                     /*!< P11GNDSEL (Bit 7)                                     */
#define ADC1_ADPGADCR_P11GNDSEL_Msk       (0x80UL)                  /*!< P11GNDSEL (Bitfield-Mask: 0x01)                       */
#define ADC1_ADPGADCR_P12GNDSEL_Pos       (11UL)                    /*!< P12GNDSEL (Bit 11)                                    */
#define ADC1_ADPGADCR_P12GNDSEL_Msk       (0x800UL)                 /*!< P12GNDSEL (Bitfield-Mask: 0x01)                       */


/* =========================================================================================================================== */
/* ================                                           ADC2                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ADCSR  ========================================================= */
#define ADC2_ADCSR_DBLANS_Pos             (0UL)                     /*!< DBLANS (Bit 0)                                        */
#define ADC2_ADCSR_DBLANS_Msk             (0x1fUL)                  /*!< DBLANS (Bitfield-Mask: 0x1f)                          */
#define ADC2_ADCSR_GBADIE_Pos             (6UL)                     /*!< GBADIE (Bit 6)                                        */
#define ADC2_ADCSR_GBADIE_Msk             (0x40UL)                  /*!< GBADIE (Bitfield-Mask: 0x01)                          */
#define ADC2_ADCSR_DBLE_Pos               (7UL)                     /*!< DBLE (Bit 7)                                          */
#define ADC2_ADCSR_DBLE_Msk               (0x80UL)                  /*!< DBLE (Bitfield-Mask: 0x01)                            */
#define ADC2_ADCSR_EXTRG_Pos              (8UL)                     /*!< EXTRG (Bit 8)                                         */
#define ADC2_ADCSR_EXTRG_Msk              (0x100UL)                 /*!< EXTRG (Bitfield-Mask: 0x01)                           */
#define ADC2_ADCSR_TRGE_Pos               (9UL)                     /*!< TRGE (Bit 9)                                          */
#define ADC2_ADCSR_TRGE_Msk               (0x200UL)                 /*!< TRGE (Bitfield-Mask: 0x01)                            */
#define ADC2_ADCSR_ADIE_Pos               (12UL)                    /*!< ADIE (Bit 12)                                         */
#define ADC2_ADCSR_ADIE_Msk               (0x1000UL)                /*!< ADIE (Bitfield-Mask: 0x01)                            */
#define ADC2_ADCSR_ADCS_Pos               (13UL)                    /*!< ADCS (Bit 13)                                         */
#define ADC2_ADCSR_ADCS_Msk               (0x6000UL)                /*!< ADCS (Bitfield-Mask: 0x03)                            */
#define ADC2_ADCSR_ADST_Pos               (15UL)                    /*!< ADST (Bit 15)                                         */
#define ADC2_ADCSR_ADST_Msk               (0x8000UL)                /*!< ADST (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSA0  ======================================================== */
#define ADC2_ADANSA_ANSA0_Pos            (0UL)                     /*!< ANSA0 (Bit 0)                                         */
#define ADC2_ADANSA_ANSA0_Msk            (0xfffUL)                 /*!< ANSA0 (Bitfield-Mask: 0xfff)                          */
/* ========================================================  ADANSA1  ======================================================== */
/* ========================================================  ADADS0  ========================================================= */
#define ADC2_ADADS_ADS00_Pos             (0UL)                     /*!< ADS00 (Bit 0)                                         */
#define ADC2_ADADS_ADS00_Msk             (0xfffUL)                 /*!< ADS00 (Bitfield-Mask: 0xfff)                          */
/* ========================================================  ADADS1  ========================================================= */
/* =========================================================  ADADC  ========================================================= */
#define ADC2_ADADC_ADC_Pos                (0UL)                     /*!< ADC (Bit 0)                                           */
#define ADC2_ADADC_ADC_Msk                (0x7UL)                   /*!< ADC (Bitfield-Mask: 0x07)                             */
#define ADC2_ADADC_AVEE_Pos               (7UL)                     /*!< AVEE (Bit 7)                                          */
#define ADC2_ADADC_AVEE_Msk               (0x80UL)                  /*!< AVEE (Bitfield-Mask: 0x01)                            */
/* =========================================================  ADCER  ========================================================= */
#define ADC2_ADCER_ACE_Pos                (5UL)                     /*!< ACE (Bit 5)                                           */
#define ADC2_ADCER_ACE_Msk                (0x20UL)                  /*!< ACE (Bitfield-Mask: 0x01)                             */
#define ADC2_ADCER_DLAGVAL_Pos            (8UL)                     /*!< DLAGVAL (Bit 8)                                       */
#define ADC2_ADCER_DLAGVAL_Msk            (0x300UL)                 /*!< DLAGVAL (Bitfield-Mask: 0x03)                         */
#define ADC2_ADCER_DIAGLD_Pos             (10UL)                    /*!< DIAGLD (Bit 10)                                       */
#define ADC2_ADCER_DIAGLD_Msk             (0x400UL)                 /*!< DIAGLD (Bitfield-Mask: 0x01)                          */
#define ADC2_ADCER_DIAGM_Pos              (11UL)                    /*!< DIAGM (Bit 11)                                        */
#define ADC2_ADCER_DIAGM_Msk              (0x800UL)                 /*!< DIAGM (Bitfield-Mask: 0x01)                           */
#define ADC2_ADCER_ADRFMT_Pos             (15UL)                    /*!< ADRFMT (Bit 15)                                       */
#define ADC2_ADCER_ADRFMT_Msk             (0x8000UL)                /*!< ADRFMT (Bitfield-Mask: 0x01)                          */
/* ========================================================  ADSTRGR  ======================================================== */
#define ADC2_ADSTRGR_TRSB_Pos             (0UL)                     /*!< TRSB (Bit 0)                                          */
#define ADC2_ADSTRGR_TRSB_Msk             (0x3fUL)                  /*!< TRSB (Bitfield-Mask: 0x3f)                            */
#define ADC2_ADSTRGR_TRSA_Pos             (8UL)                     /*!< TRSA (Bit 8)                                          */
#define ADC2_ADSTRGR_TRSA_Msk             (0x3f00UL)                /*!< TRSA (Bitfield-Mask: 0x3f)                            */
/* ========================================================  ADEXICR  ======================================================== */
#define ADC2_ADEXICR_TSSAD_Pos            (0UL)                     /*!< TSSAD (Bit 0)                                         */
#define ADC2_ADEXICR_TSSAD_Msk            (0x1UL)                   /*!< TSSAD (Bitfield-Mask: 0x01)                           */
#define ADC2_ADEXICR_OCSAD_Pos            (1UL)                     /*!< OCSAD (Bit 1)                                         */
#define ADC2_ADEXICR_OCSAD_Msk            (0x2UL)                   /*!< OCSAD (Bitfield-Mask: 0x01)                           */
#define ADC2_ADEXICR_TSSA_Pos             (8UL)                     /*!< TSSA (Bit 8)                                          */
#define ADC2_ADEXICR_TSSA_Msk             (0x100UL)                 /*!< TSSA (Bitfield-Mask: 0x01)                            */
#define ADC2_ADEXICR_OCSA_Pos             (9UL)                     /*!< OCSA (Bit 9)                                          */
#define ADC2_ADEXICR_OCSA_Msk             (0x200UL)                 /*!< OCSA (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADANSB0  ======================================================== */
#define ADC2_ADANSB_ANSB0_Pos            (0UL)                     /*!< ANSB0 (Bit 0)                                         */
#define ADC2_ADANSB_ANSB0_Msk            (0xfffUL)                 /*!< ANSB0 (Bitfield-Mask: 0xfff)                          */
/* ========================================================  ADANSB1  ======================================================== */
/* ========================================================  ADDBLDR  ======================================================== */
/* ========================================================  ADTSDR  ========================================================= */
/* ========================================================  ADOCDR  ========================================================= */
/* =========================================================  ADRD  ========================================================== */
/* =========================================================  ADDR0  ========================================================= */
/* =========================================================  ADDR1  ========================================================= */
/* =========================================================  ADDR2  ========================================================= */
/* =========================================================  ADDR3  ========================================================= */
/* =========================================================  ADDR4  ========================================================= */
/* =========================================================  ADDR5  ========================================================= */
/* =========================================================  ADDR6  ========================================================= */
/* =========================================================  ADDR7  ========================================================= */
/* =========================================================  ADDR8  ========================================================= */
/* =========================================================  ADDR9  ========================================================= */
/* ========================================================  ADDR10  ========================================================= */
/* ========================================================  ADDR11  ========================================================= */
/* ========================================================  ADDR12  ========================================================= */
/* ========================================================  ADDR13  ========================================================= */
/* ========================================================  ADDR14  ========================================================= */
/* ========================================================  ADDR15  ========================================================= */
/* ========================================================  ADDR16  ========================================================= */
/* ========================================================  ADDR17  ========================================================= */
/* ========================================================  ADDR18  ========================================================= */
/* ========================================================  ADDR19  ========================================================= */
/* ========================================================  ADDR20  ========================================================= */
/* ========================================================  ADDR21  ========================================================= */
/* ========================================================  ADDR22  ========================================================= */
/* ========================================================  ADDR23  ========================================================= */
/* ========================================================  ADDR24  ========================================================= */
/* ========================================================  ADDR25  ========================================================= */
/* ========================================================  ADDR26  ========================================================= */
/* ========================================================  ADDR27  ========================================================= */
/* ========================================================  ADDR28  ========================================================= */
/* ========================================================  ADDR29  ========================================================= */
/* ========================================================  ADDR30  ========================================================= */
/* ========================================================  ADDR31  ========================================================= */
/* =======================================================  ADCLKDIV  ======================================================== */
/* ========================================================  ADSHCR  ========================================================= */
#define ADC2_ADSHCR_SSTSH_Pos             (0UL)                     /*!< SSTSH (Bit 0)                                         */
#define ADC2_ADSHCR_SSTSH_Msk             (0xffUL)                  /*!< SSTSH (Bitfield-Mask: 0xff)                           */
#define ADC2_ADSHCR_SHANS_Pos             (8UL)                     /*!< SHANS (Bit 8)                                         */
#define ADC2_ADSHCR_SHANS_Msk             (0x700UL)                 /*!< SHANS (Bitfield-Mask: 0x07)                           */
/* ========================================================  ADDISCR  ======================================================== */
#define ADC2_ADDISCR_ADNDIS_Pos           (0UL)                     /*!< ADNDIS (Bit 0)                                        */
#define ADC2_ADDISCR_ADNDIS_Msk           (0x1fUL)                  /*!< ADNDIS (Bitfield-Mask: 0x1f)                          */
/* ========================================================  ADGSPCR  ======================================================== */
#define ADC2_ADGSPCR_PGS_Pos              (0UL)                     /*!< PGS (Bit 0)                                           */
#define ADC2_ADGSPCR_PGS_Msk              (0x1UL)                   /*!< PGS (Bitfield-Mask: 0x01)                             */
#define ADC2_ADGSPCR_GBRSCN_Pos           (1UL)                     /*!< GBRSCN (Bit 1)                                        */
#define ADC2_ADGSPCR_GBRSCN_Msk           (0x2UL)                   /*!< GBRSCN (Bitfield-Mask: 0x01)                          */
#define ADC2_ADGSPCR_LGRRS_Pos            (14UL)                    /*!< LGRRS (Bit 14)                                        */
#define ADC2_ADGSPCR_LGRRS_Msk            (0x4000UL)                /*!< LGRRS (Bitfield-Mask: 0x01)                           */
#define ADC2_ADGSPCR_GBRP_Pos             (15UL)                    /*!< GBRP (Bit 15)                                         */
#define ADC2_ADGSPCR_GBRP_Msk             (0x8000UL)                /*!< GBRP (Bitfield-Mask: 0x01)                            */
/* =======================================================  ADDBLDRA  ======================================================== */
/* =======================================================  ADDBLDRB  ======================================================== */
/* ========================================================  ADANSC0  ======================================================== */
#define ADC2_ADANSC_ANSC0_Pos            (0UL)                     /*!< ANSC0 (Bit 0)                                         */
#define ADC2_ADANSC_ANSC0_Msk            (0xfffUL)                 /*!< ANSC0 (Bitfield-Mask: 0xfff)                          */
/* ========================================================  ADANSC1  ======================================================== */
/* =======================================================  ADGCTRGR  ======================================================== */
#define ADC2_ADGCTRGR_TRSC_Pos            (0UL)                     /*!< TRSC (Bit 0)                                          */
#define ADC2_ADGCTRGR_TRSC_Msk            (0x3fUL)                  /*!< TRSC (Bitfield-Mask: 0x3f)                            */
#define ADC2_ADGCTRGR_GCADIE_Pos          (6UL)                     /*!< GCADIE (Bit 6)                                        */
#define ADC2_ADGCTRGR_GCADIE_Msk          (0x40UL)                  /*!< GCADIE (Bitfield-Mask: 0x01)                          */
#define ADC2_ADGCTRGR_GRCE_Pos            (7UL)                     /*!< GRCE (Bit 7)                                          */
#define ADC2_ADGCTRGR_GRCE_Msk            (0x80UL)                  /*!< GRCE (Bitfield-Mask: 0x01)                            */
/* ========================================================  ADSSTRL  ======================================================== */
/* ========================================================  ADSSTRO  ======================================================== */
/* ========================================================  ADSSTR0  ======================================================== */
/* ========================================================  ADSSTR1  ======================================================== */
/* ========================================================  ADSSTR2  ======================================================== */
/* ========================================================  ADSSTR3  ======================================================== */
/* ========================================================  ADSSTR4  ======================================================== */
/* ========================================================  ADSSTR5  ======================================================== */
/* ========================================================  ADSSTR6  ======================================================== */
/* ========================================================  ADSSTR7  ======================================================== */
/* ========================================================  ADSSTR8  ======================================================== */
/* ========================================================  ADSSTR9  ======================================================== */
/* =======================================================  ADSSTR10  ======================================================== */
/* =======================================================  ADSSTR11  ======================================================== */
/* =======================================================  ADSSTR12  ======================================================== */
/* =======================================================  ADSSTR13  ======================================================== */
/* =======================================================  ADSSTR14  ======================================================== */
/* =======================================================  ADSSTR15  ======================================================== */


/* =========================================================================================================================== */
/* ================                                           QSPI                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  SFMSMD  ========================================================= */
#define QSPI_SFMSMD_SFMRM_Pos             (0UL)                     /*!< SFMRM (Bit 0)                                         */
#define QSPI_SFMSMD_SFMRM_Msk             (0x7UL)                   /*!< SFMRM (Bitfield-Mask: 0x07)                           */
#define QSPI_SFMSMD_SFMSE_Pos             (4UL)                     /*!< SFMSE (Bit 4)                                         */
#define QSPI_SFMSMD_SFMSE_Msk             (0x30UL)                  /*!< SFMSE (Bitfield-Mask: 0x03)                           */
#define QSPI_SFMSMD_SFMPFE_Pos            (6UL)                     /*!< SFMPFE (Bit 6)                                        */
#define QSPI_SFMSMD_SFMPFE_Msk            (0x40UL)                  /*!< SFMPFE (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMPAE_Pos            (7UL)                     /*!< SFMPAE (Bit 7)                                        */
#define QSPI_SFMSMD_SFMPAE_Msk            (0x80UL)                  /*!< SFMPAE (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMMD3_Pos            (8UL)                     /*!< SFMMD3 (Bit 8)                                        */
#define QSPI_SFMSMD_SFMMD3_Msk            (0x100UL)                 /*!< SFMMD3 (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMOEX_Pos            (9UL)                     /*!< SFMOEX (Bit 9)                                        */
#define QSPI_SFMSMD_SFMOEX_Msk            (0x200UL)                 /*!< SFMOEX (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMOHW_Pos            (10UL)                    /*!< SFMOHW (Bit 10)                                       */
#define QSPI_SFMSMD_SFMOHW_Msk            (0x400UL)                 /*!< SFMOHW (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMOSW_Pos            (11UL)                    /*!< SFMOSW (Bit 11)                                       */
#define QSPI_SFMSMD_SFMOSW_Msk            (0x800UL)                 /*!< SFMOSW (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSMD_SFMCCE_Pos            (15UL)                    /*!< SFMCCE (Bit 15)                                       */
#define QSPI_SFMSMD_SFMCCE_Msk            (0x8000UL)                /*!< SFMCCE (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMSSC  ========================================================= */
#define QSPI_SFMSSC_SFMSW_Pos             (0UL)                     /*!< SFMSW (Bit 0)                                         */
#define QSPI_SFMSSC_SFMSW_Msk             (0xfUL)                   /*!< SFMSW (Bitfield-Mask: 0x0f)                           */
#define QSPI_SFMSSC_SFMSHD_Pos            (4UL)                     /*!< SFMSHD (Bit 4)                                        */
#define QSPI_SFMSSC_SFMSHD_Msk            (0x10UL)                  /*!< SFMSHD (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSSC_SFMSLD_Pos            (5UL)                     /*!< SFMSLD (Bit 5)                                        */
#define QSPI_SFMSSC_SFMSLD_Msk            (0x20UL)                  /*!< SFMSLD (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMSKC  ========================================================= */
#define QSPI_SFMSKC_SFMDV_Pos             (0UL)                     /*!< SFMDV (Bit 0)                                         */
#define QSPI_SFMSKC_SFMDV_Msk             (0x1fUL)                  /*!< SFMDV (Bitfield-Mask: 0x1f)                           */
#define QSPI_SFMSKC_SFMDTY_Pos            (5UL)                     /*!< SFMDTY (Bit 5)                                        */
#define QSPI_SFMSKC_SFMDTY_Msk            (0x20UL)                  /*!< SFMDTY (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMSST  ========================================================= */
#define QSPI_SFMSST_PFCNT_Pos             (0UL)                     /*!< PFCNT (Bit 0)                                         */
#define QSPI_SFMSST_PFCNT_Msk             (0x1fUL)                  /*!< PFCNT (Bitfield-Mask: 0x1f)                           */
#define QSPI_SFMSST_PFFUL_Pos             (6UL)                     /*!< PFFUL (Bit 6)                                         */
#define QSPI_SFMSST_PFFUL_Msk             (0x40UL)                  /*!< PFFUL (Bitfield-Mask: 0x01)                           */
#define QSPI_SFMSST_PFOFF_Pos             (7UL)                     /*!< PFOFF (Bit 7)                                         */
#define QSPI_SFMSST_PFOFF_Msk             (0x80UL)                  /*!< PFOFF (Bitfield-Mask: 0x01)                           */
/* ========================================================  SFMCOM  ========================================================= */
#define QSPI_SFMCOM_SFMD_Pos              (0UL)                     /*!< SFMD (Bit 0)                                          */
#define QSPI_SFMCOM_SFMD_Msk              (0xffUL)                  /*!< SFMD (Bitfield-Mask: 0xff)                            */
/* ========================================================  SFMCMD  ========================================================= */
#define QSPI_SFMCMD_DCOM_Pos              (0UL)                     /*!< DCOM (Bit 0)                                          */
#define QSPI_SFMCMD_DCOM_Msk              (0x1UL)                   /*!< DCOM (Bitfield-Mask: 0x01)                            */
/* ========================================================  SFMCST  ========================================================= */
#define QSPI_SFMCST_COMBSY_Pos            (0UL)                     /*!< COMBSY (Bit 0)                                        */
#define QSPI_SFMCST_COMBSY_Msk            (0x1UL)                   /*!< COMBSY (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMCST_EROMR_Pos             (7UL)                     /*!< EROMR (Bit 7)                                         */
#define QSPI_SFMCST_EROMR_Msk             (0x80UL)                  /*!< EROMR (Bitfield-Mask: 0x01)                           */
/* ========================================================  SFMSIC  ========================================================= */
#define QSPI_SFMSIC_SFMCIC_Pos            (0UL)                     /*!< SFMCIC (Bit 0)                                        */
#define QSPI_SFMSIC_SFMCIC_Msk            (0xffUL)                  /*!< SFMCIC (Bitfield-Mask: 0xff)                          */
/* ========================================================  SFMSAC  ========================================================= */
#define QSPI_SFMSAC_SFMAS_Pos             (0UL)                     /*!< SFMAS (Bit 0)                                         */
#define QSPI_SFMSAC_SFMAS_Msk             (0x3UL)                   /*!< SFMAS (Bitfield-Mask: 0x03)                           */
#define QSPI_SFMSAC_SFM4BC_Pos            (4UL)                     /*!< SFM4BC (Bit 4)                                        */
#define QSPI_SFMSAC_SFM4BC_Msk            (0x10UL)                  /*!< SFM4BC (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMSDC  ========================================================= */
#define QSPI_SFMSDC_SFMDN_Pos             (0UL)                     /*!< SFMDN (Bit 0)                                         */
#define QSPI_SFMSDC_SFMDN_Msk             (0xfUL)                   /*!< SFMDN (Bitfield-Mask: 0x0f)                           */
#define QSPI_SFMSDC_SFMXST_Pos            (6UL)                     /*!< SFMXST (Bit 6)                                        */
#define QSPI_SFMSDC_SFMXST_Msk            (0x40UL)                  /*!< SFMXST (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSDC_SFMXEN_Pos            (7UL)                     /*!< SFMXEN (Bit 7)                                        */
#define QSPI_SFMSDC_SFMXEN_Msk            (0x80UL)                  /*!< SFMXEN (Bitfield-Mask: 0x01)                          */
#define QSPI_SFMSDC_SFMXD_Pos             (8UL)                     /*!< SFMXD (Bit 8)                                         */
#define QSPI_SFMSDC_SFMXD_Msk             (0xff00UL)                /*!< SFMXD (Bitfield-Mask: 0xff)                           */
/* ========================================================  SFMSPC  ========================================================= */
#define QSPI_SFMSPC_SFMSPI_Pos            (0UL)                     /*!< SFMSPI (Bit 0)                                        */
#define QSPI_SFMSPC_SFMSPI_Msk            (0x3UL)                   /*!< SFMSPI (Bitfield-Mask: 0x03)                          */
#define QSPI_SFMSPC_SFMSDE_Pos            (4UL)                     /*!< SFMSDE (Bit 4)                                        */
#define QSPI_SFMSPC_SFMSDE_Msk            (0x10UL)                  /*!< SFMSDE (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMPMD  ========================================================= */
#define QSPI_SFMPMD_SFMWPL_Pos            (2UL)                     /*!< SFMWPL (Bit 2)                                        */
#define QSPI_SFMPMD_SFMWPL_Msk            (0x4UL)                   /*!< SFMWPL (Bitfield-Mask: 0x01)                          */
/* ========================================================  SFMCNT1  ======================================================== */
#define QSPI_SFMCNT1_QSPI_EXT_Pos         (26UL)                    /*!< QSPI_EXT (Bit 26)                                     */
#define QSPI_SFMCNT1_QSPI_EXT_Msk         (0xfc000000UL)            /*!< QSPI_EXT (Bitfield-Mask: 0x3f)                        */
/* ========================================================  SFMDMA  ========================================================= */
#define QSPI_SFMDMA_QSPIDMATRG_Pos        (0UL)                     /*!< QSPIDMATRG (Bit 0)                                    */
#define QSPI_SFMDMA_QSPIDMATRG_Msk        (0x1UL)                   /*!< QSPIDMATRG (Bitfield-Mask: 0x01)                      */
/* ========================================================  SFMCRPT  ======================================================== */
#define QSPI_SFMCRPT_QSPICRPT_Pos         (0UL)                     /*!< QSPICRPT (Bit 0)                                      */
#define QSPI_SFMCRPT_QSPICRPT_Msk         (0x1UL)                   /*!< QSPICRPT (Bitfield-Mask: 0x01)                        */


/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TSN85  ========================================================= */
/* =========================================================  TSN25  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            BGR                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  VBG85  ========================================================= */
/* =========================================================  VBG25  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  UID0  ========================================================== */
/* =========================================================  UID1  ========================================================== */
/* =========================================================  UID2  ========================================================== */
/* =========================================================  UID3  ========================================================== */

/** @} */ /* End of group PosMask_peripherals */
 #define assert_param(expr) ((void)0)

#ifdef __cplusplus
}
#endif

#endif /* BAT32G439_H */


/** @} */ /* End of group BAT32G439 */

/** @} */ /* End of group Cmsemicon */
